# `haddock3`

![haddock3-logo](https://github.com/haddocking/haddock3/blob/main/docs/figs/HADDOCK3-logo.png)

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.10527751.svg)](https://doi.org/10.5281/zenodo.10527751)
[![Research Software Directory](https://img.shields.io/badge/rsd-haddock3-00a3e3.svg)](https://research-software-directory.org/software/haddock3)
[![fair-software.eu](https://img.shields.io/badge/fair--software.eu-%E2%97%8F%20%20%E2%97%8F%20%20%E2%97%8F%20%20%E2%97%8F%20%20%E2%97%8F-green)](https://fair-software.eu)
[![OpenSSF Best Practices](https://www.bestpractices.dev/projects/8844/badge)](https://www.bestpractices.dev/projects/8844)

[![unit tests](https://github.com/haddocking/haddock3/workflows/tests/badge.svg?branch=main)](https://github.com/haddocking/haddock3/actions?workflow=tests)
[![build](https://github.com/haddocking/haddock3/workflows/build/badge.svg?branch=main)](https://github.com/haddocking/haddock3/actions?workflow=build)
[![docs](https://github.com/haddocking/haddock3/workflows/pages/badge.svg?branch=main)](https://github.com/haddocking/haddock3/actions?workflow=pages)

[![Codacy Badge](https://app.codacy.com/project/badge/Grade/e11e7f45400f4e8589cdf5941f95233a)](https://app.codacy.com/gh/haddocking/haddock3/dashboard?utm_source=gh&utm_medium=referral&utm_content=&utm_campaign=Badge_grade)
[![Codacy Badge](https://app.codacy.com/project/badge/Coverage/e11e7f45400f4e8589cdf5941f95233a)](https://app.codacy.com/gh/haddocking/haddock3/dashboard?utm_source=gh&utm_medium=referral&utm_content=&utm_campaign=Badge_coverage)

## Introduction

HADDOCK, standing for **H**igh **A**mbiguity **D**riven protein-protein **DOCK**ing, is a widely used computational tool for the integrative modeling of biomolecular interactions. Developed by researchers at [Utrecht University](https://uu.nl) in the [BonvinLab](https://bonvinlab.org) for more than 20 years, it integrates various types of experimental data, biochemical, biophysical, bioinformatic prediction and knowledge to guide the docking process.

## Installation

Clone the repository and run `pip install .`;

```bash
pip install haddock3
```

Execute:

```bash
$ haddock3 -h
usage: haddock3 [-h] [--restart RESTART] [--extend-run EXTEND_RUN] [--setup] [--log-level {DEBUG,INFO,WARNING,ERROR,CRITICAL}] [-v] recipe

positional arguments:
  recipe                The input recipe file path

optional arguments:
  -h, --help            show this help message and exit
  --restart RESTART     Restart the run from a given step. Previous folders from the selected step onwards will be deleted.
  --extend-run EXTEND_RUN
                        Start a run from a run directory previously prepared with the `haddock3-copy` CLI. Provide the run directory created with `haddock3-copy` CLI.
  --setup               Only setup the run, do not execute
  --log-level {DEBUG,INFO,WARNING,ERROR,CRITICAL}
  -v, --version         show version
```

For the installation of third-party additional software, please check the [INSTALL](docs/INSTALL.md).

You might also want to check the following utilities:

- [`haddock-restraints`](https://github.com/haddocking/haddock-restraints): Tool to generate restraints to be used in `haddock3`.
- [`haddock-runner`](https://github.com/haddocking/haddock-runner): Tool to run large scale `haddock3` simulations using multiple input molecules in different scenarios
- [`haddock-tools`](https://github.com/haddocking/haddock-tools): Set of useful utility scripts developed over the years by the BonvinLab group members

## Usage

The most basic usage is:

```bash
haddock3 <configuration-file.toml>
```

Check the [EXAMPLES](https://github.com/haddocking/haddock3/blob/main/examples/README.md) page for more some usage examples and the [MANUAL]() (_coming soon!_) for a more detailed explanation of the configuration file.

## Support

If you encounter any code-related issues, [please open an issue](https://github.com/haddocking/haddock3/issues/new/choose).

If you have any other questions or need help, please contact us at [ask.bioexcel.eu](https://ask.bioexcel.eu/).

If you clone this repository and use `haddock3` for your research, please support us by signing up in [this form](https://forms.gle/LCUHiYHh1hE9rd8L6). This will allow us contact you when needed for `haddock3`-related issues, and also provide us a mean to demonstrate impact when reporting for grants - which grealty helps us to keep the project alive!

## Cite us

If you used `haddock3` for your research, please cite us:

- **Research article**: (_coming soon!_)
- **Cite this repository**: M.C. Teixeira, J., Vargas Honorato, R., Giulini, M., Bonvin, A., SarahAlidoost, Reys, V., Jimenez, B., Schulte, D., van Noort, C., Verhoeven, S., Vreede, B., SSchott, & Tsai, R. (2024). haddocking/haddock3: v3.0.0-beta.5 (Version 3.0.0-beta.5) [Computer software]. [https://doi.org/10.5281/zenodo.10527751](https://doi.org/10.5281/zenodo.10527751)

## Useful resources

- [User manual]() (_coming soon!_)
- [Best practice guide](https://www.bonvinlab.org/software/bpg/)
- [The HADDOCK2.4 web server: A leap forward in integrative modelling of biomolecular complexes. Nature Prot. 2024](https://www.nature.com/articles/s41596-024-01011-0)

## Development

Please check [DEVELOPMENT](https://github.com/haddocking/haddock3/blob/main/DEVELOPMENT.md) for instructions on how to develop `haddock3`

### Code Documentation

The code documentation is automatically built and hosted at [bonvinlab.org/haddock3](https://www.bonvinlab.org/haddock3/).

To build it locally (considering you have followed the installation instructions):

```bash
tox -e docs
```

> Warning messages are expected, but the documentation should be built successfully.

The rendered documentation will be available at `haddock3-docs/index.html`. This will open a local webpage with the

### Contributing

Check the [CONTRIBUTING](CONTRIBUTING.md) file for instructions on how to contribute with the project!

<!-- ---

Happy HADDOCking!

<img src="https://www.bonvinlab.org/images/bio-haddock.png" alt="haddock" width="50px"> -->

### CNS-related code and scripts

HADDOCK requires that CNS1.3 be recompiled to increase in particular the size of some arrays and adding new functionalities.
For this, when installing CNS, copy first all the files from this directory into the source directory of your CNS installation before starting the installation.
The large number of molecule types and their corresponding force field parameters does require to increase the size of various arrays.

To copy the code and scripts to your CNS installation directory use:

```bash
cp -r source bin instlib <CNS-installation-directory>
```

The provided getarch script under the bin dir adds support for Mac M1/2/3 processors.

The provided Makefiles under the instlib dir adds the proper gfortran compiler options.

And the provided code adds functionality for:


#### Radius of gyration restraints

A radius of gyration distance restraint can be used in HADDOCK. By default it is applied to the entire system, but can be restricted to part of the system using standard CNS atom selections. For details refer to the online [HADDOCK manual](https://www.bonvinlab.org/software/haddock2.4/Rg/).

_Note_ that this functionality is not yet implemented in HADDOCK3


#### Residual dipolar couplings defined as intervector projection angle restraints

Intervector projection angle restraints ( [Meiler et al. _J. Biomol. NMR_ **17**, 185 (2000)](https://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=Retrieve&db=PubMed&list_uids=10805131&dopt=Abstract)) are obtained by taking pairs of residual dipolar couplings and generating intervector projection angle restraints (somewhat equivalent to dihedral angle restraints). These restraints have the advantage that they do no longer depend on the orientation of the dipole vector with respect to the alignment tensor. Instead they restrain the angle between two dipolar vectors, allowing for two minima. Two force constants must be therefore defined: one for the border potential function and one for the central part (e.g. between the two minima). For details refer to the online [HADDOCK manual](https://www.bonvinlab.org/software/haddock2.4/RDC/#intervector-projection-angle-restraints-for-docking).


_Note_ that this functionality is not yet implemented in HADDOCK3


#### Pseudo contact shift restraints

Pseudo contact shifts (PCS) can provide useful information on both the distances and the orientation of the molecules to be docked. They can be used directly as restraints in HADDOCK using the XPCS energy term in CNS. For details refer to the online [HADDOCK manual](https://www.bonvinlab.org/software/haddock2.4/PCS/).


_Note_ that this functionality is not yet implemented in HADDOCK3

### Using haddock3 with module

This directory provides an example module for using haddock3 with the `module` command if installed on your system.
`module` is part of the lmod software (refer to documentation below for details). In short, it allows to enable and disable software at wish on a server.

This directory contains an example module file for haddock3. It assumes that haddock3 has been installed using miniconda3. The module will source the conda environment and activate haddock3. To use it in your enviroment, someone with admin rights will have to edit it and place it in the proper location.

To configure the module script for your system, edit the provided `haddock3/3.0.0.lua` file and change the following line to specifiy the installation location of miniconda3:

```
local conda_dir = "/trinity/home/software/miniconda3"

```

Then copy the entire haddock3 directory into the `modulefiles` directory of your lmod installation. E.g on our system this is: `/opt/ohpc/pub/modulefiles/` as lmod was installed as part of the open HPC software stack (see for example https://openhpc.github.io/cloudwg/) 



#### Documentation

Lmod Web Sites

*  Documentation:    http://lmod.readthedocs.org
*  Github:           https://github.com/TACC/Lmod
*  Sourceforge:      https://lmod.sf.net
*  TACC Homepage:    https://www.tacc.utexas.edu/research-development/tacc-projects/lmod

Welcome!

To develop your own HADDOCK3 module follow the patterns used in other modules.

1. If your module belongs to a new category, create a folder for that category
   under the `modules` folder.
1. Else, create a folder for your module inside its relevant category.
   The name of that folder is the name of the module, i.e., the name used to call
   the module in the haddock3 configuration files and used throughout the code base.
1. Copy the `__init__.py` file here to the new module's folder and edit it accordingly
   to the instructions there.
1. Do the same for the `defaults.yaml` file.
1. You can then add any extra files needed inside your module's folder in order to
   develop your module fully.
1. If your module requires any extra libraries, describe how to install those libraries
   in the `docs/INSTALL.md` file. Unless approved by the Haddock Team, do not add
   those dependencies to the `requirements.*` files.
1. HADDOCK3 has already many features related to IO, subprocess run, sending jobs,
   etc. Please, look around the `libs` folder for pertinent functions, but, above all,
   feel welcomed to reach out to us with any doubts.
1. Please write also tests for your module. Our testing machinery already
   tests for the common patterns, for example, inspecting the `defaults.yaml` file.
   But you should write any additional tests to ensure that your module works properly.
   See other examples in the `tests/` folder.
1. Finally, add an example of how to use your module in the `examples/` folder.
   The example should have a short sampling scheme. Name the config file ending with
   `-test.cfg`.

Thanks, and we are happy to help you! :-)
@ The Haddock Team

C     ------------------------------------------------------------------
      SUBROUTINE FANTACCR (ATOMIPTR,ATOMJPTR,ATOMKPTR, 
     &                     ATOMILST,ATOMJLST,ATOMKLST, 
     &                     XCCROBS,XCCRERR,NCLASS,NOMEFILE)
C     ------------------------------------------------------------------
C     Fits cross correlation rate coefficient on a given structure
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xccr.inc"
      INCLUDE  "consta.inc"
      INCLUDE  "fantaxplor.inc"
      INCLUDE  'heap.inc'

      DOUBLE PRECISION AK
      LOGICAL CSWITCH,CSAVE,CERR
      COMMON /CRUN/AK 
      COMMON /CPARAM/CSWITCH,CSAVE,CERR
      INTEGER CVIOLS,IA
      COMMON /CVIOL/CVIOLS
      CHARACTER NOMEFILE*132
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*) 
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)

      INTEGER COUNT,MM,NN,I,J,K,L,NA,M,N,CLASS,NORES
      INTEGER NCLASS,NNCO,NNCC
      DOUBLE PRECISION XCCROBS(*),XCCRERR(*)
      DOUBLE PRECISION OBSXCCR,ERRXCCR
      DOUBLE PRECISION XI,XJ,XK,YI,YJ,YK,ZI,ZJ,ZK
      DOUBLE PRECISION XFA(1000),YFA(1000),ZFA(1000),XMFA(1000),
     &                 YMFA(1000),ZMFA(1000),ERRFA(1000),OBSFA(1000),
     &                 FENPCS(20,2000),WPROT(1000),
     &                 XFAN(1000),YFAN(1000),ZFAN(1000)
      DOUBLE PRECISION O1,O2,O3,O4,O5,O6,O7,O8,O9,O10,O11,O12
      DOUBLE PRECISION PS,DJK2,DJI2,DJK(1000),DJI(1000),ANGFACT(1000)
      DOUBLE COMPLEX DUMMY2
C     ------------------------------------------------------------------
C     CLASS must reamin this during the cycle of variables exchange.
C     The class is defined by NCLASS.
C     ------------------------------------------------------------------
      CLASS=1
      NNCO=0
      NNCC=0
      COUNT=0

      PRINT*,'This is FANTACROSS.'
      PRINT*,'CCRNUM is:',CCRNUM

      DO WHILE(COUNT.LT.CCRNUM)
         COUNT=COUNT+1
         DO WHILE ((XCCRASSNDX(CLASS).LT.COUNT).OR.
     &             (XCCRASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO
         IF (XCCRASSNDX(CLASS).EQ.XCCRASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         IF (NCLASS.EQ.CLASS) THEN 
             NNCO=NNCO+1
             I=ATOMIPTR(COUNT)+1
             J=ATOMJPTR(COUNT)+1
             K=ATOMKPTR(COUNT)+1

             XI=X(ATOMILST(I))
             XJ=X(ATOMJLST(J))
             XK=X(ATOMKLST(K))
             YI=Y(ATOMILST(I))
             YJ=Y(ATOMJLST(J))
             YK=Y(ATOMKLST(K))
             ZI=Z(ATOMILST(I))
             ZJ=Z(ATOMJLST(J))
             ZK=Z(ATOMKLST(K))
             OBSFA(NNCO)=XCCROBS(COUNT)
             OBSXCCR=XCCROBS(COUNT)
             ERRFA(NNCO)=XCCRERR(COUNT)
             ERRXCCR=XCCRERR(COUNT)
         END IF

         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               IF (NCLASS.EQ.CLASS) THEN
                   NNCC=NNCC+1
                   XMFA(NNCC)=X(ATOMILST(MM))
                   XFA(NNCC)=X(ATOMJLST(NN))
                   XFAN(NNCC)=X(ATOMKLST(NN))
                   YMFA(NNCC)=Y(ATOMILST(MM))
                   YFA(NNCC)=Y(ATOMJLST(NN))
                   YFAN(NNCC)=Y(ATOMKLST(NN))
                   ZMFA(NNCC)=Z(ATOMILST(MM))
                   ZFA(NNCC)=Z(ATOMJLST(NN))
                   ZFAN(NNCC)=Z(ATOMKLST(NN))
                   NORES=ATOMJLST(NN)
                   NRESIDFA(NNCC)=RESID(NORES)
                   NRESFA(NNCC)=RES(NORES)
                   NTYPEFA(NNCC)=TYPE(NORES)
               END IF
            END DO
         END DO
      END DO      

      IF (NNCC.EQ.NNCO) THEN
          DO IA=1,CCRNUM
             O1=XFA(IA)-XFAN(IA)
             O2=XFA(IA)-XMFA(IA)
             O3=YFA(IA)-YFAN(IA)
             O4=YFA(IA)-YMFA(IA)
             O5=ZFA(IA)-ZFAN(IA)
             O6=ZFA(IA)-ZMFA(IA)
             O7=O2**2
             O8=O4**2
             O9=O6**2
             O10=O1**2
             O11=O3**2
             O12=O5**2
             PS=O1*O2+O3*O4+O5*O6
             DJK2=O10+O11+O12
             DJK(IA)=SQRT(DJK2)
             DJI2=O7+O8+O9
             DJI(IA)=SQRT(DJI2)
             ANGFACT(IA)=(3.*(PS/(DJK(IA)*DJI(IA)))**2-1.)
           END DO 
           CALL FANTALINCCR(DJI,DJK,ANGFACT,NNCO,OBSFA,ERRFA,NOMEFILE,
     &                      WPROT,0)
      ELSE
         PRINT*,'Error in atom count...'
      END IF

      RETURN
      END

      SUBROUTINE ATMINI(ISTART,ISTOP)
C
C Subroutine sets coordinate arrays and harmonic constraint array
C to default values for atom numbers between ISTART and ISTOP.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'heap.inc'
      INTEGER ISTART, ISTOP
C local
      INTEGER I
      DOUBLE PRECISION    ANUM
      PARAMETER (ANUM=9999.0D0)
C begin
      DO I=ISTART,ISTOP
      X(I)=ANUM
      Y(I)=ANUM
      Z(I)=ANUM
      WMAIN(I)=0.0D0
      QMAIN(I)=1.0D0
      XCOMP(I)=ANUM
      YCOMP(I)=ANUM
      ZCOMP(I)=ANUM
      WCOMP(I)=0.0D0
      QCOMP(I)=1.0D0
      KCNSTR(I)=0.0D0
      KZCNSTR(I)=0.0D0
      RMSD(I)=0.0D0
      REFX(I)=ANUM
      REFY(I)=ANUM
      REFZ(I)=ANUM
      FBETA(I)=0.0D0
      DX(I)=0.0D0
      DY(I)=0.0D0
      DZ(I)=0.0D0
      XV(I)=0.0D0
      YV(I)=0.0D0
      ZV(I)=0.0D0
      IMOVE(I)=0
      END DO
      CALL ATMIN2(HEAP(IINTER(1)),ISTART,ISTOP)
      RETURN
      END
C
      SUBROUTINE ATMIN2(INTERE,ISTART,ISTOP)
C
      IMPLICIT NONE
C I/O
      INTEGER INTERE(*), ISTART, ISTOP
C local
      INTEGER I
C begin
      DO I=ISTART,ISTOP
      INTERE(I)=0
      ENDDO
C
      RETURN
      END

C=====================================================================
C machine-dependent system-service routines (such as TIME and DATE)
C=====================================================================
      SUBROUTINE VDATE(A,AMAX,ALEN)
C
C this routine returns the date
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) A
      INTEGER AMAX, ALEN
C local
      CHARACTER*4 YEAR
      CHARACTER*2 DAY
      CHARACTER*3 MONTH
C begin
      IF (AMAX.LT.10) THEN
      WRITE(6,'(A)') ' %VDATE-ERR: string to small'
      ELSE
      A=' '
      CALL DATE_AND_TIME(A)
C
      YEAR=A(1:4)
      DAY=A(7:8)
C
      IF (A(5:6).EQ.'01') THEN
         MONTH='Jan'
      ELSE IF (A(5:6).EQ.'02') THEN
         MONTH='Feb'
      ELSE IF (A(5:6).EQ.'03') THEN
         MONTH='Mar'
      ELSE IF (A(5:6).EQ.'04') THEN
         MONTH='Apr'
      ELSE IF (A(5:6).EQ.'05') THEN
         MONTH='May'
      ELSE IF (A(5:6).EQ.'06') THEN
         MONTH='Jun'
      ELSE IF (A(5:6).EQ.'07') THEN
         MONTH='Jul'
      ELSE IF (A(5:6).EQ.'08') THEN
         MONTH='Aug'
      ELSE IF (A(5:6).EQ.'09') THEN
         MONTH='Sep'
      ELSE IF (A(5:6).EQ.'10') THEN
         MONTH='Oct'
      ELSE IF (A(5:6).EQ.'11') THEN
         MONTH='Nov'
      ELSE IF (A(5:6).EQ.'12') THEN
         MONTH='Dec'
      END IF
C
      A=DAY//'-'//MONTH//'-'//YEAR
      ALEN=11
C
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE VTIME(A,AMAX,ALEN)
C
C this routine returns day time
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) A
      INTEGER AMAX, ALEN
C local
      CHARACTER  DSTR*8, TSTR*11
C begin
      IF (AMAX.LT.8) THEN
      WRITE(6,'(A)') ' %VTIME-ERR: string to small'
      ELSE
      CALL DATE_AND_TIME(DSTR, TSTR)
      A=TSTR(1:2)//':'//TSTR(3:4)//':'//TSTR(5:8)
      ALEN=AMAX
      CALL TRIMM(A,ALEN)
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE VCPU(SECS)
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      DOUBLE PRECISION SECS
C
C routine returns system time of current job in seconds
C
C begin
      CALL CPU_TIME(SECS)
      SECS=SECS-STRCPU
      RETURN
      END
C=====================================================================
      SUBROUTINE VINTIM
C
C initializes timer and saves initial date and time
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
C local
      INTEGER  L
      DOUBLE PRECISION     CPU
      CHARACTER*8 TIME
      CHARACTER*11 DATE
      REAL RSECS
C begin
      CALL CPU_TIME(RSECS)
      STRCPU=RSECS
      CALL VTIME(TIME,8,L)
      CALL VDATE(DATE,11,L)
      STRTIM=TIME
      STRDAT=' '
      STRDAT(1:L)=DATE(1:L)
      RETURN
      END
CC=====================================================================
      SUBROUTINE VCHKTT(STREAM,QTERM)
C
C checks wheter unit STREAM is assigned to an interactive terminal
C
C +++++++++++++++++++++++++++++++++++++++
C machine dependent Linux version
C +++++++++++++++++++++++++++++++++++++++
C
C By Axel Brunger, 14-APR-84
C
      IMPLICIT NONE
C input/output
      INTEGER STREAM
      LOGICAL QTERM
      CHARACTER*100 NAME
      INTEGER LEN
      LOGICAL QOPEN, QFORM, QWRITE
      INTEGER CSATTY
      EXTERNAL CSATTY
C begin
      CALL VINQRE('UNIT',NAME,100,LEN,QOPEN,QFORM,QWRITE,STREAM)
      IF (NAME(1:5).EQ.'INPUT' .AND. CSATTY(0).EQ.1) THEN
      QTERM=.TRUE.
      ELSE
      QTERM=.FALSE.
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE SYTASK
C
C parses UNIX system commands
C Author: Axel T. Brunger
C 
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
C local
      INTEGER SYSTEM, ISYS
      INTEGER RECMAX, RECLEN
      PARAMETER (RECMAX=160)
      CHARACTER*(RECMAX) RECORD
C begin
C
C run it through LINSUB to make symbol substutions
C fixed last argument (ATB 5/22/08)
      CALL LINSUB(RECORD,RECMAX,RECLEN,' ',0,2)
      ISYS=SYSTEM(RECORD(1:RECLEN))
      IF (ISYS.EQ.127) WRITE(6,'(A)') ' Can''t execute shell; error=127'
      IF (ISYS.EQ.-1) WRITE(6,'(A)') ' Can''t execute shell; error=-1'
      CURSOR=COMLEN           
      RETURN
      END
C=====================================================================
      SUBROUTINE GETNAM(USERNM,MAX,LENGTH)
C
C Gets the username associated with the current process and places
C it in USERNM.
C
C input/output
      CHARACTER*(*) USERNM
      INTEGER MAX, LENGTH
C
C local
      CHARACTER  USR*16
C
C begin
      USERNM=' '
      USR=' '
      CALL GETENV('USER', USR)
      IF (USR .EQ. ' ') THEN
        USERNM='unknown'
        LENGTH=MIN(7, MAX)
      ELSE
        USERNM=USR
        LENGTH=MAX
        CALL TRIMM(USERNM, LENGTH)
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE GETSYS(USERNM,MAX,LENGTH)
C
C Gets the SYSTEM associated with the current process and places
C it in USERNM.
C
      IMPLICIT NONE
C input/output
      CHARACTER*14 USERNM
      INTEGER MAX, LENGTH
C begin
      CALL COPYST(USERNM,MAX,LENGTH,'Linux',5)
      RETURN
      END
C=====================================================================
      SUBROUTINE VPROMP(UNIT,PROMPT)
C
C Makes a prompt at an interactive terminal without c/r.
C
      IMPLICIT NONE
C input/output
      INTEGER UNIT
      CHARACTER*(*) PROMPT
C local
      CHARACTER*10 NAME
C begin
      WRITE(6,'(A,$)') PROMPT
      RETURN
      END
C*********************************************************************
C=====================================================================
C=== machine-dependent I/O routines (for file opening and closing)
C=====================================================================
      SUBROUTINE NEXTVERSION(FILE)
C
C Creates "version numbers" if a "NEW" file is already there.
C
C  Input : filename  or filename_version
C  Output : filename_version+1
C
      IMPLICIT NONE
C input/output
      CHARACTER*(*) FILE
C local
      INTEGER I, FILLEN
      CHARACTER*10 NUMBERS
      CHARACTER*5 TEMP
      CHARACTER V
      INTEGER VERSION,NEWVERSION,VN
      INTEGER DECODI
      LOGICAL OK
C begin
      NUMBERS='1234567890'
      FILLEN=LEN(FILE)
      CALL TRIMM(FILE,FILLEN)
C Find position of last "_"
      I=FILLEN
      DO WHILE ((I.GT.2).AND.(INDEX(NUMBERS,FILE(I:I)).GT.0))
      V=FILE(I:I)
      I=I-1
      END DO
C Create version number
      IF ((FILE(I:I).EQ.'_').AND.(INDEX(NUMBERS,V).GT.0)) THEN
        TEMP=FILE((I+1):FILLEN)
        VERSION=DECODI(TEMP,FILLEN-I,OK)
        NEWVERSION=VERSION + 1
        TEMP=' '
      IF (MOD(NEWVERSION,10).EQ.0) THEN
          CALL ENCODI(NEWVERSION,TEMP,FILLEN-I+1,VN)
          FILE((I+1):FILLEN+1)=TEMP
      ELSE
          CALL ENCODI(NEWVERSION,TEMP,FILLEN-I,VN)
          FILE((I+1):(FILLEN))=TEMP
      END IF
      ELSE
        FILE((FILLEN+1):(FILLEN+2))='_1'
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE VOPEN(UNIT,FILE,FORM,ACCESS,ERR)
C
C Opens a file.
C
      IMPLICIT NONE
C input/output    
      INCLUDE 'iochan.inc'
      INCLUDE 'timer.inc'
      
      INTEGER UNIT
      CHARACTER*(*) FILE, FORM, ACCESS
      LOGICAL ERR
C local
      CHARACTER*132  LSTFIL, NEWFIL
      INTEGER I, FILLEN
      LOGICAL EXISTS
C begin
      ERR=.FALSE.
      IF (FILE.EQ.'$$INITIAL$$') THEN
C---------------------------------------------------------------
C
        CALL OUTBUF
C
C Initialize list of free FORTRAN units.
C It is assumed that system input is assigned to unit 5
C and system output is assigned to unit 6 and all other
C units are deassigned.
      DO I=1,MAXUN
      IFREEU(I)=0
      END DO
      IFREEU(5)=10
      IFREEU(6)=1
      ELSE
      IF (FORM.NE.'FORMATTED'.AND.FORM.NE.'UNFORMATTED') THEN
      WRITE(6,'(3A)')
     & ' %VOPEN-ERR: unknown format qualifier "',FORM,'"'
      ERR=.TRUE.
      ELSE
c        FILLEN = LEN(FILE)
c        CALL TRIMM(FILE,FILLEN)
c        write(6,'(6A)') ' VOPEN: Trying to open ',
c    &      FORM,' file "',FILE(1:FILLEN),'" to ',ACCESS
C---------------------------------------------------------------
C write append access
      IF (ACCESS.EQ.'APPEND') THEN
         IF (FORM.EQ.'FORMATTED') THEN
            OPEN(FILE=FILE,STATUS='OLD',ACCESS='APPEND',ERR=9999,
     &           UNIT=UNIT,FORM='FORMATTED')
         ELSE
            OPEN(FILE=FILE,STATUS='OLD',ACCESS='APPEND',ERR=9999,
     &           UNIT=UNIT,FORM='UNFORMATTED')
         ENDIF
C---------------------------------------------------------------
C read access
      ELSE IF (ACCESS.EQ.'READ') THEN
         IF (FORM.EQ.'FORMATTED') THEN
            OPEN(FILE=FILE,STATUS='OLD',ERR=9999,
     &           ACCESS='SEQUENTIAL',UNIT=UNIT,FORM='FORMATTED')
         ELSE
            OPEN(FILE=FILE,STATUS='OLD',ERR=9999,
     &           ACCESS='SEQUENTIAL',UNIT=UNIT,FORM='UNFORMATTED')
         ENDIF
C---------------------------------------------------------------
C write access
      ELSE IF (ACCESS.EQ.'WRITE') THEN
C Bart Hazes: Nov 25, 1997
C Mofified code because filenames were not correctly terminated on linux.
        INQUIRE(FILE=FILE,EXIST=EXISTS)
        IF (EXISTS) THEN
C
C modification ATB 5/22/08
          FILLEN = LEN(FILE)          
          CALL TRIMM(FILE,FILLEN)
C end mofication
C
          LSTFIL=FILE
          NEWFIL=FILE
          I=0
          DO WHILE (EXISTS .AND. I.LT.99)
            I=I+1
            IF (I.LE.9)THEN
              WRITE(NEWFIL(FILLEN+1:FILLEN+2),'(''_'',I1)')I
            ELSE
              WRITE(NEWFIL(FILLEN+1:FILLEN+3),'(''_'',I2)')I
            ENDIF
            INQUIRE(FILE=NEWFIL,EXIST=EXISTS)
          END DO
          IF (EXISTS) THEN
            WRITE(6,'(3A)') ' %VOPEN-ERR: > 99 versions present'
            GOTO 9999
          END IF
          IF (NEWFIL(FILLEN+3:FILLEN+3).EQ.' ') THEN
            NEWFIL(FILLEN+3:FILLEN+3)=CHAR(0)
          ELSE
            NEWFIL(FILLEN+4:FILLEN+4)=CHAR(0)
          ENDIF
          DO WHILE (I.GE.1)
            I=I-1
            IF (I.EQ.0) THEN
              LSTFIL(FILLEN+1:FILLEN+1)=CHAR(0)
            ELSE IF (I.LE.9) THEN
              WRITE(LSTFIL(FILLEN+1:FILLEN+3),'(''_'',I1,A1)')
     &          I, CHAR(0)
            ELSE
              WRITE(LSTFIL(FILLEN+1:FILLEN+4),'(''_'',I2,A1)')
     &          I, CHAR(0)
            ENDIF
            CALL RENAME(LSTFIL, NEWFIL)
            NEWFIL=LSTFIL(1:FILLEN+4)
          END DO
        END IF
        OPEN(FILE=FILE,FORM=FORM,STATUS='NEW',ACCESS='SEQUENTIAL',
     &       ERR=9999,UNIT=UNIT)
C---------------------------------------------------------------
      ELSE
      WRITE(6,'(3A)')
     & ' %VOPEN-ERR: unknown access qualilifer "',ACCESS,'"'
      ERR=.TRUE.
      END IF
      GOTO 8888
9999  ERR=.TRUE.
8888  CONTINUE
C
      IF (.NOT.ERR) THEN
C
C put appropriate code in IFREEU array:
C  +10 read formatted
C  +1  write/append formatted
C  -1  write/append unformatted
C  -10 read unformatted
      IF (FORM.EQ.'FORMATTED') THEN
      IFREEU(UNIT)=1
      ELSE
      IFREEU(UNIT)=-1
      END IF
      IF (ACCESS.EQ.'READ') IFREEU(UNIT)=IFREEU(UNIT)*10
      END IF
      END IF
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE VINQRE(MODE,NAME,MAXLEN,LENGTH,QOPEN,QFORM,QWRITE,
     &                  UNIT)
C
C file inquiry by file name or FORTRAN unit
C Flag QOPEN indicates whether file or unit is "open".
C Flag QFORM indicates whether file was opened formatted.
C Flag QWRITe indicates whether file was opened write-access.
C For inquiry by unit MAXLEN has to be specified (max length of NAME)
C and LENGTH returns with the length of NAME.
C For inquiry by file the two names INPUT and OUTPUT are reserved
C for the standard input and output channels 5 and 6.
C
      IMPLICIT NONE
C I/O
      INCLUDE 'iochan.inc'
      CHARACTER*(*) MODE, NAME
      INTEGER MAXLEN, LENGTH
      LOGICAL QOPEN, QFORM, QWRITE
C DEC Alpha
      logical qexist
      INTEGER UNIT, III, I
C begin
      QOPEN=.TRUE.
      IF (MODE.EQ.'FILE'.AND.NAME.EQ.'INPUT') THEN
      UNIT=5
      ELSE IF (MODE.EQ.'FILE'.AND.NAME.EQ.'OUTPUT') THEN
      UNIT=6
      ELSE IF (MODE.EQ.'FILE') THEN
C 
      inquire(file=name,exist=qexist)
      if (qexist) then
      INQUIRE(FILE=NAME,OPENED=QOPEN,NUMBER=UNIT)
      else
        qopen=.false.
        unit=-1
      endif
      ELSE IF (MODE.EQ.'UNIT') THEN
      IF (IFREEU(UNIT).NE.0) THEN
         IF (UNIT.EQ.5) THEN
            NAME='INPUT'
         ELSE IF (UNIT.EQ.6) THEN
            NAME='OUTPUT'
         ELSE
            NAME=' '
            INQUIRE(UNIT=UNIT,OPENED=QOPEN,NAME=NAME)
         END IF
         LENGTH=MAXLEN
         CALL TRIMM(NAME,LENGTH)
C
C modification ATB 5/28/08
C strip the UNIX pathname if present
         III=0
         DO I=1,LENGTH
            IF (NAME(I:I).EQ.'/') THEN
               III=I
            END IF
         END DO
         IF (III.GT.0) THEN
            DO I=1,LENGTH-III
               NAME(I:I)=NAME(III+I:III+I)
            END DO
            LENGTH=LENGTH-III
         END IF
C end modification
C
         IF (LENGTH.EQ.0.AND.QOPEN) THEN
            NAME='?'
            LENGTH=1
         END IF
      ELSE
         QOPEN=.FALSE.
      END IF
      END IF
C
C if file is open then get QFORM and QWRITE flags
      IF (QOPEN) THEN
      IF ((+1).EQ.(IFREEU(UNIT))) THEN
      QFORM=.TRUE.
      QWRITE=.TRUE.
      ELSE IF ((+10).EQ.(IFREEU(UNIT))) THEN
      QFORM=.TRUE.
      QWRITE=.FALSE.
      ELSE IF ((-1).EQ.(IFREEU(UNIT))) THEN
      QFORM=.FALSE.
      QWRITE=.TRUE.
      ELSE IF ((-10).EQ.(IFREEU(UNIT))) THEN
      QFORM=.FALSE.
      QWRITE=.FALSE.
      END IF
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE VCLOSE(UNIT,DISPOS,ERR)
C
C closes a file/unit with disposition DISPOS and sets the
C corresponding IFREEU element to zero.  It does not
C close standard input (unit=5) or standard output (unit=6)
C
C ++++++++++++++++++++
C generic unix version
C ++++++++++++++++++++
C
C By Axel Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'iochan.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'timer.inc'
      INTEGER UNIT
      CHARACTER*(*) DISPOS
      LOGICAL ERR
C begin
      ERR=.FALSE.
C
C close all units, except standard input and output, ATB 2/21/10
      IF (UNIT.NE.6.AND.UNIT.NE.5) THEN
C
C 12/28/06, ATB
      IF (DISPOS(1:4).EQ.'DELE') THEN
      CLOSE(UNIT=UNIT,STATUS='DELETE',ERR=9999)
      ELSE
C
C default status is 'KEEP'
      CLOSE(UNIT=UNIT,ERR=9999) 
      END IF
C
C reassign PUNIT and DUNIT to standard output, ATB 2/21/10
      IF (DUNIT.EQ.UNIT) THEN
         DUNIT=6
         IF (WRNLEV.GE.5) THEN
            WRITE(6,'(A)')' VCLOSE: Display file reset to OUTPUT.'
         END IF
      END IF
      IF (PUNIT.EQ.UNIT) THEN
         PUNIT=6
         IF (WRNLEV.GE.5) THEN
            WRITE(6,'(A)')' VCLOSE: Print file reset to OUTPUT.'
         END IF
      END IF
C
      IFREEU(UNIT)=0
      END IF
      GOTO 8888
9999  CONTINUE
      WRITE(6,'(A)') ' %VCLOSE-ERR: error during close '
      ERR=.TRUE.
8888  CONTINUE
      RETURN
      END
C=====================================================================
      SUBROUTINE XXNXTFI(WD,WDLEN,WDMAX)
C
C does machine-dependent filename expansion/modification
C
C I/O
      IMPLICIT NONE
      CHARACTER*(*) WD
      INTEGER WDLEN, WDMAX
C local
      INTEGER L, LL, LLL, MXPATH
      PARAMETER (MXPATH=132)
      CHARACTER*(MXPATH) PATH, TEMP
      LOGICAL GOTIT
C begin
      GOTIT=.FALSE.
      LL=0
      DO WHILE (LL.LT.WDLEN.AND..NOT.GOTIT)
      LL=LL+1
      IF (WD(LL:LL).EQ.':'.AND.LL.GT.1) THEN
C
C   name DISK:file-name is translated to the value
C   of the ENVIRONMENT variable  DISK  , defined by
C
C         setenv DISK  path-name,
C
C   DISK:file-name ------>  path-name/file-name
C
      CALL GETENV(WD(1:LL-1),PATH)
      L=MXPATH
      CALL TRIMM(PATH,L)
      GOTIT=.TRUE.
      END IF
      END DO
C
      IF (GOTIT.AND.L.EQ.0) THEN
      TEMP='invalid or unknown path-name: "'//WD(1:LL-1)//'"'
      L=MXPATH
      CALL TRIMM(TEMP,L)
      CALL DSPERR('XXNXTFI',TEMP(1:L))
      ELSE IF (GOTIT) THEN
      CALL COPYST(TEMP,MXPATH,LLL,PATH,L)
      CALL ADDST(TEMP,MXPATH,LLL,'/',1)
      IF (WDLEN-LL.GT.0) THEN
      CALL ADDST(TEMP,MXPATH,LLL,WD(LL+1:WDLEN),WDLEN-LL)
      END IF
      CALL COPYST(WD,WDMAX,WDLEN,TEMP,LLL)
      END IF
C
      RETURN
      END
C=====================================================================
      SUBROUTINE GETLIN(UNIT,COMLYN,COMMAX,COMLEN,EOF,ERROR)
C
C gets a line from UNIT
C
      IMPLICIT NONE
C input/output
      INTEGER UNIT
      CHARACTER*(*) COMLYN
      INTEGER COMMAX, COMLEN
      LOGICAL EOF, ERROR
C local
C begin
      READ(UNIT,'(A)',END=6666,ERR=7777) COMLYN
      COMLEN=COMMAX
      CALL TRIMM(COMLYN,COMLEN)
C
C a carriage return is treated like a blank
      COMLEN=COMLEN+1
      COMLYN(COMLEN:COMLEN)=' '
C
      GOTO 8888
6666  EOF=.TRUE.
      COMLEN=1
      COMLYN=' '
      GOTO 8888
7777  ERROR=.TRUE.
      WRITE(6,'(A)') ' %GETLIN-ERR: ERROR reading stream file'
      WRITE(6,*)     ' UNIT=',UNIT
      WRITE(6,*)     ' COMLYN=',COMLYN(1:80)
8888  CONTINUE
      RETURN
      END
C
C=====================================================================
C
      INTEGER FUNCTION ICHAR4(N)
C
C routine returns length needed to CHARACTER*4 arrays
C should be used only in connection with CALLST,
C CINIST, CFREST. The reason for putting in these
C special CHARACTER*4 routines is that there is no equivalence
C possible between a real or integer word.
C and a CHARACTER*4 word.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INTEGER N
C local
      ICHAR4=N
      RETURN
      END
C======================================================================
      INTEGER FUNCTION IREAL8(N)
C
C This routine computes lengths needed to double precision
C temporary space.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INTEGER N
C local
      IREAL8=2*N
      RETURN
      END
C======================================================================
      INTEGER FUNCTION ICPLX8(N)
C
C This routine computes lengths needed to double complex
C temporary space.
C
C Author: Axel T. Brunger
      IMPLICIT NONE
C input/output
      INTEGER N
C local
      ICPLX8=4*N
      RETURN
      END
C======================================================================
      INTEGER FUNCTION ICPLX4(N)
C
C This routine computes lengths needed to single complex
C temporary space.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INTEGER N
C local
      ICPLX4=2*N
      RETURN
      END
C======================================================================
      INTEGER FUNCTION IREAL4(N)
C
C This routine computes lengths needed for single precision
C temporary space.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C intput/output
      INTEGER N
C begin
      IREAL4=N
      RETURN
      END
C
C=====================================================================
C
      INTEGER FUNCTION INTEG4(N)
C
C This routine computes lengths needed for integer
C temporary space.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C intput/output
      INTEGER N
C begin
      INTEG4=N
      RETURN
      END
C
C=====================================================================
C
      INTEGER FUNCTION ILOGIC(N)
C
C This routine computes lengths needed for logical
C temporary space.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C intput/output
      INTEGER N
C begin
      ILOGIC=N
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE SETBSL(BACKSL)
C
C Set variable 'backsl' to backslash character
C
      IMPLICIT NONE
C
      CHARACTER*1 BACKSL
C
      BACKSL = '\\'
C
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE VHOSTNAME(HOSTNM, HNLEN)
      IMPLICIT NONE
C I/O
      CHARACTER*(*)  HOSTNM
      INTEGER        HNLEN
C
C Get host name
C
C local
      CHARACTER  CNAME*256
C begin
      HOSTNM=' '
      CALL GETENV('HOST', CNAME)
      IF (CNAME .EQ. ' ') THEN
        HOSTNM='hostname unknown'
        HNLEN=MIN(16,LEN(HOSTNM))
      ELSE
        HOSTNM=CNAME
        HNLEN=LEN(HOSTNM)
        CALL TRIMM(HOSTNM, HNLEN)
      END IF
C
      RETURN
      END
C
C=====================================================================
C
      SUBROUTINE CNSHELP(STRING)
C
      IMPLICIT NONE
C
      INCLUDE 'cns.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'comand.inc'
C
      CHARACTER*(*) STRING
C
      INTEGER MXPATH
      PARAMETER (MXPATH=132)
      CHARACTER*(MXPATH) PATH
      INTEGER IUNIT, STLEN
      CHARACTER*(COMMAX) LINE
      LOGICAL ERR, QEXIST
C begin
      CALL GETENV('CNS_HELPLIB',PATH)
      STLEN=MXPATH
      CALL TRIMM(PATH,STLEN)
C
      IF (STLEN.EQ.0) THEN
      WRITE(6,'(A)')' %CNS-HELP-ERR: CNS_HELPLIB undefined'
      ELSE
      IF ( WRNLEV.GE.10 ) THEN
      WRITE(6,'(A,A)')' CNS-HELP: Help library is ',
     &                PATH(1:STLEN)
      END IF
C
      IF ( PATH(STLEN:STLEN).NE.'/' ) THEN
      IFILE=PATH(1:STLEN) // '/' // STRING(1:LEN(STRING))
      STLEN=STLEN + LEN(STRING) + 1
      ELSE
      IFILE=PATH(1:STLEN) // STRING(1:LEN(STRING))
      STLEN=STLEN + LEN(STRING)
      END IF
C
      INQUIRE(FILE=IFILE(1:STLEN),EXIST=QEXIST)
      IF (QEXIST) THEN
      CALL ASSFIL(IFILE(1:STLEN),IUNIT,'READ','FORMATTED',ERR)
      IF ( .NOT.ERR ) THEN
      WRITE (6,'(1X)')
 5    CONTINUE
      READ(IUNIT,'(A)',END=11,ERR=10) LINE
      STLEN=COMMAX
      CALL TRIMM(LINE,STLEN)
      WRITE (6,'(1X,A)') LINE(1:STLEN)
      GOTO 5
 10   WRITE (6,'(A)')
     &    ' %CNS-HELP-ERR: Error reading from help library file'
      WRITE (6,'(A,A)')
     &    ' %CNS-HELP-ERR: check ',IFILE(1:STLEN)
 11   CONTINUE
      CALL VCLOSE(IUNIT,'KEEP',ERROR)
      WRITE (6,'(1X)')
      ELSE
      WRITE (6,'(A)')
     &    ' %CNS-HELP-ERR: Error opening help library file'
      WRITE (6,'(A,A)')
     &    ' %CNS-HELP-ERR: check ',IFILE(1:STLEN)
      END IF
      ELSE
      WRITE (6,'(A)')
     &    ' %CNS-HELP-ERR: Help library file does not exist'
      WRITE (6,'(A,A)')
     &    ' %CNS-HELP-ERR: check ',IFILE(1:STLEN)
      END IF
      END IF
C
      RETURN
      END
C
C======================================================================
C

C     ------------------------------------------------------------------
      SUBROUTINE FANTALIN (ATOMIPTR,ATOMJPTR,ATOMKPTR,ATOMLPTR,ATOMMPTR,
     &                     ATOMNPTR,ATOMILST,ATOMJLST,ATOMKLST,ATOMLLST,
     &                     ATOMMLST,ATOMNLST,XPCSOBS,XPCSERR,NCLASS,
     &                     NOMEFILE)
C     ------------------------------------------------------------------
C     Fits pseudocontact shift tensor on a given structure
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xdipo_pcs.inc"
      INCLUDE  "consta.inc"
      INCLUDE  "fantaxplor.inc"
      INCLUDE  'heap.inc'

      DOUBLE PRECISION APARA,APERP
      COMMON /FRUN/APERP,APARA
      INTEGER FSWITCH,FSAVE,FERR
      COMMON /FPARAM/FSWITCH,FSAVE,FERR
      INTEGER FVIOLS
      COMMON /VIOL/FVIOLS
      DOUBLE PRECISION FENERGTOT
      COMMON /FENERG/ FENERGTOT
      DOUBLE PRECISION XPCSE
      COMMON /XPCSENERGY/ XPCSE
      DOUBLE PRECISION FENT(20,2000),FPER(20,2000),FPAR(20,2000),
     &                 FXPCSE(20,2000)
      INTEGER CONTSAVE(20)
      COMMON /FMEDIA/FENT,FPER,FPAR,FXPCSE,CONTSAVE
      CHARACTER NOMEFILE*132
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*),ATOMLPTR(*)
      INTEGER ATOMMPTR(*),ATOMNPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*),ATOMLLST(*)
      INTEGER ATOMMLST(*),ATOMNLST(*)
      INTEGER COUNT,MM,NN,I,J,K,L,NA,M,N,CLASS,NORES
      INTEGER NCLASS,NNCO,NNCC
      DOUBLE PRECISION XPCSOBS(*),XPCSERR(*)
      DOUBLE PRECISION OBSXPCS,ERRXPCS
      DOUBLE PRECISION XI,XJ,XK,XL,XM,XN,YI,YJ,YK,YL,YM,YN,
     &                 ZI,ZJ,ZK,ZL,ZM,ZN
      DOUBLE PRECISION XFA(1000),YFA(1000),ZFA(1000),
     &                 XMFA(1000),YMFA(1000),ZMFA(1000),
     &                 ERRFA(1000),OBSFA(1000),
     &                 WPROT(1000)
      DOUBLE COMPLEX DUMMY2
C     ------------------------------------------------------------------
C     CLASS must remain this during the cycle of variables exchange.
C     The class is defined by NCLASS.
C     ------------------------------------------------------------------
      CLASS=1
      NNCO=0
      NNCC=0
      COUNT=0

      PRINT*,'This is FANTALIN for PCS.'
      PRINT*,'PCSNUM is:',PCSNUM

      DO WHILE (COUNT.LT.PCSNUM)
         COUNT=COUNT+1
         DO WHILE ((XPCSASSNDX(CLASS).LT.COUNT).OR.
     &            (XPCSASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO
         IF (XPCSASSNDX(CLASS).EQ.XPCSASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         IF (NCLASS.EQ.CLASS) THEN
             NNCO=NNCO+1
             I=ATOMIPTR(COUNT)+1
             J=ATOMJPTR(COUNT)+1
             K=ATOMKPTR(COUNT)+1
             L=ATOMLPTR(COUNT)+1
             XI=X(ATOMILST(I))
             XJ=X(ATOMJLST(J))
             XK=X(ATOMKLST(K))
             XL=X(ATOMLLST(L))
             YI=Y(ATOMILST(I))
             YJ=Y(ATOMJLST(J))
             YK=Y(ATOMKLST(K))
             YL=Y(ATOMLLST(L))
             ZI=Z(ATOMILST(I))
             ZJ=Z(ATOMJLST(J))
             ZK=Z(ATOMKLST(K))
             ZL=Z(ATOMLLST(L))
             OBSFA(NNCO)=XPCSOBS(COUNT)
             OBSXPCS=XPCSOBS(COUNT)
             ERRFA(NNCO)=XPCSERR(COUNT)
             ERRXPCS=XPCSERR(COUNT)
         END IF

         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               IF (NCLASS.EQ.CLASS) THEN
                   NNCC=NNCC+1
                   XMFA(NNCC)=X(ATOMMLST(MM))
                   XFA(NNCC)=X(ATOMNLST(NN))
                   YMFA(NNCC)=Y(ATOMMLST(MM))
                   YFA(NNCC)=Y(ATOMNLST(NN))
                   ZMFA(NNCC)=Z(ATOMMLST(MM))
                   ZFA(NNCC)=Z(ATOMNLST(NN))
                   NORES=ATOMNLST(NN)
                   NRESIDFA(NNCC)=RESID(NORES)
                   NRESFA(NNCC)=RES(NORES)
                   NTYPEFA(NNCC)=TYPE(NORES)
               END IF
            END DO
         END DO
      END DO

      IF (NNCC.EQ.NNCO) THEN
          CALL FANTALINEXE(XFA,YFA,ZFA,XMFA,YMFA,ZMFA,NNCO,OBSFA,ERRFA,
     &                     1,NOMEFILE,WPROT,0,PCSFLG)
          PRINT*,'FERR is:',FERR
          IF (FERR.EQ.1) THEN
              CALL FANTAERRORE(XFA,YFA,ZFA,XMFA,YMFA,ZMFA,NNCO,OBSFA,
     &                         ERRFA,1,PCSFLG)
          END IF
      ELSE
          PRINT*,'Error in atom count...'
      END IF

      PRINT *,'FSWITCH is:',FSWITCH
      IF (FSWITCH.EQ.1) THEN
          XPCSCOEF1(NCLASS)=APARA
          XPCSCOEF2(NCLASS)=APERP
          PRINT*,'For class:',NCLASS
          PRINT*,'New value for A1 =',APARA
          PRINT*,'New value for A2 =',APERP
      END IF

      IF (FSAVE.EQ.1) THEN
          CONTSAVE(NCLASS)=CONTSAVE(NCLASS)+1
          FENT(NCLASS,CONTSAVE(NCLASS))=FENERGTOT
          FXPCSE(NCLASS,CONTSAVE(NCLASS))=XPCSE
          FPAR(NCLASS,CONTSAVE(NCLASS))=APARA
          FPER(NCLASS,CONTSAVE(NCLASS))=APERP
          PRINT*,'Value of A1 =',FPAR(NCLASS,CONTSAVE(NCLASS))
          PRINT*,'Value of A2 =',FPER(NCLASS,CONTSAVE(NCLASS))
          PRINT*,'Total energy =',FENERGTOT
          PRINT*,'XDIPO_PCS energy =',XPCSE
          PRINT*,'CONTSAVE is:',CONTSAVE(NCLASS)
      END IF

      CALL DECLAR('CHIAX','DP',' ',DUMMY2,APARA)
      CALL DECLAR('CHIRH','DP',' ',DUMMY2,APERP)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE FANTAMEDIA (FMA,PERC)
C     ------------------------------------------------------------------
C     Averages tensor parameters on a given sub-ensemble of structures
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE
      DOUBLE PRECISION VETE(2,2000),VETT(3,2000)
      DOUBLE PRECISION FENT(20,2000),FPER(20,2000),FPAR(20,2000),
     &                 FXPCSE(20,2000)
      COMMON /FMEDIA/FENT,FPER,FPAR,FXPCSE,CONTSAVE
      INTEGER CONTSAVE(20)
      INTEGER FMA,COUNT,CB,COUNT1,NUM,CONFPRE
      DOUBLE PRECISION PERC
      DOUBLE PRECISION M1PAR,M1PER,DEVPAR
      DOUBLE COMPLEX DUMMY2
C     ------------------------------------------------------------------
C     Through FMA the class on which the average must be done is passed.
C     If it is zero, all the counters are reset.
C     ------------------------------------------------------------------
      IF (FMA.EQ.0) THEN
          DO COUNT=1,19
             CONTSAVE(COUNT)=0
          END DO
          PRINT*,'Mean vectors reset.'
      ELSE
C     ------------------------------------------------------------------
C     The best are selected
C     ------------------------------------------------------------------
          DO COUNT=1,CONTSAVE(FMA)
             VETE(1,COUNT)=0
          END DO

          DO COUNT=1,CONTSAVE(FMA)
             NUM=CONTSAVE(FMA)
             DO WHILE (VETE(1,NUM).EQ.1)
                NUM=NUM-1
             END DO
             DO COUNT1=1,CONTSAVE(FMA)-1
                IF ((FENT(FMA,COUNT1).LE.FENT(FMA,NUM)).AND.
     &              (VETE(1,COUNT1).EQ.0.0)) THEN
                     NUM=COUNT1
                END IF
             END DO
             PRINT*,'NUM is:',NUM
             VETE(1,NUM)=1
             VETE(2,COUNT)=FENT(FMA,NUM)
             VETT(1,COUNT)=FPAR(FMA,NUM)
             VETT(2,COUNT)=FPER(FMA,NUM)
          END DO

          CONFPRE=NINT((DBLE(CONTSAVE(FMA))*(PERC/100.)))
          IF (CONFPRE.EQ.0) THEN
              CONFPRE=1
          END IF
          PRINT*,'CONFPRE is:',CONFPRE
          PRINT*,'PERC is:',PERC
          PRINT*,'DBLE(CONTSAVE(FMA)) is:',DBLE(CONTSAVE(FMA))

          DO COUNT=1,CONTSAVE(FMA)
             PRINT*,'NUMBER',COUNT,'ENERGY',VETE(1,COUNT),VETE(2,COUNT)
             PRINT*,'A1',VETT(1,COUNT),' A2',VETT(2,COUNT)
          END  DO

          CB=0
          M1PAR=0
          M1PER=0
          DO COUNT=1,CONFPRE
             M1PAR=M1PAR+VETT(1,COUNT)
             M1PER=M1PER+VETT(2,COUNT)
             CB=CB+1
             PRINT*,'A1 =',VETT(1,COUNT),'A2 =',VETT(2,COUNT)
          END DO
          M1PAR=M1PAR/CB
          M1PER=M1PER/CB

          CB=0
          DEVPAR=0
          DO COUNT=1,CONFPRE
             DEVPAR=DEVPAR+(VETT(1,COUNT)-M1PAR)**2
          END DO
          DEVPAR=DEVPAR/CONFPRE
          PRINT*,'Averaged new A1 =',M1PAR
          PRINT*,'Averaged new A2 =',M1PER
          PRINT*,'Standard deviation for new A1 =',SQRT(DEVPAR)

          CALL DECLAR('CHIAX','DP',' ',DUMMY2,M1PAR)
          CALL DECLAR('CHIRH','DP',' ',DUMMY2,M1PER)

      END IF

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE FANTAERRORE (XPX,XPY,XPZ,XPMX,XPMY,XPMZ,NNAT,XOBS,
     &                        XTOLPROT,METHOD,LOCFLG)
C     ------------------------------------------------------------------
C     Calculates error on tensor parameters through Monte Carlo method
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      DOUBLE PRECISION APARA,APERP
      COMMON /FRUN/ APERP,APARA
      DOUBLE PRECISION ERRPARA(10000),ERRRH(10000)
      DOUBLE PRECISION FEPERC
      INTEGER FENUMC
      COMMON /FERRORE/FEPERC,FENUMC
      DOUBLE PRECISION FDEPERC
      INTEGER FDENUMC
      COMMON /FDERRORE/FDEPERC,FDENUMC
      DOUBLE PRECISION XPX(1000),XPY(1000),XPZ(1000),
     &                 XOBS(1000),XTOLPROT(1000)
      CHARACTER NOMEFILE*132
      DOUBLE PRECISION  XPMX(1000),XPMY(1000),XPMZ(1000),WPROT(1000)
      INTEGER NNAT,METHOD,I,A,J,IA,AA,SEL
      DOUBLE PRECISION RAND,MEDERRPARA,DEVERRPARA,DEVERRRH,MEDERRRH
      LOGICAL LOCFLG

      IF (METHOD.EQ.0) THEN
          FENUMC=FDENUMC
          FEPERC=FDEPERC
      END IF
      NOMEFILE='MONTECARLO.OUT'
      PRINT*,'FEPERC is:',FEPERC

      DO A=1,FENUMC
         J=0
         DO I=1,NNAT
            WPROT(I)=1
         END DO
         AA=NINT(FEPERC*NNAT)
         PRINT*,'AA is:',AA
         IA=0
         DO WHILE (IA.LT.AA)
            SEL=NINT(RAND()*DBLE(NNAT))
            PRINT*,'SEL IS:',SEL
            IF (WPROT(SEL).EQ.1) THEN
                WPROT(SEL)=0
                IA=IA+1
            END IF
         END DO
         CALL FANTALINEXE(XPX,XPY,XPZ,XPMX,XPMY,XPMZ,NNAT,XOBS,XTOLPROT,
     &                    METHOD,NOMEFILE,WPROT,1,LOCFLG)
         ERRPARA(A)=APARA
         ERRRH(A)=APERP
         PRINT*,'A1 =',APARA
         PRINT*,'A2 =',APERP
      END DO

      MEDERRPARA=0
      MEDERRRH=0
      DO A=1,FENUMC
         MEDERRPARA=ERRPARA(A)+MEDERRPARA
         MEDERRRH=ERRRH(A)+MEDERRRH
      END DO
      MEDERRPARA=MEDERRPARA/DBLE(FENUMC)
      MEDERRRH=MEDERRRH/DBLE(FENUMC)

      DEVERRRH=0
      DEVERRPARA=0
      DO A=1,FENUMC
         DEVERRPARA=DEVERRPARA+(ERRPARA(A)-MEDERRPARA)**2
         DEVERRRH=DEVERRRH+(ERRRH(A)-MEDERRRH)**2
      END DO
      DEVERRPARA=DEVERRPARA/DBLE(FENUMC)
      DEVERRRH=DEVERRRH/DBLE(FENUMC)

      PRINT*,'Standard deviation for A1 =',SQRT(DEVERRPARA)
      PRINT*,'Standard deviation for A2 =',SQRT(DEVERRRH)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE EXPCS (EDI,WHICH)
C     ------------------------------------------------------------------
C     Calls EXPCS2, which does the actual energy calculation
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "cns.inc"
      INCLUDE "xdipo_pcs.inc"
      INCLUDE "heap.inc"

      DOUBLE PRECISION EDI
      CHARACTER*7 WHICH

      CALL EXPCS2 (EDI,HEAP(XPCSIPTR),HEAP(XPCSJPTR),HEAP(XPCSKPTR),
     &                 HEAP(XPCSLPTR),HEAP(XPCSMPTR),HEAP(XPCSNPTR),
     &                 HEAP(XPCSILST),HEAP(XPCSJLST),HEAP(XPCSKLST),
     &                 HEAP(XPCSLLST),HEAP(XPCSMLST),HEAP(XPCSNLST),
     &                 HEAP(XPCSOBSPTR),HEAP(XPCSERRPTR),
     &                 HEAP(CALCXPCSPTR),WHICH)
      
      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE EXPCS2 (EDI,ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                       ATOMLPTR,ATOMMPTR,ATOMNPTR,
     &                       ATOMILST,ATOMJLST,ATOMKLST,
     &                       ATOMLLST,ATOMMLST,ATOMNLST,
     &                       XPCSOBS,XPCSERR,XPCSCALC,WHICH)
C     ------------------------------------------------------------------
C     Calculates pseudocontact shift energies
C
C     Energies are of the form:
C        E = K*(DELTAPCS**2)
C     where:
C        K = FORCE CONSTANT
C        DELTAPCS = CALCULATED PCS - OBSERVED PCS
C     and pseudocontact shift function is defined as:
C        PCS=A1*(3*COS(THETA)^2-1)+(3/2)*A2*(SIN(THETA)^2*COS(2*PHI))/R3
C
C     WHICH is a flag that switches between energy/force calculations
C     and PCS calculations for violations
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xdipo_pcs.inc"
      INCLUDE  "consta.inc"

      DOUBLE PRECISION XPCSE
      COMMON /XPCSENERGY/XPCSE
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*)
      DOUBLE PRECISION XPCSOBS(*),XPCSERR(*)
      DOUBLE PRECISION XPCSCALC(*),EDI
      CHARACTER*7 WHICH
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER COUNT,CLASS,MM,NN,II,I,J,K,L,NA,M,N
      PARAMETER (NA=20)
      INTEGER DMM,DNN,OUTFLAG(NA),MCOUNT,NCOUNT,PCOUNT
      DOUBLE PRECISION XI,XJ,XK,XL,XM,XN,YI,YJ,YK,YL,YM,YN,
     &                 ZI,ZJ,ZK,ZL,ZM,ZN,
     &                 E,DF1(NA),DF2(NA),DF3(NA),
     &                 PHI(NA),DPXI(NA),DPYI(NA),DPZI(NA),
     &                 DPXJ(NA),DPYJ(NA),DPZJ(NA),DPXK(NA),
     &                 DPYK(NA),DPZK(NA),DPXL(NA),DPYL(NA),
     &                 DPZL(NA),DPXM(NA),DPYM(NA),DPZM(NA),
     &                 DPXN(NA),DPYN(NA),DPZN(NA),
     &                 THETA(NA),DTXI(NA),DTYI(NA),DTZI(NA),
     &                 DTXJ(NA),DTYJ(NA),DTZJ(NA),DTXK(NA),
     &                 DTYK(NA),DTZK(NA),DTXL(NA),DTYL(NA),
     &                 DTZL(NA),DTXM(NA),DTYM(NA),DTZM(NA),
     &                 DTXN(NA),DTYN(NA),DTZN(NA),DRXM(NA),
     &                 DRYM(NA),DRZM(NA),DRXN(NA),DRYN(NA),
     &                 DRZN(NA),DIST,
     &                 O1,O2,O3,O4,O5,O6,O7,O8,O9,O10,
     &                 O11,O12,O13,O14,O15,O16,O17,O18,O19,
     &                 O20,O21,O22,O23,O24,O25,O26,O27,O28,
     &                 O29,O30,O31,O32,O33,O34,O35,O36,O37,
     &                 O38,O39,O40,O41,O42,O43,O44,O45,O46,
     &                 O47,O48,O49,O50,O51,O52,O53,O54,O55,
     &                 O56,O57,O58,O59,O60,O61,O62,O63,O64,
     &                 O65,O66,O67,O68,O69,O70,O71,O72,O73,
     &                 O74,O75,O76,O77,O78,O79,O80,O81,O82
      DOUBLE PRECISION OBSXPCS,ERRXPCS,K1,
     &                 COEF1,COEF2,A,B,DELTA,
     &                 DT,DP,DELTAXPCS,
     &                 DD,DR,CALCXPCS
C     ------------------------------------------------------------------
C     Zero out partial energy
C     ------------------------------------------------------------------
      EDI=ZERO

      CLASS=1
      K1=XPCSFORCES(1)
      COEF1=XPCSCOEF1(1)
      COEF2=XPCSCOEF2(1)

      COUNT=0
      DO WHILE (COUNT.LT.PCSNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Reset individual E to zero
C     ------------------------------------------------------------------
         E=0

         DO WHILE ((XPCSASSNDX(CLASS).LT.COUNT).OR.
     &             (XPCSASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO

         IF (XPCSASSNDX(CLASS).EQ.XPCSASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         END IF

         K1=XPCSFORCES(CLASS)
         COEF1=XPCSCOEF1(CLASS)
         COEF2=XPCSCOEF2(CLASS)
C     ------------------------------------------------------------------
C     Note there should only be one atom for I, J, K, and L
C     ------------------------------------------------------------------
         I=ATOMIPTR(COUNT)+1
         J=ATOMJPTR(COUNT)+1
         K=ATOMKPTR(COUNT)+1
         L=ATOMLPTR(COUNT)+1

         XI=X(ATOMILST(I))
         XJ=X(ATOMJLST(J))
         XK=X(ATOMKLST(K))
         XL=X(ATOMLLST(L))
         YI=Y(ATOMILST(I))
         YJ=Y(ATOMJLST(J))
         YK=Y(ATOMKLST(K))
         YL=Y(ATOMLLST(L))
         ZI=Z(ATOMILST(I))
         ZJ=Z(ATOMJLST(J))
         ZK=Z(ATOMKLST(K))
         ZL=Z(ATOMLLST(L))

         OBSXPCS=XPCSOBS(COUNT)
         ERRXPCS=XPCSERR(COUNT)
C     ------------------------------------------------------------------
C     Initialize calculated pseudocontact shift and counter
C     ------------------------------------------------------------------
         CALCXPCS=0
         II=0
         MCOUNT=0
         NCOUNT=0
C     ------------------------------------------------------------------
C     Check for correct permutations of paired atoms to get the metal-
C     nucleus vector. This depends solely on the order of the assigned 
C     atoms. OUTFLAG=1 indicates that the permutation is not allowed.
C     ------------------------------------------------------------------
         DMM=ATOMMPTR(COUNT+1)-ATOMMPTR(COUNT)
         DNN=ATOMNPTR(COUNT+1)-ATOMNPTR(COUNT)
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            MCOUNT=MCOUNT+1
            NCOUNT=0
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               NCOUNT=NCOUNT+1
               II=II+1
               IF ((DMM.GT.1).AND.(DNN.GT.1)) THEN
                   IF (MCOUNT.EQ.NCOUNT) THEN
                       OUTFLAG(II)=0
                   ELSE
                       OUTFLAG(II)=1
                   ENDIF
               ELSE
                   OUTFLAG(II)=0
               END IF
            END DO
         END DO

         II=0
         PCOUNT=0
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                  PCOUNT=PCOUNT+1
                  XM=X(ATOMMLST(MM))
                  XN=X(ATOMNLST(NN))
                  YM=Y(ATOMMLST(MM))
                  YN=Y(ATOMNLST(NN))
                  ZM=Z(ATOMMLST(MM))
                  ZN=Z(ATOMNLST(NN))
C     ------------------------------------------------------------------
C     Calculate THETA, PHI and derivatives with respect to X, Y, Z of 
C     atoms I, J, K, L, M, N. This was done with Mathematica by Nico!
C     ------------------------------------------------------------------
                  O1=-XI+XJ
                  O2=O1**2
                  O3=-YI+YJ
                  O4=O3**2
                  O5=-ZI+ZJ
                  O6=O5**2
                  O7=O2+O4+O6
                  O8=SQRT(O7)
                  O9=1/O8
                  O10=-XM+XN
                  O11=O1*O10
                  O12=-YM+YN
                  O13=O12*O3
                  O14=-ZM+ZN
                  O15=O14*O5
                  O16=O11+O13+O15
                  O17=O10**2
                  O18=O12**2
                  O19=O14**2
                  O20=O17+O18+O19
                  O21=SQRT(O20)
                  O22=1/O21
                  O23=1/O7
                  O24=O16**2
                  O25=1/O20
                  O26=O23*O24*O25
                  O27=SQRT(1.D0-O26)
                  O28=1/O27
                  O29=XM-XN
                  O30=O7**(3.D0/2.D0)
                  O31=1/O30
                  O32=O1*O16*O22*O31
                  O33=YM-YN
                  O34=O16*O22*O3*O31
                  O35=ZM-ZN
                  O36=O16*O22*O31*O5
                  O37=O20**(3.D0/2.D0)
                  O38=1/O37
                  O39=O10*O16*O38*O9
                  O40=O12*O16*O38*O9
                  O41=O14*O16*O38*O9
                  O42=-XI+XK
                  O43=O42**2
                  O44=-YI+YK
                  O45=O44**2
                  O46=-ZI+ZK
                  O47=O46**2
                  O48=O43+O45+O47
                  O49=SQRT(O48)
                  O50=-XI+XL
                  O51=O50**2
                  O52=-YI+YL
                  O53=O52**2
                  O54=-ZI+ZL
                  O55=O54**2
                  O56=O51+O53+O55
                  O57=SQRT(O56)
                  O58=1/O57
                  O59=O10*O42
                  O60=O12*O44
                  O61=O14*O46
                  O62=O59+O60+O61
                  O63=1/O62
                  O64=O10*O50
                  O65=O12*O52
                  O66=O14*O54
                  O67=O64+O65+O66
                  O68=O62**2
                  O69=1/O68
                  O70=O56**(3.D0/2.D0)
                  O71=1/O70
                  O72=O49*O50*O63*O67*O71
                  O73=1/O49
                  O74=O42*O58*O63*O67*O73
                  O75=1/O56
                  O76=O67**2
                  O77=O48*O69*O75*O76
                  O78=1/(1.D0+O77)
                  O79=O49*O52*O63*O67*O71
                  O80=O44*O58*O63*O67*O73
                  O81=O49*O54*O63*O67*O71
                  O82=O46*O58*O63*O67*O73

                  THETA(II)=ACOS(O16*O22*O9)

                  DTXI(II)=-(O28*(O32+O22*O29*O9))
                  DTYI(II)=-(O28*(O34+O22*O33*O9))
                  DTZI(II)=-(O28*(O36+O22*O35*O9))
                  DTXJ(II)=-(O28*(-O32+O10*O22*O9))
                  DTYJ(II)=-(O28*(-O34+O12*O22*O9))
                  DTZJ(II)=-(O28*(-O36+O14*O22*O9))
                  DTXK(II)=0
                  DTYK(II)=0
                  DTZK(II)=0
                  DTXL(II)=0
                  DTYL(II)=0
                  DTZL(II)=0
                  DTXM(II)=-(O28*(O39+O22*O9*(XI-XJ)))
                  DTYM(II)=-(O28*(O40+O22*O9*(YI-YJ)))
                  DTZM(II)=-(O28*(O41+O22*O9*(ZI-ZJ)))
                  DTXN(II)=-(O28*(-O39+O1*O22*O9))
                  DTYN(II)=-(O28*(-O40+O22*O3*O9))
                  DTZN(II)=-(O28*(-O41+O22*O5*O9))

                  PHI(II)=ATAN(O49*O58*O63*O67)

                  DPXI(II)=O78*(O29*O49*O58*O63-O29*O49*O58*O67*O69+
     &                          O72-O74)
                  DPYI(II)=O78*(O33*O49*O58*O63-O33*O49*O58*O67*O69+
     &                          O79-O80)
                  DPZI(II)=O78*(O35*O49*O58*O63-O35*O49*O58*O67*O69+
     &                          O81-O82)
                  DPXJ(II)=0
                  DPYJ(II)=0
                  DPZJ(II)=0
                  DPXK(II)=(-(O10*O49*O58*O67*O69)+O74)*O78
                  DPYK(II)=O78*(-(O12*O49*O58*O67*O69)+O80)
                  DPZK(II)=O78*(-(O14*O49*O58*O67*O69)+O82)
                  DPXL(II)=(O10*O49*O58*O63-O72)*O78
                  DPYL(II)=O78*(O12*O49*O58*O63-O79)
                  DPZL(II)=O78*(O14*O49*O58*O63-O81)
                  DPXM(II)=O78*(-(O49*O58*O67*O69*(XI-XK))+
     &                            O49*O58*O63*(XI-XL))
                  DPYM(II)=O78*(-(O49*O58*O67*O69*(YI-YK))+
     &                            O49*O58*O63*(YI-YL))
                  DPZM(II)=O78*(-(O49*O58*O67*O69*(ZI-ZK))+
     &                            O49*O58*O63*(ZI-ZL))
                  DPXN(II)=(O49*O50*O58*O63-O42*O49*O58*O67*O69)*O78
                  DPYN(II)=(O49*O52*O58*O63-O44*O49*O58*O67*O69)*O78
                  DPZN(II)=(O49*O54*O58*O63-O46*O49*O58*O67*O69)*O78
C     ------------------------------------------------------------------
C     Calculate the distance between the two atoms M, N (metal-nucleus)
C     and calculate the derivatives as well
C     ------------------------------------------------------------------
                  O1=-XM+XN
                  O2=O1**2
                  O3=-YM+YN
                  O4=O3**2
                  O5=-ZM+ZN
                  O6=O5**2
                  O7=O2+O4+O6
                  O8=SQRT(O7)
                  O9=1/O8
                  O10=O1*O9
                  O11=O3*O9
                  O12=O5*O9
                  DIST=O8
                  DRXM(II)=-O10
                  DRYM(II)=-O11
                  DRZM(II)=-O12
                  DRXN(II)=O10
                  DRYN(II)=O11
                  DRZN(II)=O12
C     ------------------------------------------------------------------
C     Calculate the pseudocontact shift
C     ------------------------------------------------------------------
                  A=COEF1
                  B=COEF2
                  CALCXPCS=(A*(3.*COS(THETA(II))*COS(THETA(II))-1.)+
     &                      B*(3./2.)*(SIN(THETA(II))*SIN(THETA(II))*
     &                      COS(2.*PHI(II))))/(DIST**3.0)
               END IF
            END DO
         END DO

         IF (WHICH.EQ.'ANALYZE') THEN
            XPCSCALC(COUNT)=CALCXPCS
         END IF

         DELTA=(CALCXPCS-OBSXPCS)
C     ------------------------------------------------------------------
C     Adjust the deviation based on the error range
C     ------------------------------------------------------------------
         IF ((DELTA.LT.0.000).AND.(ABS(DELTA).GT.ERRXPCS)) THEN
              DELTAXPCS=DELTA+ERRXPCS
         ELSE IF ((DELTA.GT.0.000).AND.(DELTA.GT.ERRXPCS)) THEN
              DELTAXPCS=DELTA-ERRXPCS
         ELSE
              DELTAXPCS=0.0
         END IF
         DD=DELTAXPCS

         II = 0
         PCOUNT = 0
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               II = II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT + 1
C     ------------------------------------------------------------------
C     Taking care of derivative
C     ------------------------------------------------------------------
                   DT=(1.0/(DIST**3))*(A*(-6.)*SIN(THETA(II))*
     &                   COS(THETA(II))+B*3.*SIN(THETA(II))*
     &                   COS(THETA(II))*COS(2.*PHI(II)))
                   DP=(1.0/DIST**3)*(B*(-3.)*SIN(THETA(II))*
     &                   SIN(THETA(II))*SIN(2.*PHI(II)))
                   DR=(-3.0/(DIST**4))*(A*(3.*COS(THETA(II))*
     &                   COS(THETA(II))-1.)+B*(3./2.)*
     &                   (SIN(THETA(II))*SIN(THETA(II))*
     &                   COS(2.*PHI(II))))
                  IF (DD.EQ.0.0) THEN
                      E=E+0.0
                      DF1(II)=0.0
                      DF2(II)=0.0
                      DF3(II)=0.0
                  ELSE
                      E=E+K1*(DELTAXPCS**2)
                      DF1(II)=2*K1*DELTAXPCS*DT
                      DF2(II)=2*K1*DELTAXPCS*DP
                      DF3(II)=2*K1*DELTAXPCS*DR
                  END IF
               END IF
            END DO
         END DO
C     ------------------------------------------------------------------
C     Accumulate energy
C     ------------------------------------------------------------------
         EDI=EDI+E
C     ------------------------------------------------------------------
C     Now update forces if in energy/force mode
C     ------------------------------------------------------------------
         IF (WHICH.NE.'ANALYZE') THEN
             II = 0
             DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
                DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
                   II=II+1
                   IF (OUTFLAG(II).NE.1) THEN
                       DX(ATOMILST(I))=DX(ATOMILST(I))+
     &                                 DF1(II)*DTXI(II)+DF2(II)*DPXI(II)
                       DY(ATOMILST(I))=DY(ATOMILST(I))+
     &                                 DF1(II)*DTYI(II)+DF2(II)*DPYI(II)
                       DZ(ATOMILST(I))=DZ(ATOMILST(I))+
     &                                 DF1(II)*DTZI(II)+DF2(II)*DPZI(II)
                       DX(ATOMJLST(J))=DX(ATOMJLST(J))+
     &                                 DF1(II)*DTXJ(II)+DF2(II)*DPXJ(II)
                       DY(ATOMJLST(J))=DY(ATOMJLST(J))+
     &                                 DF1(II)*DTYJ(II)+DF2(II)*DPYJ(II)
                       DZ(ATOMJLST(J))=DZ(ATOMJLST(J))+
     &                                 DF1(II)*DTZJ(II)+DF2(II)*DPZJ(II)
                       DX(ATOMKLST(K))=DX(ATOMKLST(K))+
     &                                 DF1(II)*DTXK(II)+DF2(II)*DPXK(II)
                       DY(ATOMKLST(K))=DY(ATOMKLST(K))+
     &                                 DF1(II)*DTYK(II)+DF2(II)*DPYK(II)
                       DZ(ATOMKLST(K))=DZ(ATOMKLST(K))+
     &                                 DF1(II)*DTZK(II)+DF2(II)*DPZK(II)
                       DX(ATOMLLST(L))=DX(ATOMLLST(L))+
     &                                 DF1(II)*DTXL(II)+DF2(II)*DPXL(II)
                       DY(ATOMLLST(L))=DY(ATOMLLST(L))+
     &                                 DF1(II)*DTYL(II)+DF2(II)*DPYL(II)
                       DZ(ATOMLLST(L))=DZ(ATOMLLST(L))+
     &                                 DF1(II)*DTZL(II)+DF2(II)*DPZL(II)
                       DX(ATOMMLST(MM))=DX(ATOMMLST(MM))+
     &                                  DF1(II)*DTXM(II)+DF2(II)*
     &                                  DPXM(II)+DF3(II)*DRXM(II)
                       DY(ATOMMLST(MM))=DY(ATOMMLST(MM))+
     &                                  DF1(II)*DTYM(II)+DF2(II)*
     &                                  DPYM(II)+DF3(II)*DRYM(II)
                       DZ(ATOMMLST(MM))=DZ(ATOMMLST(MM))+
     &                                  DF1(II)*DTZM(II)+DF2(II)*
     &                                  DPZM(II)+DF3(II)*DRZM(II)
                       DX(ATOMNLST(NN))=DX(ATOMNLST(NN))+
     &                                  DF1(II)*DTXN(II)+DF2(II)*
     &                                  DPXN(II)+DF3(II)*DRXN(II)
                       DY(ATOMNLST(NN))=DY(ATOMNLST(NN))+
     &                                  DF1(II)*DTYN(II)+DF2(II)*
     &                                  DPYN(II)+DF3(II)*DRYN(II)
                       DZ(ATOMNLST(NN))=DZ(ATOMNLST(NN))+
     &                                  DF1(II)*DTZN(II)+DF2(II)*
     &                                  DPZN(II)+DF3(II)*DRZN(II)

                   END IF
                END DO
             END DO
         END IF
      END DO

      XPCSE=EDI

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXPCS
C     ------------------------------------------------------------------
C     Reads in pseudocontact shift information
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "cns.inc"
      INCLUDE "comand.inc"
      INCLUDE "xdipo_pcs.inc"
      INCLUDE "funct.inc"
      INCLUDE "mtf.inc"
      INCLUDE "heap.inc"
      INCLUDE "numbers.inc"

      INTEGER FSWITCH,FSAVE,FERR
      COMMON /FPARAM/FSWITCH,FSAVE,FERR
      INTEGER FVIOLS
      COMMON /VIOL/FVIOLS
      DOUBLE PRECISION FEPERC
      INTEGER FENUMC
      COMMON /FERRORE/FEPERC,FENUMC

      INTEGER COUNT,SPTR,OLDCLASS,OLDMAXXPCS,FNCLASS
      DOUBLE PRECISION K1,CUTOFF,COEF1,COEF2
      DOUBLE PRECISION FMEDPERC
      CHARACTER*4 THENAME
      CHARACTER*132 NOMEFILE
      INTEGER TOLSWI

      NOMEFILE='XDIPO_PCS.OUT'

      SPTR=ALLHP(INTEG4(NATOM))
      CALL PUSEND('XDIPO_PCS>')
862   CONTINUE
      CALL NEXTWD('XDIPO_PCS>')
      CALL MISCOM('XDIPO_PCS>',USED)
      IF (.NOT.USED) THEN
C     ------------------------------------------------------------------
C     Documentation
C     ------------------------------------------------------------------
          IF (WD(1:4).EQ.'HELP') THEN
              WRITE(DUNIT,'(10X,A)')
     &              ' XPCS {<PCS-STATEMENT>} END ',
     &              ' <PCS-STATEMENT>:== ',
     &              ' ASSIgn <SEL> <SEL> <SEL> <SEL> <SEL>',
     &              ' <REAL> <REAL>',
     &              ' * Restraint: Metal Z X Y Nucleus PCS Err *',
     &              ' CLASsification <NAME>',
     &              ' * Starts a new class *',
     &              ' TOLL <1|0>',
     &              ' * Switch tolerance in FANTALIN (1=Yes, 0=No)',
     &              ' COEFficient <REAL> <REAL>',
     &              ' * Tensor parameters: A1 A2 *',
     &              ' FORCeconstant <REAL>',
     &              ' * Force constant for the current class *',
     &              ' NREStraints <INTEGER>',
     &              ' * Number of slots for restraints to allocate *',
     &              ' PRINt THREshold <REAL>',
     &              ' * Prints violations larger than the threshold *',
     &              ' RESEt',
     &              ' * Erases the restraint table, but keeps NRES *',
     &              ' SAVE',
     &              ' * Filename to save PCS values *',
     &              ' FMED',
     &              ' * Calculates average tensor parameters *',
     &              ' ERRON',
     &              ' * Switches Monte Carlo error evaluation ON *',
     &              ' ERROFF',
     &              ' * Switches Monte Carlo error evaluation OFF *',
     &              ' FON',
     &              ' * Switches tensor auto-update mode ON *',
     &              ' FOFF',
     &              ' * Switches tensor auto-update mode OFF *',
     &              ' SON',
     &              ' * Switches saving mode ON *',
     &              ' SOFF',
     &              ' * Switches saving mode OFF *',
     &              ' FRUN',
     &              ' * Runs FANTALIN *'
C     ------------------------------------------------------------------
C     About FANTALIN
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'TOLL') THEN
              CALL NEXTI('Tolerance setting in FANTALIN (1/0) =',TOLSWI)
              IF (TOLSWI.EQ.1) THEN
                  PCSFLG=.TRUE.
                  WRITE (DUNIT,'(A)') 'Tolerance ON in FANTALIN.'
              ELSE IF (TOLSWI.EQ.0) THEN
                  PCSFLG=.FALSE.
                  WRITE (DUNIT,'(A)') 'Tolerance OFF in FANTALIN.'
              ELSE
                  WRITE (DUNIT,'(A)') 'Unknown switch. Using default.'
              END IF
          ELSE IF (WD(1:4).EQ.'SAVE') THEN
              CALL NEXTFI('FILENAME =',NOMEFILE)
              PRINT*,'Name of the file to save PCS values :',NOMEFILE
          ELSE IF (WD(1:3).EQ.'FME') THEN
              CALL NEXTF('Percentage for average (0/100) =',FMEDPERC)
              CALL NEXTI('Average on class number =',FNCLASS)
              IF (FNCLASS.GT.NCLASSES) THEN
                  PRINT*,'%FRUN-ERR: This class does not exist...'
              ELSE
                  CALL FANTAMEDIA(FNCLASS,FMEDPERC)
              END IF
          ELSE IF (WD(1:5).EQ.'ERRON') THEN
              CALL NEXTI('Number of cycles =',FENUMC)
              CALL NEXTF('Percentage to discard (0/100) =',FEPERC)
              FEPERC=FEPERC/100.0
              FERR=1
              PRINT*,'Monte Carlo error evaluation ON'
          ELSE IF (WD(1:6).EQ.'ERROFF') THEN
              FERR=0
              PRINT*,'Monte Carlo error evaluation OFF'
          ELSE IF (WD(1:3).EQ.'FON') THEN
              FSWITCH=1
              PRINT*,'Tensor auto-update mode ON'
          ELSE IF (WD(1:4).EQ.'FOFF') THEN
              FSWITCH=0
              PRINT*,'Tensor auto-update mode OFF'
          ELSE IF (WD(1:3).EQ.'SON') THEN
              FSAVE=1
              PRINT*,'Saving mode ON'
          ELSE IF (WD(1:4).EQ.'SOFF') THEN
              FSAVE=0
              PRINT*,'Saving mode OFF'
          ELSE IF (WD(1:4).EQ.'FRUN') THEN
              CALL NEXTI('FANTALIN on class number =',FNCLASS)
              IF (FNCLASS.GT.NCLASSES.OR.FNCLASS.EQ.0) THEN
                  PRINT*,'%FRUN-ERR: This class does not exist...'
             ELSE
                  CALL FANTALIN(HEAP(XPCSIPTR),HEAP(XPCSJPTR),
     &                          HEAP(XPCSKPTR),HEAP(XPCSLPTR),
     &                          HEAP(XPCSMPTR),HEAP(XPCSNPTR),
     &                          HEAP(XPCSILST),HEAP(XPCSJLST),
     &                          HEAP(XPCSKLST),HEAP(XPCSLLST),
     &                          HEAP(XPCSMLST),HEAP(XPCSNLST),
     &                          HEAP(XPCSOBSPTR),HEAP(XPCSERRPTR),
     &                          FNCLASS,NOMEFILE )
             END  IF
C     ------------------------------------------------------------------
C     Get class name. Determine if it's an already-defined class.
C     Insert a new class if it's not.
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'CLAS') THEN
              OLDCLASS=CURCLASS
              CALL NEXTA4('Class name =',THENAME)
              MODE=NEW
              DO COUNT=1,NCLASSES
                 IF (XPCSCLASSNAMES(COUNT).EQ.THENAME) THEN
                     MODE=UPDATE
                     CURCLASS=COUNT
                 END IF
              END DO
              IF (MODE.EQ.NEW) THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more than the maximum number of classes
C     ------------------------------------------------------------------
                  IF (OLDCLASS.EQ.MAXXPCSCLASSES) THEN
                      CALL DSPERR('XDIPO_PCS','Too many classes.')
                      CALL DSPERR('XDIPO_PCS',
     &                     'Increase MAXXPCSCLASSES and recompile.')
                      CALL WRNDIE(-5,'READXPCS',
     &                     'Too many anisotropy classes.')
                  END IF
                  NCLASSES=NCLASSES+1
                  CURCLASS=NCLASSES
                  XPCSCLASSNAMES(CURCLASS)=THENAME

C     ------------------------------------------------------------------
C     If this isn't the first class, close off the old class
C     ------------------------------------------------------------------
                  IF (NCLASSES.GT.1) THEN
                      XPCSASSNDX(OLDCLASS)=PCSNUM
                  END IF
              END IF
C     ------------------------------------------------------------------
C     Set force constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'FORC') THEN
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              CALL NEXTF('Force constant =',K1)
              WRITE(DUNIT,'(A,A,A,F8.3)')
     &              'Setting force constant for class ',
     &              XPCSCLASSNAMES(CURCLASS),' to ',K1
                    XPCSFORCES(CURCLASS)=K1
C     ------------------------------------------------------------------
C     Set coefficient constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'COEF') THEN
              CALL NEXTF('Coefficient A1 =',COEF1)
              CALL NEXTF('Coefficient A2 =',COEF2)
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              WRITE(DUNIT,'(A,A,A,F8.3,F8.3)')
     &              'Setting coefficients for class ',
     &              XPCSCLASSNAMES(CURCLASS),' to ',COEF1,COEF2
                    XPCSCOEF1(CURCLASS)=COEF1
                    XPCSCOEF2(CURCLASS)=COEF2
C     ------------------------------------------------------------------
C     Reset pseudocontact shifts database
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'RESE') THEN
              CALL XPCSDEFAULTS
              CALL ALLOCXPCS(0,MAXXPCS)
C     ------------------------------------------------------------------
C     Change number of assignment slots
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'NRES') THEN
               OLDMAXXPCS=MAXXPCS
               CALL NEXTI('Number of slots =',MAXXPCS)
               CALL ALLOCXPCS(OLDMAXXPCS,MAXXPCS)
               WRITE(DUNIT,'(A,I8,A)')
     &               'XDIPO_PCS: Allocating space for',MAXXPCS,
     &               'number of restraints.'
C     ------------------------------------------------------------------
C     Read in an assignment
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'ASSI') THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more assignments than you have slots for
C     ------------------------------------------------------------------
              IF (XPCSMX.EQ.MAXXPCS) THEN
                  CALL DSPERR('XDIPO_PCS','Too many assignments.')
                  CALL DSPERR('XDIPO_PCS',
     &                        'Increasing NREStraints by 100.')
                  OLDMAXXPCS=MAXXPCS
                  MAXXPCS=MAXXPCS+100
                  CALL ALLOCXPCS(OLDMAXXPCS,MAXXPCS)
              END IF
C     ------------------------------------------------------------------
C     If there isn't a class specified, start a default class
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              CALL READXPCS2(HEAP(XPCSIPTR),HEAP(XPCSJPTR),
     &                       HEAP(XPCSKPTR),HEAP(XPCSLPTR),
     &                       HEAP(XPCSMPTR),HEAP(XPCSNPTR),
     &                       HEAP(XPCSILST),HEAP(XPCSJLST),
     &                       HEAP(XPCSKLST),HEAP(XPCSLLST),
     &                       HEAP(XPCSMLST),HEAP(XPCSNLST),
     &                       HEAP(XPCSOBSPTR),HEAP(XPCSERRPTR),
     &                       HEAP(SPTR))
C     ------------------------------------------------------------------
C     Print violations
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'PRIN') THEN
              CALL NEXTWD('PRINT>')
              IF (WD(1:4).NE.'THRE') THEN
                  CALL DSPERR('XDIPO_PCS',
     &                 'Print expects THREshold parameter.')
              ELSE
                  CALL NEXTF('THREshold =',CUTOFF)
                  IF (CUTOFF.LT.ZERO) THEN
                      CALL DSPERR('XDIPO_PCS',
     &                     'Cutoff must be positive.')
                      CUTOFF=ABS(CUTOFF)
                  END IF
                  CALL NEXTA4('ALL OR CLASs>',THENAME)
                  IF (THENAME(1:3).EQ.'ALL') THEN
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                      CALL NEXTA4('CLASS NAME =',THENAME)
                      DO COUNT=1,NCLASSES
                         IF (XPCSCLASSNAMES(COUNT).EQ.THENAME) THEN
                             PRINTCLASS(COUNT)=.TRUE.
                         ELSE
                             PRINTCLASS(COUNT)=.FALSE.
                         END IF
                      END DO
                  ELSE
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  END IF
                  CALL PRINTXPCS(CUTOFF,HEAP(CALCXPCSPTR),
     &                           HEAP(XPCSOBSPTR),HEAP(XPCSERRPTR),
     &                           HEAP(XPCSIPTR),HEAP(XPCSJPTR),
     &                           HEAP(XPCSKPTR),HEAP(XPCSLPTR),
     &                           HEAP(XPCSMPTR),HEAP(XPCSNPTR),
     &                           HEAP(XPCSILST),HEAP(XPCSJLST),
     &                           HEAP(XPCSKLST),HEAP(XPCSLLST),
     &                           HEAP(XPCSMLST),HEAP(XPCSNLST))
              END IF
C     ------------------------------------------------------------------
C     Check for END statement
C     ------------------------------------------------------------------
          ELSE
              CALL CHKEND('XDIPO_PCS>',DONE)
          END IF
      END IF
      IF (.NOT.DONE) GOTO 862
      DONE=.FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))
      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE ALLOCXPCS (OLDSIZE,NEWSIZE)
C     ------------------------------------------------------------------
C     Reset pseudocontact shift arrays to hold size entries
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "funct.inc"
      INCLUDE  "xdipo_pcs.inc"

      INTEGER OLDSIZE,NEWSIZE

      IF (OLDSIZE.NE.0) THEN
          CALL FREHP(XPCSIPTR,INTEG4(OLDSIZE))
          CALL FREHP(XPCSJPTR,INTEG4(OLDSIZE))
          CALL FREHP(XPCSKPTR,INTEG4(OLDSIZE))
          CALL FREHP(XPCSLPTR,INTEG4(OLDSIZE))
          CALL FREHP(XPCSMPTR,INTEG4(OLDSIZE))
          CALL FREHP(XPCSNPTR,INTEG4(OLDSIZE))

          CALL FREHP(XPCSILST,INTEG4(OLDSIZE))
          CALL FREHP(XPCSJLST,INTEG4(OLDSIZE))
          CALL FREHP(XPCSKLST,INTEG4(OLDSIZE))
          CALL FREHP(XPCSLLST,INTEG4(OLDSIZE))
          CALL FREHP(XPCSMLST,INTEG4(OLDSIZE))
          CALL FREHP(XPCSNLST,INTEG4(OLDSIZE))

          CALL FREHP(XPCSOBSPTR,IREAL8(OLDSIZE))
          CALL FREHP(XPCSERRPTR,IREAL8(OLDSIZE))
          CALL FREHP(CALCXPCSPTR,IREAL8(OLDSIZE))
      END IF
      XPCSIPTR=ALLHP(INTEG4(NEWSIZE))
      XPCSJPTR=ALLHP(INTEG4(NEWSIZE))
      XPCSKPTR=ALLHP(INTEG4(NEWSIZE))
      XPCSLPTR=ALLHP(INTEG4(NEWSIZE))
      XPCSMPTR=ALLHP(INTEG4(NEWSIZE))
      XPCSNPTR=ALLHP(INTEG4(NEWSIZE))

      XPCSILST=ALLHP(INTEG4(NEWSIZE))
      XPCSJLST=ALLHP(INTEG4(NEWSIZE))
      XPCSKLST=ALLHP(INTEG4(NEWSIZE))
      XPCSLLST=ALLHP(INTEG4(NEWSIZE))
      XPCSMLST=ALLHP(INTEG4(NEWSIZE))
      XPCSNLST=ALLHP(INTEG4(NEWSIZE))

      XPCSOBSPTR=ALLHP(IREAL8(NEWSIZE))
      XPCSERRPTR=ALLHP(IREAL8(NEWSIZE))
      CALCXPCSPTR=ALLHP(IREAL8(NEWSIZE))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XPCSDEFAULTS
C     ------------------------------------------------------------------
C     Sets up defaults
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xdipo_pcs.inc"

      INTEGER COUNT

      MODE=NEW
      MAXXPCS=200
      XPCSMX=200
      PCSNUM=0
      NCLASSES=0
      CURCLASS=0
      PCSFLG=.FALSE.
      DO COUNT=1,MAXXPCSCLASSES
         XPCSCLASSNAMES(COUNT)='DEFAULT'
         XPCSASSNDX(COUNT)=0
         XPCSFORCES(COUNT)=5.0
         XPCSCOEF1(COUNT)=1.0
         XPCSCOEF2(COUNT)=1.0
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXPCS2(ATOMIPTR,ATOMJPTR,ATOMKPTR,ATOMLPTR,ATOMMPTR,
     &                     ATOMNPTR,ATOMILST,ATOMJLST,ATOMKLST,ATOMLLST,
     &                     ATOMMLST,ATOMNLST,XPCSOBS,XPCSERR,SEL)
C     ------------------------------------------------------------------
C     Reads actual pseudocontact shift assignments into arrays
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "xdipo_pcs.inc"

      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*),ATOMLPTR(*)
      INTEGER ATOMMPTR(*),ATOMNPTR(*),ATOMILST(*)
      INTEGER ATOMJLST(*),ATOMKLST(*),ATOMLLST(*),ATOMMLST(*)
      INTEGER ATOMNLST(*),SEL(*)
      INTEGER ITMP,JTMP,KTMP,LTMP,II
      DOUBLE PRECISION XPCSOBS(*),XPCSERR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER NSEL,INSERTPOS,COUNT,CURSTOP,OTHERSTOP,NFLAG
      INTEGER I
      DOUBLE PRECISION XPCSO,XPCSE
C     ------------------------------------------------------------------
C     If we're in update mode, make a space for the new line
C     ------------------------------------------------------------------
      NFLAG=0
      IF (MODE.EQ.UPDATE) THEN
          DO COUNT=PCSNUM+1,XPCSASSNDX(CURCLASS)+1,-1
            ATOMIPTR(COUNT)=ATOMIPTR(COUNT-1)
            ATOMJPTR(COUNT)=ATOMJPTR(COUNT-1)
            ATOMKPTR(COUNT)=ATOMKPTR(COUNT-1)
            ATOMLPTR(COUNT)=ATOMLPTR(COUNT-1)
            ATOMMPTR(COUNT)=ATOMMPTR(COUNT-1)
            ATOMNPTR(COUNT)=ATOMNPTR(COUNT-1)
            XPCSOBS(COUNT)=XPCSOBS(COUNT-1)
            XPCSERR(COUNT)=XPCSERR(COUNT-1)
          END DO
          CURSTOP=XPCSASSNDX(CURCLASS)
          DO COUNT=1,NCLASSES
             OTHERSTOP=XPCSASSNDX(COUNT)
             IF (OTHERSTOP.GT.CURSTOP) THEN
                 XPCSASSNDX(COUNT)=OTHERSTOP+1
             END IF
          END DO
          XPCSASSNDX(CURCLASS)=CURSTOP+1
          INSERTPOS=CURSTOP
          PCSNUM=PCSNUM+1
      ELSE
          PCSNUM=PCSNUM+1
          INSERTPOS=PCSNUM
          XPCSASSNDX(CURCLASS)=INSERTPOS
      END IF
C     ------------------------------------------------------------------
C     Reading in the atom selection in the restraint table 
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_PCS',
     &                'More than 1 atom in SEL for atom I. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
         CALL DSPERR('XDIPO_PCS','Error with atom selection')
         NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMIPTR(INSERTPOS)=0
      II=ATOMIPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMILST(II)=SEL(1)
      ATOMIPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Both the atoms I and M are the metal center
C     ------------------------------------------------------------------
      IF (INSERTPOS.EQ.1) ATOMMPTR(INSERTPOS)=0
      II=ATOMMPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMMLST(II)=SEL(1)
      ATOMMPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_PCS',
     &                'More than 1 atom in SEL for atom J. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
         CALL DSPERR('XDIPO_PCS','Error with atom selection')
         NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMJPTR(INSERTPOS)=0
      II=ATOMJPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMJLST(II)=SEL(1)
      ATOMJPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_PCS',
     &                'More than 1 atom in SEL for atom K. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_PCS','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      IF (INSERTPOS.EQ.1) ATOMKPTR(INSERTPOS)=0
      II=ATOMKPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMKLST(II)=SEL(1)
      ATOMKPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_PCS',
     &                'More than 1 atom in SEL for atom L. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_PCS','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMLPTR(INSERTPOS)=0
      II=ATOMLPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMLLST(II)=SEL(1)
      ATOMLPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Next selection defines the nucleus whose PCS was measured
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_PCS',
     &                'More than 1 atom in SEL for atom N. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_PCS','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMNPTR(INSERTPOS)=0
      II=ATOMNPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XPCSMX) XPCSMX=II
      ATOMNLST(II)=SEL(1)
      ATOMNPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Reading in the observed pseudocontact shift
C     ------------------------------------------------------------------
      CALL NEXTF('Observed PCS =', XPCSO)
      CALL NEXTF('Error in PCS =', XPCSE)

      XPCSOBS(INSERTPOS)=XPCSO
      XPCSERR(INSERTPOS)=XPCSE
C     ------------------------------------------------------------------
C     Check for error atom selection. If there is one then reset the
C     counter for restraint
C     ------------------------------------------------------------------
      IF (NFLAG.EQ.1) THEN
          PCSNUM=PCSNUM-1
      END IF

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XPCSINIT
C     ------------------------------------------------------------------
C     Initializes pseudocontact shift stuff
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xdipo_pcs.inc"

      CALL XPCSDEFAULTS
      CALL ALLOCXPCS(0,MAXXPCS)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE PRINTXPCS (CUTOFF,XPCSCALC,XPCSOBS,XPCSERR,
     &                      ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                      ATOMLPTR,ATOMMPTR,ATOMNPTR,
     &                      ATOMILST,ATOMJLST,ATOMKLST,
     &                      ATOMLLST,ATOMMLST,ATOMNLST)
C     ------------------------------------------------------------------
C     Prints pseudocontact shifts with deviation larger than cutoff,
C     calculates RMSD and puts it into $RESULT
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xdipo_pcs.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "numbers.inc"

      INTEGER FVIOLS
      COMMON  /VIOL/FVIOLS
      DOUBLE PRECISION CUTOFF,XPCSCALC(*),XPCSOBS(*),XPCSERR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*)
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      DOUBLE PRECISION CALCXPCS,OBSXPCS,DELTAXPCS,DELTA,DP
      INTEGER COUNT,CLASS,I,J,K,L,M,N,NUM,II
      DOUBLE PRECISION RMS,VIOLS,ERRXPCS,XPCSENERGY
      DOUBLE COMPLEX DUMMY2
      LOGICAL PRINTTHISCLASS

      RMS=ZERO
      VIOLS=ZERO
      NUM=0
C     ------------------------------------------------------------------
C     Make sure that the array of calculated PCS is up to date
C     ------------------------------------------------------------------
      CALL EXPCS(XPCSENERGY,'ANALYZE')
      WRITE (PUNIT,'(A)') 'The following pseudocontact shifts have'
      WRITE (PUNIT,'(A)') 'deviation larger than or'
      WRITE (PUNIT,'(A)') 'equal to the cutoff:'
C     ------------------------------------------------------------------
C     Write out first class heading
C     ------------------------------------------------------------------
      CLASS=1
      PRINTTHISCLASS=PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
          WRITE (PUNIT,'(A,A)') 'Class ',XPCSCLASSNAMES(1)
      END IF
C     ------------------------------------------------------------------
C     For every pseudocontact shift entry...
C     ------------------------------------------------------------------
      COUNT = 0
      DO WHILE (COUNT.LT.PCSNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Is this the start of a new class?
C     ------------------------------------------------------------------
         IF (XPCSASSNDX(CLASS).LT.COUNT) THEN
             CLASS=CLASS+1
            PRINTTHISCLASS=PRINTCLASS(CLASS)
            IF (XPCSASSNDX(CLASS).EQ.XPCSASSNDX(CLASS-1)) THEN
                COUNT=COUNT-1
            END IF
            IF (PRINTTHISCLASS) THEN
                WRITE (PUNIT,'(A,A)') 'Class ',XPCSCLASSNAMES(CLASS)
            END IF
         END IF
C     ------------------------------------------------------------------
C     If this assignment is in a class to be printed
C     and make sure there is an entry for that class
C     ------------------------------------------------------------------
         IF ((PRINTTHISCLASS).AND.
     &       (XPCSASSNDX(CLASS).NE.XPCSASSNDX(CLASS-1))) THEN
C     ------------------------------------------------------------------
C     Always update RMSD
C     ------------------------------------------------------------------
            CALCXPCS=XPCSCALC(COUNT)
            OBSXPCS=XPCSOBS(COUNT)
            ERRXPCS=XPCSERR(COUNT)
            DP=(CALCXPCS-OBSXPCS)

            IF ((DP.LT.0.000).AND.(ABS(DP).GT.ERRXPCS)) THEN
                 DELTAXPCS=DP+ERRXPCS
            ELSE IF ((DP.GT.0.000).AND.(DP.GT.ERRXPCS)) THEN
                 DELTAXPCS=DP-ERRXPCS
            ELSE
                 DELTAXPCS=0.0
            END IF

            RMS=RMS+DELTAXPCS**2
            NUM=NUM+1
C     ------------------------------------------------------------------
C     Print out deviations larger than cutoff
C     and update number of violations
C     ------------------------------------------------------------------
            IF (ABS(DELTAXPCS).GE.CUTOFF) THEN
                I=ATOMILST(ATOMIPTR(COUNT)+1)
                J=ATOMJLST(ATOMJPTR(COUNT)+1)
                K=ATOMKLST(ATOMKPTR(COUNT)+1)
                L=ATOMLLST(ATOMLPTR(COUNT)+1)
                WRITE(PUNIT,'(A,A)') '===============================',
     &                               '==============================='
                WRITE(PUNIT,'(A)') ' Set-M-atoms'
                DO II=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
                   M=ATOMMLST(II)
                   WRITE(PUNIT,'(9X,4(1X,A))') SEGID(M),RESID(M),RES(M),
     &                                         TYPE(M)
                END DO
                WRITE(PUNIT,'(A)') ' Set-N-atoms'
                DO II=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
                   N=ATOMNLST(II)
                   WRITE(PUNIT,'(9X,4(1X,A))') SEGID(N),RESID(N),RES(N),
     &                                         TYPE(N)
                END DO

                WRITE(PUNIT,'(2(2X,A,1X,F8.3))')
     &                'Calc: ',CALCXPCS,'Obs: ',OBSXPCS
                WRITE(PUNIT,'(2X,A,1X,F8.3,2X,A,1X,F8.3)')
     &                'Error: ',ERRXPCS,'Delta: ',DELTAXPCS
                VIOLS = VIOLS + ONE
            END IF
         END IF
      END DO

      IF (NUM.GT.0) THEN
         RMS=SQRT(RMS/NUM)
      ELSE
         RMS=0.0
      END IF

      FVIOLS=VIOLS
      PRINT *,'FVIOLS =',FVIOLS

      CALL DECLAR('RESULT','DP',' ',DUMMY2,RMS)
      CALL DECLAR('VIOLATIONS','DP',' ',DUMMY2,VIOLS)

      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE EXCCR (ECCR, WHICH)
C     ------------------------------------------------------------------
C     Calls EXCCR2, which does the actual energy calculation
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xccr.inc"
      INCLUDE  "heap.inc"

      DOUBLE PRECISION ECCR
      CHARACTER*7 WHICH

      CALL EXCCR2(ECCR,HEAP(XCCRIPTR),HEAP(XCCRJPTR),HEAP(XCCRKPTR),
     &                 HEAP(XCCRILST),HEAP(XCCRJLST),HEAP(XCCRKLST),
     &                 HEAP(XCCROBSPTR),HEAP(XCCRERRPTR),
     &                 HEAP(CALCXCCRPTR),WHICH)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE EXCCR2 (ECCR,ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                        ATOMILST,ATOMJLST,ATOMKLST,
     &                        XCCROBS,XCCRERR,
     &                        XCCRCALC,WHICH)
C     ------------------------------------------------------------------
C     Calculates cross correlation rate energies
C
C     Energies are of the form:
C        E = K*(DELTACCR**2)
C     where: 
C        K = FORCE CONSTANT 
C        DELTACCR = CALCULATED CCR - OBSERVED CCR
C     and cross correlation rate function is defined as:
C        CCR = KM*(3*COS(THETA)^2-1)/DIST^3
C
C     Note that:
C        Atom I = Metal 
C        Atom J = Detected nucleus (e.g. H)
C        Atom K = Coupled nucleus (e.g. N)
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xccr.inc"
      INCLUDE  "consta.inc"

      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      DOUBLE PRECISION XCCROBS(*),XCCRERR(*)
      DOUBLE PRECISION XCCRCALC(*),ECCR
      CHARACTER*7 WHICH
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER COUNT,CLASS,MM,NN,II,I,J,K,L,NA,M,N
      PARAMETER (NA=20)
      INTEGER DMM,DNN,OUTFLAG(NA),MCOUNT,NCOUNT,PCOUNT
      DOUBLE PRECISION XI,XJ,XK,YI,YJ,YK,ZI,ZJ,ZK,CALCXCCR,E,
     &                 DFXI(NA),DFYI(NA),DFZI(NA),DFXJ(NA),DFYJ(NA),
     &                 DFZJ(NA),DFXK(NA),DFYK(NA),DFZK(NA),
     &                 DJK2,DJI2,DJI5,DJI,DF1,PS,DJK,DJI3,
     &                 O1,O2,O3,O4,O5,O6,O7,O8,O9,O10,O11,O12,O13,O14,
     &                 O15,O16,O17,O18,O19,O20,O21,O22,O23,O24,O25,O26,
     &                 O27,O28,O29,O30,O31,O32,O33,O34,O35,O36,O37,O38,
     *                 O39
      DOUBLE PRECISION OBSXCCR,ERRXCCR,K1,COEF1,A,B,DELTA,
     &                 DP,DELTAXCCR,DD
C     ------------------------------------------------------------------
C     Zero out partial energy
C     ------------------------------------------------------------------
      ECCR = ZERO
  
      CLASS = 1
      K1=XCCRFORCES(1)
      COEF1=XCCRCOEF1(1)

      COUNT=0
      DO WHILE(COUNT.LT.CCRNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Reset individual E to zero
C     ------------------------------------------------------------------
         E=0

         DO WHILE ((XCCRASSNDX(CLASS).LT.COUNT).OR.
     &             (XCCRASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO

         IF (XCCRASSNDX(CLASS).EQ.XCCRASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         K1=XCCRFORCES(CLASS)
         COEF1=XCCRCOEF1(CLASS)
C     ------------------------------------------------------------------
C     Note there should only be one atom for I, J, and K
C     ------------------------------------------------------------------
         I=ATOMIPTR(COUNT)+1
         J=ATOMJPTR(COUNT)+1
         K=ATOMKPTR(COUNT)+1

         XI=X(ATOMILST(I))
         XJ=X(ATOMJLST(J))
         XK=X(ATOMKLST(K))
         YI=Y(ATOMILST(I))
         YJ=Y(ATOMJLST(J))
         YK=Y(ATOMKLST(K))
         ZI=Z(ATOMILST(I))
         ZJ=Z(ATOMJLST(J))
         ZK=Z(ATOMKLST(K))

         OBSXCCR=XCCROBS(COUNT)
         ERRXCCR=XCCRERR(COUNT)
C     ------------------------------------------------------------------
C     Initialize calculated cross correlation rates and counter
C     ------------------------------------------------------------------
         CALCXCCR=0
         II=0
         MCOUNT=0
         NCOUNT=0
C     ------------------------------------------------------------------
C     Check for correct permutations of paired atoms to get the metal-
C     nucleus vector. This depends solely on the order of the assigned
C     atoms. OUTFLAG=1 indicates that the permutation is not allowed.
C     ------------------------------------------------------------------
         DMM=ATOMJPTR(COUNT+1)-ATOMJPTR(COUNT)
         DNN=ATOMKPTR(COUNT+1)-ATOMKPTR(COUNT)
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            MCOUNT=MCOUNT+1
            NCOUNT=0
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               NCOUNT=NCOUNT+1
               II=II+1
               IF ((DMM.GT.1).AND.(DNN.GT.1)) THEN
                    IF (MCOUNT.EQ.NCOUNT) THEN
                        OUTFLAG(II)=0
                    ELSE
                        OUTFLAG(II)=1
                    ENDIF

               ELSE
                    OUTFLAG(II)=0
               END IF
            END DO
         END DO

         II=0
         PCOUNT=0
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
C     ------------------------------------------------------------------
C     Calculate the function and its derivatives
C     ------------------------------------------------------------------
                   O1=XJ-XK
                   O2=XJ-XI
                   O3=YJ-YK
                   O4=YJ-YI
                   O5=ZJ-ZK
                   O6=ZJ-ZI
                   O7=O2**2
                   O8=O4**2
                   O9=O6**2
                   O10=O1**2
                   O11=O3**2
                   O12=O5**2
                   PS=O1*O2+O3*O4+O5*O6
                   DJK2=O10+O11+O12
                   DJI2=O7+O8+O9
                   DJI5=SQRT(DJI2**5)
                   DJI3=SQRT(DJI2**3)
                   DJI=SQRT(DJI2)
                   O13=2.*XJ-XI-XK
                   O14=6.*PS*O13
                   O15=2.*O1*DJI2
                   O16=2.*O2*DJK2
                   O17=DJK2*DJI5
                   O18=3.*PS**2-DJK2*DJI2
                   O19=2.*O1*DJI5
                   O20=5.*O2*DJK2*DJI3
                   O21=O17**2
                   O22=6.*PS*(-O2)
                   O23=6.*PS*(-O1)
                   O24=2.*YJ-YI-YK
                   O25=6.*PS*O24
                   O26=2.*O3*DJI2
                   O27=2.*O4*DJK2
                   O28=2.*O3*DJI5
                   O29=5.*O4*DJK2*DJI3
                   O30=6.*PS*(-O4)
                   O31=6.*PS*(-O3)
                   O32=2.*ZJ-ZI-ZK
                   O33=6.*PS*O32
                   O34=2.*O5*DJI2
                   O35=2.*O6*DJK2
                   O36=2.*O5*DJI5
                   O37=5.*O6*DJK2*DJI3
                   O38=6.*PS*(-O6)
                   O39=6.*PS*(-O5)
                   DJK=SQRT(DJK2)
 
                   DFXI(II)=((O23+O16)*O17-O18*O20)/O21
                   DFYI(II)=((O31+O27)*O17-O18*O29)/O21
                   DFZI(II)=((O39+O35)*O17-O18*O37)/O21
                   DFXJ(II)=((O14-O15-O16)*O17-O18*(O19+O20))/O21
                   DFYJ(II)=((O25-O26-O27)*O17-O18*(O28+O29))/O21
                   DFZJ(II)=((O33-O34-O35)*O17-O18*(O36+O37))/O21
                   DFXK(II)=((O22+O15)*O17+O18*O19)/O21
                   DFYK(II)=((O30+O26)*O17+O18*O28)/O21
                   DFZK(II)=((O38+O34)*O17+O18*O36)/O21
C     ------------------------------------------------------------------
C     Coefficient
C     ------------------------------------------------------------------
                   A=COEF1
C     ------------------------------------------------------------------
C     Calculate the cross correlation rate
C     ------------------------------------------------------------------
                   CALCXCCR=A*((3.*(PS/(DJK*DJI))**2-1.)/DJI3)
               END IF
            END DO
         END DO

         IF (WHICH.EQ.'ANALYZE') THEN
             XCCRCALC(COUNT)=CALCXCCR
         END IF

         DELTA=(CALCXCCR-OBSXCCR)
C     ------------------------------------------------------------------
C     Adjust the deviation based on the error range
C     ------------------------------------------------------------------
         IF ((DELTA.LT.0.000).AND.(ABS(DELTA).GT.ERRXCCR)) THEN
              DELTAXCCR=DELTA+ERRXCCR
         ELSE IF ((DELTA.GT.0.000).AND.(DELTA.GT.ERRXCCR)) THEN
              DELTAXCCR=DELTA-ERRXCCR
         ELSE
              DELTAXCCR=0.0
         END IF

         DD=DELTAXCCR

         II=0
         PCOUNT=0
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
                   IF (DD.EQ.0.0) THEN
                       E=E+0.0
                       DF1=0.0
                   ELSE
C     ------------------------------------------------------------------
C     Depending on CCRFLAG, the weight may be proportional to DIST^3
C     ------------------------------------------------------------------
                       IF (CCRFLG) THEN
                           E=E+K1*(DELTAXCCR**2)*DJI3
                           DF1=2*K1*DELTAXCCR*DJI3
                       ELSE
                          E=E+K1*(DELTAXCCR**2)
                          DF1=2*K1*DELTAXCCR
                       END IF
                   END IF
               END IF
            END DO
         END DO
C     ------------------------------------------------------------------
C     Accumulate energy
C     ------------------------------------------------------------------
         ECCR=ECCR+E
C     ------------------------------------------------------------------
C     Now update forces if in energy/force mode
C     ------------------------------------------------------------------
         IF (WHICH.NE.'ANALYZE') THEN
             II=0
             DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
                DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
                   II=II+1
                   IF (OUTFLAG(II).NE.1) THEN
                       DX(ATOMILST(I))=DX(ATOMILST(I))+DF1*DFXI(II)
                       DY(ATOMILST(I))=DY(ATOMILST(I))+DF1*DFYI(II)
                       DZ(ATOMILST(I))=DZ(ATOMILST(I))+DF1*DFZI(II)
                       DX(ATOMJLST(J))=DX(ATOMJLST(J))+DF1*DFXJ(II)
                       DY(ATOMJLST(J))=DY(ATOMJLST(J))+DF1*DFYJ(II)
                       DZ(ATOMJLST(J))=DZ(ATOMJLST(J))+DF1*DFZJ(II)
                       DX(ATOMKLST(K))=DX(ATOMKLST(K))+DF1*DFXK(II)
                       DY(ATOMKLST(K))=DY(ATOMKLST(K))+DF1*DFYK(II)
                       DZ(ATOMKLST(K))=DZ(ATOMKLST(K))+DF1*DFZK(II)
                   END IF
                END DO
             END DO
         END IF
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXCCR
C     ------------------------------------------------------------------
C     Reads in cross correlation rate information
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "xccr.inc"
      INCLUDE  "funct.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "heap.inc"
      INCLUDE  "numbers.inc"

      INTEGER COUNT,SPTR,OLDCLASS,OLDMAXXCCR,FNCLASS
      DOUBLE PRECISION K1,CUTOFF,COEF1
      CHARACTER*4 THENAME
      CHARACTER*132 NOMEFILE
      INTEGER WEISWI
      
      NOMEFILE='XCCR.OUT'

      SPTR=ALLHP(INTEG4(NATOM))
      CALL PUSEND('XCCR>')
862   CONTINUE
      CALL NEXTWD('XCCR>')
      CALL MISCOM('XCCR>',USED)
      IF (.NOT.USED) THEN
C     ------------------------------------------------------------------
C     Documentation
C     ------------------------------------------------------------------
          IF (WD(1:4).EQ.'HELP') THEN
              WRITE(DUNIT,'(10X,A)')
     &              ' XCCR {<CCR-STATEMENT>} END ',
     &              ' <CCR-STATEMENT>:== ',
     &              ' ASSIGN <SEL> <SEL> <SEL> <REAL> <REAL>',
     &              ' * Restraint: Metal Coupled_nucleus',
     &              ' Detected_nucleus CCR Err *',
     &              ' CLASsification <NAME>',
     &              ' * Starts a new class *',
     &              ' WEIP <1|0>',
     &              ' * Switch weight proportional to R^3 (1=Y,0=N) *',
     &              ' COEFficient <REAL>',
     &              ' * Proportionality constant *',
     &              ' FORCeconstant <REAL>',
     &              ' * Force constant for the current class *',
     &              ' NREStraints <INTEGER>',
     &              ' * Number of slots for restraints to allocate *',
     &              ' PRINt THREshold <REAL>',
     &              ' * Prints violations larger than the THREshold *',
     &              ' RESEt',
     &              ' * Erases the restraint table, but keeps NRES *',
     &              ' FRUN',
     &              ' * Runs FANTACROSS *'
C     ------------------------------------------------------------------
C     About FANTACROSS
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'FRUN') THEN
              CALL NEXTI('FANTACROSS on class number =',FNCLASS)
              IF (FNCLASS.GT.NCLASSES.OR.FNCLASS.EQ.0) THEN
                  PRINT*,'%FRUN-ERR: This class does not exist...'
              ELSE
                  CALL FANTACCR(HEAP(XCCRIPTR),HEAP(XCCRJPTR),
     &                          HEAP(XCCRKPTR),HEAP(XCCRILST),
     &                          HEAP(XCCRJLST),HEAP(XCCRKLST),
     &                          HEAP(XCCROBSPTR),HEAP(XCCRERRPTR),
     &                          FNCLASS,NOMEFILE)
              END IF
C     ------------------------------------------------------------------
C     Get class name. Determine if it's an already-defined class.
C     Insert a new class if it's not.
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'CLAS') THEN
              OLDCLASS=CURCLASS
              CALL NEXTA4('Class name =',THENAME)
              MODE=NEW
              DO COUNT=1,NCLASSES
                 IF (XCCRCLASSNAMES(COUNT).EQ.THENAME) THEN
                     MODE=UPDATE
                     CURCLASS=COUNT
                 END IF
              END DO
              IF (MODE.EQ.NEW) THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more than the maximum number of classes
C     ------------------------------------------------------------------
                  IF (OLDCLASS.EQ.MAXXCCRCLASSES) THEN
                      CALL DSPERR('XCCR','Too many classes.')
                      CALL DSPERR('XCCR',
     &                     'Increase MAXXCCRCLASSES and recompile.')
                      CALL WRNDIE(-5, 'READXCCR',
     &                      'Too many CCR classes.')
                  END IF
                  NCLASSES=NCLASSES+1
                  CURCLASS=NCLASSES
                  XCCRCLASSNAMES(CURCLASS)=THENAME
C     ------------------------------------------------------------------
C     If this isn't the first class, close off the old class
C     ------------------------------------------------------------------
                  IF (NCLASSES.GT.1) THEN
                      XCCRASSNDX(OLDCLASS)=CCRNUM
                  END IF
              END IF
C     ------------------------------------------------------------------
C     Set force constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'FORC') THEN
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES = 1
                  CURCLASS = 1
              END IF
              CALL NEXTF('Force constant =',K1)
              WRITE(DUNIT,'(A,A,A,F8.3)') 
     &              'Setting force const for class ', 
     &              XCCRCLASSNAMES(CURCLASS),' to ',K1
                    XCCRFORCES(CURCLASS)=K1
C     ------------------------------------------------------------------
C     Set weight proportional to DIST^3
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'WEIP') THEN
              CALL NEXTI('Weight proportional to R^3 (Y=1,N=0):',WEISWI)
              IF (WEISWI.EQ.1) THEN
                  CCRFLG=.TRUE.
                  WRITE (DUNIT,'(A)') 'CCR weight proportional to R^3.'
              ELSE IF (WEISWI.EQ.0) THEN
                  CCRFLG=.FALSE.
                  WRITE (DUNIT,'(A)') 'CCR weight not dependent on R.'
              ELSE
                  WRITE (DUNIT,'(A)') 'Unknown switch. Default weight.'
              END IF
C     ------------------------------------------------------------------
C     Set coefficient constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'COEF') THEN
              CALL NEXTF('CCR COEFficient =',COEF1)
C     ------------------------------------------------------------------
C     Start a default class if there isn't one already defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES = 1
                  CURCLASS = 1
              END IF
              WRITE(DUNIT,'(A,A,A,F8.3)')
     &              'Setting coefficient for class ',
     &               XCCRCLASSNAMES(CURCLASS),'to',COEF1
                     XCCRCOEF1(CURCLASS)=COEF1
C     ------------------------------------------------------------------
C     Reset cross correlation rates database
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'RESE') THEN
              CALL XCCRDEFAULTS
              CALL ALLOCXCCR(0,MAXXCCR)
C     ------------------------------------------------------------------
C     Change number of assignment slots
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'NRES') THEN
               OLDMAXXCCR=MAXXCCR
               CALL NEXTI('Number of slots =',MAXXCCR)
               CALL ALLOCXCCR(OLDMAXXCCR,MAXXCCR)
               WRITE(DUNIT,'(A,I8,A)')
     &            'XCCR: Allocating space for',MAXXCCR,
     &            'number of restraints.'
C     ------------------------------------------------------------------
C     Read in an assignment
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'ASSI') THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more assignments than you have slots for
C     ------------------------------------------------------------------
              IF (XCCRMX.EQ.MAXXCCR) THEN
                  CALL DSPERR('XCCR','Too many assignments.')
                  CALL DSPERR('XCCR',
     &                        'Increasing NREStraints by 100.')
                  OLDMAXXCCR=MAXXCCR
                  MAXXCCR=MAXXCCR+100
                  CALL ALLOCXCCR(OLDMAXXCCR,MAXXCCR)
              END IF
C     ------------------------------------------------------------------
C     If there isn't a class specified, start a default class
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              CALL READXCCR2(HEAP(XCCRIPTR),HEAP(XCCRJPTR), 
     &                       HEAP(XCCRKPTR),HEAP(XCCRILST),
     &                       HEAP(XCCRJLST),HEAP(XCCRKLST),
     &                       HEAP(XCCROBSPTR),HEAP(XCCRERRPTR),
     &                       HEAP(SPTR))
C     ------------------------------------------------------------------
C     Print violations
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'PRIN') THEN
              CALL NEXTWD('PRINT>')
              IF (WD(1:4).NE.'THRE') THEN
                  CALL DSPERR('XCCR',
     &                 'PRINt expects THREshold parameter.')
              ELSE
                  CALL NEXTF('THREshold =',CUTOFF)
                  IF (CUTOFF.LT.ZERO) THEN
                      CALL DSPERR('XCCR',
     &                            'Cutoff must be positive.')
                      CUTOFF = ABS(CUTOFF)
                  END IF
                  CALL NEXTA4('ALL OR CLASs>',THENAME)
                  IF (THENAME(1:3).EQ.'ALL') THEN
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                      CALL NEXTA4('Class name =',THENAME)
                      DO COUNT=1,NCLASSES
                         IF (XCCRCLASSNAMES(COUNT).EQ.THENAME) THEN
                             PRINTCLASS(COUNT)=.TRUE.
                         ELSE
                             PRINTCLASS(COUNT)=.FALSE.
                         END IF
                      END DO
                  ELSE
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  END IF
                  CALL PRINTXCCR(CUTOFF,HEAP(CALCXCCRPTR),
     &                           HEAP(XCCROBSPTR),HEAP(XCCRERRPTR),
     &                           HEAP(XCCRIPTR),HEAP(XCCRJPTR),
     &                           HEAP(XCCRKPTR),HEAP(XCCRILST),
     &                           HEAP(XCCRJLST),HEAP(XCCRKLST))
              END IF
C     ------------------------------------------------------------------
C     Check for END statement
C     ------------------------------------------------------------------
          ELSE
              CALL CHKEND('XCCR>',DONE)
          END IF
      END IF
      IF (.NOT.(DONE)) GOTO 862
      DONE=.FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE ALLOCXCCR (OLDSIZE,NEWSIZE)
C     ------------------------------------------------------------------
C     Resets cross correlation rate arrays to hold size entries
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "funct.inc"
      INCLUDE "xccr.inc"

      INTEGER OLDSIZE,NEWSIZE

      IF (OLDSIZE.NE.0) THEN
           CALL FREHP(XCCRIPTR,INTEG4(OLDSIZE))
           CALL FREHP(XCCRJPTR,INTEG4(OLDSIZE))
           CALL FREHP(XCCRKPTR,INTEG4(OLDSIZE))

           CALL FREHP(XCCRILST,INTEG4(OLDSIZE))
           CALL FREHP(XCCRJLST,INTEG4(OLDSIZE))
           CALL FREHP(XCCRKLST,INTEG4(OLDSIZE))

           CALL FREHP(XCCROBSPTR,IREAL8(OLDSIZE))
           CALL FREHP(XCCRERRPTR,IREAL8(OLDSIZE))
           CALL FREHP(CALCXCCRPTR,IREAL8(OLDSIZE))
      END IF
      XCCRIPTR=ALLHP(INTEG4(NEWSIZE))
      XCCRJPTR=ALLHP(INTEG4(NEWSIZE))
      XCCRKPTR=ALLHP(INTEG4(NEWSIZE))

      XCCRILST=ALLHP(INTEG4(NEWSIZE))
      XCCRJLST=ALLHP(INTEG4(NEWSIZE))
      XCCRKLST=ALLHP(INTEG4(NEWSIZE))

      XCCROBSPTR=ALLHP(IREAL8(NEWSIZE))
      XCCRERRPTR=ALLHP(IREAL8(NEWSIZE))
      CALCXCCRPTR=ALLHP(IREAL8(NEWSIZE))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XCCRDEFAULTS
C     ------------------------------------------------------------------
C     Sets up defaults
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "xccr.inc"

      INTEGER COUNT

      MODE=NEW
      MAXXCCR=200
      XCCRMX=200
      CCRNUM=0
      NCLASSES=0
      CURCLASS=0
      CCRFLG=.FALSE.
      DO COUNT=1,MAXXCCRCLASSES
         XCCRCLASSNAMES(COUNT)='DEFAULT'
         XCCRASSNDX(COUNT)=0
         XCCRFORCES(COUNT)=5.0
         XCCRCOEF1(COUNT)=1.0
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXCCR2(ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                     ATOMILST,ATOMJLST,ATOMKLST,
     &                     XCCROBS,XCCRERR,SEL)
C     ------------------------------------------------------------------
C     Reads actual cross correlation rate assignments into arrays
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "cns.inc"
      INCLUDE "mtf.inc"
      INCLUDE "coord.inc"
      INCLUDE "xccr.inc"

      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER SEL(*)
      INTEGER ITMP,JTMP,KTMP,II
      DOUBLE PRECISION XCCROBS(*),XCCRERR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER NSEL,INSERTPOS,COUNT,CURSTOP,OTHERSTOP,NFLAG
      INTEGER I
      DOUBLE PRECISION XCCRO,XCCRE
C     ------------------------------------------------------------------
C     If we're in UPDATE mode, make a space for the new line
C     ------------------------------------------------------------------
      NFLAG = 0
      IF (MODE.EQ.UPDATE) THEN
          DO COUNT=CCRNUM+1,XCCRASSNDX(CURCLASS)+1,-1
                ATOMIPTR(COUNT)=ATOMIPTR(COUNT-1)
                ATOMJPTR(COUNT)=ATOMJPTR(COUNT-1)
                ATOMKPTR(COUNT)=ATOMKPTR(COUNT-1)
                XCCROBS(COUNT)=XCCROBS(COUNT-1)
                XCCRERR(COUNT)=XCCRERR(COUNT-1)
          END DO
          CURSTOP=XCCRASSNDX(CURCLASS)
          DO COUNT=1,NCLASSES
             OTHERSTOP=XCCRASSNDX(COUNT)
             IF (OTHERSTOP.GT.CURSTOP) THEN
                 XCCRASSNDX(COUNT)=OTHERSTOP+1
             END IF
          END DO
          XCCRASSNDX(CURCLASS)=CURSTOP+1
          INSERTPOS=CURSTOP
          CCRNUM=CCRNUM+1
      ELSE
           CCRNUM=CCRNUM+1
           INSERTPOS=CCRNUM
           XCCRASSNDX(CURCLASS)=INSERTPOS
      END IF
C     ------------------------------------------------------------------
C     Reading in the atom selection in the restraint table
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN 
          CALL DSPERR('XCCR',
     &                'More than 1 atom in SEL for atom I. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XCCR','Error with atom selection')
          NFLAG = 1
      END IF
      CALL MAKIND(SEL, NATOM, NSEL) 
      IF (INSERTPOS.EQ.1) ATOMIPTR(INSERTPOS)=0
      II=ATOMIPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XCCRMX) XCCRMX=II
      ATOMILST(II) = SEL(1)
      ATOMIPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN 
          CALL DSPERR('XCCR',
     &                'More than 1 atom in SEL for atom J. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XCCR','Error with atom selection')
          NFLAG = 1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL) 
      IF (INSERTPOS.EQ.1) ATOMJPTR(INSERTPOS)=0
      II=ATOMJPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XCCRMX) XCCRMX=II
      ATOMJLST(II)=SEL(1)
      ATOMJPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN 
          CALL DSPERR('XCCR',
     &                'More than 1 atom in SEL for atom K. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XCCR','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL) 
      IF (INSERTPOS.EQ.1) ATOMKPTR(INSERTPOS)=0
      II=ATOMKPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XCCRMX) XCCRMX=II
      ATOMKLST(II)=SEL(1)
      ATOMKPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Reading in the observed cross correlation rate
C     ------------------------------------------------------------------
      CALL NEXTF('Observed CCR =',XCCRO)
      CALL NEXTF('Error in CCR =',XCCRE)

      XCCROBS(INSERTPOS)=XCCRO
      XCCRERR(INSERTPOS)=XCCRE
C     ------------------------------------------------------------------
C     Check for error in atom selection. If there is one then reset the
C     counter for restraint
C     ------------------------------------------------------------------
      IF (NFLAG.EQ.1) THEN
          CCRNUM=CCRNUM-1
      END IF

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XCCRINIT
C     ------------------------------------------------------------------
C     Initializes cross correlation rate stuff
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE "xccr.inc"

      CALL XCCRDEFAULTS
      CALL ALLOCXCCR(0,MAXXCCR)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE PRINTXCCR (CUTOFF,XCCRCALC,XCCROBS,XCCRERR,
     &                      ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                      ATOMILST,ATOMJLST,ATOMKLST)
C     ------------------------------------------------------------------
C     Prints cross correlation rates with dveiation larger than cutoff,
C     calculates RMSD and puts it into $RESULT
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xccr.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "numbers.inc"

      DOUBLE PRECISION CUTOFF,XCCRCALC(*),XCCROBS(*),XCCRERR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      DOUBLE PRECISION CALCXCCR,OBSXCCR,DELTAXCCR,DELTA,DP
      INTEGER COUNT,CLASS,I,J,K,NUM,II
      DOUBLE PRECISION RMS,VIOLS,ERRXCCR,XCCRENERGY
      DOUBLE COMPLEX DUMMY2
      LOGICAL PRINTTHISCLASS

      RMS=ZERO
      VIOLS=ZERO
      NUM=0
C     ------------------------------------------------------------------
C     Make sure that the array of calculated CCR is up to date
C     ------------------------------------------------------------------
      CALL EXCCR(XCCRENERGY,'ANALYZE')
      WRITE (PUNIT,'(A)') 'The following cross correlation rates have'
      WRITE (PUNIT,'(A)') 'deviation larger than or'
      WRITE (PUNIT,'(A)') 'equal to the cutoff:'
C     ------------------------------------------------------------------
C     Write out first class heading
C     ------------------------------------------------------------------
      CLASS=1
      PRINTTHISCLASS=PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
           WRITE (PUNIT,'(A,A)') 'Class ',XCCRCLASSNAMES(1)
      END IF
C     ------------------------------------------------------------------
C     For every cross correlation rate entry...
C     ------------------------------------------------------------------
      COUNT = 0
      DO WHILE(COUNT.LT.CCRNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Is this the start of a new class?
C     ------------------------------------------------------------------
         IF (XCCRASSNDX(CLASS).LT.COUNT) THEN
             CLASS=CLASS+1
             PRINTTHISCLASS=PRINTCLASS(CLASS)
             IF (XCCRASSNDX(CLASS).EQ.XCCRASSNDX(CLASS-1)) THEN
                 COUNT=COUNT - 1
             END IF
             IF (PRINTTHISCLASS) THEN
                  WRITE (PUNIT,'(A,A)') 'Class ',XCCRCLASSNAMES(CLASS)
             END IF
         END IF
C     ------------------------------------------------------------------
C     If this assignment is in a class to be printed
C     and make sure there is an entry for that class
C     ------------------------------------------------------------------
         IF ((PRINTTHISCLASS).AND.
     &       (XCCRASSNDX(CLASS).NE.XCCRASSNDX(CLASS-1))) THEN
C     ------------------------------------------------------------------
C     Always update RMSD
C     ------------------------------------------------------------------
              CALCXCCR=XCCRCALC(COUNT)
              OBSXCCR=XCCROBS(COUNT)
              ERRXCCR=XCCRERR(COUNT)
              DP=(CALCXCCR-OBSXCCR)

              IF ((DP.LT.0.000).AND.(ABS(DP).GT.ERRXCCR)) THEN
                   DELTAXCCR=DP+ERRXCCR
              ELSE IF ((DP.GT.0.000).AND.(DP.GT.ERRXCCR)) THEN
                   DELTAXCCR=DP-ERRXCCR
              ELSE
                   DELTAXCCR=0.0
              END IF

              RMS=RMS+DELTAXCCR**2
              NUM=NUM+1
C     ------------------------------------------------------------------
C     Print out deviations larger than cutoff
C     and update number of violations
C     ------------------------------------------------------------------
              IF (ABS(DELTAXCCR).GE.CUTOFF) THEN
                  I=ATOMILST(ATOMIPTR(COUNT)+1)
                  J=ATOMJLST(ATOMJPTR(COUNT)+1)
                  K=ATOMKLST(ATOMKPTR(COUNT)+1)
                  WRITE(PUNIT,'(A,A)') '==============================',
     &                                 '=============================='
                  WRITE(PUNIT,'(A)') ' Set-I-atoms'
                  DO II=ATOMIPTR(COUNT)+1,ATOMIPTR(COUNT+1)
                     I=ATOMILST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(I),RESID(I),
     &                                           RES(I),TYPE(I)
                  END DO
                  WRITE(PUNIT,'(A)') ' Set-J-atoms'
                  DO II=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
                     J=ATOMJLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(J),RESID(J),
     &                                           RES(J),TYPE(J)
                  END DO
                  WRITE(PUNIT,'(A)') ' Set-K-atoms'
                  DO II=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
                     K=ATOMKLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),
     &                                           RES(K),TYPE(K)
                  END DO
                  WRITE(PUNIT,'(2(2X,A,1X,F8.3))')
     &                  'Calc: ',CALCXCCR,'Obs: ',OBSXCCR
                  WRITE(PUNIT,'(2X,A,1X,F8.3,2X,A,1X,F8.3)')
     &                  'Error: ',ERRXCCR,'Delta: ',DELTAXCCR
                  VIOLS=VIOLS+ONE
              END IF
         END IF
      END DO

      IF (NUM.GT.0) THEN
          RMS=SQRT(RMS/NUM)
      ELSE
          RMS=0.0
      ENDIF

      CALL DECLAR('RESULT','DP',' ',DUMMY2,RMS)
      CALL DECLAR('VIOLATIONS','DP',' ',DUMMY2,VIOLS)

      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE FANTALINCCR(DJI,DJK,ANGFACT,NNAT,XOBS,XTOLPROT,
     &                       NOMEFILE1,ERWPROT,ERRORE)
C     ------------------------------------------------------------------
C     Handles the stuff for the calculation of CCR constant coefficient
C
C     CX,CY,CZ(STRUCTURE,ATOMNUMBER) keep coordinates of nuclei
C     FX,FY,FZ(STRUCTURE,ATOMNUMBER) keep coordinates of metal
C     NAT is a vector with the number of atoms
C     OBS is a vector with the observed cross correlation rates
C     TOLPROT is a vector with the errors on CCR
C     NOMEFILE1 is the name of the file to save deviations
C     ERWPROT is a vector with the weights
C     ERRORE switches the use(1) of weights
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      INCLUDE 'supccr.inc'
      INCLUDE 'fantaxplor.inc'

      INTEGER NNAT,METHOD
      DOUBLE PRECISION AK,A
      COMMON /CRUN/AK
      DOUBLE PRECISION DJI(1000),DJK(1000),ANGFACT(1000),
     &                 XOBS(1000),XTOLPROT(1000),ERWPROT(1000)
      CHARACTER NOMEFILE1*132 
      INTEGER ERRORE

      DO I=1,1000
         AK1(I)=ANGFACT(I)
         RK1(I)=DJI(I)
         RK2(I)=DJK(I)
      END DO

      PRINT*,'                      '
      PRINT*,'===---FANTACROSS---==='
C     ------------------------------------------------------------------
C     IHP is the number of CCR
C     ------------------------------------------------------------------
      NAT=NNAT
      IHP=NNAT
      NHP=NNAT
      PRINT*,'IHP is:',IHP
C     ------------------------------------------------------------------
C     NFE is the number of paramagnetic centers
C     ------------------------------------------------------------------
      NFE=1
      NIA=0
C     ------------------------------------------------------------------
C     Reference system not active
C     ------------------------------------------------------------------
      NSYSTEM=0
C     ------------------------------------------------------------------
C     Calculation is done on a single structure
C     ------------------------------------------------------------------
      NSTR=1
C     ------------------------------------------------------------------
C     Errors are set to 0
C     ------------------------------------------------------------------
      PERC=0
C     ------------------------------------------------------------------
C     Grid setting
C     ------------------------------------------------------------------
      NGRID=1
C     ------------------------------------------------------------------
C     Weights and multiplicity are set to 1
C     ------------------------------------------------------------------
      DO NIA=1,NAT
         MLPROT(NIA)=1
         IF(ERRORE.EQ.0) THEN
            WPROT(NIA)=1
         ELSE
            WPROT(NIA)=ERWPROT(NIA)
         END IF
      END DO

      OPEN(322,FILE='FANTACROSS.LOG')
C     ------------------------------------------------------------------
C     Vectors are passed from Xplor-NIH core
C     ------------------------------------------------------------------
      DO NIA=1,NAT
         OBS(NIA)=XOBS(NIA)
C     ------------------------------------------------------------------
C     No tolerance in fitting
C     ------------------------------------------------------------------
         TOLPROT(NIA)=0
      END DO
      CLOSE (322)
      FILENAME3=NOMEFILE1
      PRINT*,'NOMEFILE1 is:',NOMEFILE1
      OPEN(744,FILE=FILENAME3)

      CALL CSIMPLEXRUN()

      RETURN    
      END  
C     ------------------------------------------------------------------
      SUBROUTINE CSIMPLEXRUN()  
C     ------------------------------------------------------------------
C     Calculates the CCR constant coefficient which minimizes the 
C     experimental-to-calculated squared difference
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      INCLUDE 'supccr.inc'

      DIMENSION SIMP(MP,NP),EXTR(NP),VAL(MP)  
      DIMENSION ZRR(3,3)  

      OLDRESID=1.E+9  
      RESID=2.E+9  
      IVIOLATION=2000000  
      IOLDVIO=1000000  
C     ------------------------------------------------------------------
C     Initial conditions grid
C     ------------------------------------------------------------------
      DELTA=3.14159/DBLE(NGRID+1)  
      DO 1000 L=1,NGRID  
         DO 999 NK=1,NFE  
            SIMP(1,(NK-1)*MPAR+1)=1000.*(1.-2*RAND())  
999      CONTINUE  
         DO 10 I=1,MP  
            DO 10 J=1,NP  
               SIMP(I,J)=SIMP(1,J)  
               IF (I.EQ.1) THEN  
                   SIMP(1,J)=SIMP(1,J)*0.8  
               ENDIF  
               IF (I.EQ.J+1) THEN  
                   SIMP(I,J)=SIMP(I,J)/0.8*1.2  
               ENDIF  
10       CONTINUE  
         DO 11 I=1,MP  
            DO 12 J=1,NP  
12             EXTR(J)=SIMP(I,J)  
               VAL(I)=CCASH(EXTR)  
11       CONTINUE  
         CALL CSIMPCALC(SIMP,VAL)  
C     ------------------------------------------------------------------
C     Criterion of minimization of optimal solution
C     ------------------------------------------------------------------
         IF (OLDRESID.GE.RESID) THEN  
             OLDRESID=RESID  
             IOLDVIO=IVIOLATION  
             DO 13 I=1,NFE  
                OPTPHI(I)=PHI(I)  
13           CONTINUE  
         ENDIF  
1000  CONTINUE  

      DO 998 NK=1,NFE  
         EXTR((NK-1)*MPAR+1)=OPTPHI(NK)  
998   CONTINUE 

      PRINT*,' '  
      WRITE(*,FMT='(1X,A)') ' *****    BEST SOLUTION    *****'  
      PRINT*,' '  
      WRITE(*,20) IOLDVIO,OLDRESID  
      WRITE(*,21) (OPTPHI(I),I=1,NFE)  
      WRITE(*,*) 'Value of K =',OPTPHI(1)
      WRITE(744,*) 'Value of K =',OPTPHI(1)

20    FORMAT (1X,' VIOLATIONS ',I6,1X,' RESIDUALS ',F10.3)  
21    FORMAT (1X,'K = ',F15.3)  
  
      ERR=CCASH(EXTR)  
      CALL CDISPSHIFT

      RETURN  
      END  
C     ------------------------------------------------------------------
      SUBROUTINE CSIMPCALC(P,Y)  
C     ------------------------------------------------------------------
C     Simplex calculation
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      INCLUDE 'supccr.inc'
      INCLUDE 'fantaxplor.inc'  

      PARAMETER (AL=1.,BE=.5,GA=2.)  
      DIMENSION P(MP,NP),Y(MP),PR(MP),PT(MP),PE(MP),  
     &          PC(MP),PK(MP),PBAR(MP),OLDP(NP),EXTR(MP)  
C     ------------------------------------------------------------------
C     Algorithm initialization
C     ------------------------------------------------------------------
      ITER=0  
      RNDOM=0  
1     PERM=1  
      DO 1000 WHILE (PERM.GT.0)  
         PERM=0  
         DO 1100 I=1,NP  
            IF (Y(I).GT.Y(I+1)) THEN  
                APP=Y(I+1)  
                Y(I+1)=Y(I)  
                Y(I)=APP  
                DO 1200 J=1,NP  
                   APP=P(I+1,J)  
                   P(I+1,J)=P(I,J)  
                   P(I,J)=APP 
1200            CONTINUE  
                PERM=PERM+1  
            ENDIF  
1100     CONTINUE    
1000  CONTINUE  

      AVERAGE=0  
      ASTDEV=0  
      DO 100 I=1,MP  
100   AVERAGE=AVERAGE+Y(I)  
      AVERAGE=AVERAGE/MP  
      DO 101 I=1,MP  
101   ASTDEV=ASTDEV+(Y(I)-AVERAGE)**2.  
      ERR=DSQRT(ASTDEV/MP)  
      RESID=Y(1)    
      IF (ITER.GT.39999.OR.ERR.LT.1.D-9) THEN  
          WRITE (*,200) ITER,IVIOLATION,RESID  
          WRITE (*,201) (P(1,(I-1)*MPAR+5),I=1,NFE)  
200       FORMAT (1X,'Iters ',I6,1X,' Violations ',I6,  
     &            1X,'Residuals= ',F10.3)  
201       FORMAT (1X,'K = ',F9.3)
          DO 997 NK=1,NFE  
             PHI(NK)=P(1,(NK-1)*MPAR+1)  
997       CONTINUE  
          RETURN  
      ENDIF  

      ITER=ITER+1  
      DO 12 J=1,NP  
12    PBAR(J)=0  
      DO 13 I=1,NP  
         DO 13 J=1,NP  
13    PBAR(J)=PBAR(J)+P(I,J)  
      DO 14 J=1,NP  
         PBAR(J)=PBAR(J)/NP  
         PR(J)=(1.+AL)*PBAR(J)-AL*P(MP,J)  
14    CONTINUE  
      YR=CCASH(PR)  
      DO 15 J=1,NP  
         PK(J)=PR(J)  
15    CONTINUE  
      YK=YR  
      IF (YR.LT.Y(NP)) THEN  
          IF (YR.LT.Y(1)) THEN  
              DO 16 J=1,NP  
                 PE(J)=GA*PR(J)+(1.-GA)*PBAR(J)  
16            CONTINUE  
              YE=CCASH(PE)  
              ITER=ITER+1  
              IF (YE.LT.Y(1)) THEN  
                  DO 17 J=1,NP  
                     PK(J)=PE(J)  
17                CONTINUE  
                  YK=YE 
              ENDIF  
          ENDIF  
      ELSE   
          DO 18 J=1,NP  
             PT(J)=P(MP,J)  
18        CONTINUE  
          YT=Y(MP)  
          IF (YR.LT.YT) THEN  
              DO 19 J=1,NP  
                 PT(J)=PR(J)  
19            CONTINUE  
              YT=YR  
          ENDIF  
          DO 20 J=1,NP  
             PC(J)=BE*PT(J)+(1.-BE)*PBAR(J)  
20        CONTINUE  
          YC=CCASH(PC)  
          ITER=ITER+1  
          IF (YC.LT.Y(NP)) THEN  
              DO 21 J=1,NP  
                 PK(J)=PC(J)  
21            CONTINUE  
              YK=YC  
          ELSE  
              DO 22 I=1,NP  
                 OLDP(I)=P(2,I)  
22            CONTINUE  
              DO 24 I=2,NP   
                 DO 23 J=1,NP  
                    P(I,J)=.5*(P(1,J)+P(I,J))  
23               CONTINUE  
                 PR(I)=P(I,I)    
                 Y(I)=CCASH(PR)  
24            CONTINUE  
              ITER=ITER+NP-1  
              DO 25 I=1,NP  
                 OLDP(I)=ABS(OLDP(I)-P(2,I))  
25            CONTINUE  
              OLDPOPPA=0   
              DO 251 I=1,NP-1  
                 OLDPOPPA=OLDPOPPA+OLDP(I)  
251           CONTINUE  
              IF (ABS(OLDPOPPA).LT.1.D-8.AND.RNDOM.LT.10) THEN  
                  RNDOM=RNDOM+1  
                  WRITE(*,FMT='(BN,A,F16.6)') 'RANDOM  ',Y(1)  
                  DO 2001 IL=1,MP  
                     DO 2002 IM=1,NP  
                        RMR=1+RAND()  
                        P(IL,IM)=P(IL,IM)*RMR  
2002                 CONTINUE  
2001              CONTINUE     
                  DO 2011 IL=1,MP  
                     DO 2012 JM=1,NP  
2012                 EXTR(JM)=P(IL,JM)  
                     Y(IL)=CCASH(EXTR)  
2011              CONTINUE  
                  GOTO 1   
              ENDIF   
              IF (ABS(OLDPOPPA).LT.1.D-9) THEN  
                  ITER=50000  
              ENDIF  
              DO 26 J=1,NP  
                 PK(J)=0.5*(P(1,J)+P(MP,J))  
26            CONTINUE  
              YK=CCASH(PK)  
              ITER=ITER+1  
          ENDIF  
      ENDIF  
      DO 27 J=1,NP  
         P(MP,J)=PK(J)  
27    CONTINUE  
      Y(MP)=YK   
      GOTO 1  
      END  
C     ------------------------------------------------------------------
      FUNCTION CCASH(VETT)  
C     ------------------------------------------------------------------
C     Calculation of deviations and violations
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      INCLUDE 'supccr.inc'  

      DIMENSION VETT(NP)
      INTEGER M1  

      IVIOLATION=0  
      TMP1=0  
      I=1  
      DO WHILE (I.LE.NHP*NSTR)  
         CSHIFT(I)=0.0  
         I=I+1  
      ENDDO  

      DO 1 N=1,NSTR  
         DO 2 M=1,NFE  
            P=VETT((M-1)*MPAR+1)  
            TMP2=0.0  
            I=1  
            IHP=(N-1)*NHP 
            DO 10 WHILE (I.LE.NHP)  
               NPROTML=MLPROT(IHP+I)
               CSHIFT(IHP+I)=CSHIFT(IHP+I)+AK1(IHP+I)/(RK2(IHP+I)**3*
     &                       RK1(IHP+I)**3)
               I=I+1  
10          CONTINUE  
2        CONTINUE  
         DO 3 I=1,NHP  
            TMP2=ABS(CSHIFT(IHP+I)-OBS(IHP+I))-TOLPROT(IHP+I)  
            IF (TMP2.GT.0.0) THEN  
                IVIOLATION=IVIOLATION+1  
                TMP1=TMP1+TMP2**2*WPROT(IHP+I)/DBLE(MLPROT(IHP+I))  
            ENDIF  
3        CONTINUE   
1     CONTINUE  
  
      CCASH=TMP1  

      RETURN  
      END  
C     ------------------------------------------------------------------
      SUBROUTINE CDISPSHIFT 
C     ------------------------------------------------------------------
C     Display of violations
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      INCLUDE 'supccr.inc'
      INCLUDE 'fantaxplor.inc'  

      CHARACTER FILESTR*21,SS*40  
      DIMENSION VV(MAXSTR,MAXOS),VMAX(MAXOS),VMIN(MAXOS)  

      RM=0  
      TMP1=0  
      SMED=0  
      STDEV=0  
      DO 2 I=1,NSTR  
         DO 2 J=1,NHP  
            TMP2=ABS(OBS(J+(I-1)*NHP)-CSHIFT(J+(I-1)*NHP))-
     &           TOLPROT(J+(I-1)*NHP)  
            IF (TMP2.GT.0.0) THEN  
                IF (CSHIFT(J+(I-1)*NHP).GT.OBS(J+(I-1)*NHP)) THEN  
                    VV(I,J)=TMP2  
                ELSE  
                    VV(I,J)=-TMP2  
                ENDIF  
            ELSE  
                VV(I,J)=0.  
            ENDIF  
2     CONTINUE  
      DO 44 I=1, NHP  
         VMAX(I)=0.  
         VMIN(I)=1000.  
44    CONTINUE  
      DO 4 J=1,NHP  
         DO 4 I=1,NSTR  
            IF (ABS(VV(I,J)).GT.ABS(VMAX(J))) THEN   
                VMAX(J)=VV(I,J)  
            ENDIF  
            IF ((ABS(VV(I,J)).LT.ABS(VMIN(J))).AND.(VV(I,J).NE.0.)) THEN
                 VMIN(J)=VV(I,J)   
            ENDIF  
4     CONTINUE     
      DO 7 J=1,NHP  
         DO 8 I=1,NSTR  
            IF (ABS(VV(I,J)).GT.0.) THEN  
                SS(I:I+1)="*"  
            ELSE  
                SS(I:I+1)=" "  
            ENDIF  
8        CONTINUE  
         IF (VMIN(J).EQ.1000.) THEN  
             VMIN(J)=0.  
         ENDIF  
7     CONTINUE      
  
      WRITE(744,'(1X)')   
      WRITE(744,'(1X)')   
      WRITE(744,'(1X)')   
      WRITE(744,'(1X,A)')  
     &      '    PROTONS              OBS.    CALC.    ERR.^2'

      FILESTR='USELESS.FILE'  
      NIA=0
      REWIND(1)  
      DO 3 J=1,NHP*NSTR  
         TMP2=ABS(OBS(J)-CSHIFT(J))-TOLPROT(J)
         NIA=NIA+1
         IF (TMP2.GT.0.0) THEN  
             IVIOLATION=IVIOLATION+1  
             RM=RM+1  
             SMED=SMED+TMP2**2*WPROT(J)/MLPROT(J)  
             TMP1=TMP2**2*WPROT(J)/MLPROT(J)  
             WRITE (744,'(1X,A4,1X,A4,1X,A4,1X,F7.3,1X,F7.3,1X,F10.5)')
     &              NRESIDFA(NIA),NRESFA(NIA),NTYPEFA(NIA),
     &              OBS(J),CSHIFT(J),TMP1
15           FORMAT(1X,A,1X,F7.3,1X,F7.3,1X,F7.3)  
         ELSE  
             WRITE (744,'(1X,A4,1X,A4,1X,A4,1X,F7.3,1X,F7.3)')  
     &              NRESIDFA(NIA),NRESFA(NIA),NTYPEFA(NIA),
     &              OBS(J),CSHIFT(J)
        ENDIF  
3     CONTINUE  
      SMED=SMED/RM  

      DO 41 J=1,NHP*NSTR  
         TMP2=ABS(OBS(J)-CSHIFT(J))-TOLPROT(J)  
         IF (TMP2.GT.0.0) THEN  
             STDEV=STDEV+(TMP2**2-MED)**2*WPROT(J)/MLPROT(J)  
         ENDIF  
41    CONTINUE  
      STDEV=STDEV/RM  

      PRINT*,' '  
      WRITE(744,'(A)') ' '   
      WRITE(*,11) 'Mean value of error =',SMED  
11    FORMAT(1X,A,1X,F10.6)  
      WRITE(744,12) 'Mean value of error =',SMED  
12    FORMAT(1X,A,1X,F10.6)  
      WRITE(*,13) 'Standard deviation =',STDEV  
13    FORMAT(1X,A,1X,F10.6)      
      WRITE(744,14) 'Standard deviation =',STDEV  
14    FORMAT(1X,A,1X,F10.6)           
      CLOSE(744)  

      RETURN  
      END  

C ===============
      SUBROUTINE ECOLLAPSE(EC)
C 
C Front end for ECOLLAPSE2
C
C John Kuszewski 11/12/98
C ===============
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'collapse.inc'
      INCLUDE 'heap.inc'
C i/o
      DOUBLE PRECISION EC
C local vbls
C begin
      CALL ECOLLAPSE2(EC, HEAP(CLPSSELPTR))
      RETURN
      END
C ===============
      SUBROUTINE ECOLLAPSE2(EC, SELECTEDATOMS)
C
C Energy term for a simple collapse-inducing force
C
C Just forces the radius of gyration to be equal to
C the given value
C
C Perhaps I'll someday change this to handle mass-weighting
C and selections of atoms instead of all atoms
C
C JJK 6/14/96
C ===============
      IMPLICIT NONE
C i/o
      DOUBLE PRECISION EC
      INTEGER SELECTEDATOMS(*)
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'numbers.inc'
      INCLUDE 'collapse.inc'
      INCLUDE 'deriv.inc'
C local vbls 
      DOUBLE PRECISION CENX, CENY, CENZ, SUM, N, RGYR
      DOUBLE PRECISION DEDXI, DEDYI, DEDZI
      INTEGER COUNT
C begin
C
C first, calculate the centroid of the structure
C
      N = NSELECTED
      CENX = ZERO
      CENY = ZERO
      CENZ = ZERO
      DO COUNT = 1, NSELECTED
           CENX = CENX + X(SELECTEDATOMS(COUNT))
           CENY = CENY + Y(SELECTEDATOMS(COUNT))
           CENZ = CENZ + Z(SELECTEDATOMS(COUNT))
      END DO
      CENX = CENX / N
      CENY = CENY / N
      CENZ = CENZ / N
C
C Now calculate radius of gyration
C
C Rg = RMS (xi - xcm)
C    = Sqrt(Sum(ri - rcm)^2)) / Sqrt(N)
C
C where N is the number of items in the sum
C
      SUM = ZERO
      DO COUNT = 1, NSELECTED
           SUM = SUM + (X(SELECTEDATOMS(COUNT)) - CENX)**2 + 
     &                 (Y(SELECTEDATOMS(COUNT)) - CENY)**2 + 
     &                 (Z(SELECTEDATOMS(COUNT)) - CENZ)**2
      END DO
      RGYR = SQRT(SUM) / SQRT(N)
      EC = KCOLLAPSE * (RGYR - RTARGET)**2
C
C Now calculate forces
C
      DO COUNT = 1, NSELECTED
           DEDXI = 2 * KCOLLAPSE * (RGYR - RTARGET) * 
     &          (X(SELECTEDATOMS(COUNT)) - CENX) /
     &          (SQRT(N) * SQRT(SUM))
           DEDYI = 2 * KCOLLAPSE * (RGYR - RTARGET) * 
     &          (Y(SELECTEDATOMS(COUNT)) - CENY) /
     &          (SQRT(N) * SQRT(SUM))
           DEDZI = 2 * KCOLLAPSE * (RGYR - RTARGET) * 
     &          (Z(SELECTEDATOMS(COUNT)) - CENZ) /
     &          (SQRT(N) * SQRT(SUM))
           DX(SELECTEDATOMS(COUNT)) = DX(SELECTEDATOMS(COUNT)) + DEDXI
           DY(SELECTEDATOMS(COUNT)) = DY(SELECTEDATOMS(COUNT)) + DEDYI
           DZ(SELECTEDATOMS(COUNT)) = DZ(SELECTEDATOMS(COUNT)) + DEDZI
      END DO
      RETURN
      END
C ================
      SUBROUTINE READCOLLAPSE
C
C Reads the input for collapse-energy stuff.
C
C JJK 6/14/96
C ================
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'collapse.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C local vbls
C begin
C
      CALL PUSEND('COLLAPSE>')
      DO WHILE (.NOT.DONE)
           CALL NEXTWD('COLLAPSE>')
           CALL MISCOM('COLLAPSE>',USED)
           IF (.NOT.USED) THEN
C
                IF (WD(1:4).EQ.'HELP') THEN
C-DOCUMENTATION-SOURCE-BEGIN
                WRITE(DUNIT,'(8X,A)')
     &'COLLapse <collapse-statement> END ',
     &'<COLLapse-statement>:== ',
     &'   FORCe <real> | sets the force constant (default 1.0)',
     &'   TARGet <real> | sets the target radius of gyration',
     &'      | (default 1.0)',
     &'   SELEction <sel> | selects the atoms which are to be',
     &'      | used to determine Rgyr and which get the forces',
     &'      | (default: no atoms selected) '
C-DOCUMENTATION-SOURCE-END
C
C set the force constant
C
                ELSE IF (WD(1:4).EQ.'FORC') THEN
                     CALL NEXTF('force constant =', KCOLLAPSE)
C
C set the target radius of gyration
C
                ELSE IF (WD(1:4).EQ.'TARG') THEN
                     CALL NEXTF('target radius of gyration', RTARGET)
C
C get the selection of atoms to include 
C
                ELSE IF (WD(1:4).EQ.'SELE') THEN
                     IF (CLPSSELPTR.EQ.0) THEN
                          CLPSSELPTR=ALLHP(INTEG4(NATOM))
                     END IF
                     CALL READCOLLAPSE2(HEAP(CLPSSELPTR))
C     
C check for END statement
C
                ELSE
                     CALL CHKEND('COUPLINGS>', DONE)
                END IF
           END IF
      END DO
      DONE = .FALSE.
      RETURN
      END
C ==============
      SUBROUTINE READCOLLAPSE2 (SEL)
C
C Reads the selection of atoms to include in the collapse term
C 
C John Kuszewski 11/12/98
C ==============
      IMPLICIT NONE
C include files
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'collapse.inc'
C i/o
      INTEGER SEL(*)
C local vbls
C begin
      CALL SELCTA(SEL, NSELECTED, X, Y, Z,.TRUE.)
      CALL MAKIND(SEL, NATOM, NSELECTED) 
      RETURN
      END
C ==============
      SUBROUTINE COLLAPSEINIT
C
C initializes stuff for the collapse energy term
C
C JJK 6/14/96
C ==============
      IMPLICIT NONE
C include files
      INCLUDE 'collapse.inc'
C begin
      KCOLLAPSE = 1.0D0
      RTARGET = 1.0D0
      NSELECTED = 0
      CLPSSELPTR = 0
      RETURN 
      END

      SUBROUTINE SELCTA(FLAGS,NSELCT,X,Y,Z,QCOOR)
C
C Recursive atom selection routine.
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C =======================
C
C Parameter MAXDEP specifies the maximum depth of an expression
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INTEGER FLAGS(*)
      INTEGER NSELCT
      DOUBLE PRECISION X(*), Y(*), Z(*)
      LOGICAL QCOOR
C local
      INTEGER RETADR, QSTACK
      INTEGER RETMAX, MAXDEP, STKSIZ
      PARAMETER (RETMAX=100, MAXDEP=10)
C begin
      STKSIZ=MAX(MAXDEP*NATOM,MAXDEP)
      RETADR=ALLHP(INTEG4(RETMAX))
      QSTACK=ALLHP(ILOGIC(STKSIZ))
      CALL SELCT2(RETMAX,HEAP(RETADR),FLAGS,NSELCT,QCOOR,X,Y,Z,
     &            STKSIZ,HEAP(QSTACK))
      CALL FREHP(QSTACK,ILOGIC(STKSIZ))
      CALL FREHP(RETADR,INTEG4(RETMAX))
      END
C
      SUBROUTINE SELCT2(RETMAX,RETADR,FLAGS,NSELCT,QCOOR,
     &           XC,YC,ZC,STKSIZ,QSTACK)
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'xcrystal.inc'
      INCLUDE 'xtarget.inc'
      INCLUDE 'ncs.inc'
      INTEGER RETMAX, RETADR(*), FLAGS(*), NSELCT
      LOGICAL QCOOR
      DOUBLE PRECISION XC(*), YC(*), ZC(*)
      INTEGER STKSIZ
      LOGICAL QSTACK(*)
C local
      INTEGER QSTKLN, QSTART, QINDX1, QINDX2, QLIFT
      INTEGER ISTK
      LOGICAL ELEMNT, OK, ERR, QKNOWN, XRERR
      LOGICAL QRANGE, QABS, QWCARD, QWCARD1, QWCARD2, QWCARD3, EXIST
      LOGICAL CLOOP
      INTEGER IAT, IATS1
      INTEGER IAT2, NUMB, NUMB1, NUMB2
      INTEGER I, INDX1, IGRP, IBT, JBT
      INTEGER J, IDLEN, K, IATS2, IIAT
      INTEGER LEVEL, ISYM, INSYM
      DOUBLE PRECISION RMAX, RMAX2, DIST2, DXL, DYL, DZL, R(3)
      DOUBLE PRECISION XREF, YREF, ZREF
C MODIFICATION: selection token lengths doubled for wildcards with
C backslash escapes, and for input of numeric resSeq > 9999.
      CHARACTER*8 SEG1,  RES1,  RESN1,  RESID1,  SEG2,  RESN2
      INTEGER LSEG1, LRESN1, LRESD1, LSEG2, LRESN2
      CHARACTER*8 RESID2, TYPE1, TYPE2
      INTEGER LRESD2,LTYPE1,LTYPE2
      INTEGER LRESD
      CHARACTER*2 ALT1, ALT2
      INTEGER LALT1, LALT2
      CHARACTER*1 ALPH, ALPH1, ALPH2
      CHARACTER*1 SBRA, SKET
      PARAMETER (SBRA='(',SKET=')')
      DOUBLE PRECISION DPVAL
      DOUBLE COMPLEX DCVAL
      DOUBLE PRECISION XMIN, XMAX, YMIN, YMAX, ZMIN, ZMAX
      DOUBLE PRECISION XRRF, YRRF, ZRRF, XRRFF, YRRFF, ZRRFF
C pointer
      INTEGER XF, YF, ZF, XFF, YFF, ZFF, XFFF, YFFF, ZFFF
C parameter
      DOUBLE PRECISION ZERO, ONE, BIG
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, BIG=10000.0D0)
C
C begin
C
C initialize working stack
      QSTART=1
      QSTKLN=NATOM
      QLIFT=0
C
      LEVEL=1
C
      CALL SENEXT
      IF (WD(1:4).EQ.'=   ') CALL SENEXT
      IF (WD(1:2).EQ.'? ') THEN
C
C-begin-show-the-current-set
C
C This procedure prints a listing of the atoms that are currently
C set.
      WRITE(6,7001)
7001  FORMAT(' The following atoms are currently set:')
C
      SEG1='    '
      RES1='    '
      RESN1='    '
      J=0
      DO IAT=1,NATOM
      IF (SEG1.NE.SEGID(IAT).OR.RES1.NE.RESID(IAT).OR.RESN1.NE.RES(IAT))
     1 THEN
      SEG1=SEGID(IAT)
      RES1=RESID(IAT)
      RESN1=RES(IAT)
      IF (J.GT.0) WRITE(6,'(2A)') ' ',WD(1:WDLEN)
      WDLEN=0
      CALL ADDST(WD,WDMAX,WDLEN,SEGID(IAT),4)
      CALL ADDST(WD,WDMAX,WDLEN,' ',1)
      CALL ADDST(WD,WDMAX,WDLEN,RESID(IAT),4)
      CALL ADDST(WD,WDMAX,WDLEN,' ',1)
      CALL ADDST(WD,WDMAX,WDLEN,RES(IAT),4)
      IDLEN = WDLEN
      J=0
      END IF
      IF (FLAGS(IAT).EQ.1) THEN
      IF (WDLEN+1+4 .GT. 78) THEN
      WRITE(6,'(2A)') ' ',WD(1:WDLEN)
      J = 0
      WDLEN = 0
      DO K=1,IDLEN
      CALL ADDST(WD,WDMAX,WDLEN,' ',1)
      END DO
      END IF
      CALL ADDST(WD,WDMAX,WDLEN,' ',1)
      CALL ADDST(WD,WDMAX,WDLEN,TYPE(IAT),4)
      J=J+1
      END IF
      END DO
      IF (J.GT.0) WRITE(6,'(2A)') ' ',WD(1:WDLEN)
C-end-show-the-current-set
C
C jump to exit
      GOTO 99999
C
      END IF
C
C check that expression begins with a "("
      IF (.NOT.WD(1:1).EQ.SBRA) THEN
      CALL DSPERR('SELRPN','selection has to begin with a "("')
      CALL WRNDIE(-5,'SELRPN','parsing error')
C jump to exit
      GOTO 99999
      END IF
C
      CALL SENEXT
C ** invoke procedure expression **
      RETADR(LEVEL)=1
      GOTO 1110
1111  CONTINUE
C ** return label                **
C
C
      IF (.NOT.WD(1:1).EQ.SKET) THEN
      CALL DSPERR('SELRPN','selection has to end with a ")"')
      CALL SAVEWD
      END IF
      DONE=.FALSE.
C
C ** return      **
      GOTO 9999
C ** return      **
C
C
C---- BEGIN PROCEDURE EXPRESSION --------------------------------------
1110  CONTINUE
      CALL SEDOWN(LEVEL,RETMAX)
C
C ** invoke procedure term    **
      RETADR(LEVEL)=3
      GOTO 2220
2223  CONTINUE
C ** return label             **
C
2233  IF (WD(1:2).NE.'OR') GOTO 1122
      CALL SENEXT
C
C ** invoke procedure term    **
      RETADR(LEVEL)=4
      GOTO 2220
2224  CONTINUE
C ** return label             **
C
C-begin-process-or-operator
      QINDX1=QSTART
      QINDX2=QSTART-QSTKLN
      DO IAT=1,NATOM
      QSTACK(QINDX2)=QSTACK(QINDX1).OR.QSTACK(QINDX2)
      QINDX1=QINDX1+1
      QINDX2=QINDX2+1
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C-end-process-or-operator
C
      GOTO 2233
1122  CONTINUE
C
C
      CALL SEUP(LEVEL,RETMAX)
C
C     return to address:
      IF (RETADR(LEVEL).EQ.1) GOTO 1111
      IF (RETADR(LEVEL).EQ.2) GOTO 1112
      WRITE(6,'(A)') 
     & ' %SELRPN-ERR: Return address unknown. Fatal coding error'
      CALL DIE
C---- END PROCEDURE EXPRESSION ---------------------------------------
C
C
C
C---- BEGIN PROCEDURE TERM -------------------------------------------
2220  CONTINUE
      CALL SEDOWN(LEVEL,RETMAX)
C
C ** invoke procedure factor   **
      RETADR(LEVEL)=5
      GOTO 3330
3335  CONTINUE
C ** return label              **
C
4455  IF (WD(1:3).NE.'AND') GOTO 5566
      CALL SENEXT
C
C ** invoke procedure factor   **
      RETADR(LEVEL)=6
      GOTO 3330
3336  CONTINUE
C ** return label              **
C
C-begin-process-and-operator
      QINDX1=QSTART
      QINDX2=QSTART-QSTKLN
      DO IAT=1,NATOM
      QSTACK(QINDX2)=QSTACK(QINDX1).AND.QSTACK(QINDX2)
      QINDX1=QINDX1+1
      QINDX2=QINDX2+1
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C-end-process-and-operator
C
      GOTO 4455
5566  CONTINUE
C
      CALL SEUP(LEVEL,RETMAX)
C
C     return to address:
      IF (RETADR(LEVEL).EQ.3) GOTO 2223
      IF (RETADR(LEVEL).EQ.4) GOTO 2224
      WRITE(6,'(A)') 
     & ' %SELRPN-ERR: Return address unknown. Fatal coding error.'
      CALL DIE
C---- END PROCEDURE TERM ----------------------------------------------
C
C
C
C
C
C---- BEGIN PROCEDURE FACTOR ------------------------------------------
3330  CONTINUE
      CALL SEDOWN(LEVEL,RETMAX)
C=NOT===================================================================
      IF (WD(1:3).NE.'NOT') GOTO 10
C
      CALL SENEXT
C
C ** invoke procedure factor  **
      RETADR(LEVEL)=7
      GOTO 3330
3337  CONTINUE
C ** return label             **
C
C-begin-process-not-operator
      QINDX1=QSTART
      DO IAT=1,NATOM
      QSTACK(QINDX1)=.NOT.QSTACK(QINDX1)
      QINDX1=QINDX1+1
      END DO
C-end-process-not-operator
C
      GOTO 77777
C=BYRE===================================================================
10    IF (WD(1:4).NE.'BYRE') GOTO 20
C
      CALL SENEXT
C
C ** invoke procedure factor  **
      RETADR(LEVEL)=8
      GOTO 3330
3338  CONTINUE
C ** return label             **
C
C-begin-process-byres-operator
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1)=QSTACK(INDX1-QSTKLN)
      END DO
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1-QSTKLN)=.FALSE.
      END DO
      DO IAT2=1,NATOM
      IF (QSTACK(QSTART+IAT2-1)) THEN
      SEG1=SEGID(IAT2)
      RES1=RESID(IAT2)
      RESN1=RES(IAT2)
      DO IAT=1,NATOM
      IF (SEGID(IAT).EQ.SEG1) THEN
      IF (RESID(IAT).EQ.RES1.AND.RES(IAT).EQ.RESN1) THEN
      QSTACK(QSTART-QSTKLN+IAT-1)=.TRUE.
      END IF
      END IF
      END DO
      END IF
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C-end-process-byres-operator
C
      GOTO 77777
C=BYGR==============================================================
20    IF (WD(1:4).NE.'BYGR') GOTO 30
C
      CALL SENEXT
C
C ** invoke procedure factor  **
      RETADR(LEVEL)=9
      GOTO 3330
3339  CONTINUE
C ** return label             **
C
C-begin-process-bygroup-operator
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1)=QSTACK(INDX1-QSTKLN)
      END DO
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1-QSTKLN)=.FALSE.
      END DO
      DO IGRP=1,NGRP
      IAT2=IGPBS(IGRP)
      ELEMNT=.FALSE.
      CLOOP = .TRUE.
      DO WHILE (CLOOP)
      IAT2=IAT2+1
      IF (QSTACK(QSTART+IAT2-1)) THEN
      DO IAT=IGPBS(IGRP)+1,IGPBS(IGRP+1)
      QSTACK(QSTART-QSTKLN+IAT-1)=.TRUE.
      END DO
      ELEMNT=.TRUE.
      END IF
      IF (ELEMNT.OR.IAT2.GE.IGPBS(IGRP+1)) CLOOP = .FALSE.
      END DO
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C-end-process-bygroup-operator
C
      GOTO 77777
C=BOUN=========================================================
30    IF (WD(1:4).NE.'BOND') GOTO 40
C
      CALL SENEXT
C
C ** invoke procedure factor  **
      RETADR(LEVEL)=10
      GOTO 3330
3340  CONTINUE
C ** return label             **
C
C BONDedto operator added by Michael Nilges, EMBL
C-begin-process-bondedto-operator
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1)=QSTACK(INDX1-QSTKLN)
      END DO
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1-QSTKLN)=.FALSE.
      END DO
      DO I=1,NBOND
      IBT=IB(I)
      JBT=JB(I)
      IF (IBT.GT.0 .AND. JBT.GT.0) THEN
      IF(QSTACK(QSTART+JBT-1)) THEN
      QSTACK(QSTART-QSTKLN+IBT-1)=.TRUE.
      END IF
      IF(QSTACK(QSTART+IBT-1)) THEN
      QSTACK(QSTART-QSTKLN+JBT-1)=.TRUE.
      END IF
      END IF
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C-end-process-boundto-operator
C
      GOTO 77777
C=(============================================================
40    IF (WD(1:1).NE.SBRA) GOTO 50
C
      CALL SENEXT
C
C ** invoke procedure expression **
      RETADR(LEVEL)=2
      GOTO 1110
1112  CONTINUE
C ** return label                **
      IF (.NOT.WD(1:1).EQ.SKET) THEN
      WRITE(6,'(A)') ' %SELRPN-ERR: unbalanced parentheses.'
      CALL WRNDIE(-5,'SELRPN','parsing error')
C exit selection subroutine
      GOTO 99999
      END IF
      CALL SENEXT
      GOTO 77777
C==============================================================
C==========
C ALL token
C==========
50    IF (WD(1:3).EQ.'ALL') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      ELEMNT=.TRUE.
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      CALL SENEXT
C==========
C NONE token
C==========
      ELSE IF (WD(1:4).EQ.'NONE') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      ELEMNT=.FALSE.
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      CALL SENEXT
C
C===========
C PREV token
C===========
      ELSE IF (WD(1:4).EQ.'PREV') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      ELEMNT=(FLAGS(IAT).EQ.1)
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      CALL SENEXT
C
C=============
C RECALL token
C=============
      ELSE IF (WD(1:4).EQ.'RECA'.OR.WD(1:4).EQ.'STOR') THEN
C fill default (FALSE)
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
C
      IF (WD(1:7).EQ.'RECALL1'.OR.WD(1:6).EQ.'STORE1') THEN
      J=1
      ELSE IF (WD(1:7).EQ.'RECALL2'.OR.WD(1:6).EQ.'STORE2') THEN
      J=2
      ELSE IF (WD(1:7).EQ.'RECALL3'.OR.WD(1:6).EQ.'STORE3') THEN
      J=3
      ELSE IF (WD(1:7).EQ.'RECALL4'.OR.WD(1:6).EQ.'STORE4') THEN
      J=4
      ELSE IF (WD(1:7).EQ.'RECALL5'.OR.WD(1:6).EQ.'STORE5') THEN
      J=5
      ELSE IF (WD(1:7).EQ.'RECALL6'.OR.WD(1:6).EQ.'STORE6') THEN
      J=6
      ELSE IF (WD(1:7).EQ.'RECALL7'.OR.WD(1:6).EQ.'STORE7') THEN
      J=7
      ELSE IF (WD(1:7).EQ.'RECALL8'.OR.WD(1:6).EQ.'STORE8') THEN
      J=8
      ELSE IF (WD(1:7).EQ.'RECALL9'.OR.WD(1:6).EQ.'STORE9') THEN
      J=9
      ELSE
      CALL NEXTI('RECALL=',J)
      END IF
      IF (.NOT. (J.GE.1.AND.J.LE.MAXSTO)) THEN
      CALL WRNDIE(-5,'SELRPN','Store number out of range')
      ELSE IF (PTRSTO(J).EQ.0) THEN
      WRITE(6,'(A)') ' SELRPN: Store empty. No atoms selected.'
      ELSE IF (LENSTO(J).NE.NATOM) THEN
      CALL WRNDIE(-5,'SELRPN','dim. mismatch')
      ELSE
      CALL SELRCL(QSTACK(QSTART),HEAP(PTRSTO(J)),NATOM)
      END IF
      CALL SENEXT
C
C=========
C ID token
C=========
      ELSE IF (WD(1:4).EQ.'BYNU'.OR.WD(1:2).EQ.'ID') THEN
      CALL SENEXT
      IATS1=DECODI(WD,WDLEN,OK)
      ERR=.FALSE.
      IF (.NOT.OK.OR.IATS1.LE.0.OR.IATS1.GT.NATOM) THEN
      WRITE(6,'(2A)') ' %SELRPN-BYNU-ERR: no valid number ',WD(1:WDLEN)
      CALL WRNDIE(-5,'SELRPN','no valid number')
      ERR=.TRUE.
      END IF
      IATS2=IATS1
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL SENEXT
      IATS2=DECODI(WD,WDLEN,OK)
      IF (.NOT.OK.OR.IATS2.LE.0.OR.IATS2.GT.NATOM) THEN
      WRITE(6,'(2A)') ' %SELRPN-BYNU-ERR: no valid number ',WD(1:WDLEN)
      CALL WRNDIE(-5,'SELRPN','no valid number')
      ERR=.TRUE.
      END IF
      CALL SENEXT
      END IF
      IF (.NOT.ERR) THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      DO IAT=IATS1,IATS2
      QSTACK(QSTART+IAT-1)=.TRUE.
      END DO
      END IF
C
C============
C SEGID token
C============
      ELSE IF (WD(1:4).EQ.'SEGI') THEN
      CALL NEXTST('segment-id=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(SEG1,LEN(SEG1),LSEG1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL NEXTST('segment-id=',WD)
      CALL COPYST(SEG2,LEN(SEG2),LSEG2,WD,WDLEN)
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=
     &    (SEG1(1:LSEG1).LE.SEGID(IAT).AND.SEGID(IAT).LE.SEG2(1:LSEG2))
      END DO
      ELSE
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(SEGID,4,SEG1,LSEG1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=SEG1(1:LSEG1).EQ.SEGID(IAT)
      END DO
      END IF
C
      END IF
C
C============
C ALTID token
C============
      ELSE IF (WD(1:4).EQ.'ALTI') THEN
      CALL NEXTST('alternate-id=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(ALT1,LEN(ALT1),LALT1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL NEXTST('alternate-id=',WD)
      CALL COPYST(ALT2,LEN(ALT1),LALT2,WD,WDLEN)
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=
     &    (ALT1(1:LALT1).LE.ALTID(IAT).AND.ALTID(IAT).LE.ALT2(1:LALT2))
      END DO
      ELSE
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(ALTID,1,ALT1,LALT1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=ALT1(1:LALT1).EQ.ALTID(IAT)
      END DO
      END IF
C
      END IF
C
C===========
C RESN token
C===========
      ELSE IF (WD(1:4).EQ.'RESN') THEN
      CALL NEXTST('residue-name=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(RESN1,LEN(RESN1),LRESN1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL NEXTST('residue-name=',WD)
      CALL COPYST(RESN2,LEN(RESN2),LRESN2,WD,WDLEN)
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=
     &   (RESN1(1:LRESN1).LE.RES(IAT).AND.RES(IAT).LE.RESN2(1:LRESN2))
      END DO
      ELSE
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(RES,4,RESN1,LRESN1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=RESN1(1:LRESN1).EQ.RES(IAT)
      END DO
      END IF
C
      END IF
C
C============
C RESID token
C============
      ELSE IF (WD(1:4).EQ.'RESI') THEN
      CALL NEXTST('residue-id=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(RESID1,LEN(RESID1),LRESD1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL SPLITI(RESID1,NUMB1,ALPH1,LRESD1,OK)
C
      IF (.NOT.OK) THEN
      WRITE(6,'(2A)') ' %SELRPN-ERR: invalid RESID ',RESID1
      CALL WRNDIE(-5,'SELRPN','invalid residue specification')
      ERR=.TRUE.
      END IF
C
      CALL NEXTST('residue-id=',WD)
      CALL COPYST(RESID2,LEN(RESID2),LRESD2,WD,WDLEN)
      CALL SPLITI(RESID2,NUMB2,ALPH2,LRESD2,OK)
C
      IF (.NOT.OK) THEN
      WRITE(6,'(2A)') ' %SELRPN-ERR: invalid RESID ',RESID2
      CALL WRNDIE(-5,'SELRPN','invalid residue specification')
      ERR=.TRUE.
      END IF
C
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      LRESD=4
      CALL SPLITI(RESID(IAT),NUMB,ALPH,LRESD,OK)
C
      IF (.NOT.OK) THEN
      WRITE(6,'(3A,I9)') 
     & ' %SELRPN-ERR: invalid RESId ',RESID(IAT),' for atom ',IAT
      CALL WRNDIE(-5,'SELRPN','invalid RESID.')
      ERR=.TRUE.
      END IF
C
      QSTACK(QSTART+IAT-1)=
     &      (NUMB1.LT.NUMB.OR.
     &      (NUMB1.EQ.NUMB.AND.ALPH1.LE.ALPH))
     &       .AND.
     &      (NUMB.LT.NUMB2.OR.
     &      (NUMB.EQ.NUMB2.AND.ALPH.LE.ALPH2))
      END DO
      ELSE
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(RESID,4,RESID1,LRESD1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=RESID1(1:LRESD1).EQ.RESID(IAT)
      END DO
      END IF
C
      END IF
C
C===========
C NAME token
C===========
      ELSE IF (WD(1:4).EQ.'TYPE'.OR.WD(1:4).EQ.'NAME') THEN
      CALL NEXTST('atom-name=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(TYPE1,LEN(TYPE1),LTYPE1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL NEXTST('atom-name=',WD)
      CALL COPYST(TYPE2,LEN(TYPE2),LTYPE2,WD,WDLEN)
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=
     &  TYPE1(1:LTYPE1).LE.TYPE(IAT).AND.TYPE(IAT).LE.TYPE2(1:LTYPE2)
      END DO
      ELSE
C
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(TYPE,4,TYPE1,LTYPE1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=TYPE1(1:LTYPE1).EQ.TYPE(IAT)
      END DO
      END IF
C
      END IF
C
C===========
C CHEM token
C===========
      ELSE IF (WD(1:4).EQ.'CHEM') THEN
      CALL NEXTST('chemical-type=',WD)
C
      QWCARD=.NOT.QQUOT
C
      CALL COPYST(TYPE1,LEN(TYPE1),LTYPE1,WD,WDLEN)
      CALL SENEXT
      QRANGE=(WD(1:1).EQ.':')
      IF (QRANGE) THEN
      CALL NEXTST('chemical-type=',WD)
      CALL COPYST(TYPE2,LEN(TYPE2),LTYPE2,WD,WDLEN)
      CALL SENEXT
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=
     &   TYPE1(1:LTYPE1).LE.IAC(IAT).AND.IAC(IAT).LE.TYPE2(1:LTYPE2)
      END DO
      ELSE
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD) THEN
      CALL EQSTWC(IAC,4,TYPE1,LTYPE1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=TYPE1(1:LTYPE1).EQ.IAC(IAT)
      END DO
      END IF
C
      END IF
C
C===========
C ATOM token
C===========
      ELSE IF (WD(1:4).EQ.'ATOM') THEN
      CALL NEXTST('segment-id=',WD)
C
      QWCARD1=.NOT.QQUOT
C
      CALL COPYST(SEG1,LEN(SEG1),LSEG1,WD,WDLEN)
      CALL NEXTST('residue-id=',WD)
C
      QWCARD2=.NOT.QQUOT
C
      CALL COPYST(RES1,LEN(RES1),LRESD1,WD,WDLEN)
      CALL NEXTST('atom-name=',WD)
C
      QWCARD3=.NOT.QQUOT
C
      CALL COPYST(WDT,WDTMAX,WDTLEN,WD,WDLEN)
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD1) THEN
      CALL EQSTWC(SEGID,4,SEG1,LSEG1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=SEG1(1:LSEG1).EQ.SEGID(IAT)
      END DO
      END IF
C
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD2) THEN
      CALL EQSTWC(RESID,4,RES1,LRESD1,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=RES1(1:LRESD1).EQ.RESID(IAT)
      END DO
      END IF
C
      QINDX1=QSTART
      QINDX2=QSTART-QSTKLN
      DO IAT=1,NATOM
      QSTACK(QINDX2)=QSTACK(QINDX1).AND.QSTACK(QINDX2)
      QINDX1=QINDX1+1
      QINDX2=QINDX2+1
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
      IF (QWCARD3) THEN
      CALL EQSTWC(TYPE,4,WDT,WDTLEN,QSTART,NATOM,QSTACK)
      ELSE
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=WDT(1:WDTLEN).EQ.TYPE(IAT)
      END DO
      END IF
C
      QINDX1=QSTART
      QINDX2=QSTART-QSTKLN
      DO IAT=1,NATOM
      QSTACK(QINDX2)=QSTACK(QINDX1).AND.QSTACK(QINDX2)
      QINDX1=QINDX1+1
      QINDX2=QINDX2+1
      END DO
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
      CALL SENEXT
C
C===========
C POIN token
C===========
      ELSE IF (WD(1:4).EQ.'POIN') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      CALL SELTVF('POINt-vector=',R)
      XREF=R(1)
      YREF=R(2)
      ZREF=R(3)
      CALL SENEXT
      IF (WD(1:3).EQ.'CUT') THEN
      CALL NEXTF('CUT=',RMAX)
      CALL SENEXT
      ELSE
      RMAX=8.0D0
      END IF
      IF (.NOT.QCOOR) THEN
      CALL WRNDIE(-5,'SELRPN','no coordinates present')
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      ELSE
      RMAX2=RMAX*RMAX
      DO IAT=1,NATOM
      DXL=XREF-XC(IAT)
      DYL=YREF-YC(IAT)
      DZL=ZREF-ZC(IAT)
      DIST2=DXL*DXL+DYL*DYL+DZL*DZL
      ELEMNT=(DIST2.LE.RMAX2)
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      END IF
C
C===========
C ATTR token
C===========
      ELSE IF (WD(1:4).EQ.'ATTR') THEN
      CALL NEXTQL('ATTRibute=')
      IF (WD(1:3).EQ.'ABS') THEN
      QABS=.TRUE.
      CALL NEXTQL('ATTRibute=')
      ELSE
      QABS=.FALSE.
      END IF
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      IF (WD(1:4).EQ.'X   ') THEN
      CALL SELATT(X,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'Y   ') THEN
      CALL SELATT(Y,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'Z   ') THEN
      CALL SELATT(Z,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'WMAI') THEN
      CALL SELATT(WMAIN,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'QMAI') THEN
      CALL SELATT(QMAIN,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'B   ') THEN
      CALL SELATT(WMAIN,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'Q   ') THEN
      CALL SELATT(QMAIN,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'XCOM') THEN
      CALL SELATT(XCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'YCOM') THEN
      CALL SELATT(YCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'ZCOM') THEN
      CALL SELATT(ZCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'WCOM') THEN
      CALL SELATT(WCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'BCOM') THEN
      CALL SELATT(WCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'QCOM') THEN
      CALL SELATT(QCOMP,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'REFX') THEN
      CALL SELATT(REFX,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'REFY') THEN
      CALL SELATT(REFY,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'REFZ') THEN
      CALL SELATT(REFZ,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'RMSD') THEN
      CALL SELATT(RMSD,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'HARM') THEN
      CALL SELATT(KCNSTR,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'ZHAR') THEN
      CALL SELATT(KZCNSTR,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'MASS') THEN
      CALL SELATT(AMASS,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'CHAR') THEN
      CALL SELATT(CG,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE1') THEN
      CALL SELATT(HEAP(PTRSTO(1)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE2') THEN
      CALL SELATT(HEAP(PTRSTO(2)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE3') THEN
      CALL SELATT(HEAP(PTRSTO(3)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE4') THEN
      CALL SELATT(HEAP(PTRSTO(4)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE5') THEN
      CALL SELATT(HEAP(PTRSTO(5)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE6') THEN
      CALL SELATT(HEAP(PTRSTO(6)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE7') THEN
      CALL SELATT(HEAP(PTRSTO(7)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE8') THEN
      CALL SELATT(HEAP(PTRSTO(8)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:6).EQ.'STORE9') THEN
      CALL SELATT(HEAP(PTRSTO(9)),QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'DX  ') THEN
      CALL SELATT(DX,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'DY  ') THEN
      CALL SELATT(DY,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'DZ  ') THEN
      CALL SELATT(DZ,QSTART,NATOM,QSTACK,QABS)
      ELSE IF (WD(1:4).EQ.'VX  ') THEN
      DO I=1,NATOM
      XV(I)=XV(I)/TIMFAC
      END DO
      CALL SELATT(XV,QSTART,NATOM,QSTACK,QABS)
      DO I=1,NATOM
      XV(I)=XV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'VY  ') THEN
      DO I=1,NATOM
      YV(I)=YV(I)/TIMFAC
      END DO
      CALL SELATT(YV,QSTART,NATOM,QSTACK,QABS)
      DO I=1,NATOM
      YV(I)=YV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'VZ  ') THEN
      DO I=1,NATOM
      ZV(I)=ZV(I)/TIMFAC
      END DO
      CALL SELATT(ZV,QSTART,NATOM,QSTACK,QABS)
      DO I=1,NATOM
      ZV(I)=ZV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'FBET') THEN
      CALL SELATT(FBETA,QSTART,NATOM,QSTACK,QABS)
C
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_A1') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('A1',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_A2') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('A2',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_A3') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('A3',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_A4') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('A4',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_B1') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('B1',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_B2') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('B2',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_B3') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('B3',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_B4') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('B4',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_C') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('C',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_FP') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('FP',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE IF (WD(1:WDLEN).EQ.'SCATTER_FDP') THEN
      XF=ALLHP(IREAL8(NATOM))
      CALL XSCAFIL('FDP',NATOM,HEAP(XF),XRERR)
      CALL SELATT(HEAP(XF),QSTART,NATOM,QSTACK,QABS)
      CALL FREHP(XF,IREAL8(NATOM))
C
      ELSE
      CALL DSPERR('SELRPN',' unknown attribute')
      END IF
      CALL SENEXT
C
C============
C KNOWn token
C============
      ELSE IF (WD(1:4).EQ.'INIT'.OR.WD(1:4).EQ.'KNOW') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      ELEMNT=INITIA(IAT,X,Y,Z)
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      CALL SENEXT
C
C===========
C HYDR token
C===========
      ELSE IF (WD(1:4).EQ.'HYDR') THEN
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO IAT=1,NATOM
      ELEMNT=HYDROG(IAT)
      QSTACK(QSTART+IAT-1)=ELEMNT
      END DO
      CALL SENEXT
C
C===========
C TAG token
C===========
      ELSE IF (WD(1:4).EQ.'TAG ') THEN
C
C selects exactly one atom from each "entity".  An
C entity is defined as a set of atoms with equal segids,
C resids, and residue names.
C
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      SEG1='    '
      RES1='    '
      RESN1='    '
      DO IAT=1,NATOM
      IF (SEG1.NE.SEGID(IAT).OR.RES1.NE.RESID(IAT).OR.
     &      RESN1.NE.RES(IAT)) THEN
      SEG1=SEGID(IAT)
      RES1=RESID(IAT)
      RESN1=RES(IAT)
C
C check if it has been previously already defined
      EXIST=.FALSE.
      DO IIAT=1,IAT-1
      IF (QSTACK(QSTART+IIAT-1)) THEN
      IF (SEG1.EQ.SEGID(IIAT).AND.RES1.EQ.RESID(IIAT).AND.
     &      RESN1.EQ.RES(IIAT)) THEN
      EXIST=.TRUE.
      END IF
      END IF
      END DO
C
C
      IF (.NOT.EXIST) THEN
      QSTACK(QSTART+IAT-1)=.TRUE.
      ELSE
      QSTACK(QSTART+IAT-1)=.FALSE.
      END IF
      ELSE
      QSTACK(QSTART+IAT-1)=.FALSE.
      END IF
      END DO
      CALL SENEXT
C=====================================
      ELSE IF (WD(1:4).EQ.'FBOX') THEN
      CALL NEXTF('xmin=',XMIN)
      CALL NEXTF('xmax=',XMAX)
      CALL NEXTF('ymin=',YMIN)
      CALL NEXTF('ymax=',YMAX)
      CALL NEXTF('zmin=',ZMIN)
      CALL NEXTF('zmax=',ZMAX)
      XMIN=MAX(ZERO,XMIN)
      XMAX=MIN(ONE,XMAX)
      YMIN=MAX(ZERO,YMIN)
      YMAX=MIN(ONE,YMAX)
      ZMIN=MAX(ZERO,ZMIN)
      ZMAX=MIN(ONE,ZMAX)
      CALL SENEXT
C
      IF (.NOT.QCOOR) THEN
      CALL WRNDIE(-5,'SELRPN','no coordinates present')
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      ELSE
      DO IAT=1,NATOM
C
      QSTACK(QSTART+IAT-1)=.FALSE.
C compute fractional coordinates
      CALL XPSYMO(1,XC(IAT),YC(IAT),ZC(IAT),1,XRRFF,YRRFF,ZRRFF)
C
C apply mod operation
      XRRFF=MOD(XRRFF+BIG,ONE)
      YRRFF=MOD(YRRFF+BIG,ONE)
      ZRRFF=MOD(ZRRFF+BIG,ONE)
      IF          (XRRFF.GE.XMIN.AND.XRRFF.LE.XMAX
     &        .AND.YRRFF.GE.YMIN.AND.YRRFF.LE.YMAX
     &        .AND.ZRRFF.GE.ZMIN.AND.ZRRFF.LE.ZMAX) THEN
      QSTACK(QSTART+IAT-1)=.TRUE.
      END IF
      END DO
      END IF
C=====================================
      ELSE IF (WD(1:5).EQ.'SFBOX') THEN
      CALL NEXTF('xmin=',XMIN)
      CALL NEXTF('xmax=',XMAX)
      CALL NEXTF('ymin=',YMIN)
      CALL NEXTF('ymax=',YMAX)
      CALL NEXTF('zmin=',ZMIN)
      CALL NEXTF('zmax=',ZMAX)
      XMIN=MAX(ZERO,XMIN)
      XMAX=MIN(ONE,XMAX)
      YMIN=MAX(ZERO,YMIN)
      YMAX=MIN(ONE,YMAX)
      ZMIN=MAX(ZERO,ZMIN)
      ZMAX=MIN(ONE,ZMAX)
      CALL SENEXT
C
      IF (.NOT.QCOOR) THEN
      CALL WRNDIE(-5,'SELRPN','no coordinates present')
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      ELSE
      DO IAT=1,NATOM
C
      QSTACK(QSTART+IAT-1)=.FALSE.
C
C loop over non-crystallographic symmetry operators
      DO INSYM=1,XNNSYM
C
C compute non-crystallographic symmetry related atom (orthogonal coords)
      CALL NCSXYZ(1,XC(IAT),YC(IAT),ZC(IAT),INSYM,XRRF,YRRF,ZRRF)
C
C loop over crystallographic symmetry operators
      DO ISYM=1,XRNSYM
C
C compute symmetry related molecule (in fractional coordinates)
      CALL XPSYMO(1,XRRF,YRRF,ZRRF,ISYM,XRRFF,YRRFF,ZRRFF)
C
C apply mod operation
      XRRFF=MOD(XRRFF+BIG,ONE)
      YRRFF=MOD(YRRFF+BIG,ONE)
      ZRRFF=MOD(ZRRFF+BIG,ONE)
      IF          (XRRFF.GE.XMIN.AND.XRRFF.LE.XMAX
     &        .AND.YRRFF.GE.YMIN.AND.YRRFF.LE.YMAX
     &        .AND.ZRRFF.GE.ZMIN.AND.ZRRFF.LE.ZMAX) THEN
      QSTACK(QSTART+IAT-1)=.TRUE.
      END IF
      END DO
      END DO
      END DO
      END IF
C==================================
      ELSE
      WRITE(6,'(2A)') ' %SELRPN-ERR: Unrecognized word ',WD(1:WDLEN)
      CALL WRNDIE(-5,'SELRPN','parsing error')
C exit selection subroutine
      GOTO 99999
      END IF
C-end-parse-token
C
77777 CONTINUE
C=====================================
      IF (WD(1:4).EQ.'AROU') THEN
C
      IF (.NOT.QCOOR) THEN
      CALL WRNDIE(-5,'SELRPN','no coordinates present')
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      CALL SENEXT
      ELSE
      CALL NEXTF('AROUnd=',RMAX)
      RMAX2=RMAX*RMAX
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1)=QSTACK(INDX1-QSTKLN)
      END DO
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1-QSTKLN)=.FALSE.
      END DO
C
      QINDX2=QSTART
      QKNOWN=.TRUE.
      DO IAT2=1,NATOM
      IF (QSTACK(QINDX2)) THEN
      IF (.NOT. INITIA(IAT2,X,Y,Z)) THEN
      QKNOWN=.FALSE.
      ELSE
      QINDX1=QSTART-QSTKLN-1
C
C================
C-VECTORIZED-CODE
C================
      DO IAT=1,NATOM
      DXL=XC(IAT)-XC(IAT2)
      DYL=YC(IAT)-YC(IAT2)
      DZL=ZC(IAT)-ZC(IAT2)
      DIST2=DXL*DXL+DYL*DYL+DZL*DZL
      QINDX1=QINDX1+1
      QSTACK(QINDX1)=QSTACK(QINDX1).OR.(DIST2.LE.RMAX2)
      END DO
      END IF
      END IF
      QINDX2=QINDX2+1
      END DO
      END IF
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
      IF (.NOT.QKNOWN) THEN
      WRITE(6,'(A)')
     & ' %SELRPN-AROUnd-ERR: some atom coordinates unknown'
      END IF
      CALL SENEXT
C=====================================
      ELSE IF (WD(1:4).EQ.'SARO') THEN
C
      IF (.NOT.QCOOR) THEN
      CALL WRNDIE(-5,'SELRPN','no coordinates present')
      DO IAT=1,NATOM
      QSTACK(QSTART+IAT-1)=.FALSE.
      END DO
      CALL SENEXT
      ELSE
      CALL NEXTF('SAROund=',RMAX)
      RMAX2=RMAX*RMAX
      CALL SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1)=QSTACK(INDX1-QSTKLN)
      END DO
      DO INDX1=QSTART,QSTART+QSTKLN-1
      QSTACK(INDX1-QSTKLN)=.FALSE.
      END DO
C
C allocate temporary space
      XF=ALLHP(IREAL8(NATOM))
      YF=ALLHP(IREAL8(NATOM))
      ZF=ALLHP(IREAL8(NATOM))
      XFF=ALLHP(IREAL8(NATOM))
      YFF=ALLHP(IREAL8(NATOM))
      ZFF=ALLHP(IREAL8(NATOM))
      XFFF=ALLHP(IREAL8(NATOM))
      YFFF=ALLHP(IREAL8(NATOM))
      ZFFF=ALLHP(IREAL8(NATOM))
C
C loop over non-crystallographic symmetry operators
      DO INSYM=1,XNNSYM
C
C compute non-crystallographic symmetry related molecule (orthogonal coords)
      CALL NCSXYZ(NATOM,X,Y,Z,INSYM,HEAP(XF),HEAP(YF),HEAP(ZF))
C
C loop over crystallographic symmetry operators
      DO ISYM=1,XRNSYM
C
C compute symmetry related molecule (in fractional coordinates)
      CALL XPSYMO(NATOM,HEAP(XF),HEAP(YF),HEAP(ZF),ISYM,
     &            HEAP(XFF),HEAP(YFF),HEAP(ZFF))
C
      QINDX2=QSTART
      QKNOWN=.TRUE.
      DO IAT2=1,NATOM
      IF (QSTACK(QINDX2)) THEN
      IF (.NOT. INITIA(IAT2,X,Y,Z)) THEN
      QKNOWN=.FALSE.
      ELSE
      QINDX1=QSTART-QSTKLN-1
C
C compute the minimum image distance
      CALL XPIMAG(X(IAT2),Y(IAT2),Z(IAT2),
     &            1,NATOM,HEAP(XFF),HEAP(YFF),HEAP(ZFF),
     &            HEAP(XFFF),HEAP(YFFF),HEAP(ZFFF),.FALSE.,0)
      CALL SELMMM(NATOM,HEAP(XFFF),HEAP(YFFF),HEAP(ZFFF),QSTACK,
     &            QINDX1,RMAX2)
      END IF
      END IF
      QINDX2=QINDX2+1
      END DO
C
      END DO
      END DO
C
C deallocate temporary space
      CALL FREHP(XF,IREAL8(NATOM))
      CALL FREHP(YF,IREAL8(NATOM))
      CALL FREHP(ZF,IREAL8(NATOM))
      CALL FREHP(XFF,IREAL8(NATOM))
      CALL FREHP(YFF,IREAL8(NATOM))
      CALL FREHP(ZFF,IREAL8(NATOM))
      CALL FREHP(XFFF,IREAL8(NATOM))
      CALL FREHP(YFFF,IREAL8(NATOM))
      CALL FREHP(ZFFF,IREAL8(NATOM))
C
      END IF
      CALL SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
      IF (.NOT.QKNOWN) THEN
      WRITE(6,'(A)')
     & ' %SELRPN-SAROund-ERR: some atom coordinates unknown'
      END IF
C
      CALL SENEXT
C=====================================
      END IF
C
      CALL SEUP(LEVEL,RETMAX)
C     return to address:
      IF (RETADR(LEVEL).EQ.5) GOTO 3335
      IF (RETADR(LEVEL).EQ.6) GOTO 3336
      IF (RETADR(LEVEL).EQ.7) GOTO 3337
      IF (RETADR(LEVEL).EQ.8) GOTO 3338
      IF (RETADR(LEVEL).EQ.9) GOTO 3339
      IF (RETADR(LEVEL).EQ.10) GOTO 3340
      WRITE(6,'(A)') 
     &' %SELRPN-ERR: Return address unknown. Fatal coding error.'
      CALL DIE
C---- END PROCEDURE FACTOR ----------------------------------------------
C
C
C
C
9999  CONTINUE
      QINDX1=QSTART
      DO IAT=1,NATOM
      IF (QSTACK(QINDX1)) THEN
      FLAGS(IAT)=1
      ELSE
      FLAGS(IAT)=0
      END IF
      QINDX1=QINDX1+1
      END DO
C
C error exit label
99999 CONTINUE
      NSELCT=0
      DO IAT=1,NATOM
      IF (FLAGS(IAT).EQ.1) NSELCT=NSELCT+1
      END DO
      IF (WRNLEV.GE.5) THEN
      WRITE(6,'(A,I7,A,I7)')
     & ' SELRPN:',NSELCT,' atoms have been selected out of',NATOM
C
      END IF
      DPVAL = NSELCT
      CALL DECLAR( 'SELECT', 'DP', ' ', DCVAL, DPVAL )
C
      RETURN
      END
C
      SUBROUTINE SEDOWN(LEVEL,RETMAX)
C
C go down one level in SELRPN
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INTEGER LEVEL, RETMAX
C begin
      IF (LEVEL.GE.RETMAX) THEN
      WRITE(6,'(A)') ' %SELRPN-ERR: Return address overflow (RETMAX)'
      ELSE
      LEVEL=LEVEL+1
      END IF
      RETURN
      END
C===================================================================
      SUBROUTINE SEUP(LEVEL,RETMAX)
C go up one level in SELRPN
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INTEGER LEVEL, RETMAX
C begin
      LEVEL=LEVEL-1
      IF (LEVEL.LT.0) THEN
      WRITE(6,'(A)') ' %SELRPN-ERR: Return address underflow. Check'
      END IF
      RETURN
      END
C===================================================================
      SUBROUTINE SENEXT
C
C get next word  ( lets be able to type HELP at any place !! )
C Author: Axel T. Brunger
C ======================
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
C begin
      CALL NEXTWD('SELRPN>')
C
      DO WHILE (WD(1:4).EQ.'HELP')
C
      CALL CNSHELP('atom-selection')
C
      CALL NEXTWD('SELRPN>')
      END DO
      RETURN
      END
C=====================================================================
      SUBROUTINE SEPUSH(QLIFT,QSTART,QSTKLN,ISTK,STKSIZ)
C
C push stack in SELRPN
C Author: Axel T. Brunger
C ======================
      IMPLICIT NONE
      INTEGER QLIFT, QSTART, QSTKLN, ISTK, STKSIZ
C begin
      QSTART=QSTART+QSTKLN
      IF (QSTART.GT.STKSIZ) THEN
      CALL WRNDIE(-5,'SELRPN>',
     & 'max. depth of selection expression exceeded')
      ELSE
      QLIFT=QLIFT+1
      ISTK=QLIFT
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE SEBACK(QLIFT,QSTART,QSTKLN,ISTK)
C
C back stack in SELRPN
C Author: Axel T. Brunger
C ======================
      IMPLICIT NONE
      INTEGER QLIFT, QSTART, QSTKLN, ISTK
C begin
      QLIFT=QLIFT-1
      QSTART=QSTART-QSTKLN
      IF (QSTART.LE.0) THEN
      CALL WRNDIE(-5,'SELRPN>',
     & 'fatal stack underflow, check code')
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE SELATT(ARRAY,QSTART,NATOM,QSTACK,QABS)
C
C routine selects atoms based on comparisons with values in ARRAY
C Author: Axel T. Brunger
C ======================
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'consta.inc'
      DOUBLE PRECISION ARRAY(*)
      INTEGER QSTART, NATOM
      LOGICAL QSTACK(*), QABS
C local
      INTEGER IROPR, IAT
      DOUBLE PRECISION TOL, CUTOFF, DATAPT
      CHARACTER*2 RELAT
C begin
      IROPR=1
      CALL NEXTQL('operator=')
      RELAT=WD
C
C check if we have a composite relat. operator, such as ">=" or "<=" or "=="
      IF (WD(1:1).EQ.'<'.OR.WD(1:1).EQ.'>') THEN
      CALL NEXTQL('operator=')
      IF (WD(1:1).EQ.'=') THEN
      RELAT(2:2)='='
      ELSE
      CALL SAVEWD
      END IF
      END IF
C
      IF (RELAT.EQ.'LT'.OR.RELAT.EQ.'<') THEN
      IROPR=1
      ELSE IF (RELAT.EQ.'LE'.OR.RELAT.EQ.'<=') THEN
      IROPR=2
      ELSE IF (RELAT.EQ.'GT'.OR.RELAT.EQ.'>') THEN
      IROPR=3
      ELSE IF (RELAT.EQ.'GE'.OR.RELAT.EQ.'>=') THEN
      IROPR=4
      ELSE IF (RELAT.EQ.'EQ'.OR.RELAT.EQ.'=') THEN
      IROPR=5
      ELSE IF (RELAT.EQ.'NE'.OR.RELAT.EQ.'#') THEN
      IROPR=6
      ELSE
      CALL DSPERR('SELRPN','unknown relational operator')
      END IF
      CALL NEXTF('comparison=',CUTOFF)
      TOL=MAX(RSMALL,ABS(RSMALL*CUTOFF))
      DO IAT=1,NATOM
      DATAPT=ARRAY(IAT)
      IF (QABS.AND.DATAPT.LT.0) DATAPT=-DATAPT
      IF ((1).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= ((DATAPT-CUTOFF).LT.-TOL)
      ELSE IF ((2).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= ((DATAPT-CUTOFF).LE.TOL)
      ELSE IF ((3).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= ((DATAPT-CUTOFF).GT.TOL)
      ELSE IF ((4).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= ((DATAPT-CUTOFF).GE.-TOL)
      ELSE IF ((5).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= (ABS(DATAPT-CUTOFF).LT.TOL)
      ELSE IF ((6).EQ.(IROPR)) THEN
      QSTACK(QSTART+IAT-1)= (ABS(DATAPT-CUTOFF).GE.TOL)
      END IF
      END DO
      RETURN
      END
C
      SUBROUTINE SELRCL(QSTACK,STORE,NATOM)
C
C Subroutine fills QSTACK according to the values in STORE
C QSTACK=(STORE.NE.0)
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output

      INCLUDE 'consta.inc'
      LOGICAL QSTACK(*)
      DOUBLE PRECISION STORE(*)
      INTEGER NATOM
C local
      INTEGER I
C begin
      DO I=1,NATOM
      QSTACK(I)=(ABS(STORE(I)).GT.RSMALL)
      END DO
      RETURN
      END
C====================================================================
      SUBROUTINE SELTVF(PROMPT,VECTOR)
C
C parses a 3-dimensional vector within selection
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C =======================
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      DOUBLE PRECISION VECTOR(*)
      CHARACTER*(*) PROMPT
C local
      INTEGER I
      LOGICAL OK
      LOGICAL CLOOP
      CHARACTER*1 SBRA, SKET
      PARAMETER (SBRA='(',SKET=')')
C begin
      ERROR=.FALSE.
C
      CALL NEXTWD(PROMPT)
      IF (WD(1:4).EQ.'=   ') CALL NEXTWD(PROMPT)
      IF (WD(1:4).EQ.'?   ') THEN
      WRITE(6,'(1X,2A,3G12.5,A)') PROMPT,'(',(VECTOR(I),I=1,3),')'
      ELSE
      DO I=1,3
      VECTOR(I)=0.0D0
      END DO
C
      IF (WD(1:1).EQ.SBRA) THEN
      I=0
      CALL NEXTWD(PROMPT)
      CLOOP = .TRUE.
      DO WHILE (CLOOP)
C parse the x,y,z form of <vector>
      IF (I.GE.3) THEN
      ERROR=.TRUE.
      WRITE(6,'(A)') ' %SELTVF-ERR: dimension of vector greater 3'
      ELSE
      I=I+1
      VECTOR(I)=DECODF(WD,WDLEN,OK)
      ERROR=.NOT.OK
      IF (ERROR) THEN
      WRITE(6,'(2A)') ' %SELTVF-ERR: numerical value expected : ',
     1               WD(1:WDLEN)
      END IF
      END IF
      CALL NEXTWD(PROMPT)
      IF (WD(1:1).EQ.SKET.OR.ERROR) CLOOP = .FALSE.
      END DO
C
      ELSE
      WRITE(6,'(A)') ' %SELTVF-ERR: vector starts with a "("'
      END IF
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE SELMMM(NATOM,XFF,YFF,ZFF,QSTACK,QINDX1,RMAX2)
C
C Routine checks if distances are within specified cutoff RMAX2
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INTEGER NATOM
      DOUBLE PRECISION XFF(*), YFF(*), ZFF(*)
      LOGICAL QSTACK(*)
      INTEGER QINDX1
      DOUBLE PRECISION RMAX2
C local
      INTEGER IAT
      DOUBLE PRECISION DIST2
C begin
      DO IAT=1,NATOM
      DIST2=XFF(IAT)**2+YFF(IAT)**2+ZFF(IAT)**2
      QINDX1=QINDX1+1
      QSTACK(QINDX1)=QSTACK(QINDX1).OR.(DIST2.LE.RMAX2)
      END DO
      RETURN
      END
C=====================================================================
      SUBROUTINE XSCAFIL(OP,NATOM,ARRAY,XRERR)
C
C Routine stores scatter factor OP into atomic array ARRAY.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'xcrystal.inc'
      INCLUDE 'xtarget.inc'
C I/O
      CHARACTER*(*) OP
      INTEGER NATOM
      DOUBLE PRECISION ARRAY(*)
      LOGICAL XRERR
C local
      INTEGER INDEX
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
      IF (HPATOF.EQ.0.OR.XRNATF.EQ.0) THEN
      CALL DSPERR ( 'PUTSCA',
     & 'SCATTer database undefined.' )
      XRERR = .TRUE.
      DO INDEX=1,NATOM
      ARRAY(INDEX)=ZERO
      END DO
C
      ELSE
      CALL XSCAFIL2(OP,NATOM,ARRAY,XRERR,XRNATF,HEAP(HPATOF),
     &            HEAP(HPINDF),XRSM,XRSA,XRSB,XRSC,XRFP,XRFDP)
      END IF
      RETURN
      END
C===========================================================
      SUBROUTINE XSCAFIL2(OP,NATOM,ARRAY,XRERR,XRNATF,XRATOF,
     &                  XRINDF,XRSM,XRSA,XRSB,XRSC,XRFP,XRFDP)
C
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
C I/O
      CHARACTER*(*) OP
      INTEGER NATOM
      DOUBLE PRECISION ARRAY(*)
      LOGICAL XRERR
      INTEGER XRNATF, XRATOF(*), XRINDF(*)
      INTEGER XRSM
      DOUBLE PRECISION XRSA(XRSM,4), XRSB(XRSM,4), XRSC(XRSM)
      DOUBLE PRECISION XRFP(XRSM), XRFDP(XRSM)
C local
      INTEGER IAT, IINDEX, INDEX
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
C loop over all atoms
      DO INDEX=1,NATOM
C we need to lookup INDEX
      IINDEX=0
      DO IAT=1,XRNATF
      IF (XRATOF(IAT).EQ.INDEX) IINDEX=IAT
      END DO
C
      IF ( IINDEX.EQ.0 ) THEN
      ARRAY(INDEX)=ZERO
      ELSEIF (OP.EQ.'A1') THEN
      ARRAY(INDEX)=XRSA(XRINDF(IINDEX),1)
      ELSEIF (OP.EQ.'A2') THEN
      ARRAY(INDEX)=XRSA(XRINDF(IINDEX),2)
      ELSEIF (OP.EQ.'A3') THEN
      ARRAY(INDEX)=XRSA(XRINDF(IINDEX),3)
      ELSEIF (OP.EQ.'A4') THEN
      ARRAY(INDEX)=XRSA(XRINDF(IINDEX),4)
      ELSEIF (OP.EQ.'B1') THEN
      ARRAY(INDEX)=XRSB(XRINDF(IINDEX),1)
      ELSEIF (OP.EQ.'B2') THEN
      ARRAY(INDEX)=XRSB(XRINDF(IINDEX),2)
      ELSEIF (OP.EQ.'B3') THEN
      ARRAY(INDEX)=XRSB(XRINDF(IINDEX),3)
      ELSEIF (OP.EQ.'B4') THEN
      ARRAY(INDEX)=XRSB(XRINDF(IINDEX),4)
      ELSEIF (OP.EQ.'C') THEN
      ARRAY(INDEX)=XRSC(XRINDF(IINDEX))
      ELSEIF (OP.EQ.'FP') THEN
      ARRAY(INDEX)=XRFP(XRINDF(IINDEX))
      ELSEIF (OP.EQ.'FDP') THEN
      ARRAY(INDEX)=XRFDP(XRINDF(IINDEX))
      END IF
C
      END DO
C
      RETURN
      END
C

      SUBROUTINE GENRES(RESF,RESIDF,SEGIDF)
C
C adds a residue RESF to the molecular structure database
C with residue (segment) identifiers RESIDF (SEGIDF).
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'rtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'ener.inc'
      CHARACTER*4 RESF, RESIDF, SEGIDF
C local
      INTEGER I, IRES, J, IGRLST, NGRPFS, NATOMF
      INTEGER II, JJ, KK, LL, NL
      INTEGER NATPT, IPT
      LOGICAL FOUND
      INTEGER MARK
      PARAMETER (MARK=-9999)
C begin
C
C find the index of RESF in the topology file
      J=0
      FOUND=.FALSE.
      DO WHILE (J.LT.NRTRS.AND..NOT.FOUND)
      J=J+1
      FOUND=(AA(J).EQ.RESF.AND.RTRTYP(J).EQ.0)
      END DO
      IF (.NOT.FOUND) THEN
      WRITE(6,'(4A)') ' %GENRES-ERR: residue ',RESF,
     & ' not found in topology files. Add topology',
     & ' definition.'
      CALL WRNDIE(-5,'GENRES',
     & 'missing topology definition for residue')
      ELSE
      IRES=J
C
C insert atoms and atom specifications
      IGRLST=0
      NATOMF=NATOM+1
      NGRPFS=NGRP+1
      NATPT=0
      IF (IRES.GT.1) NATPT=NIC(1,IRES-1)
      DO I=NATPT+1,NIC(1,IRES)
      IF (NATOM.GE.MAXA) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXA parameter --> recompile program')
      ELSE
      NATOM=NATOM+1
      END IF
C
C temporary setup of IBLO ( so we don't have to search for the
C atom number I when setting up the exclusion list below )
      IBLO(NATOM)=I
C
C get chemical type, mass, iupac, ...
      IAC(NATOM)=MAC(I)
      AMASS(NATOM)=ARMASS(I)
      TYPE(NATOM)=FTP(I)(1:4)
      SEGID(NATOM)=SEGIDF
      RESID(NATOM)=RESIDF
      RES(NATOM)=RESF
      CG(NATOM)=CHG(I)
      LOOKUP(NATOM)=0
      QLOOKU(NATOM)=.TRUE.
      IMOVE(NATOM)=0
      CALL ATMINI(NATOM,NATOM)
C
C group list
      IF (IGRLST.NE.GRPR(I).OR.NGRP.EQ.0) THEN
      IGRLST=GRPR(I)
      IF (NGRP.GE.MAXGRP) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXGRP parameter --> recompile program')
      ELSE
      NGRP=NGRP+1
      END IF
      IGPBS(NGRP)=NATOM-1
      END IF
      END DO
      IGPBS(NGRP+1)=NATOM
C
C put in bonds
      IF (IRES.EQ.1) THEN
      I=1
      ELSE
      I=NIC(2,IRES-1)+1
      END IF
      DO IPT=I,NIC(2,IRES)
      II=SRCHC4(MIB(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      JJ=SRCHC4(MJB(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      IF (II.NE.MARK.AND.JJ.NE.MARK) THEN
      IF (NBOND.GE.MAXB) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXB parameter --> recompile program')
      ELSE
      NBOND=NBOND+1
      END IF
      IB(NBOND)=II
      JB(NBOND)=JJ
      QACBC(NBOND)=.TRUE.
      QACBB(NBOND)=.TRUE.
      ELSE
      WRITE(6,'(6A)') ' %GENRES-ERR: atom(s) in bond ',
     & MIB(IPT),' ',
     & MJB(IPT),' are undefined in topology residue ',RESF
      END IF
      END DO
C
C put in angles
      IF (IRES.EQ.1) THEN
      I=1
      ELSE
      I=NIC(3,IRES-1)+1
      END IF
      DO IPT=I,NIC(3,IRES)
      II=SRCHC4(MIT(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      JJ=SRCHC4(MJT(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      KK=SRCHC4(MKT(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      IF (II.NE.MARK.AND.JJ.NE.MARK.AND.KK.NE.MARK) THEN
      IF (NTHETA.GE.MAXT) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXT parameter --> recompile program')
      ELSE
      NTHETA=NTHETA+1
      END IF
      IT(NTHETA)=II
      JT(NTHETA)=JJ
      KT(NTHETA)=KK
      QACTC(NTHETA)=.TRUE.
      QACTB(NTHETA)=.TRUE.
      QACTUC(NTHETA)=.TRUE.
      QACTUB(NTHETA)=.TRUE.
      ELSE
      WRITE(6,'(8A)') ' %GENRES-ERR: atom(s) in angle ',
     & MIT(IPT),' ',MJT(IPT),' ',MKT(IPT),
     & ' are undefined in topology residue ',RESF
      END IF
      END DO
C
C put in dihedrals
      IF (IRES.EQ.1) THEN
      I=1
      ELSE
      I=NIC(4,IRES-1)+1
      END IF
      DO IPT=I,NIC(4,IRES)
      II=SRCHC4(MIP(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      JJ=SRCHC4(MJP(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      KK=SRCHC4(MKP(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      LL=SRCHC4(MLP(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      IF (II.NE.MARK.AND.JJ.NE.MARK.AND.KK.NE.MARK.AND.LL.NE.MARK) THEN
      IF (NPHI.GE.MAXP) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXP parameter --> recompile program')
      ELSE
      NPHI=NPHI+1
      END IF
      IP(NPHI)=II
      JP(NPHI)=JJ
      KP(NPHI)=KK
      LP(NPHI)=LL
      QACPB(NPHI)=.TRUE.
      QACPC(NPHI)=.TRUE.
      QACPD(NPHI)=.TRUE.
      ELSE
      WRITE(6,'(11A)') ' %GENRES-ERR: atom(s) in dihedral ',
     & MIP(IPT),' ',MJP(IPT),' ',MKP(IPT),' ',MLP(IPT),
     & ' are undefined in ','topology residue ',RESF
      END IF
      END DO
C
C put in improper dihedrals
      IF (IRES.EQ.1) THEN
      I=1
      ELSE
      I=NIC(5,IRES-1)+1
      END IF
      DO IPT=I,NIC(5,IRES)
      II=SRCHC4(MIM(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      JJ=SRCHC4(MJM(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      KK=SRCHC4(MKM(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      LL=SRCHC4(MLM(IPT)(1:4),TYPE,NATOMF,NATOM,MARK)
      IF (II.NE.MARK.AND.JJ.NE.MARK.AND.KK.NE.MARK.AND.LL.NE.MARK) THEN
      IF (NIMPHI.GE.MAXIMP) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXIMP parameter --> recompile program')
      ELSE
      NIMPHI=NIMPHI+1
      END IF
      IM(NIMPHI)=II
      JM(NIMPHI)=JJ
      KM(NIMPHI)=KK
      LM(NIMPHI)=LL
      QACIB(NIMPHI)=.TRUE.
      QACIC(NIMPHI)=.TRUE.
      QACID(NIMPHI)=.TRUE.
      ELSE
      WRITE(6,'(11A)') ' %GENRES-ERR: atom(s) in improper ',
     & MIM(IPT),' ',MJM(IPT),' ',MKM(IPT),' ',MLM(IPT),
     & ' are undefined in ','topology residue ',RESF
      END IF
      END DO
C
C put in nonbonding exclusions
      DO I=NATOMF,NATOM
      NL=IBLO(I)
      II=0
      IF (NL.GT.1) II=MXN(NL-1)
      JJ=MXN(NL)-II
      DO KK=1,JJ
      II=II+1
      LL=SRCHC4(MNB(II)(1:4),TYPE,NATOMF,NATOM,MARK)
      IF (LL.NE.MARK) THEN
      IF (NNB.GE.MAXNB) THEN
      CALL WRNDIE(-5,'GENRES',
     & 'exceeded MAXNB parameter --> recompile program')
      ELSE
      NNB=NNB+1
      END IF
      INB(NNB)=LL
      ELSE
      WRITE(6,'(4A)') ' %GENRES-ERR: atom in exclusion ',
     & MNB(II),' is undefined in topology residue ',RESF
      END IF
      END DO
      IBLO(I)=NNB
      END DO
C
      END IF
C
      RETURN
      END
C======================================================================
      SUBROUTINE PATSET
C
C Patch command parser
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'cstack.inc'
      INCLUDE 'heap.inc'
C local
      INTEGER ISLCT, SET, NADD, DIM
      PARAMETER (NADD=50)
C begin
C
C estimate the final number of atoms
C NADD is the maximum number of atoms to be added when invoking
C this routine once.
      DIM=MIN(MAXA,NATOM+NADD)
C
C dynamic
      ISLCT=ALLHP(INTEG4(DIM))
      SET=CALLST(ICHAR4(DIM))
      CALL PATSE2(DIM,HEAP(ISLCT),CSTACK(SET))
      CALL FREHP(ISLCT,INTEG4(DIM))
      CALL CFREST(ICHAR4(DIM))
      RETURN
      END
C
      SUBROUTINE PATSE2(DIM,ISLCT,SET)
C
      IMPLICIT NONE
C input/ouput
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INTEGER DIM, ISLCT(*)
      CHARACTER*4 SET(*)
C local
      CHARACTER*4 PATNAM, SETNAM, STEMP
      LOGICAL QSORT
      INTEGER I, NSLCT, NSET
C begin
      QSORT=.FALSE.
      DO I=1,NATOM
      SET(I)='    '
      END DO
      CALL NEXTA4('patch-residue=',PATNAM)
      CALL PUSEND('PATCH>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('PATCH>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-patch')
C
      ELSE IF (WD(1:4).EQ.'REFE') THEN
      CALL NEXTA4('reference=',SETNAM)
      CALL FILL4(ISLCT,NATOM,0)
      CALL SELCTA(ISLCT,NSLCT,X,Y,Z,.TRUE.)
      DO I=1,NATOM
      IF (ISLCT(I).EQ.1) THEN
      IF (SET(I).NE.'    ') ERROR=.TRUE.
      SET(I)=SETNAM
      END IF
      END DO
      IF (ERROR) THEN
      WRITE(6,'(A)') ' %PATSET-ERR: referenced sets have to be disjoint'
      END IF
      ELSE IF (WD(1:4).EQ.'SORT') THEN
      CALL NEXTLO('SORT=',QSORT)
      ELSE
      CALL CHKEND('PATCH>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
C translate SET
      NSET=0
      DO I=1,NATOM
      IF (SET(I).NE.'    ') THEN
      NSET=NSET+1
      STEMP=SET(I)
      SET(NSET)=STEMP
      ISLCT(NSET)=I
      END IF
      END DO
C
      CALL PATCH(PATNAM,DIM,NSET,SET,ISLCT,QSORT)
C
C finally, clear the lists
      CALL SCRATC
      CALL SHOW
      RETURN
      END
C
      SUBROUTINE PATCH(PATNAM,DIM,NSET,SET,ISET,LSORT)
C
C General patching routine, patching data read from RTF.
C Deletions and addition of atoms, bonds, etc,
C modify atom specifications and group boundaries.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'rtf.inc'
      CHARACTER*4 PATNAM
      INTEGER DIM, NSET
      CHARACTER*4 SET(*)
      INTEGER ISET(*)
      LOGICAL LSORT
C local
      INTEGER GRPLST, MAP, INVMAP, DATOM, LINB, LIBLO, ATMLST
      INTEGER XNNB
C dynamic
      XNNB=NNB
      GRPLST=ALLHP(INTEG4(DIM))
      ATMLST=ALLHP(INTEG4(DIM))
      MAP=ALLHP(INTEG4(DIM))
      INVMAP=ALLHP(INTEG4(DIM))
      DATOM=ALLHP(INTEG4(DIM))
      LINB=ALLHP(INTEG4(XNNB))
      LIBLO=ALLHP(INTEG4(DIM))
      CALL PATCH2(PATNAM,DIM,NSET,SET,ISET,LSORT,
     &            HEAP(ATMLST),HEAP(GRPLST),
     &            HEAP(MAP),HEAP(INVMAP),HEAP(DATOM),
     &            HEAP(LINB),HEAP(LIBLO))
      CALL FREHP(LIBLO,INTEG4(DIM))
      CALL FREHP(LINB,INTEG4(XNNB))
      CALL FREHP(DATOM,INTEG4(DIM))
      CALL FREHP(INVMAP,INTEG4(DIM))
      CALL FREHP(MAP,INTEG4(DIM))
      CALL FREHP(ATMLST,INTEG4(DIM))
      CALL FREHP(GRPLST,INTEG4(DIM))
      RETURN
      END
C======================================================================
      SUBROUTINE PATCH2(PATNAM,DIM,NSET,SET,ISET,LSORT,
     &                 GRPLST,ATMLST,MAP,INVMAP,DATOM,LINB,
     &                 LIBLO)
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'rtf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'cstack.inc'
      CHARACTER*4 PATNAM
      INTEGER DIM, NSET
      CHARACTER*4 SET(*)
      INTEGER ISET(*)
      LOGICAL LSORT
      INTEGER GRPLST(*), ATMLST(*)
      INTEGER MAP(*), INVMAP(*), DATOM(*)
      INTEGER LINB(*), LIBLO(*)
C local
      EXTERNAL  EXCH
      INTEGER   OFFSET, PATGRP
      INTEGER   GROUP, I, II, IPATC, IPT, K, INDEX
      INTEGER   J, JJ, KK, L, LL, NL, NDATOM, IDELTA, ALEN
      LOGICAL   FOUND, ERROR, BYPASS, QERROR
      CHARACTER*4 STEMP
      CHARACTER*8 ACTION
C parameter
      INTEGER   MARK, GPOFF
      PARAMETER (MARK=-9999, GPOFF=100)
      DOUBLE PRECISION ANUM
      PARAMETER (ANUM=9998.0D0)
C
C begin
      QERROR=.FALSE.
C
C get index of patch residue in topology file
      J=0
      FOUND=.FALSE.
      DO WHILE (J.LT.NRTRS.AND..NOT.FOUND)
      J=J+1
      FOUND=(AA(J).EQ.PATNAM.AND.RTRTYP(J).EQ.1)
      END DO
      IF (.NOT.FOUND) THEN
      WRITE(6,'(3A)')
     &' %PATCH-ERR: patch ',PATNAM,' not found in topology file '
      ELSE
      IPATC=J
C
      NDATOM=0
C
C Fill group list GRPLST with values corresponding to
C current molecular topology and store current order of atoms in ATMLST
C note: we assume that a single patch does not contain more
C than GPOFF sub-groups
      DO I=1,NGRP
      DO J=IGPBS(I)+1,IGPBS(I+1)
      GRPLST(J)=I*GPOFF
      ATMLST(J)=J
      END DO
      END DO
C
C Read in atoms of patch residue PATNAM
C Prepare atom mapping (add atoms, modify GRPLST, make list
C of atoms to be deleted)
      PATGRP=-1
      BYPASS=.TRUE.
C
      IF (IPATC.GT.1) THEN
      II=NIC(1,IPATC-1)+1
      ELSE
      II=1
      END IF
      DO I=II,NIC(1,IPATC)
      NL=PATOM(FTP(I),NSET,SET,ISET,TYPE,MARK)
      IF (DELAT(I).NE.'ADD ' .AND. NL.EQ.MARK) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELAT(I),ACTION,ALEN)
      WRITE(6,'(5(1X,A))') '%PATCH-ERR: to be',ACTION(1:ALEN),'atom',
     &    FTP(I),'not found in molecular structure.'
      END IF
      IF (DELAT(I).EQ.'DELE') THEN
C
C Atom is to be deleted
      IF (NL.NE.MARK) THEN
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(7A)')
     &' PATCH: atom ',SEGID(NL),' ',RESID(NL),' ',TYPE(NL),
     &' will be deleted'
      END IF
      BYPASS=.FALSE.
      NDATOM=NDATOM+1
      DATOM(NDATOM)=NL
      END IF
C
C
      ELSE IF (DELAT(I).EQ.'MODI') THEN
C
C change atom specifications according to patch residue.
      IF (NL.NE.MARK) THEN
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(7A)')
     &' PATCH: atom ',SEGID(NL),' ',RESID(NL),' ',TYPE(NL),
     &' specifications will be modified'
      END IF
C
C dont change chemical type or charge if not specified
      IF (.NOT.MAC(I).EQ.'    ') THEN
      LOOKUP(NL)=0
      QLOOKU(NL)=.TRUE.
      IAC(NL)=MAC(I)
      AMASS(NL)=ARMASS(I)
      END IF
      IF (ABS(CHG(I)).LT.ANUM) CG(NL)=CHG(I)
C
C The following group re-assignment is bypassed if atom I in PRES
C has group number 0
      IF (GRPR(I).GT.0) THEN
      ATMLST(NL)=I
      BYPASS=.FALSE.
      IF (GRPR(I).NE.PATGRP) THEN
      PATGRP=GRPR(I)
      GROUP=PATGRP+GRPLST(NL)
      IF (PATGRP.GE.GPOFF) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded GPOFF (routine PATCH2) parameter')
      END IF
      END IF
      GRPLST(NL)=GROUP
      END IF
      END IF
C
      ELSE IF (DELAT(I).EQ.'ADD ') THEN
C
C This atom should be added.
      IF (NATOM+1.GT.DIM) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded NADD (routine PATCH) or MAXA parameter')
      ELSE
C
C check that atom won't be duplicated
      IF (NL.NE.MARK) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELAT(I),ACTION,ALEN)
      WRITE(6,'(2A)') ' %PATCH-ERR: attempt to add duplicate atom =',
     1 FTP(I)
      CALL PATCHERRATM(FTP(I),NL)
      ELSE
C
C find appropriate SEGID, RESID for atom to be added
      FOUND=.FALSE.
      J=0
      DO WHILE (.NOT. (FOUND.OR.J.GE.NSET))
      J=J+1
      IF (SET(J).EQ.'NIL ') THEN
      FOUND=.TRUE.
      ELSE
      FOUND=(SET(J)(1:1).EQ.FTP(I)(1:1))
      END IF
      END DO
      IF (.NOT. FOUND) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELAT(I),ACTION,ALEN)
      WRITE(6,'(3A)') ' %PATCH-ERR: no refe=',FTP(I)(1:1),
     &   ' set found for atom to be added'
      ELSE
C
C set up new atom
      BYPASS=.FALSE.
      NATOM=NATOM+1
      IAC(NATOM)=MAC(I)
      AMASS(NATOM)=ARMASS(I)
      CG(NATOM)=CHG(I)
      IMOVE(NATOM)=0
      LOOKUP(NATOM)=0
      QLOOKU(NATOM)=.TRUE.
      STEMP=RES(ISET(J))
      RES(NATOM)=STEMP
      STEMP=SEGID(ISET(J))
      SEGID(NATOM)=STEMP
      STEMP=RESID(ISET(J))
      RESID(NATOM)=STEMP
      IF (SET(J).EQ.'NIL ') THEN
      TYPE(NATOM)=FTP(I)(1:4)
      ELSE
      TYPE(NATOM)=FTP(I)(2:5)
      END IF
      NSET=NSET+1
      STEMP=SET(J)
      SET(NSET)=STEMP
      ISET(NSET)=NATOM
C
C first, all explicit nonbonded are set to zero
      IBLO(NATOM)=NNB
C
C now, the new atom has to be to assigned to a group number
C the case with GRPR(I)=0 is special
      IF (GRPR(I).EQ.0) THEN
      GRPLST(NATOM)=GRPLST(ISET(J))
      ATMLST(NATOM)=ATMLST(ISET(J))
      ELSE
      ATMLST(NATOM)=I
      IF (GRPR(I).NE.PATGRP) THEN
      PATGRP=GRPR(I)
      GROUP=PATGRP+GRPLST(ISET(J))
      IF (PATGRP.GE.GPOFF) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded GPOFF (routine PATCH2) parameter')
      END IF
      END IF
      GRPLST(NATOM)=GROUP
      END IF
C
C Now reset coordinates, etc. for added atom:
      CALL ATMINI(NATOM,NATOM)
C
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(7A)') ' PATCH: atom ',SEGID(NATOM),' ',
     1 RESID(NATOM),' ',TYPE(NATOM),' added'
      END IF
      END IF
      END IF
      END IF
      END IF
      END DO
C
      IF (.NOT.BYPASS) THEN
      CALL SORT(NDATOM,EXCH,ORDER,DATOM,1,0,0,0,0,0,0)
C
C Now define a map as well as an inverse map to map the atom
C numbers.
C First, sort GRPLST, using quicksort (SORT4P conserves the order of
C equal elements, this is essential at this point!)
      CALL SORTP(NATOM,INVMAP,ORDER5,GRPLST,ATMLST,0,0,0,0,0,2)
      DO I=1,NATOM
      MAP(INVMAP(I))=I
      END DO
C
C account for deletions, reduce NATOM by NDATOM,
C deleted atoms are mapped to MARK
      OFFSET=1
      DO I=1,NATOM
      IF (OFFSET.LE.NDATOM) THEN
      IF (DATOM(OFFSET).EQ.I) THEN
      MAP(I)=MARK
      OFFSET=OFFSET+1
      END IF
      END IF
      END DO
      NATOM=NATOM-NDATOM
      OFFSET=0
      DO I=1,NATOM
      DO WHILE (MAP(INVMAP(I+OFFSET)).EQ.MARK)
      OFFSET=OFFSET+1
      END DO
      INVMAP(I)=INVMAP(I+OFFSET)
      END DO
      DO I=1,NATOM
      MAP(INVMAP(I))=I
      END DO
C
C
C now begin complete mapping of molecular topology, COORD, COORDC, CNST
C note that NATOM is already reduced by the number of deleted atoms.
      CALL MAPIC(MAP,INVMAP,GRPLST,LINB,LIBLO,MARK)
C
C finally map and compress the ISET array
      CALL AVALUE(MAP,ISET,NSET,MARK)
      II=NSET
      NSET=0
      DO I=1,II
      IF (ISET(I).NE.MARK) THEN
      NSET=NSET+1
      STEMP=SET(I)
      SET(NSET)=STEMP
      ISET(NSET)=ISET(I)
      END IF
      END DO
      END IF
C
C
C add in or delete internal coordinates using final atom sequence
C
C deletion of bonds, angles, dihedrals and improper dihedrals
C takes account of the symmetry operations:
C bonds:     (a,b)<-->(b,a)
C angles:    (a,b,c)<-->(c,b,a)
C dihedrals: (a,b,c,d)<-->(d,c,b,a)
C impropers: (a,b,c,d)<-->(d,c,b,a)
C
C put in bonds
C
      IF (IPATC.GT.1) THEN
      I=NIC(2,IPATC-1)+1
      ELSE
      I=1
      END IF
      DO IPT=I,NIC(2,IPATC)
      II=PATOM(MIB(IPT),NSET,SET,ISET,TYPE,MARK)
      JJ=PATOM(MJB(IPT),NSET,SET,ISET,TYPE,MARK)
      ERROR=.FALSE.
      IF (II.EQ.MARK.OR.JJ.EQ.MARK) THEN
      ERROR=.TRUE.
      ELSE IF (DELBD(IPT).EQ.'ADD ') THEN
      IF (NBOND.GE.MAXB) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded MAXB parameter --> recompile program')
      ELSE
      NBOND=NBOND+1
      IB(NBOND)=II
      JB(NBOND)=JJ
      QACBB(NBOND)=.TRUE.
      QACBC(NBOND)=.TRUE.
      END IF
      ELSE IF (DELBD(IPT).EQ.'DELE') THEN
      INDEX=FIND52(IB,JB,0,0,0,II,JJ,0,0,0,NBOND,2,MARK)
      IF (INDEX.EQ.MARK) THEN
      INDEX=FIND52(IB,JB,0,0,0,JJ,II,0,0,0,NBOND,2,MARK)
      END IF
      IF (INDEX.NE.MARK) THEN
      IB(INDEX)=MARK
      ELSE
      ERROR=.TRUE.
      END IF
      END IF
      IF (ERROR) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELBD(IPT),ACTION,ALEN)
      WRITE(6,'(6(1X,A))') '%PATCH-ERR: to be',ACTION(1:ALEN),'bond',
     &  MIB(IPT),MJB(IPT),'not found in molecular structure.'
      CALL PATCHERRATM(MIB(IPT),II)
      CALL PATCHERRATM(MJB(IPT),JJ)
      END IF
      END DO
C
C put in angles
      IF (IPATC.GT.1) THEN
      I=NIC(3,IPATC-1)+1
      ELSE
      I=1
      END IF
      DO IPT=I,NIC(3,IPATC)
      II=PATOM(MIT(IPT),NSET,SET,ISET,TYPE,MARK)
      JJ=PATOM(MJT(IPT),NSET,SET,ISET,TYPE,MARK)
      KK=PATOM(MKT(IPT),NSET,SET,ISET,TYPE,MARK)
      ERROR=.FALSE.
      IF (II.EQ.MARK.OR.JJ.EQ.MARK.OR.KK.EQ.MARK) THEN
      ERROR=.TRUE.
      ELSE IF (DELAN(IPT).EQ.'ADD ') THEN
      IF (NTHETA.GE.MAXT) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded MAXT parameter --> recompile program')
      ELSE
      NTHETA=NTHETA+1
      IT(NTHETA)=II
      JT(NTHETA)=JJ
      KT(NTHETA)=KK
      QACTB(NTHETA)=.TRUE.
      QACTC(NTHETA)=.TRUE.
      QACTUB(NTHETA)=.TRUE.
      QACTUC(NTHETA)=.TRUE.
      END IF
      ELSE IF (DELAN(IPT).EQ.'DELE') THEN
      INDEX=FIND52(IT,JT,KT,0,0,II,JJ,KK,0,0,NTHETA,3,MARK)
      IF (INDEX.EQ.MARK) THEN
      INDEX=FIND52(IT,JT,KT,0,0,KK,JJ,II,0,0,NTHETA,3,MARK)
      END IF
      IF (INDEX.NE.MARK) THEN
      IT(INDEX)=MARK
      ELSE
      ERROR=.TRUE.
      END IF
      END IF
      IF (ERROR) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELAN(IPT),ACTION,ALEN)
      WRITE(6,'(7(1X,A))') '%PATCH-ERR: to be',ACTION(1:ALEN),'angle',
     & MIT(IPT),MJT(IPT),MKT(IPT),'not found in molecular structure.'
      CALL PATCHERRATM(MIT(IPT),II)
      CALL PATCHERRATM(MJT(IPT),JJ)
      CALL PATCHERRATM(MKT(IPT),KK)
      END IF
      END DO
C
C     put in dihedrals
C
      IF (IPATC.GT.1) THEN
      I=NIC(4,IPATC-1)+1
      ELSE
      I=1
      END IF
      DO IPT=I,NIC(4,IPATC)
      ERROR=.FALSE.
      II=PATOM(MIP(IPT),NSET,SET,ISET,TYPE,MARK)
      JJ=PATOM(MJP(IPT),NSET,SET,ISET,TYPE,MARK)
      KK=PATOM(MKP(IPT),NSET,SET,ISET,TYPE,MARK)
      LL=PATOM(MLP(IPT),NSET,SET,ISET,TYPE,MARK)
      IF (II.EQ.MARK.OR.JJ.EQ.MARK.OR.KK.EQ.MARK.OR.LL.EQ.MARK) THEN
      ERROR=.TRUE.
      ELSE IF (DELPT(IPT).EQ.'ADD ') THEN
      IF (NPHI.GE.MAXP) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded MAXP parameter --> recompile program')
      ELSE
      NPHI=NPHI+1
      END IF
      IP(NPHI)=II
      JP(NPHI)=JJ
      KP(NPHI)=KK
      LP(NPHI)=LL
      QACPB(NPHI)=.TRUE.
      QACPC(NPHI)=.TRUE.
      QACPD(NPHI)=.TRUE.
      ELSE IF (DELPT(IPT).EQ.'DELE') THEN
      INDEX=FIND52(IP,JP,KP,LP,0,II,JJ,KK,LL,0,NPHI,4,MARK)
      IF (INDEX.EQ.MARK) THEN
      INDEX=FIND52(IP,JP,KP,LP,0,LL,KK,JJ,II,0,NPHI,4,MARK)
      END IF
      IF (INDEX.NE.MARK) THEN
      IP(INDEX)=MARK
      ELSE
      ERROR=.TRUE.
      END IF
      END IF
      IF (ERROR) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELPT(IPT),ACTION,ALEN)
      WRITE(6,'(8(1X,A))')'%PATCH-ERR: to be',ACTION(1:ALEN),'dihedral',
     & MIP(IPT),MJP(IPT),MKP(IPT),MLP(IPT),
     & 'not found in molecular structure.'
      CALL PATCHERRATM(MIP(IPT),II)
      CALL PATCHERRATM(MJP(IPT),JJ)
      CALL PATCHERRATM(MKP(IPT),KK)
      CALL PATCHERRATM(MLP(IPT),LL)
      END IF
      END DO
C
C put in improper dihedrals
      IF (IPATC.GT.1) THEN
      I=NIC(5,IPATC-1)+1
      ELSE
      I=1
      END IF
      DO IPT=I,NIC(5,IPATC)
      ERROR=.FALSE.
      II=PATOM(MIM(IPT),NSET,SET,ISET,TYPE,MARK)
      JJ=PATOM(MJM(IPT),NSET,SET,ISET,TYPE,MARK)
      KK=PATOM(MKM(IPT),NSET,SET,ISET,TYPE,MARK)
      LL=PATOM(MLM(IPT),NSET,SET,ISET,TYPE,MARK)
      IF (II.EQ.MARK.OR.JJ.EQ.MARK.OR.KK.EQ.MARK.OR.LL.EQ.MARK) THEN
      ERROR=.TRUE.
      ELSE IF (DELMT(IPT).EQ.'ADD ') THEN
      IF (NIMPHI.GE.MAXIMP) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded MAXIMP parameter --> recompile program')
      ELSE
      NIMPHI=NIMPHI+1
      END IF
      IM(NIMPHI)=II
      JM(NIMPHI)=JJ
      KM(NIMPHI)=KK
      LM(NIMPHI)=LL
      QACIB(NIMPHI)=.TRUE.
      QACIC(NIMPHI)=.TRUE.
      QACID(NIMPHI)=.TRUE.
      ELSE IF (DELMT(IPT).EQ.'DELE') THEN
      INDEX=FIND52(IM,JM,KM,LM,0,II,JJ,KK,LL,0,NIMPHI,4,MARK)
      IF (INDEX.EQ.MARK) THEN
      INDEX=FIND52(IM,JM,KM,LM,0,LL,KK,JJ,II,0,NIMPHI,4,MARK)
      END IF
      IF (INDEX.NE.MARK) THEN
      IM(INDEX)=MARK
      ELSE
      ERROR=.TRUE.
      END IF
      ELSE
      ERROR=.TRUE.
      END IF
      IF (ERROR) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,DELMT(IPT),ACTION,ALEN)
      WRITE(6,'(8(1X,A))')'%PATCH-ERR: to be',ACTION(1:ALEN),'improper',
     & MIM(IPT),MJM(IPT),MKM(IPT),MLM(IPT),
     & 'not found in molecular structure.'
      CALL PATCHERRATM(MIM(IPT),II)
      CALL PATCHERRATM(MJM(IPT),JJ)
      CALL PATCHERRATM(MKM(IPT),KK)
      CALL PATCHERRATM(MLM(IPT),LL)
      END IF
      END DO
C
C put in explicit nonbonding exclusions
      IF (IPATC.GT.1) THEN
      II=NIC(1,IPATC-1)
      ELSE
      II=0
      END IF
      DO J=II+1,NIC(1,IPATC)
C
      IF (J.GT.1) THEN
      L=MXN(J-1)
      ELSE
      L=0
      END IF
      IF (MXN(J).GT.L) THEN
C
C for this atom there are some exclusions ...
      JJ=PATOM(FTP(J),NSET,SET,ISET,TYPE,MARK)
      IF (JJ.EQ.MARK) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,'DELE',ACTION,ALEN)
      WRITE(6,'(3A)')
     & ' %PATCH-ERR: to be deleted exclusion list atom ',FTP(J),
     & ' not found in molecular structure.'
      ELSE
C
C first, delete all previous exclusions for this atom
      IF (JJ.GT.1) THEN
      IDELTA=(IBLO(JJ)-IBLO(JJ-1))
      ELSE
      IDELTA=IBLO(JJ)
      END IF
      IF (IDELTA.GT.0) THEN
      NNB=NNB-IDELTA
      DO IPT=JJ,NATOM
      IBLO(IPT)=IBLO(IPT)-IDELTA
      END DO
      DO IPT=IBLO(JJ)+1,NNB
      INB(IPT)=INB(IPT+IDELTA)
      END DO
      END IF
C
C now, look-up all new pairs
      DO K=L+1,MXN(J)
      KK=PATOM(MNB(K),NSET,SET,ISET,TYPE,MARK)
      IF (KK.EQ.MARK) THEN
      CALL PATCHERR(QERROR,PATNAM,NSET,SET,ISET,'DELE',ACTION,ALEN)
      WRITE(6,'(3A)')
     & ' %PATCH-ERR: to be deleted exclusion list atom ',MNB(K),
     & ' not found in molecular structure.'
      ELSE
      IF (NNB.GE.MAXNB) THEN
      CALL WRNDIE(-5,'PATCH',
     & 'exceeded MAXNB parameter --> recompile program')
      ELSE
      NNB=NNB+1
      END IF
C
C finally, we have to insert the pair JJ, KK into the exclusion list
      DO IPT=JJ,NATOM
      IBLO(IPT)=IBLO(IPT)+1
      END DO
      DO IPT=NNB,IBLO(JJ)+1,-1
      INB(IPT)=INB(IPT-1)
      END DO
      INB(IBLO(JJ))=KK
      END IF
      END DO
      END IF
      END IF
C
      END DO
      IF (QERROR) WRITE(6,'(1X,78("%"),/)')
C
C remove all internal coordinates containing MARK
      CALL CMPRIC(MARK,LSORT)
      END IF
C
      RETURN
C
      END
C======================================================================
      SUBROUTINE PATCHERR(QERROR,PATNAM,NSET,SET,ISET,ID,ACTION,ALEN)
C
C Print a patch error header, if this is the first error.
C Also set the string ACTION(1:ALEN) to the action based on 
C the 4-character ID action identifier.
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'timer.inc'
      LOGICAL QERROR
      INTEGER NSET,ISET(NSET), ALEN
      CHARACTER*(*) PATNAM,SET(NSET),ID,ACTION
C local
      INTEGER I, J, K, IAT
C begin
      IF (ID.EQ.'DELE') THEN
      ACTION='deleted'
      ALEN=7
      ELSE IF (ID.EQ.'ADD ') THEN
      ACTION='added'
      ALEN=5
      ELSE
      ACTION='modified'
      ALEN=8
      END IF
      IF (.NOT.QERROR) THEN
      QERROR=.TRUE.
      WRITE(6,'(1X,78("%"))')
      WRITE(6,'(1X,2A)') '%PATCH-ERR: PATCH=',PATNAM
      I=0
      DO WHILE(I.LT.NSET)
      I=I+1
      J=I+1
      DO WHILE(SET(I).EQ.SET(J).AND.J.LT.NSET)
      J=J+1
      END DO
C     Write first and last atoms slected for each reference set,
C     or all selected atoms when message=all. Note that nothing will
C     be printed for a reference set that was not defined by the
C     patch invocation.
      IF (J-1.GT.I) THEN
      IAT = ISET(I)
      WRITE(6,'(1X,4A,3(1X,A),A)') '%PATCH-ERR: REFErence=',SET(I),
     &  '   first atom=(',SEGID(IAT),RESID(IAT),RES(IAT),TYPE(IAT),')'
      IF (WRNLEV.GT.5) THEN
      DO K = I+1, J-2
      IAT = ISET(K)
      WRITE(6,'(1X,A,29X,2A,3(1X,A),A)') '%PATCH-ERR:',
     &  '(',SEGID(IAT),RESID(IAT),RES(IAT),TYPE(IAT),')'
      END DO
      END IF
      IAT = ISET(J-1)
      WRITE(6,'(1X,A,19X,2A,3(1X,A),A)') '%PATCH-ERR:',
     &  'last atom=(',SEGID(IAT),RESID(IAT),RES(IAT),TYPE(IAT),')'
      ELSE
      IAT = ISET(I)
      WRITE(6,'(1X,4A,3(1X,A),A)') '%PATCH-ERR: REFErence=',SET(I),
     &  '   atom=(',SEGID(IAT),RESID(IAT),RES(IAT),TYPE(IAT),')'
      END IF
      I=J
      END DO
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE PATCHERRATM(NAME,IAT)
C
C Print error information about a patch atom selection
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'timer.inc'
      CHARACTER*(*) NAME
      INTEGER IAT
C begin
      IF (WRNLEV.GT.5) THEN
      IF (IAT.LE.0 .OR. IAT.GT.NATOM) THEN
      WRITE(6,'(3A)')
     &    ' %PATCH-ERR:      atom ',NAME,' =  not found'
      ELSE
      WRITE(6,'(4A,3(1X,A),A)')
     &    ' %PATCH-ERR:      atom ',NAME,' = (',
     &    SEGID(IAT),RESID(IAT),RES(IAT),TYPE(IAT),')'
      END IF
      END IF
      END
C======================================================================
      SUBROUTINE DELTIC
C
C Routine deletes atoms and all references to atoms
C
C For syntax see main parsing loop "HELP"
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
C local
      INTEGER FLAGS, MAP, INVMAP, GRPLST, LINB, LIBLO
      INTEGER XNATOM, XNNB
C dynamic
      XNATOM=NATOM
      XNNB=NNB
      FLAGS=ALLHP(INTEG4(NATOM))
      MAP=ALLHP(INTEG4(NATOM))
      INVMAP=ALLHP(INTEG4(NATOM))
      GRPLST=ALLHP(INTEG4(NATOM))
      LINB=ALLHP(INTEG4(NNB))
      LIBLO=ALLHP(INTEG4(NATOM))
      CALL DELTI2(HEAP(FLAGS),HEAP(MAP),HEAP(INVMAP),
     &            HEAP(GRPLST),HEAP(LINB),HEAP(LIBLO))
      CALL FREHP(LIBLO,INTEG4(XNATOM))
      CALL FREHP(LINB,INTEG4(XNNB))
      CALL FREHP(GRPLST,INTEG4(XNATOM))
      CALL FREHP(INVMAP,INTEG4(XNATOM))
      CALL FREHP(MAP,INTEG4(XNATOM))
      CALL FREHP(FLAGS,INTEG4(XNATOM))
      RETURN
      END
C
      SUBROUTINE DELTI2(FLAGS,MAP,INVMAP,GRPLST,LINB,LIBLO)
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'comand.inc'
      INTEGER FLAGS(*)
      INTEGER MAP(*), INVMAP(*)
      INTEGER GRPLST(*), LINB(*), LIBLO(*)
C local
      LOGICAL LSORT
      INTEGER I, J, II, OFFSET, NSLCT
C Temporary mark for deleted atoms:
      INTEGER MARK
      PARAMETER (MARK=-9999)
C
C begin
C
C defaults
      LSORT=.FALSE.
      CALL FILL4(FLAGS,NATOM,0)
      NSLCT=0
C
C parsing
      CALL PUSEND('DELETE>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('DELETE>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-delete')
C
      ELSE IF (WD(1:4).EQ.'SORT') THEN
      CALL NEXTLO('SORT=',LSORT)
      ELSE IF (WD(1:4).EQ.'SELE') THEN
      CALL SELCTA(FLAGS,NSLCT,X,Y,Z,.TRUE.)
      ELSE
      CALL CHKEND('DELETE>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      IF (NSLCT.GT.0) THEN
C
C construct MAP and INVMAP
      II=NATOM
      DO I=1,NATOM
      IF (FLAGS(I).EQ.1) THEN
      II=II-1
      MAP(I)=MARK
      END IF
      END DO
      NATOM=II
C
      OFFSET=0
      DO I=1,NATOM
      DO WHILE (FLAGS(I+OFFSET).EQ.1)
      OFFSET=OFFSET+1
      END DO
      INVMAP(I)=I+OFFSET
      END DO
      DO I=1,NATOM
      MAP(INVMAP(I))=I
      END DO
C
C fill temporary group list
      DO I=1,NGRP
      DO J=IGPBS(I)+1,IGPBS(I+1)
      GRPLST(J)=I
      END DO
      END DO
C
C now do mapping and compression of molecular topology, etc.
      CALL MAPIC(MAP,INVMAP,GRPLST,LINB,LIBLO,MARK)
      CALL CMPRIC(MARK,LSORT)
C
      END IF
C
C finally, scratch the lists
      CALL SCRATC
      CALL SHOW
      RETURN
      END
C======================================================================
      INTEGER FUNCTION PATOM(ATOM,NSET,SET,ISET,TYPE,MARK)
C
C tries to find ATOM=<reference><iupac> in SET, TYPE.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      CHARACTER*5 ATOM
      INTEGER NSET
      CHARACTER*4 SET(*)
      INTEGER ISET(*)
      CHARACTER*4 TYPE(*)
      INTEGER MARK
C local
      LOGICAL FOUND
      INTEGER I
C begin
      FOUND=.FALSE.
      I=0
      DO WHILE (.NOT. (FOUND.OR.I.GE.NSET))
      I=I+1
      IF (SET(I).EQ.'NIL ') THEN
      FOUND=(ATOM(1:4).EQ.TYPE(ISET(I)))
      ELSE
      FOUND=(SET(I)(1:1).EQ.ATOM(1:1))
      IF (FOUND) FOUND=(ATOM(2:5).EQ.TYPE(ISET(I)))
      END IF
      END DO
      IF (FOUND) THEN
      PATOM=ISET(I)
      ELSE
      PATOM=MARK
      END IF
      RETURN
      END
C======================================================================
      SUBROUTINE MAPIC(MAP,INVMAP,GRPLST,LINB,LIBLO,MARK)
C
C Subroutine maps molecular topology, coordinates, and
C constraints according to
C a MAP and its inverse INV_MAP. GRP_LST contains a group number for
C each atom and is used to redefine the group boundaries. See PATIC2
C for use of this routine.
C
C note: this routine may be modified when the molecular topology,
C coordinates, or constraints blocks are modified.
C after calling this routine a call to cmpric is necessary to
C delete marked atoms in all lists.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'cstack.inc'
      INCLUDE 'param.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'ener.inc'
      INTEGER MAP(*), INVMAP(*), GRPLST(*), LINB(*), LIBLO(*), MARK
C local
      INTEGER WORK, CWORK, LWORK
      INTEGER GROUP, I, II, J
C
C begin
      LWORK=MAX(NATOM,NBOND,NTHETA,NPHI,NIMPHI)
      WORK=ALLHP(IREAL8(LWORK))
      CWORK=CALLST(ICHAR4(NATOM))
C
      IF (WRNLEV.GE.10) THEN
      WRITE(6,1500)
1500  FORMAT(' MAPIC: Atom numbers being modified')
      END IF
C
C map all atom properties
      CALL AINDC4(INVMAP,IAC,NATOM,CSTACK(CWORK))
      CALL AINDX4(INVMAP,LOOKUP,NATOM,HEAP(WORK))
      CALL AINDL4(INVMAP,QLOOKU,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,AMASS,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,CG,NATOM,HEAP(WORK))
      CALL AINDC4(INVMAP,TYPE,NATOM,CSTACK(CWORK))
      CALL AINDC4(INVMAP,RES,NATOM,CSTACK(CWORK))
      CALL AINDC4(INVMAP,RESID,NATOM,CSTACK(CWORK))
      CALL AINDC4(INVMAP,SEGID,NATOM,CSTACK(CWORK))
      CALL AINDX4(INVMAP,IMOVE,NATOM,HEAP(WORK))
C
      CALL AINDR8(INVMAP,X,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,Y,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,Z,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,WMAIN,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,QMAIN,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,XCOMP,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,YCOMP,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,ZCOMP,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,WCOMP,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,QCOMP,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,DX,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,DY,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,DZ,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,XV,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,YV,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,ZV,NATOM,HEAP(WORK))
C
      CALL AINDR8(INVMAP,RMSD,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,KCNSTR,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,KZCNSTR,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,REFX,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,REFY,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,REFZ,NATOM,HEAP(WORK))
      CALL AINDR8(INVMAP,FBETA,NATOM,HEAP(WORK))
C
C delete stores
      DO I=1,MAXSTO
      IF (PTRSTO(I).NE.0) THEN
      CALL FREHP(PTRSTO(I),IREAL8(LENSTO(I)))
      PTRSTO(I)=0
      LENSTO(I)=0
      END IF
      END DO
C
C map atom lists
      CALL AVALUE(MAP,IB,NBOND,MARK)
      CALL AVALUE(MAP,JB,NBOND,MARK)
C
      CALL AVALUE(MAP,IT,NTHETA,MARK)
      CALL AVALUE(MAP,JT,NTHETA,MARK)
      CALL AVALUE(MAP,KT,NTHETA,MARK)
C
      CALL AVALUE(MAP,IP,NPHI,MARK)
      CALL AVALUE(MAP,JP,NPHI,MARK)
      CALL AVALUE(MAP,KP,NPHI,MARK)
      CALL AVALUE(MAP,LP,NPHI,MARK)
C
      CALL AVALUE(MAP,IM,NIMPHI,MARK)
      CALL AVALUE(MAP,JM,NIMPHI,MARK)
      CALL AVALUE(MAP,KM,NIMPHI,MARK)
      CALL AVALUE(MAP,LM,NIMPHI,MARK)
C
      CALL AINDX4(INVMAP,GRPLST,NATOM,HEAP(WORK))
C
C re-define INB, IBLO explicit non-bond-exclusion list.
      CALL AVALUE(MAP,INB,NNB,MARK)
C
      NNB=0
      DO I=1,NATOM
      IF (INVMAP(I).GT.1) THEN
      II=IBLO(INVMAP(I)-1)+1
      ELSE
      II=1
      END IF
      DO J=II,IBLO(INVMAP(I))
      IF (INB(J).NE.MARK) THEN
      NNB=NNB+1
      LINB(NNB)=INB(J)
      END IF
      END DO
      LIBLO(I)=NNB
      END DO
C
      DO I=1,NATOM
      IBLO(I)=LIBLO(I)
      END DO
      DO I=1,NNB
      INB(I)=LINB(I)
      END DO
C
C now re-define groups:
      GROUP=-1
      NGRP=0
      DO I=1,NATOM
      IF (GROUP.NE.GRPLST(I)) THEN
      GROUP=GRPLST(I)
      IF (NGRP.GE.MAXGRP) THEN
      CALL WRNDIE(-5,'MAPIC',
     & 'exceeded MAXGRP parameter --> recompile program')
      ELSE
      NGRP=NGRP+1
      IGPBS(NGRP)=I-1
      END IF
      END IF
      END DO
      IGPBS(NGRP+1)=NATOM
C
      CALL FREHP(WORK,IREAL8(LWORK))
      CALL CFREST(ICHAR4(NATOM))
      RETURN
      END
C
      SUBROUTINE CMPRIC(MARK,LSORT)
C
C     Routine deletes marked bonds, angles, ...
C     compresses molecular structure database.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
      INTEGER   MARK
      LOGICAL   LSORT
C local
      EXTERNAL  EXCH5
      INTEGER   I, II
      LOGICAL   CONDIT
C begin
C     compress bond lists,...
C
      II=0
      DO I=1,NBOND
      CONDIT=(IB(I).EQ.MARK.OR.JB(I).EQ.MARK)
      IF (.NOT.CONDIT) THEN
      II=II+1
      IB(II)=IB(I)
      JB(II)=JB(I)
      ACBB(II)=ACBB(I)
      ACBC(II)=ACBC(I)
      QACBB(II)=QACBB(I)
      QACBC(II)=QACBC(I)
      END IF
      END DO
      NBOND=II
C
      II=0
      DO I=1,NTHETA
      CONDIT=(IT(I).EQ.MARK.OR.JT(I).EQ.MARK.OR.KT(I).EQ.MARK)
      IF (.NOT. CONDIT) THEN
      II=II+1
      IT(II)=IT(I)
      JT(II)=JT(I)
      KT(II)=KT(I)
      ACTB(II)=ACTB(I)
      ACTC(II)=ACTC(I)
      ACTUB(II)=ACTUB(I)
      ACTUC(II)=ACTUC(I)
      QACTB(II)=QACTB(I)
      QACTC(II)=QACTC(I)
      QACTUB(II)=QACTUB(I)
      QACTUC(II)=QACTUC(I)
      END IF
      END DO
      NTHETA=II
C
      II=0
      DO I=1,NPHI
      CONDIT=(IP(I).EQ.MARK.OR.JP(I).EQ.MARK.OR.KP(I).EQ.MARK
     1        .OR.LP(I).EQ.MARK)
      IF (.NOT.CONDIT) THEN
      II=II+1
      IP(II)=IP(I)
      JP(II)=JP(I)
      KP(II)=KP(I)
      LP(II)=LP(I)
      ACPB(II)=ACPB(I)
      ACPC(II)=ACPC(I)
      ACPD(II)=ACPD(I)
      QACPB(II)=QACPB(I)
      QACPC(II)=QACPC(I)
      QACPD(II)=QACPD(I)
      END IF
      END DO
      NPHI=II
C
      II=0
      DO I=1,NIMPHI
      CONDIT=(IM(I).EQ.MARK.OR.JM(I).EQ.MARK.OR.KM(I).EQ.MARK
     1        .OR.LM(I).EQ.MARK)
      IF (.NOT.CONDIT) THEN
      II=II+1
      IM(II)=IM(I)
      JM(II)=JM(I)
      KM(II)=KM(I)
      LM(II)=LM(I)
      ACIB(II)=ACIB(I)
      ACIC(II)=ACIC(I)
      ACID(II)=ACID(I)
      QACIB(II)=QACIB(I)
      QACIC(II)=QACIC(I)
      QACID(II)=QACID(I)
      END IF
      END DO
      NIMPHI=II
C
C     finally sort all lists if LSORT is true
C
      IF (LSORT) THEN
      CALL SORT(NBOND,EXCH5,ORDER5,IB,JB,0,0,0,0,0,2)
      CALL SORT(NTHETA,EXCH5,ORDER5,IT,JT,KT,0,0,0,0,3)
      CALL SORT(NPHI,EXCH5,ORDER5,IP,JP,KP,LP,0,0,0,4)
      CALL SORT(NIMPHI,EXCH5,ORDER5,IM,JM,KM,LM,0,0,0,4)
      END IF
C
      RETURN
      END
C=====================================================================
      SUBROUTINE DUPLIC
C
C parses duplicate statement
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
C local
      INTEGER ONATOM
C pointer
      INTEGER FLAGS, FLAGS2, INDEX, MAP, GRPLST
C begin
      ONATOM=NATOM
      FLAGS=ALLHP(INTEG4(ONATOM))
      FLAGS2=ALLHP(INTEG4(ONATOM+1))
      INDEX=ALLHP(INTEG4(ONATOM))
      MAP=ALLHP(INTEG4(ONATOM+1))
      GRPLST=ALLHP(INTEG4(ONATOM))
      CALL DUPLI2(HEAP(FLAGS),HEAP(FLAGS2),
     &            HEAP(INDEX),HEAP(MAP),HEAP(GRPLST))
      CALL FREHP(GRPLST,INTEG4(ONATOM))
      CALL FREHP(MAP,INTEG4(ONATOM+1))
      CALL FREHP(INDEX,INTEG4(ONATOM))
      CALL FREHP(FLAGS2,INTEG4(ONATOM+1))
      CALL FREHP(FLAGS,INTEG4(ONATOM))
      RETURN
      END
C======================================================================
      SUBROUTINE DUPLI2(FLAGS,FLAGS2,INDEX,MAP,GRPLST)
C
C See routine DUPLIC above.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'mtf.inc'
      INTEGER FLAGS(*), FLAGS2(0:*), INDEX(*), MAP(0:*), GRPLST(*)
C local
      INTEGER NFLAGS
      CHARACTER*4 NSEGID, NRESID
C begin
C
C defaults
      CALL FILL4(FLAGS,NATOM,0)
      NFLAGS=0
      NSEGID='    '
      NRESID='    '
C
C parsing
      CALL PUSEND('DUPLicate>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('DUPLicate>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-duplicate')
C
      ELSE IF (WD(1:4).EQ.'SELE') THEN
      CALL SELCTA(FLAGS,NFLAGS,X,Y,Z,.TRUE.)
      ELSE IF (WD(1:4).EQ.'SEGI') THEN
      CALL NEXTA4('SEGId=',NSEGID)
      ELSE IF (WD(1:4).EQ.'RESI') THEN
      CALL NEXTA4('RESIdue=',NRESID)
      ELSE
      CALL CHKEND('DUPLicate>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      IF (NFLAGS.GT.0) THEN
      IF (NSEGID.EQ.'    '.AND.NRESID.EQ.'    ') THEN
      CALL WRNDIE(-5,'DUPLI2',
     & 'Non-blank SEGId or RESIdue (or both) have to be specified')
      ELSE
C
      CALL DUPLI3(NFLAGS,FLAGS,FLAGS2,INDEX,MAP,GRPLST,NSEGID,NRESID)
C
C scratch the lists
      CALL SCRATC
      CALL SHOW
      END IF
      END IF
C
      RETURN
      END
C======================================================================
      SUBROUTINE DUPLI3(NFLAGS,FLAGS,FLAGS2,
     &                  INDEX,MAP,GRPLST,NSEGID,NRESID)
C
C Routine duplicates the specified atoms.  It copies all atomic
C properties, such as X,Y,Z, MASS, etc.  It copies those bonds,
C angles, dihedrals for which at least one atom has been
C selected.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'funct.inc'
      INTEGER NFLAGS, FLAGS(*), FLAGS2(0:*), INDEX(*)
      INTEGER MAP(0:*), GRPLST(*)
      CHARACTER*4 NSEGID, NRESID
C local
      INTEGER IAT, II, IG, J, OGROUP, ONATOM, NN
C begin
C
C first make an index list of all selected atoms.
      FLAGS2(0)=0
      DO IAT=1,NATOM
      INDEX(IAT)=FLAGS(IAT)
      FLAGS2(IAT)=FLAGS(IAT)
      END DO
      CALL MAKIND(INDEX,NATOM,NFLAGS)
C
C initialize the atom number map
      MAP(0)=0
      DO IAT=1,NATOM
      MAP(IAT)=IAT
      END DO
C
C make a group list of the current atoms
      DO IG=1,NGRP
      DO IAT=IGPBS(IG)+1,IGPBS(IG+1)
      GRPLST(IAT)=IG
      END DO
      END DO
      ONATOM=NATOM
C
C duplicate atomic properties
      DO IAT=1,NFLAGS
      IF (NATOM.GE.MAXA) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXA parameter --> recompile program')
      ELSE
      NATOM=NATOM+1
      END IF
      IAC(NATOM)=IAC(INDEX(IAT))
      LOOKUP(NATOM)=LOOKUP(INDEX(IAT))
      QLOOKU(NATOM)=QLOOKU(INDEX(IAT))
      AMASS(NATOM)=AMASS(INDEX(IAT))
      CG(NATOM)=CG(INDEX(IAT))
      TYPE(NATOM)=TYPE(INDEX(IAT))
      RES(NATOM)=RES(INDEX(IAT))
      IF (NRESID.NE.'    ') THEN
      RESID(NATOM)=NRESID
      ELSE
      RESID(NATOM)=RESID(INDEX(IAT))
      END IF
      IF (NSEGID.NE.'    ') THEN
      SEGID(NATOM)=NSEGID
      ELSE
      SEGID(NATOM)=SEGID(INDEX(IAT))
      END IF
      IMOVE(NATOM)=IMOVE(INDEX(IAT))
      X(NATOM)=X(INDEX(IAT))
      Y(NATOM)=Y(INDEX(IAT))
      Z(NATOM)=Z(INDEX(IAT))
      WMAIN(NATOM)=WMAIN(INDEX(IAT))
      QMAIN(NATOM)=QMAIN(INDEX(IAT))
      XCOMP(NATOM)=XCOMP(INDEX(IAT))
      YCOMP(NATOM)=YCOMP(INDEX(IAT))
      ZCOMP(NATOM)=ZCOMP(INDEX(IAT))
      WCOMP(NATOM)=WCOMP(INDEX(IAT))
      QCOMP(NATOM)=QCOMP(INDEX(IAT))
      DX(NATOM)=DX(INDEX(IAT))
      DY(NATOM)=DY(INDEX(IAT))
      DZ(NATOM)=DZ(INDEX(IAT))
      XV(NATOM)=XV(INDEX(IAT))
      YV(NATOM)=YV(INDEX(IAT))
      ZV(NATOM)=ZV(INDEX(IAT))
      RMSD(NATOM)=RMSD(INDEX(IAT))
      KCNSTR(NATOM)=KCNSTR(INDEX(IAT))
      KZCNSTR(NATOM)=KZCNSTR(INDEX(IAT))
      REFX(NATOM)=REFX(INDEX(IAT))
      REFY(NATOM)=REFY(INDEX(IAT))
      REFZ(NATOM)=REFZ(INDEX(IAT))
      FBETA(NATOM)=FBETA(INDEX(IAT))
C
C update the map
      MAP(INDEX(IAT))=NATOM
      END DO
C
C delete VECTOR stores
      DO II=1,MAXSTO
      IF (PTRSTO(II).NE.0) THEN
      CALL FREHP(PTRSTO(II),IREAL8(LENSTO(II)))
      PTRSTO(II)=0
      LENSTO(II)=0
      END IF
      END DO
C
C duplicate bonds
      NN=NBOND
      DO II=1,NN
      IF (FLAGS2(IB(II)).EQ.1.OR.FLAGS2(JB(II)).EQ.1) THEN
      IF (NBOND.GE.MAXB) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXB parameter --> recompile program')
      ELSE
      NBOND=NBOND+1
      END IF
      IB(NBOND)=MAP(IB(II))
      JB(NBOND)=MAP(JB(II))
      ACBB(NBOND)=ACBB(II)
      ACBC(NBOND)=ACBC(II)
      QACBB(NBOND)=QACBB(II)
      QACBC(NBOND)=QACBC(II)
      END IF
      END DO
C
C duplicate angles
      NN=NTHETA
      DO II=1,NN
      IF (FLAGS2(IT(II)).EQ.1.OR.FLAGS2(JT(II)).EQ.1.OR.
     &      FLAGS2(KT(II)).EQ.1) THEN
      IF (NTHETA.GE.MAXT) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXT parameter --> recompile program')
      ELSE
      NTHETA=NTHETA+1
      END IF
      IT(NTHETA)=MAP(IT(II))
      JT(NTHETA)=MAP(JT(II))
      KT(NTHETA)=MAP(KT(II))
      ACTB(NTHETA)=ACTB(II)
      ACTC(NTHETA)=ACTC(II)
      ACTUB(NTHETA)=ACTUB(II)
      ACTUC(NTHETA)=ACTUC(II)
      QACTB(NTHETA)=QACTB(II)
      QACTC(NTHETA)=QACTC(II)
      QACTUB(NTHETA)=QACTUB(II)
      QACTUC(NTHETA)=QACTUC(II)
      END IF
      END DO
C
C duplicate dihedrals
      NN=NPHI
      DO II=1,NN
      IF (FLAGS2(IP(II)).EQ.1.OR.FLAGS2(JP(II)).EQ.1.OR.
     &      FLAGS2(KP(II)).EQ.1.OR.FLAGS2(LP(II)).EQ.1) THEN
      IF (NPHI.GE.MAXP) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXP parameter --> recompile program')
      ELSE
      NPHI=NPHI+1
      END IF
      IP(NPHI)=MAP(IP(II))
      JP(NPHI)=MAP(JP(II))
      KP(NPHI)=MAP(KP(II))
      LP(NPHI)=MAP(LP(II))
      ACPB(NPHI)=ACPB(II)
      ACPC(NPHI)=ACPC(II)
      ACPD(NPHI)=ACPD(II)
      QACPB(NPHI)=QACPB(II)
      QACPC(NPHI)=QACPC(II)
      QACPD(NPHI)=QACPD(II)
      END IF
      END DO
C
C duplicate impropers
      NN=NIMPHI
      DO II=1,NN
      IF (FLAGS2(IM(II)).EQ.1.OR.FLAGS2(JM(II)).EQ.1.OR.
     &      FLAGS2(KM(II)).EQ.1.OR.FLAGS2(LM(II)).EQ.1) THEN
      IF (NIMPHI.GE.MAXIMP) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXIMP parameter --> recompile program')
      ELSE
      NIMPHI=NIMPHI+1
      END IF
      IM(NIMPHI)=MAP(IM(II))
      JM(NIMPHI)=MAP(JM(II))
      KM(NIMPHI)=MAP(KM(II))
      LM(NIMPHI)=MAP(LM(II))
      ACIB(NIMPHI)=ACIB(II)
      ACIC(NIMPHI)=ACIC(II)
      ACID(NIMPHI)=ACID(II)
      QACIB(NIMPHI)=QACIB(II)
      QACIC(NIMPHI)=QACIC(II)
      QACID(NIMPHI)=QACID(II)
      END IF
      END DO
C
C duplicate explicit nonbonded exclusions
      DO IAT=1,NFLAGS
      IF (INDEX(IAT).GT.1) THEN
      II=IBLO(INDEX(IAT)-1)+1
      ELSE
      II=1
      END IF
      DO J=II,IBLO(INDEX(IAT))
      IF (NNB.GE.MAXNB) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXNB parameter --> recompile program')
      ELSE
      NNB=NNB+1
      END IF
      INB(NNB)=MAP(INB(J))
      END DO
      IBLO(MAP(INDEX(IAT)))=NNB
      END DO
C
C duplicate groups
C
C make a group list of the current atoms
      OGROUP=NGRP
      DO IAT=1,NFLAGS
      IF (GRPLST(INDEX(IAT)).NE.OGROUP) THEN
C
C make a new group
      IF (NGRP.GE.MAXGRP) THEN
      CALL WRNDIE(-5,'DUPLI3',
     & 'exceeded MAXGRP parameter --> recompile program')
      ELSE
      NGRP=NGRP+1
      END IF
      OGROUP=GRPLST(INDEX(IAT))
      IGPBS(NGRP)=MAP(INDEX(IAT))-1
      IF (IGPBS(NGRP).NE.ONATOM+IAT-1) THEN
      CALL WRNDIE(-5,'DUPL3','Programming error')
      END IF
      END IF
      END DO
      IGPBS(NGRP+1)=NATOM
C
      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE EXRDC (EDI,WHICH)
C     ------------------------------------------------------------------
C     Calls EXRDC2, which does the actual energy calculation
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xdipo_rdc.inc"
      INCLUDE  "heap.inc"

      DOUBLE PRECISION EDI
      CHARACTER*7 WHICH

      CALL EXRDC2(EDI,HEAP(XRDCIPTR),HEAP(XRDCJPTR),HEAP(XRDCKPTR),
     &                HEAP(XRDCLPTR),HEAP(XRDCMPTR),HEAP(XRDCNPTR),
     &                HEAP(XRDCILST),HEAP(XRDCJLST),HEAP(XRDCKLST),
     &                HEAP(XRDCLLST),HEAP(XRDCMLST),HEAP(XRDCNLST),
     &                HEAP(XRDCOBSPTR),HEAP(XRDCERRPTR),
     &                HEAP(CALCXRDCPTR),WHICH)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE EXRDC2 (EDI,ATOMIPTR,ATOMJPTR,ATOMKPTR,ATOMLPTR, 
     &                       ATOMMPTR,ATOMNPTR,ATOMILST,ATOMJLST,
     &                       ATOMKLST,ATOMLLST,ATOMMLST,ATOMNLST,
     &                       XRDCOBS,XRDCERR,XRDCCALC,WHICH)
C     ------------------------------------------------------------------
C     Calculates residual dipolar coupling energies
C
C     Energies are of the form:
C        E=K*(DELTARDC**2)
C     where :
C        K=FORCE CONSTANT
C        DELTARDC=CALCULATED RDC-OBSERVED RDC
C     and residual dipolar coupling function is defined as:
C        RDC=A1*(3*COS(THETA)^2-1)+(3/2)*A2*(SIN(THETA)^2*COS(2*PHI))
C
C     WHICH is a flag that switches between energy/force calculations
C     and RDC calculations for violations
C
C     Note that:
C        Atom I=Origin of the tensor
C        Atom J=Z direction
C        Atom K=X direction
C        Atom L=Y direction
C        Atom M=Coupled nucleus (e.g. N)
C        Atom N=Detected nucleus (e.g. H)
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xdipo_rdc.inc"
      INCLUDE  "consta.inc"

      DOUBLE PRECISION DIPOE
      COMMON /DIPOENERGY/DIPOE
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*)
      DOUBLE PRECISION XRDCOBS(*),XRDCERR(*)
      DOUBLE PRECISION XRDCCALC(*),EDI
      CHARACTER*7 WHICH
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER COUNT,CLASS,MM,NN,II,I,J,K,L,NA,M,N,SWAP
      PARAMETER (NA=20)
      INTEGER DMM,DNN,OUTFLAG(NA),MCOUNT,NCOUNT,PCOUNT
      DOUBLE PRECISION XI,XJ,XK,XL,XM,XN,YI,YJ,YK,YL,YM,YN,
     &                 ZI,ZJ,ZK,ZL,ZM,ZN,
     &                 E,DF1(NA),DF2(NA),DF3(NA),
     &                 PHI(NA),DPXI(NA),DPYI(NA),DPZI(NA),
     &                 DPXJ(NA),DPYJ(NA),DPZJ(NA),DPXK(NA),
     &                 DPYK(NA),DPZK(NA),DPXL(NA),DPYL(NA),
     &                 DPZL(NA),DPXM(NA),DPYM(NA),DPZM(NA),
     &                 DPXN(NA),DPYN(NA),DPZN(NA),
     &                 THETA(NA),DTXI(NA),DTYI(NA),DTZI(NA),
     &                 DTXJ(NA),DTYJ(NA),DTZJ(NA),DTXK(NA),
     &                 DTYK(NA),DTZK(NA),DTXL(NA),DTYL(NA),
     &                 DTZL(NA),DTXM(NA),DTYM(NA),DTZM(NA),
     &                 DTXN(NA),DTYN(NA),DTZN(NA),DRXM(NA),
     &                 DRYM(NA),DRZM(NA),DRXN(NA),DRYN(NA),
     &                 DRZN(NA),DIST,
     &                 O1,O2,O3,O4 ,O5 ,O6 ,O7 ,O8,O9,O10,
     &                 O11,O12,O13,O14,O15,O16,O17,O18,O19,
     &                 O20,O21,O22,O23,O24,O25,O26,O27,O28,
     &                 O29,O30,O31,O32,O33,O34,O35,O36,O37,
     &                 O38,O39,O40,O41,O42,O43,O44,O45,O46,
     &                 O47,O48,O49,O50,O51,O52,O53,O54,O55,
     &                 O56,O57,O58,O59,O60,O61,O62,O63,O64,
     &                 O65,O66,O67,O68,O69,O70,O71,O72,O73,
     &                 O74,O75,O76,O77,O78,O79,O80,O81,O82
      DOUBLE PRECISION OBSXRDC,ERRXRDC,K1,
     &                 COEF1,COEF2,A,B,DELTA,
     &                 DT,DP,DELTAXRDC,
     &                 DD,DR,CALCXRDC
C     ------------------------------------------------------------------
C     Zero out partial energy
C     ------------------------------------------------------------------
      EDI=ZERO

      CLASS=1
      K1=XRDCFORCES(1)
      COEF1=XRDCCOEF1(1)
      COEF2=XRDCCOEF2(1)

      COUNT=0

      DO WHILE (COUNT.LT.RDCNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Reset individual E to zero
C     ------------------------------------------------------------------
         E=0

         DO WHILE ((XRDCASSNDX(CLASS).LT.COUNT).OR.
     &             (XRDCASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO

         IF (XRDCASSNDX(CLASS).EQ.XRDCASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         K1=XRDCFORCES(CLASS)
         COEF1=XRDCCOEF1(CLASS)
         COEF2=XRDCCOEF2(CLASS)
C     ------------------------------------------------------------------
C     Note there should only be one atom for I, J, K, and L
C     ------------------------------------------------------------------
         I=ATOMIPTR(COUNT)+1
         J=ATOMJPTR(COUNT)+1
         K=ATOMKPTR(COUNT)+1
         L=ATOMLPTR(COUNT)+1

         XI=X(ATOMILST(I))
         XJ=X(ATOMJLST(J))
         XK=X(ATOMKLST(K))
         XL=X(ATOMLLST(L))
         YI=Y(ATOMILST(I))
         YJ=Y(ATOMJLST(J))
         YK=Y(ATOMKLST(K))
         YL=Y(ATOMLLST(L))
         ZI=Z(ATOMILST(I))
         ZJ=Z(ATOMJLST(J))
         ZK=Z(ATOMKLST(K))
         ZL=Z(ATOMLLST(L))

         OBSXRDC=XRDCOBS(COUNT)
         ERRXRDC=XRDCERR(COUNT)
C     ------------------------------------------------------------------
C     Initialzie calculated residual dipolar coupling and counter
C     ------------------------------------------------------------------
         CALCXRDC=0
         II=0
         MCOUNT=0
         NCOUNT=0
C     ------------------------------------------------------------------
C     Check for correct permutations of paired atoms to get the nucleus-
C     nucleus vector. This depends solely on the order of the assigned
C     atoms. OUTFLAG=1 indicates that the permutation is not allowed.
C     ------------------------------------------------------------------
         DMM=ATOMMPTR(COUNT+1)-ATOMMPTR(COUNT)
         DNN=ATOMNPTR(COUNT+1)-ATOMNPTR(COUNT)
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            MCOUNT=MCOUNT+1
            NCOUNT=0
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               NCOUNT=NCOUNT+1
               II=II+1
               IF ((DMM.GT.1).AND.(DNN.GT.1)) THEN
                    IF (MCOUNT.EQ.NCOUNT) THEN
                        OUTFLAG(II)=0
                    ELSE
                        OUTFLAG(II)=1
                    ENDIF
               ELSE
                    OUTFLAG(II)=0
               END IF
            END DO
         END DO

         II=0
         PCOUNT=0
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
                   XM=X(ATOMMLST(MM))
                   XN=X(ATOMNLST(NN))
                   YM=Y(ATOMMLST(MM))
                   YN=Y(ATOMNLST(NN))
                   ZM=Z(ATOMMLST(MM))
                   ZN=Z(ATOMNLST(NN))
C     ------------------------------------------------------------------
C     Calculate THETA, PHI and derivatives with respect to X, Y, Z of
C     atoms I, J, K, L, M, N. This was done with Mathematica by Nico!
C     ------------------------------------------------------------------
                   O1=-XI+XJ
                   O2=O1**2
                   O3=-YI+YJ
                   O4=O3**2
                   O5=-ZI+ZJ
                   O6=O5**2
                   O7=O2+O4+O6
                   O8=SQRT(O7)
                   O9=1/O8
                   O10=-XM+XN
                   O11=O1*O10
                   O12=-YM+YN
                   O13=O12*O3
                   O14=-ZM+ZN
                   O15=O14*O5
                   O16=O11+O13+O15
                   O17=O10**2
                   O18=O12**2
                   O19=O14**2
                   O20=O17+O18+O19
                   O21=SQRT(O20)
                   O22=1/O21
                   O23=1/O7
                   O24=O16**2
                   O25=1/O20
                   O26=O23*O24*O25
                   O27=SQRT(1.D0-O26)
                   O28=1/O27
                   O29=XM-XN
                   O30=O7**(3.D0/2.D0)
                   O31=1/O30
                   O32=O1*O16*O22*O31
                   O33=YM-YN
                   O34=O16*O22*O3*O31
                   O35=ZM-ZN
                   O36=O16*O22*O31*O5
                   O37=O20**(3.D0/2.D0)
                   O38=1/O37
                   O39=O10*O16*O38*O9
                   O40=O12*O16*O38*O9
                   O41=O14*O16*O38*O9
                   O42=-XI+XK
                   O43=O42**2
                   O44=-YI+YK
                   O45=O44**2
                   O46=-ZI+ZK
                   O47=O46**2
                   O48=O43+O45+O47
                   O49=SQRT(O48)
                   O50=-XI+XL
                   O51=O50**2
                   O52=-YI+YL
                   O53=O52**2
                   O54=-ZI+ZL
                   O55=O54**2
                   O56=O51+O53+O55
                   O57=SQRT(O56)
                   O58=1/O57
                   O59=O10*O42
                   O60=O12*O44
                   O61=O14*O46
                   O62=O59+O60+O61
                   O63=1/O62
                   O64=O10*O50
                   O65=O12*O52
                   O66=O14*O54
                   O67=O64+O65+O66
                   O68=O62**2
                   O69=1/O68
                   O70=O56**(3.D0/2.D0)
                   O71=1/O70
                   O72=O49*O50*O63*O67*O71
                   O73=1/O49
                   O74=O42*O58*O63*O67*O73
                   O75=1/O56
                   O76=O67**2
                   O77=O48*O69*O75*O76
                   O78=1/(1.D0+O77)
                   O79=O49*O52*O63*O67*O71
                   O80=O44*O58*O63*O67*O73
                   O81=O49*O54*O63*O67*O71
                   O82=O46*O58*O63*O67*O73
  
                   THETA(II)=ACOS(O16*O22*O9)
         
                   DTXI(II)=-(O28*(O32+O22*O29*O9))
                   DTYI(II)=-(O28*(O34+O22*O33*O9))
                   DTZI(II)=-(O28*(O36+O22*O35*O9))
                   DTXJ(II)=-(O28*(-O32+O10*O22*O9))
                   DTYJ(II)=-(O28*(-O34+O12*O22*O9))
                   DTZJ(II)=-(O28*(-O36+O14*O22*O9))
                   DTXK(II)=0
                   DTYK(II)=0
                   DTZK(II)=0
                   DTXL(II)=0
                   DTYL(II)=0
                   DTZL(II)=0
                   DTXM(II)=-(O28*(O39+O22*O9*(XI-XJ)))
                   DTYM(II)=-(O28*(O40+O22*O9*(YI-YJ)))
                   DTZM(II)=-(O28*(O41+O22*O9*(ZI-ZJ)))
                   DTXN(II)=-(O28*(-O39+O1*O22*O9))
                   DTYN(II)= -(O28*(-O40+O22*O3*O9))
                   DTZN(II)=-(O28*(-O41+O22*O5*O9))
  
                   PHI(II)=ATAN(O49*O58*O63*O67)

                   DPXI(II)=O78*(O29*O49*O58*O63-O29*O49*O58*O67*O69+
     &                           O72-O74)
                   DPYI(II)=O78*(O33*O49*O58*O63-O33*O49*O58*O67*O69+
     &                           O79-O80)
                   DPZI(II)=O78*(O35*O49*O58*O63-O35*O49*O58*O67*O69+
     &                           O81-O82)
                   DPXJ(II)=0
                   DPYJ(II)=0
                   DPZJ(II)=0
                   DPXK(II)=(-(O10*O49*O58*O67*O69)+O74)*O78
                   DPYK(II)=O78*(-(O12*O49*O58*O67*O69)+O80)
                   DPZK(II)=O78*(-(O14*O49*O58*O67*O69)+O82)
                   DPXL(II)=(O10*O49*O58*O63-O72)*O78
                   DPYL(II)=O78*(O12*O49*O58*O63-O79)
                   DPZL(II)=O78*(O14*O49*O58*O63-O81)
                   DPXM(II)=O78*(-(O49*O58*O67*O69*(XI-XK))+
     &                             O49*O58*O63*(XI-XL))
                   DPYM(II)=O78*(-(O49*O58*O67*O69*(YI-YK))+
     &                             O49*O58*O63*(YI-YL))
                   DPZM(II)=O78*(-(O49*O58*O67*O69*(ZI-ZK))+
     &                             O49*O58*O63*(ZI-ZL))
                   DPXN(II)=(O49*O50*O58*O63-O42*O49*O58*O67*O69)*O78
                   DPYN(II)=(O49*O52*O58*O63-O44*O49*O58*O67*O69)*O78
                   DPZN(II)=(O49*O54*O58*O63-O46*O49*O58*O67*O69)*O78
C     ------------------------------------------------------------------
C     Calculate the distance between the two atoms M, N (coupled nuclei)
C     and calculate the derivatives as well
C     ------------------------------------------------------------------
                   O1=-XM+XN
                   O2=O1**2
                   O3=-YM+YN
                   O4=O3**2
                   O5=-ZM+ZN
                   O6=O5**2
                   O7=O2+O4+O6
                   O8=SQRT(O7)
                   O9=1/O8
                   O10=O1*O9
                   O11=O3*O9
                   O12=O5*O9
                   DIST=O8
                   DRXM(II)=-O10
                   DRYM(II)=-O11
                   DRZM(II)=-O12
                   DRXN(II)=O10
                   DRYN(II)=O11
                   DRZN(II)=O12
C     ------------------------------------------------------------------
C     Calculate the residual dipolar coupling
C     ------------------------------------------------------------------
                   A=COEF1
                   B=COEF2
                   CALCXRDC=A*(3.*COS(THETA(II))*COS(THETA(II))-1.)+
     &                      B*(3./2.)*(SIN(THETA(II))*SIN(THETA(II))*
     &                      COS(2.*PHI(II)))
               END IF
            END DO
         END DO

         IF (WHICH.EQ.'ANALYZE') THEN
             XRDCCALC(COUNT)=CALCXRDC
         END IF

         DELTA=CALCXRDC-OBSXRDC
C     ------------------------------------------------------------------
C     Adjust the deviation based on the error range
C     ------------------------------------------------------------------
         IF ((DELTA.LT.0.000).AND.(ABS(DELTA).GT.ERRXRDC)) THEN
              DELTAXRDC=DELTA+ERRXRDC
         ELSE IF ((DELTA.GT.0.000).AND.(DELTA.GT.ERRXRDC)) THEN
              DELTAXRDC=DELTA-ERRXRDC
         ELSE
              DELTAXRDC=0.0
         END IF

         DD=DELTAXRDC

         II=0
         PCOUNT=0
         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
C     ------------------------------------------------------------------
C     Taking care of derivative
C     ------------------------------------------------------------------
                   DT=(A*(-6.)*SIN(THETA(II))*
     &                 COS(THETA(II))+B*3.*SIN(THETA(II))*
     &                 COS(THETA(II))*COS(2.*PHI(II)))
                   DP=(B*(-3.)*SIN(THETA(II))*
     &                 SIN(THETA(II))*SIN(2.*PHI(II)))
                   DR=0.0
                   IF (DD.EQ.0.0) THEN
                       E=E+0.0
                       DF1(II)=0.0
                       DF2(II)=0.0
                       DF3(II)=0.0
                   ELSE
                       E=E+K1*(DELTAXRDC**2)
                       DF1(II)=2*K1*DELTAXRDC*DT
                       DF2(II)=2*K1*DELTAXRDC*DP
                       DF3(II)=2*K1*DELTAXRDC*DR
                   END IF
               END IF
            END DO
         END DO
C     ------------------------------------------------------------------
C     Accumulate energy
C     ------------------------------------------------------------------
         EDI=EDI+E
C     ------------------------------------------------------------------
C     Now update forces if in energy/force mode
C     ------------------------------------------------------------------
         IF (WHICH.NE.'ANALYZE') THEN
             II=0
             DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
                DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
                   II=II+1
                   IF (OUTFLAG(II).NE.1) THEN
                       DX(ATOMILST(I))=DX(ATOMILST(I))+
     &                                 DF1(II)*DTXI(II)+DF2(II)*DPXI(II)
                       DY(ATOMILST(I))=DY(ATOMILST(I))+
     &                                 DF1(II)*DTYI(II)+DF2(II)*DPYI(II)
                       DZ(ATOMILST(I))=DZ(ATOMILST(I))+
     &                                 DF1(II)*DTZI(II)+DF2(II)*DPZI(II)
                       DX(ATOMJLST(J))=DX(ATOMJLST(J))+
     &                                 DF1(II)*DTXJ(II)+DF2(II)*DPXJ(II)
                       DY(ATOMJLST(J))=DY(ATOMJLST(J))+
     &                                 DF1(II)*DTYJ(II)+DF2(II)*DPYJ(II)
                       DZ(ATOMJLST(J))=DZ(ATOMJLST(J))+
     &                                 DF1(II)*DTZJ(II)+DF2(II)*DPZJ(II)
                       DX(ATOMKLST(K))=DX(ATOMKLST(K))+
     &                                 DF1(II)*DTXK(II)+DF2(II)*DPXK(II)
                       DY(ATOMKLST(K))=DY(ATOMKLST(K))+
     &                                 DF1(II)*DTYK(II)+DF2(II)*DPYK(II)
                       DZ(ATOMKLST(K))=DZ(ATOMKLST(K))+
     &                                 DF1(II)*DTZK(II)+DF2(II)*DPZK(II)
                       DX(ATOMLLST(L))=DX(ATOMLLST(L))+
     &                                 DF1(II)*DTXL(II)+DF2(II)*DPXL(II)
                       DY(ATOMLLST(L))=DY(ATOMLLST(L))+
     &                                 DF1(II)*DTYL(II)+DF2(II)*DPYL(II)
                       DZ(ATOMLLST(L))=DZ(ATOMLLST(L))+
     &                                 DF1(II)*DTZL(II)+DF2(II)*DPZL(II)
                       DX(ATOMMLST(MM))=DX(ATOMMLST(MM))+
     &                                  DF1(II)*DTXM(II)+DF2(II)*
     &                                  DPXM(II)+DF3(II)*DRXM(II)
                       DY(ATOMMLST(MM))=DY(ATOMMLST(MM))+
     &                                  DF1(II)*DTYM(II)+DF2(II)*
     &                                  DPYM(II)+DF3(II)*DRYM(II)
                       DZ(ATOMMLST(MM))=DZ(ATOMMLST(MM))+
     &                                  DF1(II)*DTZM(II)+DF2(II)*
     &                                  DPZM(II)+DF3(II)*DRZM(II)
                       DX(ATOMNLST(NN))=DX(ATOMNLST(NN))+
     &                                  DF1(II)*DTXN(II)+DF2(II)*
     &                                  DPXN(II)+DF3(II)*DRXN(II)
                       DY(ATOMNLST(NN))=DY(ATOMNLST(NN))+
     &                                  DF1(II)*DTYN(II)+DF2(II)*
     &                                  DPYN(II)+DF3(II)*DRYN(II)
                       DZ(ATOMNLST(NN))=DZ(ATOMNLST(NN))+
     &                                  DF1(II)*DTZN(II)+DF2(II)*
     &                                  DPZN(II)+DF3(II)*DRZN(II)
                   END IF
                END DO
             END DO
         END IF
      END DO

      DIPOE=EDI

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXRDC
C     ------------------------------------------------------------------
C     Reads in residual dipolar coupling information
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "xdipo_rdc.inc"
      INCLUDE  "funct.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "heap.inc"
      INCLUDE  "numbers.inc"

      INTEGER FDSWITCH,FDSAVE,FDERR
      COMMON  /FDPARAM/FDSWITCH,FDSAVE,FDERR
      DOUBLE PRECISION FDEPERC
      INTEGER FDENUMC
      COMMON /FDERRORE/FDEPERC,FDENUMC

      INTEGER COUNT,SPTR,OLDCLASS,OLDMAXXRDC,FNCLASS,FNUMC
      DOUBLE PRECISION K1,K2,CUTOFF,COEF1,COEF2
      DOUBLE PRECISION FMEDPERC,FPERC
      CHARACTER*4 THENAME
      CHARACTER*132 NOMEFILE
      INTEGER TOLSWI

      NOMEFILE='XDIPO_RDC.OUT'

      SPTR=ALLHP(INTEG4(NATOM))
      CALL PUSEND('XDIPO_RDC>')
862   CONTINUE
      CALL NEXTWD('XDIPO_RDC>')
      CALL MISCOM('XDIPO_RDC>',USED)
      IF (.NOT.USED) THEN
C     ------------------------------------------------------------------
C     Documentation
C     ------------------------------------------------------------------
          IF (WD(1:4).EQ.'HELP') THEN
              WRITE(DUNIT,'(10X,A)')
     &              ' XRDC {<RDC-STATEMENT>} END ',
     &              ' <RDC-STATEMENT>:== ',
     &              ' ASSIgn <SEL> <SEL> <SEL> <SEL> <SEL> <SEL>',
     &              ' <REAL> <REAL>',
     &              ' * Restraint: Metal Z X Y Coupled_nucleus',
     &              ' Detected_nucleus RDC Err *',
     &              ' CLASsification <NAME>',
     &              ' * Starts a new class *',
     &              ' TOLL <1|0>',
     &              ' * Switch tolerance in FANTALIN (1=Yes, 0=No)',
     &              ' COEFficient <REAL> <REAL>',
     &              ' * Tensor parameters: A1 A2 *',
     &              ' FORCeconstant <REAL>',
     &              ' * Force constant for the current class *',
     &              ' NREStraints <INTEGER>',
     &              ' * Number of slots for restraints to allocate *',
     &              ' PRINt THREshold <REAL>',
     &              ' * Prints violations larger than the THREshold *',
     &              ' RESEt',
     &              ' * Erases the restraint table, but keeps NRES *',
     &              ' SAVE',
     &              ' * Filename to save RDC values *',
     &              ' FMED',
     &              ' * Calculates average tensor parameters *',
     &              ' ERRON',
     &              ' * Switches Monte Carlo error evaluation ON *',
     &              ' ERROFF',
     &              ' * Switches Monte Carlo error evaluation OFF *',
     &              ' FON',
     &              ' * Switches tensor auto-update mode ON *',
     &              ' FOFF',
     &              ' * Switches tensor auto-update mode OFF *',
     &              ' SON',
     &              ' * Switches saving mode ON *',
     &              ' SOFF',
     &              ' * Switches saving mode OFF *',
     &              ' FRUN',
     &              ' * Runs FANTALIN *'
C     ------------------------------------------------------------------
C     About FANTALIN
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'TOLL') THEN
              CALL NEXTI('Tolerance setting in FANTALIN (1/0) =',TOLSWI)
              IF (TOLSWI.EQ.1) THEN
                  DIPFLG=.TRUE.
                  WRITE (DUNIT,'(A)') 'Tolerance ON in FANTALIN.'
              ELSE IF (TOLSWI.EQ.0) THEN
                  DIPFLG=.FALSE.
                  WRITE (DUNIT,'(A)') 'Tolerance OFF in FANTALIN.'
              ELSE
                  WRITE (DUNIT,'(A)') 'Unknown switch. Using default.'
              END IF
          ELSE IF (WD(1:4).EQ.'SAVE') THEN
              CALL NEXTFI('Filename =',NOMEFILE)
              PRINT*,'Name of the file to save RDC values :',NOMEFILE
          ELSE IF (WD(1:3).EQ.'FME') THEN
              CALL NEXTF('Percentage for average (0/100) =',FMEDPERC)
              CALL NEXTI('Average on class number =',FNCLASS)
              IF (FNCLASS.GT.NCLASSES) THEN
                  PRINT*,'%FRUN-ERR: This class does not exist...'
              ELSE
                  CALL FANTADIPOMEDIA(FNCLASS,FMEDPERC)
              END IF
          ELSE IF (WD(1:5).EQ.'ERRON') THEN
              CALL NEXTI('Number of cycles =',FDENUMC)
              CALL NEXTF('Percentage to discard (0/100) =',FDEPERC)
              FDEPERC=FDEPERC/100.0
              FDERR=1
              PRINT*,'Monte Carlo error evaluation ON'
          ELSE IF (WD(1:6).EQ.'ERROFF') THEN
              FDERR=0
              PRINT*,'Monte Carlo error evaluation OFF'
          ELSE IF (WD(1:3).EQ.'FON') THEN
              FDSWITCH=1
              PRINT*,'Tensor auto-update mode ON'
          ELSE IF (WD(1:4).EQ.'FOFF') THEN
              FDSWITCH=0
              PRINT*,'Tensor auto-update mode OFF'
          ELSE IF (WD(1:3).EQ.'SON') THEN
              FDSAVE=1
              PRINT*,'Saving mode ON'
          ELSE IF (WD(1:4).EQ.'SOFF') THEN
              FDSAVE=0
              PRINT*,'Saving mode OFF'
          ELSE IF (WD(1:4).EQ.'FRUN') THEN
              CALL NEXTI('FANTALIN on class number =',FNCLASS)
              IF (FNCLASS.GT.NCLASSES.OR.FNCLASS.EQ.0) THEN
                  PRINT*,'%FRUN-ERR: This class does not exist...'
             ELSE
                  CALL FANTADIPO(HEAP(XRDCIPTR),HEAP(XRDCJPTR),
     &                          HEAP(XRDCKPTR),HEAP(XRDCLPTR),
     &                          HEAP(XRDCMPTR),HEAP(XRDCNPTR),
     &                          HEAP(XRDCILST),HEAP(XRDCJLST),
     &                          HEAP(XRDCKLST),HEAP(XRDCLLST),
     &                          HEAP(XRDCMLST),HEAP(XRDCNLST),
     &                          HEAP(XRDCOBSPTR),HEAP(XRDCERRPTR),
     &                          FNCLASS,NOMEFILE)
             END IF
C     ------------------------------------------------------------------
C     Get class name. Determine if it's an already-defined class.
C     Insert a new class if it's not.
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'CLAS') THEN
               OLDCLASS=CURCLASS
               CALL NEXTA4('Class name =',THENAME)
               MODE=NEW
               DO COUNT=1,NCLASSES
                  IF (XRDCCLASSNAMES(COUNT).EQ.THENAME) THEN
                      MODE=UPDATE
                      CURCLASS=COUNT
                  END IF
               END DO
               IF (MODE.EQ.NEW) THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more than the maximum number of classes
C     ------------------------------------------------------------------
                   IF (OLDCLASS.EQ.MAXXRDCCLASSES) THEN
                       CALL DSPERR('XDIPO_RDC','Too many classes.')
                       CALL DSPERR('XDIPO_RDC',
     &                      'Increase MAXXRDCCLASSES and recompile.')
                       CALL WRNDIE(-5, 'READXRDC',
     &                      'Too many anisotropy classes.')
                   END IF
                   NCLASSES=NCLASSES+1
                   CURCLASS=NCLASSES
                   XRDCCLASSNAMES(CURCLASS)=THENAME
C     ------------------------------------------------------------------
C     If this isn't the first class, close off the old class
C     ------------------------------------------------------------------
                   IF (NCLASSES.GT.1) THEN
                       XRDCASSNDX(OLDCLASS)=RDCNUM
                   END IF
               END IF
C     ------------------------------------------------------------------
C     Set force constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'FORC') THEN
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              CALL NEXTF('Force constant =',K1)
              WRITE(DUNIT,'(A,A,A,F8.3)')
     &              'Setting force constant for class ', 
     &              XRDCCLASSNAMES(CURCLASS),' to ',K1
                    XRDCFORCES(CURCLASS)=K1
C     ------------------------------------------------------------------
C     Set coefficient constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'COEF') THEN
              CALL NEXTF('Coefficient A1 =',COEF1)
              CALL NEXTF('Coefficient A2 =',COEF2)
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              WRITE(DUNIT,'(A,A,A,F8.3,F8.3)')
     &              'Setting coefficients for class ',
     &              XRDCCLASSNAMES(CURCLASS),' to ',COEF1,COEF2
                    XRDCCOEF1(CURCLASS)=COEF1
                    XRDCCOEF2(CURCLASS)=COEF2
C     ------------------------------------------------------------------
C     Reset residual dipolar couplings database
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'RESE') THEN
              CALL XRDCDEFAULTS
              CALL ALLOCXRDC(0,MAXXRDC)
C     ------------------------------------------------------------------
C     Change number of assignment slots
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'NRES') THEN
              OLDMAXXRDC=MAXXRDC
              CALL NEXTI('Number of slots =',MAXXRDC)
              CALL ALLOCXRDC(OLDMAXXRDC,MAXXRDC)
              WRITE(DUNIT,'(A,I8,A)')
     &             'XDIPO_RDC: Allocating space for',MAXXRDC,
     &             'number of restraints.'
C     ------------------------------------------------------------------
C     Read in an assignment
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'ASSI') THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more assignments than you have slots for
C     ------------------------------------------------------------------
              IF (XRDCMX.EQ.MAXXRDC) THEN
                  CALL DSPERR('XDIPO_RDC','Too many assignments.')
                  CALL DSPERR('XDIPO_RDC',
     &                        'Increasing NREStraints by 100.')
                  OLDMAXXRDC=MAXXRDC
                  MAXXRDC=MAXXRDC+100
                  CALL ALLOCXRDC(OLDMAXXRDC,MAXXRDC)
              END IF
C     ------------------------------------------------------------------
C     If there isn't a class specified, start a default class
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES=1
                  CURCLASS=1
              END IF
              CALL READXRDC2(HEAP(XRDCIPTR),HEAP(XRDCJPTR), 
     &                       HEAP(XRDCKPTR),HEAP(XRDCLPTR),
     &                       HEAP(XRDCMPTR),HEAP(XRDCNPTR),
     &                       HEAP(XRDCILST),HEAP(XRDCJLST),
     &                       HEAP(XRDCKLST),HEAP(XRDCLLST),
     &                       HEAP(XRDCMLST),HEAP(XRDCNLST),
     &                       HEAP(XRDCOBSPTR),HEAP(XRDCERRPTR),
     &                       HEAP(SPTR))
C     ------------------------------------------------------------------
C     Print violations
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'PRIN') THEN
              CALL NEXTWD('PRINT>')
              IF (WD(1:4).NE.'THRE') THEN
                  CALL DSPERR('XDIPO_RDC',
     &                 'PRINt expects THREshold parameter.')
              ELSE
                  CALL NEXTF('THREshold =',CUTOFF)
                  IF (CUTOFF.LT.ZERO) THEN
                      CALL DSPERR('XDIPO_RDC',
     &                     'Cutoff must be positive.')
                      CUTOFF=ABS(CUTOFF)
                  END IF
                  CALL NEXTA4('ALL OR CLASs>',THENAME)
                  IF (THENAME(1:3).EQ.'ALL') THEN
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                      CALL NEXTA4('CLASS NAME =',THENAME)
                      DO COUNT=1,NCLASSES
                         IF (XRDCCLASSNAMES(COUNT).EQ.THENAME) THEN
                             PRINTCLASS(COUNT)=.TRUE.
                         ELSE
                             PRINTCLASS(COUNT)=.FALSE.
                         END IF
                      END DO
                  ELSE
                      DO COUNT=1,NCLASSES
                         PRINTCLASS(COUNT)=.TRUE.
                      END DO
                  END IF
                  CALL PRINTXRDC(CUTOFF,HEAP(CALCXRDCPTR),
     &                           HEAP(XRDCOBSPTR),HEAP(XRDCERRPTR),
     &                           HEAP(XRDCIPTR),HEAP(XRDCJPTR),
     &                           HEAP(XRDCKPTR),HEAP(XRDCLPTR),
     &                           HEAP(XRDCMPTR),HEAP(XRDCNPTR),
     &                           HEAP(XRDCILST),HEAP(XRDCJLST),
     &                           HEAP(XRDCKLST),HEAP(XRDCLLST),
     &                           HEAP(XRDCMLST),HEAP(XRDCNLST))
                END IF
C     ------------------------------------------------------------------
C     Check for END statement
C     ------------------------------------------------------------------
          ELSE
              CALL CHKEND('XDIPO_RDC>',DONE)
          END IF
      END IF
      IF (.NOT.DONE) GOTO 862
      DONE=.FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))
      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE ALLOCXRDC (OLDSIZE,NEWSIZE)
C     ------------------------------------------------------------------
C     Reset residual dipolar coupling arrays to hold size entries

C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------

      IMPLICIT NONE

      INCLUDE  "funct.inc"
      INCLUDE  "xdipo_rdc.inc"

      INTEGER OLDSIZE, NEWSIZE

      IF (OLDSIZE.NE.0) THEN
          CALL FREHP(XRDCIPTR,INTEG4(OLDSIZE))
          CALL FREHP(XRDCJPTR,INTEG4(OLDSIZE))
          CALL FREHP(XRDCKPTR,INTEG4(OLDSIZE))
          CALL FREHP(XRDCLPTR,INTEG4(OLDSIZE))
          CALL FREHP(XRDCMPTR,INTEG4(OLDSIZE))
          CALL FREHP(XRDCNPTR,INTEG4(OLDSIZE))

          CALL FREHP(XRDCILST,INTEG4(OLDSIZE))
          CALL FREHP(XRDCJLST,INTEG4(OLDSIZE))
          CALL FREHP(XRDCKLST,INTEG4(OLDSIZE))
          CALL FREHP(XRDCLLST,INTEG4(OLDSIZE))
          CALL FREHP(XRDCMLST,INTEG4(OLDSIZE))
          CALL FREHP(XRDCNLST,INTEG4(OLDSIZE))

          CALL FREHP(XRDCOBSPTR,IREAL8(OLDSIZE))
          CALL FREHP(XRDCERRPTR,IREAL8(OLDSIZE))
          CALL FREHP(CALCXRDCPTR,IREAL8(OLDSIZE))
      END IF
      XRDCIPTR=ALLHP(INTEG4(NEWSIZE))
      XRDCJPTR=ALLHP(INTEG4(NEWSIZE))
      XRDCKPTR=ALLHP(INTEG4(NEWSIZE))
      XRDCLPTR=ALLHP(INTEG4(NEWSIZE))
      XRDCMPTR=ALLHP(INTEG4(NEWSIZE))
      XRDCNPTR=ALLHP(INTEG4(NEWSIZE))

      XRDCILST=ALLHP(INTEG4(NEWSIZE))
      XRDCJLST=ALLHP(INTEG4(NEWSIZE))
      XRDCKLST=ALLHP(INTEG4(NEWSIZE))
      XRDCLLST=ALLHP(INTEG4(NEWSIZE))
      XRDCMLST=ALLHP(INTEG4(NEWSIZE))
      XRDCNLST=ALLHP(INTEG4(NEWSIZE))

      XRDCOBSPTR=ALLHP(IREAL8(NEWSIZE))
      XRDCERRPTR=ALLHP(IREAL8(NEWSIZE))
      CALCXRDCPTR=ALLHP(IREAL8(NEWSIZE))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XRDCDEFAULTS
C     ------------------------------------------------------------------
C     Sets up defaults
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xdipo_rdc.inc"

      INTEGER COUNT

      MODE=NEW
      MAXXRDC=200
      XRDCMX=200
      RDCNUM=0
      NCLASSES=0
      CURCLASS=0
      DIPFLG=.FALSE.
      DO COUNT=1, MAXXRDCCLASSES
           XRDCCLASSNAMES(COUNT)='DEFAULT'
           XRDCASSNDX(COUNT)=0
           XRDCFORCES(COUNT)=5.0
           XRDCCOEF1(COUNT)=1.0
           XRDCCOEF2(COUNT)=1.0
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXRDC2(ATOMIPTR,ATOMJPTR,ATOMKPTR,ATOMLPTR,ATOMMPTR,
     &                     ATOMNPTR,ATOMILST,ATOMJLST,ATOMKLST,ATOMLLST,
     &                     ATOMMLST,ATOMNLST,XRDCOBS,XRDCERR,SEL)
C     ------------------------------------------------------------------
C     Reads actual residual dipolar coupling assignments into arrays
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "xdipo_rdc.inc"

      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*),SEL(*)
      INTEGER ITMP,JTMP,KTMP,LTMP,II
      DOUBLE PRECISION XRDCOBS(*),XRDCERR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER NSEL,INSERTPOS,COUNT,CURSTOP,OTHERSTOP,NFLAG
      INTEGER I
      DOUBLE PRECISION XRDCO,XRDCE
C     ------------------------------------------------------------------
C     If we're in UPDATE mode, make a space for the new line
C     ------------------------------------------------------------------
      NFLAG=0
      IF (MODE.EQ.UPDATE) THEN
          DO COUNT=RDCNUM+1,XRDCASSNDX(CURCLASS)+1, -1
             ATOMIPTR(COUNT)=ATOMIPTR(COUNT-1)
             ATOMJPTR(COUNT)=ATOMJPTR(COUNT-1)
             ATOMKPTR(COUNT)=ATOMKPTR(COUNT-1)
             ATOMLPTR(COUNT)=ATOMLPTR(COUNT-1)
             ATOMMPTR(COUNT)=ATOMMPTR(COUNT-1)
             ATOMNPTR(COUNT)=ATOMNPTR(COUNT-1)
             XRDCOBS(COUNT)=XRDCOBS(COUNT-1)
             XRDCERR(COUNT)=XRDCERR(COUNT-1)
           END DO
           CURSTOP=XRDCASSNDX(CURCLASS)
           DO COUNT=1,NCLASSES
                OTHERSTOP=XRDCASSNDX(COUNT)
                IF (OTHERSTOP.GT.CURSTOP) THEN
                    XRDCASSNDX(COUNT)=OTHERSTOP+1
                END IF
           END DO
           XRDCASSNDX(CURCLASS)=CURSTOP+1
           INSERTPOS=CURSTOP
           RDCNUM=RDCNUM+1
      ELSE
           RDCNUM=RDCNUM+1
           INSERTPOS=RDCNUM
           XRDCASSNDX(CURCLASS)=INSERTPOS
      END IF
C     ------------------------------------------------------------------
C     Reading in the atom selection in the restraint table
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom I. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
         CALL DSPERR('XDIPO_RDC','Error with atom selection')
         NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMIPTR(INSERTPOS)=0
      II=ATOMIPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMILST(II)=SEL(1)
      ATOMIPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom J. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
         CALL DSPERR('XDIPO_RDC','Error with atom selection')
         NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMJPTR(INSERTPOS)=0
      II=ATOMJPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMJLST(II)=SEL(1)
      ATOMJPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom K. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_RDC','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL, NATOM, NSEL)
      IF (INSERTPOS.EQ.1) ATOMKPTR(INSERTPOS)=0
      II=ATOMKPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMKLST(II)=SEL(1)
      ATOMKPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom L. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_RDC','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMLPTR(INSERTPOS)=0
      II=ATOMLPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMLLST(II)=SEL(1)
      ATOMLPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Next two selections define the vector of the coupled nuclei. Note
C     that the order of atoms picked is important.
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom M. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_RDC','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMMPTR(INSERTPOS)=0
      II=ATOMMPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMMLST(II)=SEL(1)
      ATOMMPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN
          CALL DSPERR('XDIPO_RDC',
     &                'More than 1 atom in SEL for atom N. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XDIPO_RDC','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL)
      IF (INSERTPOS.EQ.1) ATOMNPTR(INSERTPOS)=0
      II=ATOMNPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XRDCMX) XRDCMX=II
      ATOMNLST(II)=SEL(1)
      ATOMNPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Reading in the observed residual dipolar coupling
C     ------------------------------------------------------------------
      CALL NEXTF('Observed RDC =',XRDCO)
      CALL NEXTF('Error in RDC =',XRDCE)

      XRDCOBS(INSERTPOS)=XRDCO
      XRDCERR(INSERTPOS)=XRDCE
C     ------------------------------------------------------------------
C     Check for error atom selection. If there is one then reset the
C     counter for restraint
C     ------------------------------------------------------------------
      IF (NFLAG.EQ.1) THEN
          RDCNUM=RDCNUM-1
      END IF

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XRDCINIT
C     ------------------------------------------------------------------
C     Initializes residual dipolar coupling stuff
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xdipo_rdc.inc"

      CALL XRDCDEFAULTS
      CALL ALLOCXRDC(0,MAXXRDC)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE PRINTXRDC (CUTOFF,XRDCCALC,XRDCOBS,XRDCERR,
     &                      ATOMIPTR,ATOMJPTR,ATOMKPTR,
     &                      ATOMLPTR,ATOMMPTR,ATOMNPTR,
     &                      ATOMILST,ATOMJLST,ATOMKLST,
     &                      ATOMLLST,ATOMMLST,ATOMNLST)
C     ------------------------------------------------------------------
C     Prints residual dipolar couplings with deviation larger than cutoff,
C     calculates RMSD and puts it into $RESULT
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xdipo_rdc.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "numbers.inc"

      DOUBLE PRECISION CUTOFF,XRDCCALC(*),XRDCOBS(*),XRDCERR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*)
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      DOUBLE PRECISION CALCXRDC,OBSXRDC,DELTAXRDC,DELTA,DP
      INTEGER COUNT,CLASS,I,J,K,L,M,N,NUM,II
      DOUBLE PRECISION RMS,VIOLS,ERRXRDC,XRDCENERGY
      DOUBLE COMPLEX DUMMY2
      LOGICAL PRINTTHISCLASS

      RMS=ZERO
      VIOLS=ZERO
      NUM=0
C     ------------------------------------------------------------------
C     Make sure that the array of calculated RDC is up to date
C     ------------------------------------------------------------------
      CALL EXRDC(XRDCENERGY,'ANALYZE')
      WRITE (PUNIT,'(A)') 'The following RDC''s have'
      WRITE (PUNIT,'(A)') 'deviation larger than or'
      WRITE (PUNIT,'(A)') 'equal to the cutoff:'
C     ------------------------------------------------------------------
C     Write out first class heading
C     ------------------------------------------------------------------
      CLASS=1
      PRINTTHISCLASS=PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
          WRITE (PUNIT,'(A,A)') 'Class ',XRDCCLASSNAMES(1)
      END IF
C     ------------------------------------------------------------------
C     For every residual dipolar couplig entryY...
C     ------------------------------------------------------------------
      COUNT=0
      DO WHILE (COUNT.LT.RDCNUM)
         COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Is this the start of a new class?
C     ------------------------------------------------------------------
         IF (XRDCASSNDX(CLASS).LT.COUNT) THEN
             CLASS=CLASS+1
             PRINTTHISCLASS=PRINTCLASS(CLASS)
             IF (XRDCASSNDX(CLASS).EQ.XRDCASSNDX(CLASS-1)) THEN
                 COUNT=COUNT-1
             END IF
             IF (PRINTTHISCLASS) THEN
                 WRITE (PUNIT,'(A,A)') 'Class ',XRDCCLASSNAMES(CLASS)
             END IF
         END IF
C     ------------------------------------------------------------------
C     If this assignment is in a class to be printed
C     and make sure there is an entry for that class
C     ------------------------------------------------------------------
         IF ((PRINTTHISCLASS).AND.
     &       (XRDCASSNDX(CLASS).NE.XRDCASSNDX(CLASS-1))) THEN
C     ------------------------------------------------------------------
C     Always update RMSD
C     ------------------------------------------------------------------
              CALCXRDC=XRDCCALC(COUNT)
              OBSXRDC=XRDCOBS(COUNT)
              ERRXRDC=XRDCERR(COUNT)
              DP=(CALCXRDC-OBSXRDC)

              IF ((DP.LT.0.000).AND.(ABS(DP).GT.ERRXRDC)) THEN
                   DELTAXRDC=DP+ERRXRDC
              ELSE IF ((DP.GT.0.000).AND.(DP.GT.ERRXRDC)) THEN
                   DELTAXRDC=DP-ERRXRDC
              ELSE
                   DELTAXRDC=0.0
              END IF

              RMS=RMS+DELTAXRDC**2
              NUM=NUM+1
C     ------------------------------------------------------------------
C     Print out deviations larger than cutoff
C     and update number of violations
C     ------------------------------------------------------------------
              IF (ABS(DELTAXRDC).GE.CUTOFF) THEN
                  I=ATOMILST(ATOMIPTR(COUNT)+1)
                  J=ATOMJLST(ATOMJPTR(COUNT)+1)
                  K=ATOMKLST(ATOMKPTR(COUNT)+1)
                  L=ATOMLLST(ATOMLPTR(COUNT)+1)
                  WRITE(PUNIT,'(A,A)') '==============================',
     &                                 '=============================='
                  WRITE(PUNIT,'(A)') 'Set-M-atoms'
                  DO II=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
                     M=ATOMMLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(M),RESID(M),
     &                                           RES(M),TYPE(M)
                  END DO
                  WRITE(PUNIT,'(A)') 'Set-N-atoms'
                  DO II=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
                     N=ATOMNLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(N),RESID(N),
     &                                           RES(N),TYPE(N)
                  END DO

                  WRITE(PUNIT,'(2(2X,A,1X,F8.3))')
     &                  'Calc: ',CALCXRDC,'Obs: ',OBSXRDC
                  WRITE(PUNIT,'(2X,A,1X,F8.3,2X,A,1X,F8.3)')
     &                  'Error: ',ERRXRDC,'Delta: ',DELTAXRDC
                  VIOLS=VIOLS+ONE
              END IF
         END IF
      END DO

      IF (NUM.GT.0) THEN
          RMS=SQRT(RMS / NUM)
      ELSE
          RMS=0.0
      ENDIF

      CALL DECLAR('RESULT','DP',' ',DUMMY2,RMS)
      CALL DECLAR('VIOLATIONS','DP',' ',DUMMY2,VIOLS)

      RETURN
      END

      SUBROUTINE RSTRAN
C
C restraints parser.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
C local
      DOUBLE PRECISION TMP
C pointer
      INTEGER IFLAGS
C parsing
      CALL NEXTWD('RESTraints>')
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-restraints')
C
      ELSEIF (WD(1:4).EQ.'PLAN') THEN
      CALL PLNPAR
      ELSE IF (WD(1:4).EQ.'DIHE') THEN
      IFLAGS=ALLHP(INTEG4(NATOM))
      CALL RSTDIH(HEAP(IFLAGS))
      CALL FREHP(IFLAGS,INTEG4(NATOM))
      ELSE IF (WD(1:4).EQ.'HARM') THEN
C
C turn on the harmonic energy term
      QENER(SSHARM)=.TRUE.
C
      CALL PUSEND('HARMonic>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('HARMonic>')
      CALL MISCOM('HARMonic>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-restraints-harmonic')
C
      ELSE IF (WD(1:1).EQ.'?') THEN
      WRITE (6,'(A,I3)')' HARM: exponent=',KCEXPN
      IF(QPLANAR) THEN
      WRITE (6,'(A)')
     &' HARM: planar restraints defined for atoms with neg. harmonic'
      WRITE (6,'(A)')'       energy constant,'
      WRITE (6,'(A,3F8.3)')'       plane defined by the normal vector',
     &                     PNORMAL
      END IF
C====
      ELSE IF (WD(1:4).EQ.'NORM') THEN
      CALL NEXTVF('NORMal-vector=', PNORMAL)
      TMP=SQRT(PNORMAL(1)**2+PNORMAL(2)**2+PNORMAL(3)**2)
      IF (TMP.LE.RSMALL) THEN
      QPLANAR=.FALSE.
      ELSE
      PNORMAL(1)=PNORMAL(1)/TMP
      PNORMAL(2)=PNORMAL(2)/TMP
      PNORMAL(3)=PNORMAL(3)/TMP
      QPLANAR=.TRUE.
      END IF
C====
      ELSE IF (WD(1:4).EQ.'EXPO') THEN
      CALL NEXTI('EXPOnent=',KCEXPN)
C====
      ELSE
      CALL CHKEND('HARMonic>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C===============================================
C==== A. Bonvin Z-position restraining within a slice
C===============================================
      ELSE IF (WD(1:4).EQ.'ZHAR') THEN
C
C turn on the harmonic energy term
      QENER(SSZHAR)=.TRUE.
C
      CALL PUSEND('ZHARmonic>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('ZHARmonic>')
      CALL MISCOM('ZHARmonic>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-restraints-zharmonic')
C
      ELSE IF (WD(1:1).EQ.'?') THEN
      WRITE (6,'(A,I3)')' ZHAR: exponent=',KZCEXP
C====
      ELSE IF (WD(1:4).EQ.'ZMAX') THEN
      CALL NEXTF('ZMAX value=', ZHARMAX)
      ELSE IF (WD(1:4).EQ.'ZMIN') THEN
      CALL NEXTF('ZMIN value=', ZHARMIN)
C====
      ELSE IF (WD(1:4).EQ.'EXPO') THEN
      CALL NEXTI('EXPOnent=',KZCEXP)
C====
      ELSE
      CALL CHKEND('ZHARmonic>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C===============================================
C===============================================
      ELSE
      CALL DSPERR('RSTRAN','Unkown Restraints Option.')
      END IF
C
      CALL EFLAGSYMBOLS
C
      RETURN
      END
C======================================================================
      SUBROUTINE FIX
C
C fixed atom setup parser.
C
C For syntax see main parsing loop "HELP"
C
C Authors: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'funct.inc'
C pointer
      INTEGER IFLAGS
C begin
      IFLAGS=ALLHP(INTEG4(NATOM))
      CALL FIX2(HEAP(IFLAGS))
      CALL FREHP(IFLAGS,INTEG4(NATOM))
      RETURN
      END
C======================================================================
      SUBROUTINE FIX2(IFLAGS)
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'nbonds.inc'
      INCLUDE 'update.inc'
      INCLUDE 'heap.inc'
      INTEGER IFLAGS(*)
C local
      INTEGER ISELCT, I, NFIXED
C parameter
      DOUBLE PRECISION ZERO, RAD, ONE
      PARAMETER (RAD=PI/180.0D0, ZERO=0.0D0, ONE=1.0D0)
C begin
C
C parsing
      CALL PUSEND('FIX>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('FIX>')
      CALL MISCOM('FIX>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
         CALL CNSHELP('cns-fix')
C
      ELSE IF (WD(1:1).EQ.'?') THEN
      NFIXED=0
      DO I=1,NATOM
      IF (IMOVE(I).EQ.1) THEN
      NFIXED=NFIXED+1
      END IF
      END DO
      WRITE (6,'(/A,I5,A)')' FIX : ',NFIXED,' atoms fixed'
C
      ELSE IF (WD(1:4).EQ.'SELE') THEN
      DO I=1,NATOM
      IFLAGS(I)=MAX(0,IMOVE(I))
      END DO
      CALL SELCTA(IFLAGS,ISELCT,X,Y,Z,.TRUE.)
      NFIXED=ISELCT
      IF (ISELCT.GE.0) THEN
      DO I=1,NATOM
      IMOVE(I)=IFLAGS(I)
      END DO
      END IF
C
      ELSE
      CALL CHKEND('FIX>',DONE)
      END IF
C
      END IF
      END DO
      DONE=.FALSE.
C
      RETURN
      END
C====================================================================
      SUBROUTINE RSTDIH(IFLAGS)
C
C setup dihedral angle restraints.
C
C Author: Axel T. Brunger
C modified for cross-validation by Alexandre Bonvin 12/6/95
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'ener.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'mtf.inc'
      INTEGER IFLAGS(*)
C local
      INTEGER NEWASS,ITEMP
C parameter
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
C begin
C
C allocate space if not already allocated
      IF (MCMPHI.EQ.0) THEN
      CALL CDIHP(400)
      END IF
C parsing
      CALL PUSEND('DIHEDRAL>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('DIHEDRAL>')
      CALL MISCOM('DIHEDRAL>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-restraints-dihedral')
C
      ELSE IF (WD(1:4).EQ.'NASS') THEN
      NEWASS=MCMPHI
      CALL NEXTI('NASSign=',NEWASS)
      IF (NEWASS.NE.MCMPHI) THEN
      WRITE(6,'(A,I7,A)')
     & ' RSTDIH: allocating space for ',NEWASS,' assignments.'
      CALL CDIHP(NEWASS)
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'RESE') THEN
      CALL CDIRES
      QENER(SSCDIH)=.FALSE.
C====================================================================
      ELSE IF (WD(1:4).EQ.'SCAL') THEN
      CALL NEXTF('SCALe=',CNSCA)
C====================================================================
      ELSE IF (WD(1:1).EQ.'?') THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &            HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &            HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &            -ONE,HEAP(HPDCV),0,DIHICV)
      IF (DIHICV.GT.0) THEN
      CALL CDIPRI(PUNIT,CNPHI,CNSCA,HEAP(ICIP),HEAP(ICJP),
     &            HEAP(ICKP),HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),
     &            HEAP(ICCPE),HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),
     &            -ONE,HEAP(HPDCV),1,DIHICV)
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'ASSI') THEN
      QENER(SSCDIH)=.TRUE.
      CALL CDIASS(MCMPHI,CNPHI,HEAP(ICIP),HEAP(ICJP),HEAP(ICKP),
     &            HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),HEAP(ICCPE),
     &            HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),HEAP(HPDCV),
     &            IFLAGS,NATOM,X,Y,Z)
C====================================================================
      ELSE IF (WD(1:2).EQ.'CV') THEN
      CALL NEXTI('CV excluded partition number:',DIHICV)
C A. Bonvin
C store working set
      IF (DIHICV.GT.0) THEN
      CALL STWCV(CNPHI,DIHICV,HEAP(ICIP),HEAP(ICJP),HEAP(ICKP),
     &           HEAP(ICLP),HEAP(ICICP),HEAP(ICCPD),HEAP(ICCPE),
     &           HEAP(ICCPB),HEAP(ICCPC),HEAP(ICCPO),HEAP(HPDCV),
     &           CWNPHI,HEAP(IWCIP),HEAP(IWCJP),HEAP(IWCKP),
     &           HEAP(IWCLP),HEAP(IWCCPD),HEAP(IWCCPE),
     &           HEAP(IWCCPB),HEAP(IWCCPC),HEAP(IWCCPO))
      END IF
C====================================================================
      ELSE IF (WD(1:4).EQ.'PART') THEN
      CALL NEXTI('number of PARTitions:',ITEMP)
      ITEMP=MAX(0,ITEMP)
      CALL DIHCVS(CNPHI,HEAP(HPDCV),ITEMP)
      IF (ITEMP.EQ.0) THEN
      DIHICV=0
      END IF
C====================================================================
      ELSE
      CALL CHKEND('DIHEDRAL>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      CALL EFLAGSYMBOLS
C
      RETURN
      END
C===================================================================
      SUBROUTINE CDIINI
C
C Routine initializes the CONStraints DIHEdral list
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
C begin
C initialize heap pointers of dynamic data structure
      ICIP=0
      ICJP=0
      ICKP=0
      ICLP=0
      ICICP=0
      ICCPD=0
      ICCPE=0
      ICCPB=0
      ICCPC=0
      ICCPO=0
      IWCIP=0
      IWCJP=0
      IWCKP=0
      IWCLP=0
      IWCCPD=0
      IWCCPE=0
      IWCCPB=0
      IWCCPC=0
      IWCCPO=0
      HPDCV=0
      CALL CDIRES
      RETURN
      END
C====================================================================
      SUBROUTINE CDIRES
C
C Routine resets the CONStraints DIHEdral list
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
C parameter
      DOUBLE PRECISION ONE
      PARAMETER (ONE=1.0D0)
C begin
      CNPHI=0
      CWNPHI=0
      CNSCA=ONE
      DIHICV=0
      RETURN
      END
C====================================================================
      SUBROUTINE CDIHP(NEW)
C
C Routine allocates space for CONStraints DIHEdral list
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INTEGER NEW
C begin
      IF (ICIP.NE.0) CALL FREHP(ICIP,INTEG4(MCMPHI))
      IF (ICJP.NE.0) CALL FREHP(ICJP,INTEG4(MCMPHI))
      IF (ICKP.NE.0) CALL FREHP(ICKP,INTEG4(MCMPHI))
      IF (ICLP.NE.0) CALL FREHP(ICLP,INTEG4(MCMPHI))
      IF (ICICP.NE.0) CALL FREHP(ICICP,INTEG4(LCICP))
      IF (ICCPD.NE.0) CALL FREHP(ICCPD,INTEG4(MCMPHI))
      IF (ICCPE.NE.0) CALL FREHP(ICCPE,INTEG4(MCMPHI))
      IF (ICCPB.NE.0) CALL FREHP(ICCPB,IREAL8(MCMPHI))
      IF (ICCPC.NE.0) CALL FREHP(ICCPC,IREAL8(MCMPHI))
      IF (ICCPO.NE.0) CALL FREHP(ICCPO,IREAL8(MCMPHI))
      IF (HPDCV.NE.0) CALL FREHP(HPDCV,INTEG4(MCMPHI))
C
      IF (IWCIP.NE.0) CALL FREHP(IWCIP,INTEG4(MCMPHI))
      IF (IWCJP.NE.0) CALL FREHP(IWCJP,INTEG4(MCMPHI))
      IF (IWCKP.NE.0) CALL FREHP(IWCKP,INTEG4(MCMPHI))
      IF (IWCLP.NE.0) CALL FREHP(IWCLP,INTEG4(MCMPHI))
      IF (IWCCPD.NE.0) CALL FREHP(IWCCPD,INTEG4(MCMPHI))
      IF (IWCCPE.NE.0) CALL FREHP(IWCCPE,INTEG4(MCMPHI))
      IF (IWCCPB.NE.0) CALL FREHP(IWCCPB,IREAL8(MCMPHI))
      IF (IWCCPC.NE.0) CALL FREHP(IWCCPC,IREAL8(MCMPHI))
      IF (IWCCPO.NE.0) CALL FREHP(IWCCPO,IREAL8(MCMPHI))
C
      MCMPHI=0
      CNPHI=0
      CWNPHI=0
      ICIP=0
      ICJP=0
      ICKP=0
      ICLP=0
      ICICP=0
      ICCPD=0
      ICCPE=0
      ICCPB=0
      ICCPC=0
      ICCPO=0
      LCICP=0
      IWCIP=0
      IWCJP=0
      IWCKP=0
      IWCLP=0
      IWCCPD=0
      IWCCPE=0
      IWCCPB=0
      IWCCPC=0
      IWCCPO=0
      HPDCV=0
C
C allocate new space
      IF (NEW.GT.0) THEN
      MCMPHI=NEW
      ICIP=ALLHP(INTEG4(MCMPHI))
      ICJP=ALLHP(INTEG4(MCMPHI))
      ICKP=ALLHP(INTEG4(MCMPHI))
      ICLP=ALLHP(INTEG4(MCMPHI))
      LCICP=NATOM
      ICICP=ALLHP(INTEG4(LCICP))
      ICCPD=ALLHP(INTEG4(MCMPHI))
      ICCPE=ALLHP(INTEG4(MCMPHI))
      ICCPB=ALLHP(IREAL8(MCMPHI))
      ICCPC=ALLHP(IREAL8(MCMPHI))
      ICCPO=ALLHP(IREAL8(MCMPHI))
C
      IWCIP=ALLHP(INTEG4(MCMPHI))
      IWCJP=ALLHP(INTEG4(MCMPHI))
      IWCKP=ALLHP(INTEG4(MCMPHI))
      IWCLP=ALLHP(INTEG4(MCMPHI))
      IWCCPD=ALLHP(INTEG4(MCMPHI))
      IWCCPE=ALLHP(INTEG4(MCMPHI))
      IWCCPB=ALLHP(IREAL8(MCMPHI))
      IWCCPC=ALLHP(IREAL8(MCMPHI))
      IWCCPO=ALLHP(IREAL8(MCMPHI))
      HPDCV=ALLHP(INTEG4(MCMPHI))
      END IF
      RETURN
      END
C====================================================================
      SUBROUTINE CDIPRI(PUNIT,CNPHI,CNSCA,CIP,CJP,CKP,CLP,
     &                  CICP,CCPD,CCPE,CCPB,CCPC,CCPO,THRESH,
     &                  DIHCV,ITEST,DIHICV)
C
C Routine prints the CONStraints DIHEdral list
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
      INTEGER PUNIT, CNPHI, ITEST, DIHICV
      DOUBLE PRECISION CNSCA
      INTEGER CIP(*), CJP(*), CKP(*), CLP(*), CICP(*), CCPD(*)
      INTEGER CCPE(*), DIHCV(*)
      DOUBLE PRECISION CCPB(*), CCPC(*), CCPO(*), THRESH
C local
      INTEGER I, NRMS, NVIOL
      DOUBLE PRECISION EDUMMY, RMS
      DOUBLE COMPLEX DBCOMP
      DOUBLE PRECISION DBPREC
C parameter
      DOUBLE PRECISION ZERO, ONE, RAD
      PARAMETER (ZERO=0.0D0, ONE=1.0D0, RAD=PI/180.0D0)
C begin
      RMS=ZERO
      NRMS=0
      NVIOL=0
C
      WRITE(6,'(A,I6)') ' Total number of dihedral angle restraints=',
     &        CNPHI
      WRITE(6,'(A,F10.4)') '  overall scale =',CNSCA
      IF (DIHICV.GT.0) THEN
      IF (ITEST.EQ.0) THEN
      WRITE(6,'(A)')
     & ' $$$$$$$$$$$$$$$$$$ working set $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
      ELSE
      WRITE(6,'(A,I5,A)')
     & ' $$$$$$$$$$$$$$$$$$$$ test set (TEST=',DIHICV,
     & ')  $$$$$$$$$$$$$$$$$$$$$$'
      END IF
      END IF
      DO I=1,CNPHI
      IF ((ITEST.EQ.0.AND.DIHCV(I).NE.DIHICV).OR.
     &    (ITEST.EQ.1.AND.DIHCV(I).EQ.DIHICV)) THEN
      CALL ETOR(EDUMMY,EDUMMY,CIP(I),CJP(I),CKP(I),CLP(I),1,1,
     &     CCPC(I),
     &     CCPD(I),CCPB(I),'GENERAL',CCPO(I),CCPE(I),'ANAL',
     &     CNSCA,ONE)
      IF (ABS(PCDATA(PCDEVI)).GE.THRESH) THEN
      WRITE(PUNIT,'(A)') ' ========================================'
      WRITE(PUNIT,'(4(1X,A))')
     &  SEGID(CIP(I)),RESID(CIP(I)),RES(CIP(I)),TYPE(CIP(I))
      WRITE(PUNIT,'(4(1X,A))')
     &  SEGID(CJP(I)),RESID(CJP(I)),RES(CJP(I)),TYPE(CJP(I))
      WRITE(PUNIT,'(4(1X,A))')
     &  SEGID(CKP(I)),RESID(CKP(I)),RES(CKP(I)),TYPE(CKP(I))
      WRITE(PUNIT,'(4(1X,A))')
     &  SEGID(CLP(I)),RESID(CLP(I)),RES(CLP(I)),TYPE(CLP(I))
      WRITE(PUNIT,'(5(A,F9.3))')
     &  ' Dihedral=',PCDATA(PCGEOM),'  Energy=',PCDATA(PCENER),
     &  ' C=',PCDATA(PCCONS),' Equil=',PCDATA(PCEQUI), ' Delta=',
     &  PCDATA(PCDEVI)
      WRITE(PUNIT,'(A,F8.3,A,I3)')
     $  ' Range=',CCPO(I)/RAD,' Exponent=',CCPE(I)
      NVIOL=NVIOL+1
      END IF
      NRMS=NRMS+1
      RMS=RMS+PCDATA(PCDEVI)**2
      END IF
      END DO
C
      WRITE(6,'(A,I5)')
     &     ' Number of dihedral angle restraints=', NRMS
      IF (THRESH.GT.ZERO) THEN
      WRITE(6,'(A,F8.3,A,I5)')
     &     ' Number of violations greater than ', THRESH, ': ', NVIOL
      END IF
      DBPREC=NVIOL
      IF (ITEST.EQ.0) THEN
      CALL DECLAR( 'VIOLATIONS', 'DP', ' ', DBCOMP, DBPREC )
      DBPREC=NRMS
      CALL DECLAR( 'NUMBER', 'DP', ' ', DBCOMP, DBPREC )
      ELSE
      CALL DECLAR( 'TEST_VIOLATIONS', 'DP', ' ', DBCOMP, DBPREC )
      ENDIF
      IF (NRMS.GT.0) THEN
      DBPREC=RMS/NRMS
      DBPREC=SQRT(DBPREC)
      ELSE
      DBPREC = ZERO
      END IF
      IF (ITEST.EQ.0) THEN
      CALL DECLAR( 'RMS', 'DP', ' ', DBCOMP, DBPREC )
      CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
      ELSE
      CALL DECLAR( 'TEST_RMS', 'DP', ' ', DBCOMP, DBPREC )
      END IF
      WRITE(6,'(A,F8.3)') ' RMS deviation=',DBPREC
C
      RETURN
      END
C====================================================================
      SUBROUTINE CDIASS(MCMPHI,CNPHI,CIP,CJP,CKP,CLP,
     &                  CICP,CCPD,CCPE,CCPB,CCPC,CCPO,DIHCV,
     &                  IFLAGS,NATOM,X,Y,Z)
C
C Routine assigns a new dihedral angle restraint.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'consta.inc'
      INTEGER MCMPHI, CNPHI
      INTEGER CIP(*), CJP(*), CKP(*), CLP(*), CICP(*), CCPD(*)
      INTEGER CCPE(*)
      DOUBLE PRECISION CCPB(*), CCPC(*), CCPO(*)
      INTEGER DIHCV(*),IFLAGS(*), NATOM
      DOUBLE PRECISION X(*), Y(*), Z(*)
C local
      LOGICAL ERR
      INTEGER I, ISELCT, CDIHE(4)
C parameter
      DOUBLE PRECISION RAD
      PARAMETER (RAD=PI/180.0D0)
C begin
      IF (CNPHI.GE.MCMPHI) THEN
      WRITE(6,'(A)')
     & ' %CSTRAN-ERR: allocation for assignments exceeded',
     & '              increase NASSignment and run again.'
      CALL WRNDIE(-1,'CSTRAN',
     & 'exceeded allocation for assigments')
      ELSE
      CNPHI=CNPHI+1
      END IF
      ERR=.FALSE.
      DO I=1,4
      CALL SELCTA(IFLAGS,ISELCT,X,Y,Z,.TRUE.)
      IF (ISELCT.NE.1) THEN
      WRITE(6,'(A)')
     & ' %CSTRAN-ERR: selection has to contain exactly one atom.'
      ERR=.TRUE.
      END IF
      CALL MAKIND(IFLAGS,NATOM,ISELCT)
      CDIHE(I)=IFLAGS(1)
      END DO
      CIP(CNPHI)=CDIHE(1)
      CJP(CNPHI)=CDIHE(2)
      CKP(CNPHI)=CDIHE(3)
      CLP(CNPHI)=CDIHE(4)
      CALL NEXTF('force-constant=',CCPC(CNPHI))
      CALL NEXTF('minimum-angle=',CCPB(CNPHI))
      CALL NEXTF('range-angle=',CCPO(CNPHI))
      CALL NEXTI('exponent=',CCPE(CNPHI))
      CCPB(CNPHI)=CCPB(CNPHI)*RAD
      CCPO(CNPHI)=ABS(CCPO(CNPHI)*RAD)
      CCPD(CNPHI)=0
C include the dihedral in the working set
      DIHCV(CNPHI)=-1
      DO I=1,NATOM
      CICP(I)=0
      END DO
      IF (ERR) CNPHI=CNPHI-1
      RETURN
      END
C===================================================================
      SUBROUTINE ECNSTR(EC,REFX,REFY,REFZ,KCNSTR,NATOM,KCEXPN,
     &                  QPLANAR,PNORMAL)
C
C Routine computes harmonic atomic restraints
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'consta.inc'
      DOUBLE PRECISION EC, PNORMAL(*)
      DOUBLE PRECISION REFX(*), REFY(*), REFZ(*), KCNSTR(*)
      INTEGER NATOM
      INTEGER KCEXPN
      LOGICAL QPLANAR
C local
      INTEGER I
      DOUBLE PRECISION  CEXPN, E1, C, AX, AY, AZ, S, DF
      DOUBLE PRECISION  R
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
      CEXPN=KCEXPN
      EC=ZERO
      DO I=1,NATOM
      C=KCNSTR(I)
      IF (C.GT.ZERO .OR. (C.LT.ZERO .AND. .NOT.QPLANAR)) THEN
      AX=X(I)-REFX(I)
      AY=Y(I)-REFY(I)
      AZ=Z(I)-REFZ(I)
      S=AX*AX+AY*AY+AZ*AZ
      IF (S.GT.RSMALL) THEN
      R=SQRT(S)
      E1=C*R**KCEXPN
      DF=CEXPN*E1/S
      EC=EC+E1
      DX(I)=DX(I)+AX*DF
      DY(I)=DY(I)+AY*DF
      DZ(I)=DZ(I)+AZ*DF
      END IF
      ELSE IF (C.LT.ZERO .AND. QPLANAR) THEN
      AX=PNORMAL(1)*(X(I)-REFX(I))
      AY=PNORMAL(2)*(Y(I)-REFY(I))
      AZ=PNORMAL(3)*(Z(I)-REFZ(I))
      R=AX+AY+AZ
      S=R*R
      IF (S.GT.RSMALL) THEN
      E1=ABS(C)*R**KCEXPN
      DF=CEXPN*E1/S
      EC=EC+E1
      DX(I)=DX(I)+R*PNORMAL(1)*DF
      DY(I)=DY(I)+R*PNORMAL(2)*DF
      DZ(I)=DZ(I)+R*PNORMAL(3)*DF
      END IF
      END IF
      END DO
      RETURN
      END
C===================================================================
      SUBROUTINE EZHARM(EC,KZCNSTR,NATOM,KZCEXP,
     &                  ZHARMAX,ZHARMIN)
C
C Routine computes harmonic z atomic restraints
C
C Author: Alexandre M.J.J. Bonvin
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'consta.inc'
      DOUBLE PRECISION EC 
      DOUBLE PRECISION KZCNSTR(*), ZHARMAX, ZHARMIN, ZHARMID
      INTEGER NATOM,NZ
      INTEGER KZCEXP
C local
      INTEGER I
      DOUBLE PRECISION  CEXPN, E1, C, AX, AY, AZ, ZZ, S, DF
      DOUBLE PRECISION  R,AVZ,AVZMIN,AVZMAX,ZLIM
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
      CEXPN=KZCEXP
      EC=ZERO
      NZ=0
      AVZ=ZERO
      ZHARMID=(ZHARMAX-ZHARMIN)/2.0
      
      DO I=1,NATOM
      C=KZCNSTR(I)
      IF (C.GT.ZERO) THEN
      ZZ=Z(I)
      IF (ZZ.GT.ZHARMAX) THEN
      AZ=ZZ-ZHARMAX
      ELSE IF (ZZ.LT.ZHARMIN) THEN
      AZ=ZZ-ZHARMIN
      ELSE
      AZ=0
      ENDIF
      S=AZ*AZ
      IF (S.GT.RSMALL) THEN
      R=SQRT(S)
      E1=C*R**KZCEXP
      DF=CEXPN*E1/S
      EC=EC+E1
      DX(I)=ZERO
      DY(I)=ZERO
      DZ(I)=DZ(I)+AZ*DF
      END IF
      ELSE IF (C.LT.ZERO) THEN
      AVZ=AVZ+ZZ
      NZ=NZ+1
      END IF
      END DO
      IF (NZ.GT.0) THEN
      AVZ=AVZ/NZ
      IF (AVZ.GT.ZHARMID) THEN
      ZLIM=ZHARMAX
      ELSE IF (AVZ.LT.ZHARMID) THEN
      ZLIM=ZHARMIN
      ENDIF
C
      DO I=1,NATOM
      C=KZCNSTR(I)
      IF (C.LT.ZERO) THEN
      AZ=0
      ZZ=Z(I)
      IF (ZZ.LT.ZHARMAX) THEN
      IF (ZZ.GT.ZHARMIN) THEN
      AZ=ZZ-ZLIM
      END IF
      END IF
      S=AZ*AZ
      IF (S.GT.RSMALL) THEN
      R=SQRT(S)
      E1=-C*R**KZCEXP
      DF=CEXPN*E1/S
      EC=EC+E1
      DX(I)=ZERO
      DY(I)=ZERO
      DZ(I)=DZ(I)+AZ*DF
      END IF
      END IF      
      END DO
      END IF

      RETURN
      END
C======================================================================
      SUBROUTINE CSTRES
C
C initialize some restraint variables
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'cnst.inc'
C parameter
      DOUBLE PRECISION ZERO, ONE
      PARAMETER (ZERO=0.0D0, ONE=1.0D0)
C begin
C
C harmonic constraint
      KCEXPN=2
      KZCEXP=2
      QPLANAR=.FALSE.
      RETURN
      END
C
C====================================================================
      SUBROUTINE DIHCVS(DIHNUM,DIHCV,PART)
C
C Routine partitions DIHEDRAL data into PART sets.
C DIHCV will contain integer numbers between 1 and PART.
C
C Author: Axel T. Brunger
C Modifed for dihedrals: Alexandre Bonvin 12/6/95
C
C
C     IMPLICIT NONE
C I/O
      INTEGER DIHNUM, DIHCV(*)
      INTEGER PART
C local
      INTEGER I, P, NP, NTRYTOT, NRETRY
      DOUBLE PRECISION RNUM
      NTRYTOT = 0
C begin
  100 CONTINUE
      NRETRY = 0
      IF (PART.GT.0) THEN
      DO I=1,DIHNUM
      CALL GGUBFS(RNUM)
      DIHCV(I)=MAX(1,MIN(PART,INT(RNUM*PART)+1))
      END DO
C
      IF (PART .EQ. DIHNUM) THEN
      DO I=1,DIHNUM
      DIHCV(I)=I
      END DO
      END IF
C
      DO P=1,PART
      NP=0
      DO I=1,DIHNUM
      IF (DIHCV(I).EQ.P) THEN
      NP=NP+1
      END IF
      END DO
      IF (NP .EQ. 0) THEN
        NRETRY = 1
      ENDIF
      WRITE(6,'(A,I3,A,I5,A)') ' For set ',P,
     & ' there are ',NP,' dihedral angle restraints.'
      END DO
      ELSE
      WRITE(6,'(A)')
     & ' Data are not partitioned or partitioning removed.'
      DO I=1,DIHNUM
      DIHCV(I)=-1
      END DO
      END IF
      NTRYTOT = NTRYTOT + NRETRY
      IF (NRETRY.GT.0.AND.NTRYTOT.LE.10) THEN
      WRITE(6,'(A)')
     & ' Test set with 0 constraints! New trial...'
      GOTO 100
      ELSE IF (NTRYTOT .GT. 10) THEN
      CALL WRNDIE(-1,'DIHCVS',
     & 'Unable to partition the dihedral data within ten trials')
      ENDIF
C
      RETURN
      END
C
C====================================================================
      SUBROUTINE STWCV(CNPHI,IPART,CIP,CJP,CKP,
     &           CLP,CICP,CCPD,CCPE,CCPB,CCPC,CCPO,DIHCV,
     &           CWNPHI,WCIP,WCJP,WCKP,
     &           WCLP,WCCPD,WCCPE,WCCPB,WCCPC,WCCPO)
C
C store dihedral angle restraints correponding to the current working
C set for cross-validation
C Author: Alexandre Bonvin
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'pick.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
      INTEGER CNPHI, CWNPHI, IPART
      INTEGER CIP(*), CJP(*), CKP(*), CLP(*), CICP(*), CCPD(*)
      INTEGER CCPE(*), DIHCV(*)
      INTEGER WCIP(*), WCJP(*), WCKP(*), WCLP(*), WCCPD(*)
      INTEGER WCCPE(*)
      DOUBLE PRECISION CCPB(*), CCPC(*), CCPO(*)
      DOUBLE PRECISION WCCPB(*), WCCPC(*), WCCPO(*)
C local
      INTEGER I
C
      CWNPHI=0
      DO I=1,CNPHI
      IF (DIHCV(I).NE.IPART) THEN
      CWNPHI=CWNPHI+1
      WCIP(CWNPHI)=CIP(I)
      WCJP(CWNPHI)=CJP(I)
      WCKP(CWNPHI)=CKP(I)
      WCLP(CWNPHI)=CLP(I)
      WCCPD(CWNPHI)=CCPD(I)
      WCCPE(CWNPHI)=CCPE(I)
      WCCPB(CWNPHI)=CCPB(I)
      WCCPC(CWNPHI)=CCPC(I)
      WCCPO(CWNPHI)=CCPO(I)
      END IF
      END DO
      WRITE(6,'(A,I3,A,I5,A)') ' Working set ',IPART,
     & ' containing ',CWNPHI,' dihedral angle restraints.'
C
      RETURN
      END

      SUBROUTINE SEGMNT
C
C Segment generation and residue sequence interpreter
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'cstack.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
C local
C parameter
C SEGDIM is the maximum number of atoms involved during a
C single patching process, NADD is the maximum number
C of added atoms during a single patching process.
C MAX is the maximum number of link statements in all link files combined. 
      INTEGER SEGDIM, NADD, MAX
      PARAMETER (SEGDIM=100, NADD=50, MAX=6000)
C pointer
      INTEGER SET, ISET
      INTEGER LINK, LINKH, LINKT, FIRST
      INTEGER FIRSTT, LAST, LASTH
      INTEGER SLINKH, SLINKT, SFIRST, SLASTH
C begin
      LINK=CALLST(ICHAR4(MAX))
      LINKH=CALLST(ICHAR4(MAX))
      LINKT=CALLST(ICHAR4(MAX))
      FIRST=CALLST(ICHAR4(MAX))
      FIRSTT=CALLST(ICHAR4(MAX))
      LAST=CALLST(ICHAR4(MAX))
      LASTH=CALLST(ICHAR4(MAX))
      SLINKH=CALLST(ICHAR4(MAX))
      SLINKT=CALLST(ICHAR4(MAX))
      SFIRST=CALLST(ICHAR4(MAX))
      SLASTH=CALLST(ICHAR4(MAX))
      SET=CALLST(ICHAR4(SEGDIM+NADD))
      ISET=ALLHP(INTEG4(SEGDIM+NADD))
      CALL SEGMN2(NADD,SEGDIM,CSTACK(SET),HEAP(ISET),MAX,
     &           CSTACK(LINK),CSTACK(LINKH),CSTACK(LINKT),
     &           CSTACK(FIRST),CSTACK(FIRSTT),CSTACK(LAST),
     &           CSTACK(LASTH),CSTACK(SLINKH),
     &           CSTACK(SLINKT),CSTACK(SFIRST),CSTACK(SLASTH))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(MAX))
      CALL CFREST(ICHAR4(SEGDIM+NADD))
      CALL FREHP(ISET,INTEG4(SEGDIM+NADD))
C
      RETURN
      END
C
      SUBROUTINE SEGMN2(NADD,DIM,SET,ISET,MAX,
     &                  LINK, LINKH, LINKT, FIRST,
     &                  FIRSTT, LAST, LASTH, 
     &                  SLINKH, SLINKT, SFIRST, SLASTH)
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'ctitla.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'timer.inc'
      INTEGER NADD, DIM
      CHARACTER*4 SET(*)
      INTEGER ISET(*)
      INTEGER MAX
      CHARACTER*4 LINK(MAX), LINKH(MAX), LINKT(MAX), FIRST(MAX)
      CHARACTER*4 FIRSTT(MAX), LAST(MAX), LASTH(MAX)
      CHARACTER*4 SLINKH(MAX), SLINKT(MAX), SFIRST(MAX), SLASTH(MAX)
C local
      INTEGER NUMBER, NRES, NRSOLD
      INTEGER I, J, DUMMY, NSET
      INTEGER ILINK, IFIRST, ILAST
      LOGICAL FOUND, QFIRST, ECHOLD, SIDCHK, QSEP, QCHAIN, QLINK
      CHARACTER*4 RID, SID, REN, RENOLD, RIDOLD, PATNAM
      CHARACTER*4 SIDX, SIDOLD, RIDX, RENX, IUPX
      CHARACTER*5 A
      CHARACTER*1 CHAIN
      DOUBLE PRECISION XIN, YIN, ZIN, WIN
      INTEGER NATOM1, IJ
      LOGICAL QRESTART
      CHARACTER*100 ERRMSG
      INTEGER ERRMSG_LEN, CURRSTRM
C begin
C
C defaults
      SID='    '
      NRES=0
      SIDCHK=.FALSE.
C
C parsing
      CALL PUSEND('SEGMENT>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('SEGMENT>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-segment')
C
      ELSE IF (WD(1:4).EQ.'NAME') THEN
      CALL NEXTA4('SEGMent-name=',SID)
      SIDCHK=.TRUE.
      ELSE IF (WD(1:4).EQ.'MOLE') THEN
      REN='    '
      NUMBER=1
      CALL PUSEND('MOLECULE>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('MOLECULE>')
      IF (WD(1:4).EQ.'NAME') THEN
      CALL NEXTA4('MOLEcule=',REN)
      ELSE IF (WD(1:4).EQ.'NUMB') THEN
      CALL NEXTI('NUMBer=',NUMBER)
      ELSE
      CALL CHKEND('MOLECULE>',DONE)
      END IF
      END DO
      DONE=.FALSE.
      DO I=1,NUMBER
      NRES=NRES+1
C
C convert residue number into hybrid_36 format ATB 2/15/10
      WDT=' '
      CALL HY36ENCODE(4,NRES,WDT,ERRMSG,ERRMSG_LEN)
      IF (ERRMSG_LEN.NE.0) THEN
      WRITE(6,'(A)') ' SEGMNT-err: specified',
     & ' number of molecules exceeds RESId field'
      WRITE(6,'(A,A)') ' SEGMNT-err', ERRMSG(1:ERRMSG_LEN) 
      CALL WRNDIE(-5,'SEGMNT','Too many molecules specified.')
      END IF
      WDTLEN=4
      CALL TRIML(WDT,WDTLEN)
CC
CCCC      CALL ENCODI(NRES,WDT,WDTMAX,WDTLEN)
      CALL COPYST(RID,4,DUMMY,WDT,WDTLEN)
C
C now check whether residue is new at all
      FOUND=.FALSE.
      J=0
      DO WHILE (J.LT.NATOM.AND..NOT.FOUND)
      J=J+1
      FOUND=(SID.EQ.SEGID(J).AND.RID.EQ.RESID(J).AND.REN.EQ.RES(J))
      END DO
      IF (FOUND) THEN
      WRITE(6,'(7A)') ' %SEGMNT-ERR: attempt to enter duplicate ',
     1'residue ',SID,' ',RID,' ',REN
      ELSE
      CALL GENRES(REN,RID,SID)
      END IF
      END DO
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(A,I5,6A)')
     & ' SEGMNT: ',NUMBER,' ',REN,' molecules have ',
     & 'been added to segment "',SID,'"'
      END IF
C
      ELSE IF (WD(1:4).EQ.'CHAI') THEN
C
C defaults
      ILINK=0
      IFIRST=0
      ILAST=0
      QSEP=.FALSE.
      QCHAIN=.FALSE.
      QLINK=.TRUE.
C
C parsing
      CALL PUSEND('CHAIN>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('CHAIN>')
      CALL MISCOM('CHAIN>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'LINK') THEN
      IF (ILINK.GE.MAX) THEN
      WRITE(6,'(A)') ' %SEGMENT-ERR: max. number of LINK exceeded'
      ELSE
      ILINK=ILINK+1
      END IF
      CALL NEXTA4('LINK-patch=',LINK(ILINK))
      LINKH(ILINK)='*   '
      LINKT(ILINK)='*   '
      SLINKH(ILINK)='-   '
      SLINKT(ILINK)='+   '
      CALL PUSEND('LINK>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('LINK>')
      IF (WD(1:4).EQ.'HEAD') THEN
      CALL NEXTA4('HEAD-reference=',SLINKH(ILINK))
      CALL NEXTA4('HEAD-residues=',LINKH(ILINK))
      ELSE IF (WD(1:4).EQ.'TAIL') THEN
      CALL NEXTA4('TAIL-reference=',SLINKT(ILINK))
      CALL NEXTA4('TAIL-residues=',LINKT(ILINK))
      ELSE
      CALL CHKEND('LINK>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE IF (WD(1:4).EQ.'FIRS') THEN
      IF (IFIRST.GE.MAX) THEN
      WRITE(6,'(A)') ' %SEGMENT-ERR: max. number of FIRST exceeded'
      ELSE
      IFIRST=IFIRST+1
      END IF
      CALL NEXTA4('FIRSt-patch=',FIRST(IFIRST))
      SFIRST(IFIRST)='+   '
      FIRSTT(IFIRST)='*   '
      CALL PUSEND('FIRST>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('FIRST>')
      IF (WD(1:4).EQ.'TAIL') THEN
      CALL NEXTA4('TAIL-reference=',SFIRST(IFIRST))
      CALL NEXTA4('TAIL-residues=',FIRSTT(IFIRST))
      ELSE
      CALL CHKEND('FIRST>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE IF (WD(1:4).EQ.'LAST') THEN
      IF (ILAST.GE.MAX) THEN
      WRITE(6,'(A)') ' %SEGMENT-ERR: max. number of LAST exceeded'
      ELSE
      ILAST=ILAST+1
      END IF
      CALL NEXTA4('LAST-patch=',LAST(ILAST))
      LASTH(ILAST)='*   '
      SLASTH(ILAST)='-   '
      CALL PUSEND('LAST>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('LAST>')
      IF (WD(1:4).EQ.'HEAD') THEN
      CALL NEXTA4('HEAD-reference=',SLASTH(ILAST))
      CALL NEXTA4('HEAD-residues=',LASTH(ILAST))
      ELSE
      CALL CHKEND('LAST>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE IF (WD(1:4).EQ.'SEQU') THEN
      QFIRST=.TRUE.
      NRSOLD=NRES
      CALL PUSEND('SEQUENCE>')
      CALL NEXTWD('SEQUENCE>')
      IF (WD(1:3).EQ.'END') CALL CHKEND('SEQUENCE>',DONE)
      DO WHILE (.NOT.DONE)
      CALL COPYST(REN,4,DUMMY,WD,WDLEN)
      NRES=NRES+1
C
C convert residue number into hybrid_36 format ATB 2/15/10
      WDT=' '
      CALL HY36ENCODE(4,NRES,WDT,ERRMSG,ERRMSG_LEN)
      IF (ERRMSG_LEN.NE.0) THEN
      WRITE(6,'(A)') ' SEGMNT-err: specified',
     & ' number of residues exceeds RESId field'
      WRITE(6,'(A,A)') ' SEGMNT-err', ERRMSG(1:ERRMSG_LEN) 
      CALL WRNDIE(-5,'SEGMNT','Too many residues specified.')
      END IF
      WDTLEN=4
      CALL TRIML(WDT,WDTLEN)
CC
CCCC      CALL ENCODI(NRES,WDT,WDTMAX,WDTLEN)
      CALL COPYST(RID,4,DUMMY,WDT,WDTLEN)
C
C now check whether residue is new at all
      FOUND=.FALSE.
      J=0
      DO WHILE (J.LT.NATOM.AND..NOT.FOUND)
      J=J+1
      FOUND=(SID.EQ.SEGID(J).AND.RID.EQ.RESID(J).AND.REN.EQ.RES(J))
      END DO
      IF (FOUND) THEN
      WRITE(6,'(7A)') ' %SEGMNT-ERR: attempt to enter duplicate ',
     1'residue ',SID,' ',RID,' ',REN
      NRES=NRES-1
      ELSE
      IF (QFIRST) THEN
      CALL SEGFIR(REN,RID,SID,FIRST,FIRSTT,SFIRST,PATNAM,SET,
     &            NATOM1,IFIRST,NADD,ISET,NSET,DIM)
      QFIRST=.FALSE.
      ELSE
      CALL SEGLNK(NATOM1,ILINK,NSET,DIM,ISET,NADD,REN,RID,
     &      SID,LINK,LINKH,LINKT,SLINKH,SLINKT,RENOLD,RIDOLD,
     &      SET,PATNAM,.TRUE.)
      END IF
      RENOLD=REN
      RIDOLD=RID
      END IF
      CALL NEXTWD('SEQUence-element (terminate with END) =')
      IF (WD(1:3).EQ.'END') CALL CHKEND('SEQUENCE>',DONE)
      END DO
      DONE=.FALSE.
      IF (NRES.GT.NRSOLD) THEN
      CALL SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
      IF (WRNLEV.GE.5) THEN
      WRITE(6,'(A,I5,3A)') ' SEGMNT: ',NRES-NRSOLD,
     1 ' residues were inserted into segment "',SID,'"'
      END IF
      END IF
C
      ELSE IF (WD(1:4).EQ.'SEPA') THEN
      CALL NEXTLO('SEPArate-by-segid=',QSEP)
C
      ELSE IF (WD(1:4).EQ.'CONV') THEN
      CALL NEXTLO('CONVert-chainid-to-segid=',QCHAIN)
C
      ELSE IF (WD(1:4).EQ.'COOR') THEN
      IF (WRNLEV.GE.10) THEN
      WRITE(6,'(A)') ' SEGMNT-info: sequence read from coordinate file'
      END IF
C
C initialize various counters
      NRSOLD=NRES
      SIDOLD='    '
      QFIRST=.TRUE.
      RID='    '
      REN='    '
      ECHOLD=.FALSE.
C 
      CURRSTRM=0
C
C parsing
      CALL PUSEND('COOR>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('COOR>')
CCCC
C check for missing end statement, ATB 2/21/10
      IF (CURRSTRM.EQ.0) THEN
      CURRSTRM=NSTRM
      END IF
      IF (CURRSTRM.NE.NSTRM.AND.WD(1:WDLEN).NE.'END') THEN
C
      WRITE(6,'(A)') 
     & ' SEGMNT-err: End of coordinate file without END statement.'
      WRITE(6,'(A)') 
     & '             Please insert END statement and re-run.'
      CALL WRNDIE(-5,'SEGMNT','Fatal error in reading coordinates.')
      END IF
CCCC
      IF (ECHOLD) QECHO=.TRUE.
      CALL MISCOM('COOR>',USED)
      IF (.NOT.USED) THEN
C
      IF (WD(1:4).EQ.'ATOM'.OR.WD(1:4).EQ.'HETA') THEN
C
C this section reads the Brookhaven atom coordinates
      READ(COMLYN,'(12X,A4,1X,A4,A1,A5,3X,3F8.3,6X,F6.2,6X,A4)',
     &     ERR=8888) IUPX,RENX,CHAIN,A,XIN,YIN,ZIN,WIN,SIDX
C
C special handling of PDB RESSEQ and ICODE, ATB 02/15/10
      IF (A(5:5).EQ.' ') then
         RIDX=A(1:4)
      ELSE
         IF (A(1:1).NE.' ') then
           WRITE(6,'(A,A,A)')     
     & ' %CREAD-ERR: residue ID and insertion character ',
     & A,' exceed 4 characters.'           
           CALL WRNDIE(-5,'SEGMNT',
     &      'Unsupported PDB fields.')
         END IF
         RIDX=A(2:5) 
      END IF
C
C make RIDX left-justified
      IJ=4
      CALL TRIML(RIDX,IJ)
      CALL TRIMM(RIDX,IJ)
CCC      IJ=5
CCC      CALL TRIML(A,IJ)
CCC      CALL TRIMM(A,IJ)
CCC      IF (IJ.GT.4) THEN
CCC      WRITE(6,'(A,A,A)')
CCC     & ' %CREAD-ERR: residue ID and insertion character ',
CCC     & A,' exceed 4 characters.'
CCC      END IF
CCC      RIDX=A(1:4)
C
C make RENX left-justified, ATB 12/12/09
      I=4
      CALL TRIML(RENX,I)
C
      IF ( QCHAIN ) THEN
         IF (CHAIN.NE.' ') THEN
           SIDX=CHAIN
         END IF
      END IF
C
      IF (QSEP) THEN
      IF (SIDX.NE.SIDOLD) THEN
C
C make last patch if more than one residue in current chain
      IF (NRES.GT.NRSOLD) THEN
      CALL SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
      IF (WRNLEV.GE.5.AND.NRES-NRSOLD.GT.1) THEN
      WRITE(6,'(A,I5,3A)') 
     & ' SEGMNT-info: auto chain termination due to different segid.',
     & NRES-NRSOLD,
     & ' residues were inserted into segid "',SIDOLD,'"'
      END IF
      END IF
C
C initialize various counters
      NRSOLD=NRES
      QFIRST=.TRUE.
      RID='    '
      REN='    '
      ECHOLD=.FALSE.
      SIDOLD=SIDX
C
C modification, ATB 12/01/09: automatic chain termination if no link found
C to next residue
      ELSEIF (RID.NE.RIDX.OR.REN.NE.RENX) THEN
C test if a link exists between these two residues.  If not -> restart
      FOUND=.FALSE.
      I=0
      DO WHILE (.NOT. (FOUND.OR.I.GE.ILINK))
      I=I+1
      FOUND=(RENX.EQ.LINKT(I).AND.RENOLD.EQ.LINKH(I))
      END DO
      IF (.NOT.FOUND) THEN
C
C make last patch if more than one residue in current chain
      IF (NRES.GT.NRSOLD) THEN
      CALL SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
      IF (WRNLEV.GE.5) THEN
      WRITE(6,'(A,I5,3A)') 
     & ' SEGMNT-info: auto chain termination due to unavailable link. ',
     &  NRES-NRSOLD,
     & ' residues were inserted into segid "',SIDOLD,'"'
      END IF
      END IF
C
C initialize various counters
      NRSOLD=NRES
      QFIRST=.TRUE.
      RID='    '
      REN='    '
      ECHOLD=.FALSE.
      SIDOLD=SIDX
      END IF   
      END IF
      END IF
C
      CURSOR=COMLEN
      CALL SEGATM(NATOM1,ILINK,NSET,DIM,ISET,NADD,NRES,
     &           IFIRST,REN,RID,SID,LINK,LINKH,LINKT,SLINKH,SLINKT,
     &           FIRST,SFIRST,FIRSTT,RENOLD,RIDOLD,SET,PATNAM,RIDX,
     &           SIDX,RENX,QFIRST,SIDCHK,QLINK)
      IF (.NOT.QLINK) QLINK=.TRUE.
C
      ECHOLD=QECHO
      QECHO=.FALSE.
C
      ELSE IF (WD(1:3).EQ.'TER') THEN
C
C terminate chain and start new chain
C
C go to end of line
      CURSOR=COMLEN
C
C make last patch
      IF (NRES.GT.NRSOLD) THEN
      CALL SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
      IF (WRNLEV.GE.5) THEN
      WRITE(6,'(A,I5,3A)') 
     & ' SEGMNT-info: chain termination due to TER keyword. ',
     & NRES-NRSOLD,
     & ' residues were inserted into segid "',SID,'"'
      END IF
      END IF
C
C initialize various counters
      NRSOLD=NRES
      QFIRST=.TRUE.
      RID='    '
      REN='    '
      ECHOLD=.FALSE.
C
      ELSE IF (WD(1:5).EQ.'BREAK') THEN
C
C do not make link, but do not start new chain
C
C go to end of line
      CURSOR=COMLEN
C
C initialize various flags
      QFIRST=.FALSE.
      QLINK=.FALSE.
C
      ELSE IF (WD(1:5).EQ.'CRYST') THEN
C
C go to end of line
      CURSOR=COMLEN
      ELSE IF (WD(1:6).EQ.'ANISOU') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:4).EQ.'ORIG') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'SCALE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'HEADER') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'COMPND') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'SOURCE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'KEYWDS') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'EXPDTA') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'DBREF') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'AUTHOR') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'REVDAT') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:4).EQ.'JRNL') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'SEQADV') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'SEQRES') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'TITLE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'MODRES') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'FTNOTE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'HET   ') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'HETNAM') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'HETSYN') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'CAVEAT') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'FORMUL') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'HELIX') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'SHEET') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:4).EQ.'TURN') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'SSBOND') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'SPLIT') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:4).EQ.'SITE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:4).EQ.'LINK') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:5).EQ.'MTRIX') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'CISPEP') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'CONECT') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'MASTER') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE IF (WD(1:6).EQ.'SPRSDE') THEN
C
C go to end of line
      CURSOR=COMLEN
C
      ELSE
C
      CALL CHKEND('COOR>',DONE)
      END IF
      END IF
      END DO
      GOTO 7777
8888  ERROR=.TRUE.
7777  CONTINUE
      IF (ERROR) WRITE(6,'(A)') ' %SEGMNT-ERR: ERROR during read'
      DONE=.FALSE.
C
C make last patch
      IF (NRES.GT.NRSOLD) THEN
      CALL SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
      IF (WRNLEV.GE.5) THEN     
      WRITE(6,'(A,I5,3A)') 
     & ' SEGMNT-info: chain termination due to END keyword. ',
     & NRES-NRSOLD,
     & ' residues were inserted into segid "',SID,'"'
      END IF
      END IF
C
      ELSE
      CALL CHKEND('CHAIN>',DONE)
      END IF
      END IF
      END DO
      DONE=.FALSE.
C
      ELSE
      CALL CHKEND('SEGMENT>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
C finally, clear the lists
      CALL SCRATC
      CALL SHOW
      RETURN
      END
C
      SUBROUTINE SEGFIR(REN,RID,SID,FIRST,FIRSTT,SFIRST,PATNAM,SET,
     &            NATOM1,IFIRST,NADD,ISET,NSET,DIM)
C
C generates residue REN and apply first patch (see SEGMNT above)
C Author: Axel Brunger
C I/O
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'timer.inc'
      CHARACTER*4 REN, RID, SID, FIRST(*), FIRSTT(*), SFIRST(*)
      CHARACTER*4 PATNAM, SET(*)
      INTEGER NATOM1, IFIRST, NADD, ISET(*), NSET, DIM
C local
      INTEGER I, J
      LOGICAL FOUND
C begin
      NATOM1=NATOM
      CALL GENRES(REN,RID,SID)
C
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(8A)') ' SEGMNT: residue ',REN,' ',RID,' has been ',
     & 'added to segid "',SID,'"'
      END IF
C
      IF (IFIRST.GT.0) THEN
C
C lookup patch FIRST residue
      FOUND=.FALSE.
      I=0
      DO WHILE (.NOT. (FOUND.OR.I.GE.IFIRST))
      I=I+1
      FOUND=(REN.EQ.FIRSTT(I))
      END DO
C disabled wildcard matching, ATB 12/01/09
CCC      IF (.NOT.FOUND) THEN
CCC      I=0
CCC      DO WHILE (.NOT. (FOUND.OR.I.GE.IFIRST))
CCC      I=I+1
CCC      CALL EQSTWC(REN,4,FIRSTT(I),4,1,1,FOUND)
CCC      END DO
CCC      END IF
      IF (.NOT.FOUND) THEN
      IF (WRNLEV.GE.10) THEN
      WRITE(6,'(A)') ' %Segmnt-info: No matching FIRST patch found'
      END IF
      ELSE
      PATNAM=FIRST(I)
C
C generate SET, ISET for PATCH
      NSET=0
      DO J=NATOM1+1,NATOM
      IF (NSET.GE.DIM) THEN
      WRITE(6,'(A)') ' %SEGMNT-ERR: DIM exceeded'
      ELSE
      NSET=NSET+1
      SET(NSET)=SFIRST(I)
      ISET(NSET)=J
      END IF
      END DO
      CALL PATCH(PATNAM,NATOM+NADD,NSET,SET,ISET,.FALSE.)
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(6A)') ' SEGMNT: ',PATNAM,' has been patched to ',
     & REN,' ',RID
      END IF
      END IF
      END IF
      RETURN
      END
C
      SUBROUTINE SEGLNK(NATOM1,ILINK,NSET,DIM,ISET,NADD,REN,RID,
     &      SID,LINK,LINKH,LINKT,SLINKH,SLINKT,RENOLD,RIDOLD,
     &      SET,PATNAM,QLINK)
C
C generate residue ren and link it to chain head
C (see SEGMNT above)
C Author: Axel Brunger
C I/O
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'timer.inc'
      INTEGER NATOM1, ILINK, NSET, DIM, ISET(*), NADD
      CHARACTER*4 REN, RID, SID, LINK(*), LINKH(*), LINKT(*)
      CHARACTER*4 SLINKH(*), SLINKT(*)
      CHARACTER*4 RENOLD, RIDOLD, SET(*), PATNAM
      LOGICAL QLINK
C local
      INTEGER I, J, NATOM2
      LOGICAL FOUND, COND
C begin
C
C
C NATOM1+1 keeps track of the first atom in the previously inserted 
C residue (NATOM1 is the end of next to last residue) -> store in NATOM2
      NATOM2=NATOM1
C
C NATOM1 is now the last atom in the previously inserted residue
      NATOM1=NATOM
C
C generate new residue REN
      CALL GENRES(REN,RID,SID)
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(9A)') ' SEGMNT: residue ',REN,' ',RID,' has been ',
     & 'added to segid "',SID,'"'
      END IF
C
      IF (ILINK.GT.0.AND.QLINK) THEN
C
C lookup patch link element between last and current residue
      FOUND=.FALSE.
      I=0
      DO WHILE (.NOT. (FOUND.OR.I.GE.ILINK))
      I=I+1
      FOUND=(REN.EQ.LINKT(I).AND.RENOLD.EQ.LINKH(I))
      END DO
CCC disabled wildcard matching, ATB 12/01/92
CCC      IF (.NOT.FOUND) THEN
CCC      I=0
CCC      DO WHILE (.NOT. (FOUND.OR.I.GE.ILINK))
CCC      I=I+1
CCC      CALL EQSTWC(REN,4,LINKT(I),4,1,1,COND)
CCC      CALL EQSTWC(RENOLD,4,LINKH(I),4,1,1,FOUND)
CCC      FOUND=FOUND.AND.COND
CCC      END DO
CCC      END IF
      IF (.NOT. FOUND) THEN
      IF (WRNLEV.GE.10) THEN
      WRITE(6,'(A)') ' %Segmnt-info: no matching LINK found'
      END IF
      ELSE
      PATNAM=LINK(I)
C
C generate SET, ISET list for PATCH
      NSET=0
      DO J=NATOM2+1,NATOM1
      IF (NSET.GE.DIM) THEN
      WRITE(6,'(A)') ' %SEGMNT-ERR: DIM exceeded'
      ELSE
      NSET=NSET+1
      SET(NSET)=SLINKH(I)
      ISET(NSET)=J
      END IF
      END DO
      DO J=NATOM1+1,NATOM
      IF (NSET.GE.DIM) THEN
      WRITE(6,'(A)') ' %SEGMNT-ERR: DIM exceeded'
      ELSE
      NSET=NSET+1
      SET(NSET)=SLINKT(I)
      ISET(NSET)=J
      END IF
      END DO
      CALL PATCH(PATNAM,NATOM+NADD,NSET,SET,ISET,.FALSE.)
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(10A)') ' SEGMNT: ',PATNAM,' has been patched to ',
     & RENOLD,' ',RIDOLD,' and ',REN,' ',RID
      END IF
      END IF
      END IF
C
C Redetermine NATOM1 (end of next-to-last residue) in case it
C was changed by patch.
      NATOM1=NATOM-1
      DO WHILE( RESID(NATOM1).EQ.RESID(NATOM) .AND.
     &          SEGID(NATOM1).EQ.SEGID(NATOM) .AND. NATOM1.GT.1)
      NATOM1=NATOM1-1
      END DO     
      RETURN
      END
C
      SUBROUTINE SEGLAS(NSET,NADD,DIM,ISET,ILAST,NATOM1,REN,RID,LAST,
     &           LASTH,SLASTH,SET,PATNAM)
C
C lookup appropriate last patch for residue REN
C Author: Axel Brunger
C I/O
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'timer.inc'
      INTEGER NSET, NADD, DIM, ISET(*), ILAST, NATOM1
      CHARACTER*4 REN, RID, LAST(*), LASTH(*), SLASTH(*), SET(*)
      CHARACTER*4 PATNAM
C local
      LOGICAL FOUND
      INTEGER I, J, L
C begin
      IF (ILAST.GT.0) THEN
      FOUND=.FALSE.
      I=0
      DO WHILE (.NOT. (FOUND.OR.I.GE.ILAST))
      I=I+1
      FOUND=(REN.EQ.LASTH(I))
      END DO
C disabled wildcard matching, ATB, 12/01/09
CCC      IF (.NOT.FOUND) THEN
CCC      I=0
CCC      DO WHILE (.NOT. (FOUND.OR.I.GE.ILAST))
CCC      I=I+1
CCC      CALL EQSTWC(REN,4,LASTH(I),4,1,1,FOUND)
CCC      END DO
CCC      END IF
      IF (.NOT.FOUND) THEN
      IF (WRNLEV.GE.10) THEN
      WRITE(6,'(A)') ' %Segmnt-info: no matching LAST patch found'
      END IF
      ELSE
      PATNAM=LAST(I)
C
C generate SET, ISET list for PATCH
      NSET=0
      L=NATOM
      DO J=NATOM1+1,NATOM
      IF (NSET.GE.DIM) THEN
      WRITE(6,'(A)') ' %SEGMNT-ERR: DIM exceeded'
      ELSE
      NSET=NSET+1
      SET(NSET)=SLASTH(I)
      ISET(NSET)=J
      END IF
      END DO
      CALL PATCH(PATNAM,NATOM+NADD,NSET,SET,ISET,.FALSE.)
      IF (WRNLEV.GT.5) THEN
      WRITE(6,'(6A)') ' SEGMNT: ',PATNAM,' has been patched to ',
     & REN,' ',RID
      END IF
      END IF
      END IF
      RETURN
      END
C
      SUBROUTINE SEGATM(NATOM1,ILINK,NSET,DIM,ISET,NADD,NRES,
     &           IFIRST,REN,RID,SID,LINK,LINKH,LINKT,SLINKH,SLINKT,
     &           FIRST,SFIRST,FIRSTT,RENOLD,RIDOLD,SET,PATNAM,RIDX,
     &           SIDX,RENX,QFIRST,SIDCHK,QLINK)
C
C processes current atom line for COOR option
C (see routine SEGMNT above)
C Author: Axel Brunger
C  I/O
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'timer.inc'
      INTEGER NATOM1, ILINK, NSET, DIM, ISET(*), NADD, NRES
      INTEGER IFIRST
      CHARACTER*4 REN, RID, SID, LINK(*), LINKH(*), LINKT(*)
      CHARACTER*4 SLINKH(*), SLINKT(*), FIRST(*), SFIRST(*)
      CHARACTER*4 FIRSTT(*), RENOLD, RIDOLD, SET(*), PATNAM
      CHARACTER*4 RIDX, SIDX, RENX
      LOGICAL QFIRST, SIDCHK, QLINK
C local
      INTEGER I
      LOGICAL FOUND
C begin
C
C now we check whether segment id's match and whether residue is new
      IF (SIDCHK) THEN
      IF (SID.NE.SIDX) THEN
      WRITE(6,'(A)')
     & ' %SEGMNT-ERR: segid in coordinate file does not match NAME.'
      CALL WRNDIE(-5,'SEGMNT',' check NAME specification.')
      END IF
      END IF
C
      IF (RID.NE.RIDX.OR.REN.NE.RENX) THEN
C
C now check whether residue is new at all
      FOUND=.FALSE.
      I=0
      DO WHILE (I.LT.NATOM.AND..NOT.FOUND)
      I=I+1
      FOUND=(SIDX.EQ.SEGID(I).AND.RIDX.EQ.RESID(I).AND.RENX.EQ.RES(I))
      END DO
      IF (FOUND) THEN
      WRITE(6,'(7A)') ' %SEGMNT-ERR: attempt to enter duplicate ',
     &'residue ',SIDX,' ',RIDX,' ',RENX
      CALL WRNDIE(-5,'SEGMNT',
     & ' check PDB file for residue duplications.')
      ELSE
      SID=SIDX
      RID=RIDX
      REN=RENX
      NRES=NRES+1
      IF (QFIRST) THEN
      CALL SEGFIR(REN,RID,SID,FIRST,FIRSTT,SFIRST,PATNAM,SET,
     &            NATOM1,IFIRST,NADD,ISET,NSET,DIM)
      QFIRST=.FALSE.
      ELSE
      CALL SEGLNK(NATOM1,ILINK,NSET,DIM,ISET,NADD,REN,RID,
     &            SID,LINK,LINKH,LINKT,SLINKH,SLINKT,RENOLD,RIDOLD,
     &            SET,PATNAM,QLINK)
      END IF
      RIDOLD=RID
      RENOLD=REN
      END IF
      END IF
      RETURN
      END

C
C ==========================================================================
C
      SUBROUTINE DPSTOR(X)
C
      IMPLICIT NONE
C I/O
      INCLUDE 'machvar.inc'
      DOUBLE PRECISION  X
C
C FORCES THE ARGUMENT VALUE X TO BE STORED IN MEMORY LOCATION V.
C Source code taken from fftpack41/tfftpk.f
C
      DPTMPV=X
      RETURN
      END
C
C ==========================================================================
C
      DOUBLE PRECISION FUNCTION DPTRUNC(X)
C
      IMPLICIT NONE
C I/O
      INCLUDE 'machvar.inc'
      DOUBLE PRECISION  X
C
C DPTRUNC IS A PORTABLE FORTRAN FUNCTION WHICH TRUNCATES A VALUE TO THE
C MACHINE DOUBLE PRECISION WORD SIZE, REGARDLESS OF WHETHER LONGER
C PRECISION INTERNAL REGISTERS ARE USED FOR FLOATING POINT ARITHMETIC IN
C COMPUTING THE VALUE INPUT TO DPTRUNC.  THE METHOD USED IS TO FORCE A
C STORE INTO MEMORY BY USING A COMMON BLOCK IN ANOTHER SUBROUTINE.
C Source code taken from fftpack41/tfftpk.f
C
      CALL DPSTOR(X)
      DPTRUNC=DPTMPV
      RETURN
      END
C
C ==========================================================================
C
      SUBROUTINE SETFPEPS
C
      IMPLICIT NONE
C I/O
      INCLUDE 'numbers.inc'
      INCLUDE 'machvar.inc'
C
C Determine the machine epsilon i.e. the smallest FPEPS such that both
C 1+FPEPS and 1-FPEPS are different from 1.
C
C local
      DOUBLE PRECISION ONEDP
      DOUBLE COMPLEX DBCOMP
C
C external
C NONE
C
C begin
C
C ONEDP doesn't really need to be defined - EPSILON() only needs to know
C the type
      ONEDP=(1.00)
      FPEPS = EPSILON(ONEDP)
      DBCOMP = DCMPLX(ZERO,ZERO)
      CALL DECLAR('FP_EPSILON', 'DP', ' ', DBCOMP, FPEPS)
      RETURN
      END
C
C ==========================================================================
C

      SUBROUTINE EVALTB( MODE, INDEX, STINDX, FLAGS, XRERR )
      IMPLICIT NONE
C
C     evaluate the parse tables to obtain a value for the right
C     hand side of the equation
C
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
C
      LOGICAL XRERR
      INTEGER INDEX
      INTEGER FLAGS(*)
      CHARACTER*4 MODE
      INTEGER K, L, STINDX
C
Ctabtrace       WRITE(19,'(1X,A)')'INITIAL TABLE SETUP:'
Ctabtrace       WRITE(19,'(1X,A,A)')'MODE = ',MODE
Ctabtrace       CALL TBOUT
C
      K = 1
      L = K + 1
1     IF ( TEO(1) .NE. '<' .AND. ( VOP(L) .LE. VOP(K) ) ) THEN
C
         IF     ( TEO(K) .EQ. '+' ) THEN
            CALL XRADD( K, XRERR )
         ELSEIF ( TEO(K) .EQ. '-' ) THEN
            CALL XRSUB( K, XRERR )
         ELSEIF ( TEO(K) .EQ. '*' ) THEN
            CALL XRMULT( K, XRERR )
         ELSEIF ( TEO(K) .EQ. ',' ) THEN
            CALL XRCOMA( K, MODE, XRERR )
         ELSEIF ( TEO(K) .EQ. '/' ) THEN
            CALL XRDIV( K, XRERR )
         ELSEIF ( TEO(K) .EQ. '^' ) THEN
            CALL XRPOWR( K, XRERR )
         ELSEIF ( TEO(K) .EQ. '=' ) THEN
            CALL XREQU( K, MODE,  XRERR )
         ELSEIF ( TEO(K) .EQ. 'A' ) THEN
            CALL XRABS( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'M' ) THEN
            CALL XRMIN( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. '~' ) THEN
            CALL XRUNM( K, XRERR )
         ELSEIF ( TEO(K) .EQ. 'H' ) THEN
            CALL XRHEAV( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'Z' ) THEN
            CALL XRMAX( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'L' ) THEN
            CALL XRLOG( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'E' ) THEN
            CALL XREXP( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'G' ) THEN
            CALL XRGAUS( K, L, INDEX, XRERR )
         ELSEIF ( TEO(K) .EQ. 'W' ) THEN
            CALL XRMAXW( K, L, INDEX, XRERR )
CCC deleted NORM function ATB 25/12/06
CCC         ELSEIF ( TEO(K) .EQ. 'N' ) THEN
CCC            CALL XRNORM( K, L, INDEX, STINDX, FLAGS, XRERR )
         ELSEIF ( TEO(K) .EQ. 'B' ) THEN
            CALL XRCLOG( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'D' ) THEN
            CALL XRSIGN( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'F' ) THEN
            CALL XRASIN( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'J' ) THEN
            CALL XRACOS( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'S' ) THEN
            CALL XRSINE( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'C' ) THEN
            CALL XRCOS( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'T' ) THEN
            CALL XRTAN( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'Q' ) THEN
            CALL XRSQRT( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'I' ) THEN
            CALL XRINT( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'R' ) THEN
            CALL XRMOD( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'V' ) THEN
            CALL XRENCD( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'X' ) THEN
            CALL XRDECD( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'Y' ) THEN
            CALL XRRAND( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'b' ) THEN
            CALL XRNINT( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'c' ) THEN
            CALL XRCAPIT( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'a' ) THEN
            CALL XRIMOD( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'l' ) THEN
            CALL XRLEN( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 's' ) THEN
            CALL XRSUBSTR( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'i' ) THEN
            CALL XRINDEX( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'r' ) THEN
            CALL XRRINDEX( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'f' ) THEN
            CALL XRFORMAT( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'g' ) THEN
            CALL XRADJUSTL( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 't' ) THEN
            CALL XRTRIM( K, L, XRERR )
         ELSEIF ( TEO(K) .EQ. 'm' ) THEN
            CALL XRMATCH( K, L, XRERR )
         ENDIF
         IF ( XRERR ) THEN
            RETURN
         ENDIF
C
C        if last operation wasn't a noop remove it as processed
C
         IF(TEO(K) .NE. '_')THEN
            CALL TBPACK( K )
         ENDIF
Ctabtrace         CALL TBOUT
C
C        backup a position in the table for next comparison
C        if it is a noop go back another one
C
36       K = K - 1
         IF ( TEO(K) .EQ. '_' ) GOTO 36
C
C        want to compare to the next operation in the table
C        unless it is a noop
C
         L = K
37       L = L + 1
         IF ( TEO(L) .EQ. '_' ) GOTO 37
C
C        go back and make the comparison
C
         IF ( K .GT. 1 ) GOTO 1
      ELSE
C
C        continue working through the table of operators
C
38       K = K + 1
         IF ( TEO(K) .EQ. '_' ) GOTO 38
         L = K
39       L = L + 1
         IF ( TEO(L) .EQ. '_' ) GOTO 39
         GOTO 1
      ENDIF
      RETURN
      END
C
      SUBROUTINE HIER( MODE, XRERR )
      IMPLICIT NONE
C
C     this routine parses the string containing the equation and
C     stores all information in the parsing tables.
C     parameters:
C        mode -> type of calculation (real, comp, scal, phas, ampl)
C        xrerr -> returned true if this routine errs
C     parse tables:
C         teo -- is an array of the actual operators
C         vop -- holds the value of the operator in teo, this is
C                used to determine precedence when calculating
C         vareq -- holds character representations of all parts of
C                  the equation that are not operators
C         vartype -- tells whether the item in vareq is a double
C                    precision number, a double complex number, or
C                    a function
C         rvareq -- holds the value of vareq if it is a double
C                      precision number.
C         cvareq -- holds the value of vareq if it is a double
C                      complex number.
C         svareq -- holds the value of vareq if it is a string.
C
C
      CHARACTER*(*) MODE
      LOGICAL XRERR
      INCLUDE 'cns.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'timer.inc'
C     max variable length VNAMLN = WDMAX chars
      CHARACTER*(WDMAX) TMPWD
      INTEGER TWDLEN
      INTEGER K, I, INCPAR, VCPTR
      LOGICAL FOUND, INQUOT, OK
      DOUBLE PRECISION DECODF
      INTEGER PARBAL
      CHARACTER*1 LR, LSTOKN
      DOUBLE PRECISION DPVAL
      DOUBLE COMPLEX DCVAL
      CHARACTER*2 WDTYP
C
C     initialize everything
C
      CALL VINIT
      XRERR  = .FALSE.
      INQUOT = .FALSE.
      K = 0
      INCPAR = 0
      VCPTR = 0
      PARBAL = 0
      LR = 'L'
      IF ( MODE .EQ. 'EVAL' ) THEN
         XSTMAX = SVARMX
      ELSE
         XSTMAX = 4
      ENDIF
C
C     get next word; must be the left paren.
C
      CALL NEXTSL('Expression=')
C
      IF ( WD(1:4) .NE. '(   ' ) THEN
         CALL DSPERR('Expression>','Must begin with (')
         XRERR = .TRUE.
         RETURN
      ENDIF
C
C     if made it into the expression (found left paren) then continue
C     parsing until parens balance
C
101   CONTINUE
C
C     k points to next index in tables to place variable info
C
      TMPWD = WD
      TWDLEN = WDLEN
      IF ( TMPWD(1:4) .EQ. '(   '.AND..NOT.QQUOT ) THEN
         PARBAL = PARBAL + 1
         IF ( PARBAL .EQ. 1 ) THEN
            TMPWD = '>'
            TWDLEN = 1
            LSTOKN = 'O'
         ENDIF
      ELSEIF ( TMPWD(1:4) .EQ. ')   '.AND..NOT.QQUOT ) THEN
         PARBAL = PARBAL - 1
         IF ( PARBAL .EQ. 0 ) THEN
            TMPWD = '<'
            TWDLEN = 1
            LSTOKN = 'O'
         ENDIF
      ENDIF
      IF (QQUOT) THEN
C
C     it is a quoted string.
C
                 VARTYP(K) = 'ST'
                 SVAREQ(K) = ' '
                 SVAREQ(K)(1:WDLEN) = WD(1:WDLEN)
                 SVARLN(K) = WDLEN
C
C     look for operators and determine precedence
C
      ELSE IF ( TMPWD(1:4) .EQ. '>' ) THEN
         IF ( K .NE. 0 ) THEN
            CALL DSPERR('Expression>','Illegal character')
            XRERR = .TRUE.
            RETURN
         ENDIF
         K = K + 1
         VOP(K) = INCPAR
         TEO(K) = '>'
C
C        the show command 'show ( x )' is implemented by insert-
C        ing 'show=' into the command netting 'show (show=x)'
C        then when the assignment to show is made the value is printed
C
         IF ( MODE .EQ. 'SHOW' ) THEN
            VARTYP(1) = 'VT'
            VARNUM(1) = 29
            VAREQ(1) = 'SHOW                '
            TEO(2) = '='
            VOP(2) = 1
            K = 2
         ENDIF
      ELSEIF ( TMPWD(1:1) .EQ. '<' ) THEN
C
C     at end of equation check for balanced parens
C
         K = K + 1
         VOP(K) = INCPAR
         TEO(K) = '<'
      ELSEIF ( TMPWD(1:1) .EQ. '+' .OR. TMPWD(1:1) .EQ. '-' )THEN
         K = K + 1
         VOP(K) = 2 + INCPAR
         TEO(K) = TMPWD(1:1)
         LSTOKN = 'O'
      ELSEIF ( TMPWD(1:1) .EQ. '=' ) THEN
         IF ( K .GT. 1 ) THEN
            CALL DSPERR('EXPRESSION PARSER',
     &                  'TOO MANY TERMS TO LEFT OF EQUAL SIGN')
            XRERR = .TRUE.
            RETURN
         ENDIF
         LSTOKN = 'O'
         K = K + 1
         VOP(K) = 1 + INCPAR
         TEO(K) = '='
         LR = 'R'
      ELSEIF ( TMPWD(1:1) .EQ. ',' ) THEN
         K = K + 1
         VOP(K) = INCPAR
         TEO(K) = ','
         LSTOKN = 'O'
      ELSEIF ( TMPWD(1:1) .EQ. '^' ) THEN
         K = K + 1
         VOP(K) = 5 + INCPAR
         TEO(K) = '^'
         LSTOKN = 'O'
      ELSEIF ( TMPWD(1:1) .EQ. '~' ) THEN
         K = K + 1
         VOP(K) = 6 + INCPAR
         TEO(K) = '~'
         IF ( LSTOKN .EQ. 'S' ) THEN
            CALL DSPERR('EXPRESSION-EVALUATOR',
     &            'Illegal use of unary minus')
            XRERR = .TRUE.
            RETURN
         ELSE
            LSTOKN = 'O'
         ENDIF
      ELSEIF ( TMPWD(1:1) .EQ. '*' ) THEN
         K = K + 1
         CALL NEXTSL('Expression=')
         IF ( WD(1:1) .NE. '*' ) THEN
            CALL SAVEWD
            VOP(K) = 3 + INCPAR
            TEO(K) = '*'
         ELSE
            VOP(K) = 5 + INCPAR
            TEO(K) = '^'
         ENDIF
         LSTOKN = 'O'
      ELSEIF ( TMPWD(1:1) .EQ. '/' ) THEN
         K = K + 1
         VOP(K) = 3 + INCPAR
         TEO(K) = '/'
         LSTOKN = 'O'
      ELSEIF ( TMPWD(1:1) .EQ. '(' ) THEN
C
C        boost precedence level when within parens
C
         INCPAR = INCPAR + 10
      ELSEIF ( TMPWD(1:1) .EQ. ')' ) THEN
         INCPAR = INCPAR - 10
      ELSE
C
C        if not an operator assume it is a
C        variable, function, or a literal constant
C
         VAREQ(K) = TMPWD
         FOUND = .FALSE.
C
C to substitute it as a symbol
C ,ie $PI
         IF ( WD(1:1) .EQ. '$' ) THEN
               IF ( MODE .EQ. 'EVAL' .AND. LR .EQ. 'L' ) THEN
C
C in evaluate mode, the first symbol is to be assigned --
C don't replace it and store the variable name for the
C assignment.
C
                  VARTYP(K) = 'VT'
                  VAREQ(K) = WD
                  IF (WDLEN.GT.VNAMLN) THEN
      CALL DSPERR('HIER','name of symbol too long.')
                  END IF
                  FOUND = .TRUE.
               ELSE
                  TMPWD = WD
                  TWDLEN = WDLEN
                  CALL WDSUB( TMPWD,WDMAX,TWDLEN,FOUND,
     &                                    WDTYP, DPVAL, DCVAL )
      IF (.NOT.FOUND) THEN
      CALL DSPERR('WDSUB','symbol not found')
      END IF
                  IF ( FOUND ) THEN
                     VAREQ(K) = TMPWD
                     VARTYP(K) = WDTYP
                     IF ( WDTYP .EQ. 'DP' ) THEN
                        RVAREQ(K) = DPVAL
                     ELSEIF ( WDTYP .EQ. 'DC' ) THEN
                        CVAREQ(K) = DCVAL
                     ELSEIF ( WDTYP .EQ. 'ST') THEN
                        SVAREQ(K) = ' '
                        SVAREQ(K)(1:TWDLEN) = TMPWD(1:TWDLEN)
                        SVARLN(K) = TWDLEN
                     ELSEIF ( WDTYP .EQ. 'LO') THEN
                        SVAREQ(K) = ' '
                        SVAREQ(K)(1:TWDLEN) = TMPWD(1:TWDLEN)
                        SVARLN(K) = TWDLEN
                     ENDIF
                  ENDIF
               ENDIF
C
C check through VECTOR variables
         ELSE IF ( MODE .EQ. 'REAL' .OR. MODE .EQ. 'SHOW' ) THEN
            CALL SCHVAR( K, FOUND )
C
C check through XRAY-variables
         ELSE IF (MODE.NE.'EVAL') THEN
            CALL XCHVAR( K, FOUND )
         ENDIF
C
C        if not a valid variable name, check the functions
C
         IF ( .NOT. FOUND ) THEN
            CALL XRCHFX( MODE, K, FOUND )
            IF ( FOUND ) THEN
               VARTYP(K) = 'FX'
               K = K + 1
               VOP(K)  = 7 + INCPAR
               IF ( LSTOKN .EQ. 'S' ) THEN
                  CALL DSPERR('EXPRESSION-EVALUATOR',
     &                        'Function follows symbol')
                  XRERR = .TRUE.
                  RETURN
               ELSE
                  LSTOKN = 'O'
               ENDIF
            ELSE
C
C              if not a function we assume that word is a literal constant
C              Everything else is assumed to be an unquoted string.
C
C              Check first for quoted strings
C
               CALL CHKNUM(VAREQ(K),TWDLEN,OK)
C
               IF (OK) THEN
C
C              we think it is a number !! try to decode it
C
                 VARTYP(K) = 'DP'
                 RVAREQ(K) = DECODF(VAREQ(K),TWDLEN,OK)
C
C                here we provide an error message
C
                 IF (.NOT.OK) CALL DSPERR('EXPRESSION-EVALUATOR',
     &            'Error converting number')
      ELSEIF (WD(1:WDLEN).EQ.'TRUE'.OR.WD(1:WDLEN).EQ.'FALSE') THEN
C
C logical
                 VARTYP(K) = 'LO'
                 SVAREQ(K) = ' '
                 SVAREQ(K)(1:WDLEN) = WD(1:WDLEN)
                 SVARLN(K) = WDLEN
               ELSE
C
C                it must be a string.
C
                 VARTYP(K) = 'ST'
                 SVAREQ(K) = ' '
                 SVAREQ(K)(1:WDLEN) = WD(1:WDLEN)
                 SVARLN(K) = WDLEN
                 IF (WRNLEV .GE. 2 ) THEN
       WRITE(6,'(3A)') ' Assuming literal string "',WD(1:WDLEN),'"'
                 ENDIF
               ENDIF
C
               IF ( LSTOKN .EQ. 'S' ) THEN
                  CALL DSPERR('EXPRESSION-EVALUATOR',
     &                     'Illegal consecutive symbols')
                  XRERR = .TRUE.
                  RETURN
               ELSE
                  LSTOKN = 'S'
               ENDIF
            ENDIF
         ELSE
            IF ( LSTOKN .EQ. 'S' ) THEN
               CALL DSPERR('EXPRESSION-EVALUATOR',
     &            'Illegal consecutive symbols')
               XRERR = .TRUE.
               RETURN
            ELSE
               LSTOKN = 'S'
            ENDIF
         ENDIF
      ENDIF
C
C
      IF ( TMPWD(1:1) .NE. '<' ) THEN
C        if in evaluation mode get the variable name not it's value
         CALL NEXTSL('Expression=')
         GOTO 101
      ENDIF
C
C     total number of operations in equation
C
      NUMOPS = K
C
C     look for any unary minus signs, replace with ~
C
      DO I = 2,NUMOPS
         IF ( TEO(I) .EQ. '-' .AND. VARTYP(I-1) .EQ. '  '
     &                        .AND. VOP(I-1) .LT. VOP(I) + 5 )THEN
C
            TEO(I) = '~'
            VOP(I) = VOP(I) + 3
         ENDIF
      ENDDO
C
C     check to make sure there no undefined vareq or vartypes
C     exceptions for argument less fxs, allow ().
C
      DO I = 1,NUMOPS -1
         IF ( VARTYP(I) .EQ. '  ' .AND. TEO(I+1) .NE. '~' .AND.
     &        TEO(I) .NE. 'K' .AND. TEO(I) .NE. 'O' .AND.
     &        TEO(I) .NE. 'P' .AND. TEO(I) .NE. 'U' .AND.
     &        TEO(I) .NE. 'Y' ) THEN
            XRERR = .TRUE.
            CALL DSPERR('HIER>','Illegal consecutive operators')
            RETURN
         ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE SCASSN( INDEX, MODE, STINDX, XRERR )
      IMPLICIT NONE
C
C     the table has been evaluated leaving the final result in either
C     rvareq(1), svareq(1), or cvareq(1).  make the final assignment
C     to array which correlates to varnum(1).
C
      INCLUDE 'cns.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'update.inc'
      INCLUDE 'nbonds.inc'
      INCLUDE 'vector.inc'
C
C     argument declarations
C
      INTEGER INDEX
      CHARACTER*4 MODE
      INTEGER STINDX
      LOGICAL XRERR
      INTEGER IST
C
C
      IF ( VARNUM(1) .EQ. 29 ) THEN
C
C        ********
C        * SHOW *
C        ********
C
C        special construct to allow (show=x) to just print out x
C
         IF ( VARTYP(1) .EQ. 'DP' ) THEN
            WRITE(6,'(A,G14.4)') ' SHOW = ',RVAREQ(1)
         ELSEIF ( VARTYP(1) .EQ. 'ST' ) THEN
            WRITE(6,'(A,A)')' SHOW = ',SVAREQ(1)(1:SVARLN(1))
         ELSEIF ( VARTYP(1) .EQ. 'DC' ) THEN
            WRITE(6,*)' SHOW = ',CVAREQ(1)
         ENDIF
      ELSEIF ( VARNUM(1) .EQ. 1 ) THEN
C
C        *******
C        *  B  *
C        *******
C
         WMAIN(INDEX)   = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 2 ) THEN
C
C        *******
C        *  Q  *
C        *******
C
         QMAIN(INDEX)   = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 3 ) THEN
C
C        *********
C        * BCOMP *
C        *********
C
         WCOMP(INDEX)   = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 4 ) THEN
C
C        *********
C        * QCOMP *
C        *********
C
         QCOMP(INDEX)   = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 5 ) THEN
C
C        **************************
C        * HARMONIC or CONSTRAINT *
C        **************************
C
         KCNSTR(INDEX)  = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 6 ) THEN
C
C        ********
C        * MASS *
C        ********
C
         AMASS(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 7 ) THEN
C
C        **********
C        * CHARGE *
C        **********
C
         CG(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 8 ) THEN
C
C        *********
C        * FBETA *
C        *********
C
         FBETA(INDEX)   = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 9 ) THEN
C
C        *******
C        *  X  *
C        *******
C
         X(INDEX)       = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 10 ) THEN
C
C        *******
C        *  Y  *
C        *******
C
         Y(INDEX)       = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 11 ) THEN
C
C        *******
C        *  Z  *
C        *******
C
         Z(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 12 ) THEN
C
C        *********
C        * XCOMP *
C        *********
C
         XCOMP(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 13 ) THEN
C
C        *********
C        * YCOMP *
C        *********
C
         YCOMP(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 14 ) THEN
C
C        *********
C        * ZCOMP *
C        *********
C
         ZCOMP(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 15 ) THEN
C
C        ********
C        *  DX  *
C        ********
C
         DX(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 16 ) THEN
C
C        ********
C        *  DY  *
C        ********
C
         DY(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 17 ) THEN
C
C        ********
C        *  DZ  *
C        ********
C
         DZ(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 18 ) THEN
C
C        ********
C        * REFX *
C        ********
C
         REFX(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 19 ) THEN
C
C        ********
C        * REFY *
C        ********
C
         REFY(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 20 ) THEN
C
C        ********
C        * REFZ *
C        ********
C
         REFZ(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .EQ. 21 ) THEN
C
C        ********
C        *  VX  *
C        ********
C
         XV(INDEX) = RVAREQ(1) * TIMFAC
      ELSEIF ( VARNUM(1) .EQ. 22 ) THEN
C
C        ********
C        *  VY  *
C        ********
C
         YV(INDEX) = RVAREQ(1) * TIMFAC
      ELSEIF ( VARNUM(1) .EQ. 23 ) THEN
C
C        ********
C        *  VZ  *
C        ********
C
         ZV(INDEX) = RVAREQ(1) * TIMFAC
      ELSEIF ( VARNUM(1) .EQ. 24 ) THEN
C
C        *********
C        * SEGID *
C        *********
C
         SEGID(INDEX) = SVAREQ(1)(1:4)
      ELSEIF ( VARNUM(1) .EQ. 25 ) THEN
C
C        *********
C        * RESID *
C        *********
C
         RESID(INDEX) = SVAREQ(1)(1:4)
      ELSEIF ( VARNUM(1) .EQ. 26 ) THEN
C
C        ***********
C        * RESNAME *
C        ***********
C
         RES(INDEX) = SVAREQ(1)(1:4)
      ELSEIF ( VARNUM(1) .EQ. 27 ) THEN
C
C        *****************
C        * IUPAC or NAME *
C        *****************
C
         TYPE(INDEX) = SVAREQ(1)(1:4)
      ELSEIF ( VARNUM(1) .EQ. 28 ) THEN
C
C        ************
C        * CHEMICAL *
C        ************
C
         IAC(INDEX) = SVAREQ(1)(1:4)
C set type-based parameter update flags each time when invoking
C this vector statement
      UPBOND=.TRUE.
      UPANGL=.TRUE.
      UPDIHE=.TRUE.
      UPIMPR=.TRUE.
      UPNBLK=.TRUE.
C
      ELSEIF ( VARNUM(1) .EQ. 50 ) THEN
C
C        ********
C        * RMSD *
C        ********
C
         RMSD(INDEX) = RVAREQ(1)
      ELSEIF ( VARNUM(1) .GE. 30 .AND. VARNUM(1) .LE. 38 ) THEN
C
C        *********************
C        * STORE# or RECALL# *
C        *********************
C
         IST = VARNUM(1) - 29
         CALL PUTSTO(RVAREQ(1),INDEX,IST,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 51 ) THEN
C
C        *********************
C        SCATTER_A1
C        *********************
C
         CALL PUTSCA('A1','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 52 ) THEN
C
C        *********************
C        SCATTER_A2
C        *********************
C
         CALL PUTSCA('A2','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 53 ) THEN
C
C        *********************
C        SCATTER_A3
C        *********************
C
         CALL PUTSCA('A3','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 54 ) THEN
C
C        *********************
C        SCATTER_A4
C        *********************
C
         CALL PUTSCA('A4','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 55 ) THEN
C
C        *********************
C        SCATTER_B1
C        *********************
C
         CALL PUTSCA('B1','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 56 ) THEN
C
C        *********************
C        SCATTER_B2
C        *********************
C
         CALL PUTSCA('B2','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 57 ) THEN
C
C        *********************
C        SCATTER_B3
C        *********************
C
         CALL PUTSCA('B3','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 58 ) THEN
C
C        *********************
C        SCATTER_B4
C        *********************
C
         CALL PUTSCA('B4','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 59 ) THEN
C
C        *********************
C        SCATTER_FP
C        *********************
C
         CALL PUTSCA('FP','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 60 ) THEN
C
C        *********************
C        SCATTER_FDP
C        *********************
C
         CALL PUTSCA('FDP','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 61 ) THEN
C
C        *********************
C        SCATTER_C
C        *********************
C
         CALL PUTSCA('C','PUT',RVAREQ(1),INDEX,XRERR)
      ELSEIF ( VARNUM(1) .EQ. 68 ) THEN
C
C        *********
C        * ALTID *
C        *********
C
         ALTID(INDEX) = SVAREQ(1)(1:1)
      ELSEIF ( VARNUM(1) .EQ. 69 ) THEN
C
C        **************************
C        ZHARMONIC 
C        **************************
C
         KZCNSTR(INDEX)  = RVAREQ(1)
      ENDIF
C
      RETURN
      END
C
      SUBROUTINE PUTSCA(OP,MODE,R,INDEX,XRERR)
C
C Routine stores value R scatter array at index INDEX.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'xcrystal.inc'
      INCLUDE 'xtarget.inc'
C I/O
      CHARACTER*(*) OP, MODE
      DOUBLE PRECISION R
      INTEGER INDEX
      LOGICAL XRERR
C begin
C
      IF (HPATOF.EQ.0.OR.XRNATF.EQ.0) THEN
      CALL DSPERR ( 'PUTSCA',
     & 'SCATTer database undefined.' )
      XRERR = .TRUE.
      ELSE
      CALL PUTSC2(OP,MODE,R,INDEX,XRERR,XRNATF,HEAP(HPATOF),
     &            HEAP(HPINDF),XRSM,XRSA,XRSB,XRSC,XRFP,XRFDP)
      END IF
      RETURN
      END
C===========================================================
      SUBROUTINE PUTSC2(OP,MODE,R,INDEX,XRERR,XRNATF,XRATOF,
     &                  XRINDF,XRSM,XRSA,XRSB,XRSC,XRFP,XRFDP)
C
C Routine stores/recalls value R scatter array at index INDEX.
C
C Warning: only minimal checking is done to make sure that the
C selection is compatible with the SCATTer definition.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
C I/O
      CHARACTER*(*) OP, MODE
      DOUBLE PRECISION R
      INTEGER INDEX
      LOGICAL XRERR
      INTEGER XRNATF, XRATOF(*), XRINDF(*)
      INTEGER XRSM
      DOUBLE PRECISION XRSA(XRSM,4), XRSB(XRSM,4), XRSC(XRSM)
      DOUBLE PRECISION XRFP(XRSM), XRFDP(XRSM)
C local
      INTEGER IAT, IINDEX
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
C
C we need to lookup INDEX
      IINDEX=0
      DO IAT=1,XRNATF
      IF (XRATOF(IAT).EQ.INDEX) IINDEX=IAT
      END DO
C
      IF ( IINDEX.EQ.0 ) THEN
      IF (MODE.EQ.'PUT') THEN
C
C in PUT mode print error message
      CALL DSPERR ( 'PUTSCA',
     & 'Selection is incompatible with SCATter definition.' )
      XRERR = .TRUE.
      ELSE
C
C in GET mode assign R to zero
      R=ZERO
      END IF
      ELSE
C
      IF (MODE.EQ.'PUT') THEN
C
      IF (OP.EQ.'A1') THEN
      XRSA(XRINDF(IINDEX),1)=R
      ELSEIF (OP.EQ.'A2') THEN
      XRSA(XRINDF(IINDEX),2)=R
      ELSEIF (OP.EQ.'A3') THEN
      XRSA(XRINDF(IINDEX),3)=R
      ELSEIF (OP.EQ.'A4') THEN
      XRSA(XRINDF(IINDEX),4)=R
      ELSEIF (OP.EQ.'B1') THEN
      XRSB(XRINDF(IINDEX),1)=R
      ELSEIF (OP.EQ.'B2') THEN
      XRSB(XRINDF(IINDEX),2)=R
      ELSEIF (OP.EQ.'B3') THEN
      XRSB(XRINDF(IINDEX),3)=R
      ELSEIF (OP.EQ.'B4') THEN
      XRSB(XRINDF(IINDEX),4)=R
      ELSEIF (OP.EQ.'C') THEN
      XRSC(XRINDF(IINDEX))=R
      ELSEIF (OP.EQ.'FP') THEN
      XRFP(XRINDF(IINDEX))=R
      ELSEIF (OP.EQ.'FDP') THEN
      XRFDP(XRINDF(IINDEX))=R
      END IF
C
      ELSEIF (MODE.EQ.'GET') THEN
C
      IF (OP.EQ.'A1') THEN
      R=XRSA(XRINDF(IINDEX),1)
      ELSEIF (OP.EQ.'A2') THEN
      R=XRSA(XRINDF(IINDEX),2)
      ELSEIF (OP.EQ.'A3') THEN
      R=XRSA(XRINDF(IINDEX),3)
      ELSEIF (OP.EQ.'A4') THEN
      R=XRSA(XRINDF(IINDEX),4)
      ELSEIF (OP.EQ.'B1') THEN
      R=XRSB(XRINDF(IINDEX),1)
      ELSEIF (OP.EQ.'B2') THEN
      R=XRSB(XRINDF(IINDEX),2)
      ELSEIF (OP.EQ.'B3') THEN
      R=XRSB(XRINDF(IINDEX),3)
      ELSEIF (OP.EQ.'B4') THEN
      R=XRSB(XRINDF(IINDEX),4)
      ELSEIF (OP.EQ.'C') THEN
      R=XRSC(XRINDF(IINDEX))
      ELSEIF (OP.EQ.'FP') THEN
      R=XRFP(XRINDF(IINDEX))
      ELSEIF (OP.EQ.'FDP') THEN
      R=XRFDP(XRINDF(IINDEX))
      END IF
C
      END IF
C
      END IF
C
      RETURN
      END
C
      SUBROUTINE PUTSTO(R,INDEX,IST,XRERR)
C
C Routine stores value R into store IST at index INDEX.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
C I/O
      DOUBLE PRECISION R
      INTEGER INDEX, IST
      LOGICAL XRERR
C begin
      IF ( IST .LT. 1 .OR. IST .GT. 9 ) THEN
      CALL DSPERR ( 'PUTSTO','STORE non-existent' )
      XRERR = .TRUE.
      ELSEIF ( PTRSTO(IST) .EQ. 0 ) THEN
      CALL DSPERR ( 'PUTSTO','STORE pointer Corruption' )
      XRERR = .TRUE.
      ELSE
      CALL PUTST2(R,HEAP(PTRSTO(IST)),INDEX)
      ENDIF
      RETURN
      END
C
      SUBROUTINE PUTST2(R,STORE,INDEX)
C
C See routine PUTSTO above
C
      IMPLICIT NONE
C I/O
      DOUBLE PRECISION R, STORE(*)
      INTEGER INDEX
C begin
      STORE(INDEX)=R
      RETURN
      END
C
      SUBROUTINE GETSTO(R,INDEX,IST,XRERR)
C
C Routine puts value of store IST at index INDEX into R.
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'vector.inc'
C I/O
      DOUBLE PRECISION R
      INTEGER INDEX, IST
      LOGICAL XRERR
C begin
      IF ( IST .LT. 1 .OR. IST .GT. 9 ) THEN
      CALL DSPERR ( 'PUTSTO','STORE non-existent' )
      XRERR = .TRUE.
      ELSEIF ( PTRSTO(IST) .EQ. 0 ) THEN
      CALL DSPERR ( 'PUTSTO','STORE pointer Corruption' )
      XRERR = .TRUE.
      ELSE
      CALL GETST2(R,HEAP(PTRSTO(IST)),INDEX)
      ENDIF
      RETURN
      END
C
      SUBROUTINE GETST2(R,STORE,INDEX)
C
C See routine PUTSTO above
C
      IMPLICIT NONE
C I/O
      DOUBLE PRECISION R, STORE(*)
      INTEGER INDEX
C begin
      R=STORE(INDEX)
      RETURN
      END
C
      SUBROUTINE SCDO
      IMPLICIT NONE
C
C     set aside some heap and call parsing routine for vector
C     do command
C
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'comand.inc'
C
C     local variables
C
      INTEGER FLAGS
C
C     get heap space, and call routine to parse vector expression
C
      CALL NEXTWD('DO>')
      IF ( WD(1:4) .EQ. 'HELP' ) THEN
         CALL CNSHELP('cns-do')
         CALL CNSHELP('atom-expression')
         CALL CNSHELP('atom-object')
         CALL CNSHELP('atom-selection')
         RETURN
      ELSE
         CALL SAVEWD
      ENDIF
C
      FLAGS=ALLHP(INTEG4(NATOM))
      CALL SCPARS(HEAP(FLAGS),X,Y,Z)
      CALL FREHP(FLAGS,INTEG4(NATOM))
      RETURN
      END
      SUBROUTINE SCHVAR( K, FOUND )
      IMPLICIT NONE
C
C     check to see if variable is valid, if so get type
C
      LOGICAL FOUND
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
      INTEGER I, J, K, LAST
C
      FOUND = .FALSE.
C
C     determine the last character in the variable name.
C     scan through the valid names; if the given name is
C     long enough to uniquely identify the valid name then
C     compare the two
C
C this 20 is okay, since the constants are only 20 chars - WLD 980105
      DO J = 1,20
         IF ( VAREQ(K)(J:J) .NE. ' ' ) LAST = J
      ENDDO
C
      DO I = 1,SCNUMV
         IF ( LAST .GE. VUNIQ(I) ) THEN
            IF ( VAREQ(K)(1:LAST) .EQ. VNAMES(I)(1:LAST) ) THEN
               VAREQ(K) = VNAMES(I)
               FOUND = .TRUE.
               VARTYP(K) = VTYP(I)
               VARNUM(K) = VNUM(I)
               RETURN
            ENDIF
         ENDIF
      ENDDO
C
      RETURN
      END
      SUBROUTINE SCIDE2(FLAGS,X,Y,Z)
      IMPLICIT NONE
C
C
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'vector.inc'
C
C     parameter declarations
C
      INTEGER FLAGS(*)
      DOUBLE PRECISION X(*), Y(*), Z(*)
C
C     local variable declarations
C
      INTEGER COUNT
      INTEGER NSELCT
      INTEGER INDEX
      CHARACTER*4 MODE
      LOGICAL XRERR
C
      XRERR = .FALSE.
      MODE = 'REAL'
C
C
C     parse the equation into the tables
C
      CALL NEXTWD('IDENt>')
      IF ( WD(1:4) .EQ. 'HELP' ) THEN
         CALL CNSHELP('cns-identity')
         CALL CNSHELP('atom-object')
         CALL CNSHELP('atom-selection')
         RETURN
      ELSE
         CALL SAVEWD
      ENDIF
C
      CALL HIER( MODE, XRERR )
      IF ( XRERR ) THEN
         CALL DSPERR('IDENTIFY>',
     &               'Expression error, IDEN not performed.')
         RETURN
      ENDIF
C
      CALL SELCTA(FLAGS,NSELCT,X,Y,Z,.TRUE.)
C
C     no error during parsing, so perform the calculation in four steps
C     for each reflection point:
C          a.  the storing of tables is not needed here because
C              the tables never get evaluated (and altered), but
C              this routine also allocates heap space for stores
C          b.  store actual array values in parse tables
C          d.  store the value derived from step b in the array
C
      COUNT=0
      DO INDEX = 1,NATOM
C
C        step a) store or obtain parsing tables, set aside heap
C
         CALL TABMGT( INDEX, XRERR )
         IF ( XRERR ) GOTO 999
C
C        step b) fill values in for variables
C
         IF ( FLAGS(INDEX) .EQ. 1 ) THEN
             COUNT=COUNT+1
CCC             RVAREQ(1) = COUNT  !ATB 4/27/94
             RVAREQ(1) = INDEX
         ELSE
             RVAREQ(1) = 0
         ENDIF
C
C        step d) assign the table result to the array on left hand side
C
         CALL SCASSN( INDEX, MODE, INDEX, XRERR )
         IF ( XRERR ) GOTO 999
      ENDDO
C
      RETURN
C
C     print out error message and return
C
999   CALL DSPERR('IDENTIFY>','Assignment aborted.')
      WRITE(6,*)' Starting with array index: ',
     &          INDEX
      RETURN
      END
C
      SUBROUTINE SCIDEN
      IMPLICIT NONE
C
C     set aside some heap, and call routine to process the vector
C     iden expression
C
C input/output
C
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
C
C     local variables
C
      INTEGER FLAGS
C
C     begin
C
      FLAGS=ALLHP(INTEG4(NATOM))
      CALL SCIDE2(HEAP(FLAGS),X,Y,Z)
      CALL FREHP(FLAGS,INTEG4(NATOM))
      RETURN
      END
      SUBROUTINE SCPARS(FLAGS,X,Y,Z)
      IMPLICIT NONE
C
C     routine to do a non-recursive parse
C     this routine expects to receive an expression in parens.
C     ex.   (variable1 = variable2 * variable 3)
C
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'vector.inc'
C
C     parameter declarations
C
      INTEGER FLAGS(*)
      DOUBLE PRECISION X(*), Y(*), Z(*)
C
C     local variable declarations
C
      INTEGER NSELCT, INDEX
      INTEGER REFLCT
      CHARACTER*4 MODE
      LOGICAL XRERR
C
      XRERR = .FALSE.
C
      MODE = 'REAL'
C
C     parse the equation into the tables
C
      CALL HIER( MODE, XRERR )
      IF ( XRERR ) THEN
         CALL DSPERR('DO>',
     &               'Expression error, Calculation not performed.')
         RETURN
      ENDIF
C
      CALL SELCTA(FLAGS,NSELCT,X,Y,Z,.TRUE.)
C
C     no error during parsing, so perform the calculation in four steps
C     for each reflection point:
C          a.  on first pass save the table values and if we are
C              going to assign to a storeN set aside the heap space
C              to perform the operation, on subsequent passes restore
C              the tables from the saved values.
C          b.  store actual array values in parse tables
C          c.  evaluate the parse table to obtain a value for
C              the right hand side of the equation
C          d.  store the value derived from step b in the array
C
      INDEX = 0
      DO REFLCT = 1,NATOM
        IF ( FLAGS(REFLCT) .EQ. 1 ) THEN
           INDEX = INDEX + 1
C
Ctabtrace       WRITE(19,'(1X,A,I3)')'REFLECTION POINT: ',REFLCT
C
C         step a) store or obtain parsing tables, set aside heap
C
          CALL TABMGT( INDEX, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step b) fill values in for variables
C
          CALL SCTBVL( MODE, REFLCT, INDEX, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step c) evaluate the table
C
          CALL EVALTB( MODE, REFLCT, INDEX, FLAGS, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step d) assign the table result to the array on left hand side
C
          CALL SCASSN( REFLCT, MODE, INDEX, XRERR )
          IF ( XRERR ) GOTO 999
        ENDIF
      ENDDO
      RETURN
C
C     print out error message and return
C
999   CALL DSPERR('SCPARS>','Assignment aborted.')
      WRITE(6,*)' Starting with array index: ', REFLCT
      RETURN
      END
      SUBROUTINE SCSHO2(FLAGS,X,Y,Z)
      IMPLICIT NONE
C
C     perform the show command
C
C
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'timer.inc'
      INCLUDE 'vector.inc'
C
C     parameter declarations
C
      INTEGER FLAGS(*)
      DOUBLE PRECISION X(*), Y(*), Z(*)
C
C     local variable declarations
C
      INTEGER NSELCT
      INTEGER I
      CHARACTER*4 SCMODE, MODE
      LOGICAL XRERR
      DOUBLE PRECISION A, A2
      INTEGER NCONF, STINDX
      DOUBLE COMPLEX DBCOMP
      DOUBLE PRECISION DBPREC
C
      XRERR = .FALSE.
      MODE = 'SHOW'
C
      CALL DECLAR( 'RESULT', 'ST', ' ', DBCOMP, DBPREC )
C
C     obtain optional show qualifier, default to element
C
      CALL NEXTWD('Show Qualifier=')
      IF ( WD(1:4) .EQ. '(   ' ) THEN
         SCMODE = 'ELEM'
         CALL SAVEWD
      ELSEIF ( WD(1:3) .EQ. 'SUM' .OR. WD(1:3) .EQ. 'MAX' .OR.
     &         WD(1:4) .EQ. 'ELEM' .OR. WD(1:3) .EQ. 'MIN' .OR.
     &         WD(1:3) .EQ. 'AVE' .OR. WD(1:4) .EQ. 'NORM' .OR.
     &         WD(1:3) .EQ. 'RMS' ) THEN
         SCMODE = WD(1:4)
      ELSEIF ( WD(1:4) .EQ. 'HELP' ) THEN
         CALL CNSHELP('cns-show')
         CALL CNSHELP('atom-object')
         CALL CNSHELP('atom-expression')
         CALL CNSHELP('atom-selection')
         RETURN
      ELSE
         CALL DSPERR('SHOW>','Illegal Qualifier.')
         RETURN
      ENDIF
C
C
C     parse the equation into the tables
C
      CALL HIER( MODE, XRERR)
      IF ( XRERR ) THEN
         CALL DSPERR('SHOW>',
     &               'Expression error, Show not performed.')
         RETURN
      ENDIF
C
      CALL SELCTA(FLAGS,NSELCT,X,Y,Z,.TRUE.)
C
C     no error during parsing, so perform the calculation in four steps
C     for each reflection point:
C          a.  on first pass save the table values, on subsequent
C              passes restore the tables from the saved values.
C          b.  store actual array values in parse tables
C          c.  evaluate the parse table to obtain a value for
C              the right hand side of the equation
C          d.  store the value derived from step b in the array
C
      STINDX = 0
      NCONF = 0
      DO I = 1,NATOM
        IF ( FLAGS(I) .EQ. 1 ) THEN
C
           STINDX = STINDX + 1
Ctabtrace       write(19,'(1x,a,i3)')'reflection point: ',I
C
C         step a) store or obtain parsing tables
C
          CALL TABMGT(  STINDX, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step b) fill values in for variables
C
          CALL SCTBVL( MODE, I, STINDX, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step c) evaluate the table
C
          CALL EVALTB( MODE, I, STINDX, FLAGS, XRERR )
          IF ( XRERR ) GOTO 999
C
C         step d) now have result of expression in _vareq(1)
C
          IF ( STINDX .EQ. 1 ) THEN
            IF ( VARTYP(1) .EQ. 'ST'  .AND. SCMODE.NE.'ELEM') THEN
              WRITE(6,'(3A)') ' SHOW: ',SCMODE,
     &            ' not valid for strings. Mode set to ELEM.'
              SCMODE='ELEM'
            END IF
          END IF
          IF ( SCMODE .EQ. 'ELEM' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                NCONF=0
             END IF
            IF (WRNLEV.GE.5) THEN
             IF ( VARTYP(1) .EQ. 'ST' ) THEN
              WRITE(6,1002) SEGID(I), RES(I),RESID(I),TYPE(I),
     &               SVAREQ(1)(1:4)
1002          FORMAT(' ( ',4(A,1X),')  ',A)
             ELSE
              WRITE(6,1000) SEGID(I), RES(I),RESID(I),TYPE(I),RVAREQ(1)
1000          FORMAT(' ( ',4(A,1X),')  ',G12.5)
             ENDIF
            END IF
            CALL DECLAR('RESULT',VARTYP(1),
     &           SVAREQ(1)(1:SVARLN(1)),CVAREQ(1),RVAREQ(1))
            NCONF=NCONF+1
          ELSEIF ( SCMODE(1:3) .EQ. 'SUM' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                DBPREC = 0.0D0
                NCONF=0
             END IF
             DBPREC = DBPREC + RVAREQ(1)
             NCONF  = NCONF  + 1
          ELSEIF ( SCMODE(1:3) .EQ. 'MAX' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                DBPREC = -R4BIG
                NCONF=0
             END IF
             IF ( DBPREC .LT. RVAREQ(1) ) DBPREC = RVAREQ(1)
             NCONF  = NCONF  + 1
          ELSEIF ( SCMODE(1:3) .EQ. 'MIN' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                DBPREC = R4BIG
                NCONF=0
             END IF
             IF ( DBPREC .GT. RVAREQ(1) ) DBPREC = RVAREQ(1)
             NCONF  = NCONF  + 1
          ELSEIF ( SCMODE(1:3) .EQ. 'AVE' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                DBPREC = 0.0D0
                NCONF  = 0
             ENDIF
             DBPREC = DBPREC + RVAREQ(1)
             NCONF  = NCONF  + 1
          ELSEIF ( SCMODE .EQ. 'NORM' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                DBPREC = 0.0D0
                NCONF  = 0
             ENDIF
             DBPREC = DBPREC + RVAREQ(1)**2
             NCONF = NCONF + 1
          ELSEIF ( SCMODE(1:3) .EQ. 'RMS' ) THEN
             IF ( STINDX .EQ. 1 ) THEN
                A      = 0.0D0
                A2 = 0.0D0
                NCONF  = 0
             ENDIF
             A = A + RVAREQ(1)
             A2 = A2 + RVAREQ(1)**2
             NCONF = NCONF + 1
          ENDIF
        ENDIF
      ENDDO
C
C     now output the results of all modes performed over a selection
C
      IF (NCONF.EQ.0) THEN
         IF (WRNLEV.GE.5) THEN
            WRITE(6,'(A)') ' SHOW: zero atoms selected'
         END IF
         XRERR = .TRUE.
         DBPREC = 0.0D0
         CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
      ELSE
         IF ( SCMODE(1:3) .EQ. 'SUM' ) THEN
           IF (WRNLEV.GE.5) THEN
           WRITE(6,9010)' SHOW: sum over selected elements = ',DBPREC
           END IF
9010       FORMAT ( A,F14.6 )
           CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ELSEIF ( SCMODE(1:3) .EQ. 'MAX' ) THEN
            IF (WRNLEV.GE.5) THEN
            WRITE(6,9010)' SHOW: maximum of selected elements = ',DBPREC
            END IF
            CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ELSEIF ( SCMODE(1:3) .EQ. 'MIN' ) THEN
            IF (WRNLEV.GE.5) THEN
            WRITE(6,9010)' SHOW: minimum of selected elements = ',DBPREC
            END IF
            CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ELSEIF ( SCMODE(1:3) .EQ. 'AVE' ) THEN
            DBPREC = DBPREC / NCONF
            IF (WRNLEV.GE.5) THEN
            WRITE(6,9010)' SHOW: average of selected elements = ',
     &                    DBPREC
            END IF
            CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ELSEIF ( SCMODE .EQ. 'NORM' ) THEN
            DBPREC = SQRT(DBPREC / NCONF)
            IF (WRNLEV.GE.5) THEN
            WRITE(6,9010)' SHOW: norm of selected elements = ',DBPREC
            END IF
            CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ELSEIF ( SCMODE(1:3) .EQ. 'RMS' ) THEN
             A = A / NCONF
             A2 = A2 / NCONF
             DBPREC=SQRT(A2-A**2)
      IF (WRNLEV.GE.5) THEN
      WRITE(6,'(A,F14.6)')
     &' SHOW: rms deviation from aver of selected elements = ',DBPREC
      END IF
            CALL DECLAR( 'RESULT', 'DP', ' ', DBCOMP, DBPREC )
         ENDIF
      ENDIF
      RETURN
C
C     print out error message and return
C
999   CALL DSPERR('SHOW>','Assignment aborted')
      WRITE(6,*)' Starting with array index: ', I
      RETURN
      END
C
      SUBROUTINE SCSHOW
      IMPLICIT NONE
C
C     set aside some heap, and call routine to process the
C     show expression
C
C input/output
C
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
C
C     local variables
C
      INTEGER FLAGS
C
C     begin
C
      FLAGS=ALLHP(INTEG4(NATOM))
      CALL SCSHO2(HEAP(FLAGS),X,Y,Z)
      CALL FREHP(FLAGS,INTEG4(NATOM))
      RETURN
      END
      SUBROUTINE SCTBVL( MODE, INDEX, STINDX, XRERR )
      IMPLICIT NONE
C
C     for each variable in the parse table there is a double
C     precision, a double complex, and a string  variable (the three
C     valid data types).  the variable type tells the computation
C     routines which one is being used. in this routine get the value
C     for this index (array element 'index') and store it in the proper
C     variable, correct the variable type to match the mode of
C     calculation if needed.
C
      INCLUDE 'cns.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'vector.inc'
C
      INTEGER INDEX, STINDX
      CHARACTER*4 MODE
      LOGICAL XRERR
      INTEGER I, IST
C
C
      XRERR = .FALSE.
C     start with 2nd location, first is on left hand side of equation
      DO I = 2,NUMOPS
         IF ( VARNUM(I) .EQ. 1 ) THEN
C
C           *******
C           *  B  *
C           *******
C
            RVAREQ(I) = WMAIN(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 2 ) THEN
C
C           *******
C           *  Q  *
C           *******
C
            RVAREQ(I) = QMAIN(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 3 ) THEN
C
C           *********
C           * BCOMP *
C           *********
C
            RVAREQ(I) = WCOMP(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 4 ) THEN
C
C           *********
C           * QCOMP *
C           *********
C
            RVAREQ(I) = QCOMP(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 5 ) THEN
C
C           **************************
C           * HARMONIC or CONSTRAINT *
C           **************************
C
            RVAREQ(I) = KCNSTR(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 6 ) THEN
C
C           ********
C           * MASS *
C           ********
C
            RVAREQ(I) = AMASS(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 7 ) THEN
C
C           **********
C           * CHARGE *
C           **********
C
            RVAREQ(I) = CG(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 8 ) THEN
C
C           *********
C           * FBETA *
C           *********
C
            RVAREQ(I) = FBETA(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 9 ) THEN
C
C           *******
C           *  X  *
C           *******
C
            RVAREQ(I) = X(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 10 ) THEN
C
C           *******
C           *  Y  *
C           *******
C
            RVAREQ(I) = Y(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 11 ) THEN
C
C           *******
C           *  Z  *
C           *******
C
            RVAREQ(I) = Z(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 12 ) THEN
C
C           *********
C           * XCOMP *
C           *********
C
            RVAREQ(I) = XCOMP(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 13 ) THEN
C
C           *********
C           * YCOMP *
C           *********
C
            RVAREQ(I) = YCOMP(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 14 ) THEN
C
C           *********
C           * ZCOMP *
C           *********
C
            RVAREQ(I) = ZCOMP(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 15 ) THEN
C
C           ********
C           *  DX  *
C           ********
C
            RVAREQ(I) = DX(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 16 ) THEN
C
C           ********
C           *  DY  *
C           ********
C
            RVAREQ(I) = DY(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 17 ) THEN
C
C           ********
C           *  DZ  *
C           ********
C
            RVAREQ(I) = DZ(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 18 ) THEN
C
C           ********
C           * REFX *
C           ********
C
            RVAREQ(I) = REFX(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 19 ) THEN
C
C           ********
C           * REFY *
C           ********
C
            RVAREQ(I) = REFY(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 20 ) THEN
C
C           ********
C           * REFZ *
C           ********
C
            RVAREQ(I) = REFZ(INDEX)
         ELSEIF ( VARNUM(I) .EQ. 21 ) THEN
C
C           ********
C           *  VX  *
C           ********
C
            RVAREQ(I) = XV(INDEX) / TIMFAC
         ELSEIF ( VARNUM(I) .EQ. 22 ) THEN
C
C           ********
C           *  VY  *
C           ********
C
            RVAREQ(I) = YV(INDEX) / TIMFAC
         ELSEIF ( VARNUM(I) .EQ. 23 ) THEN
C
C           ********
C           *  VZ  *
C           ********
C
            RVAREQ(I) = ZV(INDEX) / TIMFAC
         ELSEIF ( VARNUM(I) .EQ. 24 ) THEN
C
C           *********
C           * SEGID *
C           *********
C
            SVAREQ(I)(1:4) = SEGID(INDEX)
            SVARLN(I) = 4
            CALL TRIMM(SVAREQ(I),SVARLN(I))
         ELSEIF ( VARNUM(I) .EQ. 25 ) THEN
C
C           *********
C           * RESID *
C           *********
C
            SVAREQ(I)(1:4) = RESID(INDEX)
            SVARLN(I) = 4
            CALL TRIMM(SVAREQ(I),SVARLN(I))
         ELSEIF ( VARNUM(I) .EQ. 26 ) THEN
C
C           ***********
C           * RESNAME *
C           ***********
C
            SVAREQ(I)(1:4) = RES(INDEX)
            SVARLN(I) = 4
            CALL TRIMM(SVAREQ(I),SVARLN(I))
         ELSEIF ( VARNUM(I) .EQ. 27 ) THEN
C
C           *****************
C           * IUPAC or NAME *
C           *****************
C
            SVAREQ(I)(1:4) = TYPE(INDEX)
            SVARLN(I) = 4
            CALL TRIMM(SVAREQ(I),SVARLN(I))
         ELSEIF ( VARNUM(I) .EQ. 28 ) THEN
C
C           ************
C           * CHEMICAL *
C           ************
C
            SVAREQ(I)(1:4) = IAC(INDEX)
            SVARLN(I) = 4
            CALL TRIMM(SVAREQ(I),SVARLN(I))
         ELSEIF ( VARNUM(I) .EQ. 50 ) THEN
C
C           ********
C           * RMSD *
C           ********
C
            RVAREQ(I) = RMSD(INDEX)
          ELSEIF ( VARNUM(I) .EQ. 29 ) THEN
C
C           ********
C           * SHOW *
C           ********
C
            CALL DSPERR('SCTBVL>','Illegal use of SHOW')
            XRERR = .TRUE.
            RETURN
         ELSEIF ( VARNUM(I).GE. 30 .AND. VARNUM(I) .LE. 38 ) THEN
C
C           *********************
C           * STORE# or RECALL# *
C           *********************
C
            IST = VARNUM(I) - 29
            CALL GETSTO(RVAREQ(I),INDEX,IST,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 51 ) THEN
C
C           *********************
C           SCATTER_A1
C           *********************
C
            CALL PUTSCA('A1','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 52 ) THEN
C
C           *********************
C           SCATTER_A2
C           *********************
C
            CALL PUTSCA('A2','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 53 ) THEN
C
C           *********************
C           SCATTER_A3
C           *********************
C
            CALL PUTSCA('A3','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 54 ) THEN
C
C           *********************
C           SCATTER_A4
C           *********************
C
            CALL PUTSCA('A4','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 55 ) THEN
C
C           *********************
C           SCATTER_B1
C           *********************
C
            CALL PUTSCA('B1','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 56 ) THEN
C
C           *********************
C           SCATTER_B2
C           *********************
C
            CALL PUTSCA('B2','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 57 ) THEN
C
C           *********************
C           SCATTER_B3
C           *********************
C
            CALL PUTSCA('B3','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 58 ) THEN
C
C           *********************
C           SCATTER_B4
C           *********************
C
            CALL PUTSCA('B4','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 59 ) THEN
C
C           *********************
C           SCATTER_FP
C           *********************
C
            CALL PUTSCA('FP','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 60 ) THEN
C
C           *********************
C           SCATTER_FDP
C           *********************
C
            CALL PUTSCA('FDP','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 61 ) THEN
C
C           *********************
C           SCATTER_C
C           *********************
C
            CALL PUTSCA('C','GET',RVAREQ(I),INDEX,XRERR)
         ELSEIF ( VARNUM(I) .EQ. 68 ) THEN
C
C           *********
C           * ALTID *
C           *********
C
            SVAREQ(I)(1:4) = ALTID(INDEX)
            SVARLN(I) = 1
            CALL TRIMM(SVAREQ(I),SVARLN(I))
        ENDIF
      ENDDO
C
      RETURN
      END
C=================================================================
      SUBROUTINE TABMGT( STINDX, XRERR )
      IMPLICIT NONE
C
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'symbol.inc'
C
      LOGICAL XRERR
      INTEGER STINDX
      INTEGER I, IST
      INTEGER KVOP(MAXOPR)
      INTEGER KVRNUM(MAXOPR)
      CHARACTER*1 KTEO(MAXOPR)
      CHARACTER*2 KVRTYP(MAXOPR)
      CHARACTER*(VNAMLN) KVAREQ(MAXOPR)
      CHARACTER*4  KSVREQ(MAXOPR)
      INTEGER KSVRLN(MAXOPR)
      DOUBLE PRECISION KRVREQ(MAXOPR)
      DOUBLE COMPLEX   KCVREQ(MAXOPR)
      INTEGER KNMOPS
C
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C
      SAVE KVOP, KTEO, KVRTYP, KVAREQ, KRVREQ, KCVREQ,
     &     KNMOPS, KSVREQ, KVRNUM, KSVRLN
C
C
C     on first pass if the vareq to the left of the equals sign
C     is a storeN or recallN, then set aside the heap space if needed
C
      IF ( STINDX .EQ. 1 ) THEN
         IF ( VARNUM(1) .GE. 30 .AND. VARNUM(1) .LE. 38 ) THEN
C
C           check to see if we are modifying the contents of the store
C
            IST = VARNUM(1) - 29
C
C see whethter we have to allocate space of the STORE
              IF ( PTRSTO(IST).EQ.0. OR.
     &             (PTRSTO(IST).NE.0.AND.LENSTO(IST).NE.NATOM) ) THEN
                  IF (PTRSTO(IST).NE.0) THEN
                     CALL FREHP( PTRSTO(IST), IREAL8(LENSTO(IST)))
                  END IF
                  PTRSTO(IST) = ALLHP(IREAL8(NATOM))
                  LENSTO(IST) = NATOM
                  CALL FILLR8(HEAP(PTRSTO(IST)),NATOM,ZERO)
            ENDIF
         ENDIF
         KNMOPS = NUMOPS
      ELSE
         NUMOPS = KNMOPS
      ENDIF
C
      DO I = 1,MAXOPR
C
C        on first pass we haven't modified the table yet, so
C        save it to temp variables so we can use it for the
C        other reflection points
C
C *todo* should change this to be a real scratch area instead
C        of saving all of these variables
C
         IF ( STINDX .EQ. 1 ) THEN
            KVOP(I)    = VOP(I)
            KTEO(I)    = TEO(I)
            KVRTYP(I) = VARTYP(I)
            KVAREQ(I)  = VAREQ(I)
            KRVREQ(I) = RVAREQ(I)
            KCVREQ(I) = CVAREQ(I)
            KSVREQ(I) = SVAREQ(I)(1:4)
            KSVRLN(I) = SVARLN(I)
            KVRNUM(I) = VARNUM(I)
         ELSE
C
C           evaluating the table destroys it, so for every reflection
C           point after the first, restore the table from saved values
C
            VOP(I)    = KVOP(I)
            TEO(I)    = KTEO(I)
            VARTYP(I) = KVRTYP(I)
            VAREQ(I)  = KVAREQ(I)
            RVAREQ(I) = KRVREQ(I)
            CVAREQ(I) = KCVREQ(I)
            SVAREQ(I)(1:4) = KSVREQ(I)
            SVARLN(I) = KSVRLN(I)
            VARNUM(I) = KVRNUM(I)
         ENDIF
      ENDDO
      RETURN
      END
      SUBROUTINE TBPACK( K )
      IMPLICIT NONE
C
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
C
      INTEGER K, IJ
C
C     remove an entry from the parse tables
C
      NUMOPS = NUMOPS - 1
      IF ( K .NE. 1 ) THEN
         DO IJ = K,NUMOPS
            VAREQ(IJ) = VAREQ(IJ+1)
            VARTYP(IJ) = VARTYP(IJ+1)
            VOP(IJ) = VOP(IJ+1)
            TEO(IJ) = TEO(IJ+1)
            RVAREQ(IJ) = RVAREQ(IJ+1)
            CVAREQ(IJ) = CVAREQ(IJ+1)
            SVAREQ(IJ) = SVAREQ(IJ+1)
            SVARLN(IJ) = SVARLN(IJ+1)
         ENDDO
      ENDIF
      RETURN
      END
C
      SUBROUTINE VINIT
      IMPLICIT NONE
C
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
      INTEGER I
C
C     set values of variable names
C
      VNAMES(1) = 'B                   '
      VTYP(1)   = 'DP'
      VUNIQ(1)  = 1
      VNUM(1)   = 1
C
      VNAMES(2) = 'Q                   '
      VTYP(2)   = 'DP'
      VUNIQ(2)  = 1
      VNUM(2)   = 2
C
      VNAMES(3) = 'BCOMP               '
      VTYP(3)   = 'DP'
      VUNIQ(3)  = 4
      VNUM(3)   = 3
C
      VNAMES(4) = 'QCOMP               '
      VTYP(4)   = 'DP'
      VUNIQ(4)  = 4
      VNUM(4)   = 4
C
      VNAMES(5) = 'CONSTRAINT          '
      VTYP(5)   = 'DP'
      VUNIQ(5)  = 4
      VNUM(5)   = 5
C
      VNAMES(6) = 'HARMONIC            '
      VTYP(6)   = 'DP'
      VUNIQ(6)  = 4
      VNUM(6)   = 5
C
      VNAMES(7) = 'MASS                '
      VTYP(7)   = 'DP'
      VUNIQ(7)  = 4
      VNUM(7)   = 6
C
C
      VNAMES(8) = 'CHARGE              '
      VTYP(8)   = 'DP'
      VUNIQ(8)  = 4
      VNUM(8)   = 7
C
C
      VNAMES(9) = 'FBETA               '
      VTYP(9)   = 'DP'
      VUNIQ(9)  = 4
      VNUM(9)   = 8
C
C
      VNAMES(10)= 'X                   '
      VTYP(10)  = 'DP'
      VUNIQ(10) = 1
      VNUM(10)  = 9
C
C
      VNAMES(11)= 'Y                   '
      VTYP(11)  = 'DP'
      VUNIQ(11) = 1
      VNUM(11)  = 10
C
C
      VNAMES(12)= 'Z                   '
      VTYP(12)  = 'DP'
      VUNIQ(12) = 1
      VNUM(12)  = 11
C
C
      VNAMES(13)= 'XCOMP               '
      VTYP(13)  = 'DP'
      VUNIQ(13) = 4
      VNUM(13)  = 12
C
C
      VNAMES(14)= 'YCOMP               '
      VTYP(14)  = 'DP'
      VUNIQ(14) = 4
      VNUM(14)  = 13
C
C
      VNAMES(15)= 'ZCOMP               '
      VTYP(15)  = 'DP'
      VUNIQ(15) = 4
      VNUM(15)  = 14
C
C
      VNAMES(16)= 'DX                  '
      VTYP(16)  = 'DP'
      VUNIQ(16) = 2
      VNUM(16)  = 15
C
C
      VNAMES(17)= 'DY                  '
      VTYP(17)  = 'DP'
      VUNIQ(17) = 2
      VNUM(17)  = 16
C
C
      VNAMES(18)= 'DZ                  '
      VTYP(18)  = 'DP'
      VUNIQ(18) = 2
      VNUM(18)  = 17
C
C
      VNAMES(19)= 'REFX                '
      VTYP(19)  = 'DP'
      VUNIQ(19) = 4
      VNUM(19)  = 18
C
C
      VNAMES(20)= 'REFY                '
      VTYP(20)  = 'DP'
      VUNIQ(20) = 4
      VNUM(20)  = 19
C
C
      VNAMES(21)= 'REFZ                '
      VTYP(21)  = 'DP'
      VUNIQ(21) = 4
      VNUM(21)  = 20
C
C
      VNAMES(22)= 'VX                  '
      VTYP(22)  = 'DP'
      VUNIQ(22) = 2
      VNUM(22)  = 21
C
C
      VNAMES(23)= 'VY                  '
      VTYP(23)  = 'DP'
      VUNIQ(23) = 2
      VNUM(23)  = 22
C
C
      VNAMES(24)= 'VZ                  '
      VTYP(24)  = 'DP'
      VUNIQ(24) = 2
      VNUM(24)  = 23
C
C
      VNAMES(25)= 'SEGID               '
      VTYP(25)  = 'ST'
      VUNIQ(25) = 4
      VNUM(25)  = 24
C
C
      VNAMES(26)= 'RESID               '
      VTYP(26)  = 'ST'
      VUNIQ(26) = 4
      VNUM(26)  = 25
C
C
      VNAMES(27)= 'RESNAME             '
      VTYP(27)  = 'ST'
      VUNIQ(27) = 4
      VNUM(27)  = 26
C
      VNAMES(28)= 'IUPAC               '
      VTYP(28)  = 'ST'
      VUNIQ(28) = 4
      VNUM(28)  = 27
C
C
      VNAMES(29)= 'NAME                '
      VTYP(29)  = 'ST'
      VUNIQ(29) = 4
      VNUM(29)  = 27
C
C
      VNAMES(30)= 'CHEMICAL            '
      VTYP(30)  = 'ST'
      VUNIQ(30) = 4
      VNUM(30)  = 28
C
C
      VNAMES(31)= 'SHOW                '
      VTYP(31)  = 'VT'
      VUNIQ(31) = 4
      VNUM(31)  = 29
C
      VNAMES(32)= 'STORE1              '
      VTYP(32)  = 'DP'
      VUNIQ(32) = 6
      VNUM(32)  = 30
C
C
      VNAMES(33)= 'STORE2              '
      VTYP(33)  = 'DP'
      VUNIQ(33) = 6
      VNUM(33)  = 31
C
C
      VNAMES(34)= 'STORE3              '
      VTYP(34)  = 'DP'
      VUNIQ(34) = 6
      VNUM(34)  = 32
C
C
      VNAMES(35)= 'STORE4              '
      VTYP(35)  = 'DP'
      VUNIQ(35) = 6
      VNUM(35)  = 33
C
      VNAMES(36)= 'STORE5              '
      VTYP(36)  = 'DP'
      VUNIQ(36) = 6
      VNUM(36)  = 34
C
C
      VNAMES(37)= 'STORE6              '
      VTYP(37)  = 'DP'
      VUNIQ(37) = 6
      VNUM(37)  = 35
C
C
      VNAMES(38)= 'STORE7              '
      VTYP(38)  = 'DP'
      VUNIQ(38) = 6
      VNUM(38)  = 36
C
C
      VNAMES(39)= 'STORE8              '
      VTYP(39)  = 'DP'
      VUNIQ(39) = 6
      VNUM(39)  = 37
C
C
      VNAMES(40)= 'STORE9              '
      VTYP(40)  = 'DP'
      VUNIQ(40) = 6
      VNUM(40)  = 38
C
C
      VNAMES(41)= 'RECALL1             '
      VTYP(41)  = 'DP'
      VUNIQ(41) = 6
      VNUM(41)  = 30
C
C
      VNAMES(42)= 'RECALL2             '
      VTYP(42)  = 'DP'
      VUNIQ(42) = 6
      VNUM(42)  = 31
C
C
      VNAMES(43)= 'RECALL3             '
      VTYP(43)  = 'DP'
      VUNIQ(43) = 6
      VNUM(43)  = 32
C
C
      VNAMES(44)= 'RECALL4             '
      VTYP(44)  = 'DP'
      VUNIQ(44) = 6
      VNUM(44)  = 33
C
      VNAMES(45)= 'RECALL5             '
      VTYP(45)  = 'DP'
      VUNIQ(45) = 6
      VNUM(45)  = 34
C
C
      VNAMES(46)= 'RECALL6             '
      VTYP(46)  = 'DP'
      VUNIQ(46) = 6
      VNUM(46)  = 35
C
C
      VNAMES(47)= 'RECALL7             '
      VTYP(47)  = 'DP'
      VUNIQ(47) = 6
      VNUM(47)  = 36
C
C
      VNAMES(48)= 'RECALL8             '
      VTYP(48)  = 'DP'
      VUNIQ(48) = 6
      VNUM(48)  = 37
C
C
      VNAMES(49)= 'RECALL9             '
      VTYP(49)  = 'DP'
      VUNIQ(49) = 6
      VNUM(49)  = 38
C
      VNAMES(50)= 'RMSD                '
      VTYP(50)  = 'DP'
      VUNIQ(50) = 4
      VNUM(50)  = 50
C
      VNAMES(51)= 'SCATTER_A1          '
      VTYP(51)  = 'DP'
      VUNIQ(51) = 10
      VNUM(51)  = 51
C
      VNAMES(52)= 'SCATTER_A2          '
      VTYP(52)  = 'DP'
      VUNIQ(52) = 10
      VNUM(52)  = 52
C
      VNAMES(53)= 'SCATTER_A3          '
      VTYP(53)  = 'DP'
      VUNIQ(53) = 10
      VNUM(53)  = 53
C
      VNAMES(54)= 'SCATTER_A4          '
      VTYP(54)  = 'DP'
      VUNIQ(54) = 10
      VNUM(54)  = 54
C
      VNAMES(55)= 'SCATTER_B1          '
      VTYP(55)  = 'DP'
      VUNIQ(55) = 10
      VNUM(55)  = 55
C
      VNAMES(56)= 'SCATTER_B2          '
      VTYP(56)  = 'DP'
      VUNIQ(56) = 10
      VNUM(56)  = 56
C
      VNAMES(57)= 'SCATTER_B3          '
      VTYP(57)  = 'DP'
      VUNIQ(57) = 10
      VNUM(57)  = 57
C
      VNAMES(58)= 'SCATTER_B4          '
      VTYP(58)  = 'DP'
      VUNIQ(58) = 10
      VNUM(58)  = 58
C
      VNAMES(59)= 'SCATTER_FP          '
      VTYP(59)  = 'DP'
      VUNIQ(59) = 10
      VNUM(59)  = 59
C
      VNAMES(60)= 'SCATTER_FDP         '
      VTYP(60)  = 'DP'
      VUNIQ(60) = 11
      VNUM(60)  = 60
C
      VNAMES(61)= 'SCATTER_C           '
      VTYP(61)  = 'DP'
      VUNIQ(61) = 9
      VNUM(61)  = 61
C
      VNAMES(62)= 'NOE_DISTANCE        '
      VTYP(62)  = 'DP'
      VUNIQ(62) = 5
      VNUM(62)  = 62
C
      VNAMES(63)= 'NOE_LOWER-ERROR     '
      VTYP(63)  = 'DP'
      VUNIQ(63) = 5
      VNUM(63)  = 63
C
      VNAMES(64)= 'NOE_HIGHER-ERROR    '
      VTYP(64)  = 'DP'
      VUNIQ(64) = 5
      VNUM(64)  = 64
C
      VNAMES(65)= 'NOE_VOLUME          '
      VTYP(65)  = 'DP'
      VUNIQ(65) = 5
      VNUM(65)  = 65
C
      VNAMES(66)= 'NOE_WEIGHT          '
      VTYP(66)  = 'DP'
      VUNIQ(66) = 5
      VNUM(66)  = 66
C
      VNAMES(67)= 'NOE_TEST            '
      VTYP(67)  = 'DP'
      VUNIQ(67) = 5
      VNUM(67)  = 67
C
      VNAMES(68)= 'ALTID               '
      VTYP(68)  = 'ST'
      VUNIQ(68) = 4
      VNUM(68)  = 68
C
      VNAMES(69)= 'ZHARMONIC           '
      VTYP(69)  = 'DP'
      VUNIQ(69) = 4
      VNUM(69)  = 69
C
      SCNUMV = 69
C
C obsolete variable XRNUMV
      XRNUMV = 0
C
      DO I = 1,MAXOPR
         VOP(I) = 0
         TEO(I) = ' '
         VAREQ(I) = '                    '
         RVAREQ(I) = 0.0D0
         VARTYP(I) = '  '
         SVAREQ(I) = ' '
         SVARLN(I) = 0
         CVAREQ(I) = DCMPLX(0.0D0,0.0D0)
         VARNUM(I) = 0
      ENDDO
C
      RETURN
      END
C
      SUBROUTINE TBOUT
      IMPLICIT NONE
C
C     this routine is used as a debugging tool only
C
      INCLUDE 'cns.inc'
      INCLUDE 'vector.inc'
C
      INTEGER I
C
C
      WRITE(19,100)
100   FORMAT(1X,'    VOP TEO VAREQ    TYPE        REAL          COMP')
      DO I = 1,NUMOPS
      WRITE(19,'(1X,I2,2X,I3,2X,A1,2X,A8,2X,A2,2X,F14.5,2(F14.4))')
     &I,VOP(I),TEO(I),VAREQ(I),VARTYP(I),RVAREQ(I),CVAREQ(I)
      ENDDO
      RETURN
      END
      SUBROUTINE EVAL
      IMPLICIT NONE
C
C
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'funct.inc'
      INCLUDE 'symbol.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'timer.inc'
C
C     local variable declarations
C
      INTEGER IDUMMY(1), IL1
      CHARACTER*4 MODE
      LOGICAL XRERR
C
      XRERR = .FALSE.
      MODE = 'EVAL'
C
C     look for help request
C
      CALL NEXTWD('EVALUATE>')
      IF ( WD(1:4) .EQ. 'HELP' ) THEN
         CALL CNSHELP('cns-evaluate')
         RETURN
      ELSE
         CALL SAVEWD
      ENDIF
C
C     parse the equation into the tables
C
      CALL HIER( MODE, XRERR )
      IF ( XRERR ) THEN
         CALL DSPERR('EVALUATE>',
     &               'Expression error, EVALUATE not performed.')
         RETURN
      ENDIF
C
C     no error during parsing, so perform the evaluation
C
C     step a) evaluate the table
C
      CALL EVALTB( MODE, 1, 1, IDUMMY, XRERR )
      IF ( XRERR ) GOTO 999
C
C     step b) assign the value to the variable
C
      CALL LDECLAR( VAREQ(1)(2:VNAMLN), VARTYP(1),
     &            SVAREQ(1)(1:SVARLN(1)), CVAREQ(1), RVAREQ(1) )
C
      IF (WRNLEV.GE.5) THEN
C
C     echo the assignment
C
      IL1=VNAMLN
      CALL TRIMM(VAREQ(1),IL1)
      IF (VARTYP(1).EQ.'ST') THEN
      WRITE(6,'(5A)')
     &     ' EVALUATE: symbol ',VAREQ(1)(1:IL1),' set to "',
     &      SVAREQ(1)(1:SVARLN(1)),'" (string)'
      ELSE IF (VARTYP(1).EQ.'DP') THEN
      WRITE(6,'(3A,G14.6,A)')
     &     ' EVALUATE: symbol ',VAREQ(1)(1:IL1),' set to ',
     &      RVAREQ(1),' (real)'
      ELSE IF (VARTYP(1).EQ.'DC') THEN
      WRITE(6,'(3A,G14.6,A,G14.6,A)')
     &     ' EVALUATE: symbol ',VAREQ(1)(1:IL1),' set to (',
     &     DBLE(CVAREQ(1)),',',DIMAG(CVAREQ(1)),') (complex)'
      ELSEIF (VARTYP(1).EQ.'LO') THEN
      WRITE(6,'(5A)')
     &     ' EVALUATE: symbol ',VAREQ(1)(1:IL1),' set to ',
     &      SVAREQ(1)(1:SVARLN(1)),' (logical)'
      END IF
      END IF
C
      RETURN
C
C     print out error message and return
C
999   CALL DSPERR('EVALUATE>','EVALUATE assignment aborted.')
      RETURN
      END
C
C =================================================================
C

      SUBROUTINE CONNEC
C
C Determines connectivity of a specified set of atoms by
C making a recursive search on the chemical bond graph given by
C IB(i),JB(i),i=1,NBOND
C
C The total number of sets is stored in symbol $mset.  Each
C set is assigned a unique id (1,...,mset).
C The individual set ids are optionally stored in the specified
C atom object.
C The size of each set is stored in the specified atom object.
C
C Author: Axel T. Brunger
C =======================
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'funct.inc'
C local
      INTEGER MAXLEV
C parameter
      INTEGER IATBMX
      PARAMETER (IATBMX=12)
C pointer
      INTEGER NATBON, IATBON, SUBSET
      INTEGER LIST, VERTEX, IND, RETADR
      INTEGER ASETIDTO, ANSETTO
C begin
      MAXLEV=MAX(2,NBOND)
      NATBON=ALLHP(INTEG4(NATOM))
      IATBON=ALLHP(INTEG4(NATOM*IATBMX))
      SUBSET=ALLHP(INTEG4(NATOM))
      LIST=ALLHP(INTEG4(NATOM))
      VERTEX=ALLHP(INTEG4(MAXLEV))
      IND=ALLHP(INTEG4(MAXLEV))
      RETADR=ALLHP(INTEG4(MAXLEV))
      ASETIDTO=ALLHP(IREAL8(NATOM))
      ANSETTO=ALLHP(IREAL8(NATOM))
      CALL CONNE2(HEAP(NATBON),IATBMX,HEAP(IATBON),
     &             HEAP(SUBSET),HEAP(LIST),MAXLEV,
     &             HEAP(VERTEX),HEAP(IND),HEAP(RETADR),
     &             HEAP(ASETIDTO),HEAP(ANSETTO))
      CALL FREHP(ANSETTO,IREAL8(NATOM))
      CALL FREHP(ASETIDTO,IREAL8(NATOM))
      CALL FREHP(RETADR,INTEG4(MAXLEV))
      CALL FREHP(IND,INTEG4(MAXLEV))
      CALL FREHP(VERTEX,INTEG4(MAXLEV))
      CALL FREHP(LIST,INTEG4(NATOM))
      CALL FREHP(SUBSET,INTEG4(NATOM))
      CALL FREHP(IATBON,INTEG4(NATOM*IATBMX))
      CALL FREHP(NATBON,INTEG4(NATOM))
C
      RETURN
      END
C=====================================================================
      SUBROUTINE CONNE2(NATBON,IATBMX,IATBON,
     &                   SUBSET,LIST,MAXLEV,VERTEX,IND,RETADR,
     &                   ASETIDTO,ANSETTO)
C
C see CONNEC above
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C input/output
      INCLUDE 'cns.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'comand.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'funct.inc'
      INTEGER NATBON(*),IATBMX,IATBON(IATBMX,*)
      INTEGER SUBSET(*)
      INTEGER LIST(*), MAXLEV, VERTEX(*), IND(*), RETADR(*)
      DOUBLE PRECISION ASETIDTO(*), ANSETTO(*)
C local
      INTEGER  I, IBT, JBT, MSET, LEVEL, PASSED, NEXT, M
      INTEGER NSUBSE, SIZE
      LOGICAL QPRINT
      CHARACTER*4 SI, RI, RE, AT
      CHARACTER*(WDMAX) SETIDTO, NSETTO
      INTEGER LSETIDTO, LNSETTO
      DOUBLE PRECISION DBPREC
      DOUBLE COMPLEX DBCOMP
C parameter
      INTEGER MARK
      PARAMETER (MARK=-1)
C begin
C
C defaults
      CALL FILL4(SUBSET,NATOM,1)
      NSUBSE=NATOM
      QPRINT=.FALSE.
      SETIDTO=' '
      NSETTO=' '
C
C command parsing
      CALL PUSEND('CONNECT>')
      DO WHILE (.NOT.DONE)
      CALL NEXTWD('CONNECT>')
C
      IF (WD(1:4).EQ.'HELP') THEN
C
      CALL CNSHELP('cns-connectivity')
C
      ELSE IF (WD(1:4).EQ.'SELE') THEN
      CALL SELCTA(SUBSET,NSUBSE,X,Y,Z,.TRUE.)
      ELSE IF (WD(1:4).EQ.'PRIN') THEN
      CALL NEXTLO('PRINT=',QPRINT)
      ELSE IF (WD(1:WDLEN).EQ.'SETIDTO') THEN
      CALL NEXTST('SETIDTO=',WD)
      CALL COPYST(SETIDTO,WDMAX,LSETIDTO,WD,WDLEN)
      ELSE IF (WD(1:WDLEN).EQ.'NSETTO') THEN
      CALL NEXTST('NSETTO=',WD)
      CALL COPYST(NSETTO,WDMAX,LNSETTO,WD,WDLEN)
      ELSE
      CALL CHKEND('CONNECT>',DONE)
      END IF
      END DO
      DONE=.FALSE.
C
C first make list of all bonds of all atoms (vertices)
      DO I=1,NATOM
      NATBON(I)=0
      END DO
      DO I=1,NBOND
      IBT=IB(I)
      JBT=JB(I)
      NATBON(IBT)=NATBON(IBT)+1
      NATBON(JBT)=NATBON(JBT)+1
      IF (NATBON(IBT).GT.IATBMX.OR.NATBON(JBT).GT.IATBMX) THEN
      CALL WRNDIE(-1,'<CONNEC>','IATBMX exceeded')
      END IF
      IATBON(NATBON(JBT),JBT)=IBT
      IATBON(NATBON(IBT),IBT)=JBT
      END DO
C
C do search in bond graph
      DO I=1,NATOM
      LIST(I)=MARK
      END DO
      LEVEL=1
      MSET=0
      I=1
6363  IF ( .NOT. (I.LE.NATOM) ) GOTO 6364
      IF (.NOT.(LIST(I).EQ.MARK.AND.SUBSET(I).EQ.1))GOTO 6365
      MSET=MSET+1
C
C *invoke PROCEDURE SEARCH (PASSED:=VERTEX)
      PASSED=I
      RETADR(LEVEL)=1
      GOTO 2000
2001  CONTINUE
C *return address
C
C
6365  CONTINUE
      I=I+1
      GOTO 6363
6364  CONTINUE
      GOTO 2999
C
C---- PROCEDURE SEARCH ( CALL BY VALUE: PASSED->VERTEX ) --------------
C     LOCAL: IND
C *head
2000  CONTINUE
      LEVEL=LEVEL+1
      IF (LEVEL.GT.MAXLEV) CALL WRNDIE(-2,'<CONNE2>','MAXLEV exceeded')
      VERTEX(LEVEL)=PASSED
C
C *begin
      LIST(VERTEX(LEVEL))=MSET
C
C * *loop head: FOR { IND(LEVEL)=1,NATBON(VERTEX(LEVEL) }
      IND(LEVEL)=0
7711  CONTINUE
C * *loop iteration
      IND(LEVEL)=IND(LEVEL)+1
      IF (IND(LEVEL).GT.NATBON(VERTEX(LEVEL))) GOTO 7722
C * *loop begin
C
      NEXT=IATBON(IND(LEVEL),VERTEX(LEVEL))
      IF (LIST(NEXT).NE.-1.AND.LIST(NEXT).NE.MSET) THEN
      CALL WRNDIE(0,'<CONNE2>','check algorithm')
      END IF
CCCCC      IF (LIST(NEXT).EQ.MARK.AND.SUBSET(NEXT).EQ.1) THEN
      IF (.NOT.(LIST(NEXT).EQ.MARK.AND.SUBSET(NEXT).EQ.1))GOTO 3567
C
C * * *invoke procedure SEARCH ( PASSED:=NEXT )
      PASSED=NEXT
      RETADR(LEVEL)=2
      GOTO 2000
2002  CONTINUE
C * * *return label
C
CCCCC     END IF
3567  CONTINUE
C
C * *end loop
      GOTO 7711
7722  CONTINUE
C * *exit loop
C
C *return to address
      LEVEL=LEVEL-1
      IF (LEVEL.LE.0) CALL WRNDIE(-1,'<CONNE2>','Level underflow')
      IF (RETADR(LEVEL).EQ.2) GOTO 2002
      IF (RETADR(LEVEL).EQ.1) GOTO 2001
      CALL WRNDIE(-2,'<CONNE2>','Unknown return address, check code')
C--END PROCEDURE SEARCH-----------------------------------------------
C
2999  CONTINUE
C
C summary statement
      WRITE(6,'(A,I6,A)')
     &' CONNECt: selected atoms form ',MSET,
     &' covalently disconnected set(s)'
C
C symbol
      DBPREC=MSET
      CALL DECLAR( 'MSET', 'DP', ' ', DBCOMP, DBPREC )
C
C extensive info
      IF (QPRINT) THEN
      DO M=1,MSET
      WRITE(6,'(A,I6,A)')
      WRITE(6,'(A,I6,A)') ' CONNECt: list of all atoms in set ',M
      DO I=1,NATOM
      IF (LIST(I).EQ.M) THEN
      CALL ATOMID(I,SI,RI,RE,AT)
      WRITE(6,'(11A)')
     & '        ','    ','  (',SI,' ',RI,' ',RE,' ',AT,')'
      END IF
      END DO
      END DO
      END IF
C
C fill atom object with set ids and set sizes if required
      IF (SETIDTO.NE.' '.OR.NSETTO.NE.' ') THEN
C
C initialize temporary arrays
      DO I=1,NATOM
      ASETIDTO(I)=0
      ANSETTO(I)=0
      END DO
C
C loop through all sets
      DO M=1,MSET
C
C determine size of set
      SIZE=0
      DO I=1,NATOM
      IF (LIST(I).EQ.M) THEN
      SIZE=SIZE+1
      END IF
      END DO
C
C set id is M and set size is SIZE.  Now fill the temporary arrays
      DO I=1,NATOM
      IF (LIST(I).EQ.M) THEN
      ASETIDTO(I)=M
      ANSETTO(I)=SIZE
      END IF
      END DO
C
      END DO
C
C now copy the temporary arrays into specified atom object
      IF (SETIDTO.NE.' ') THEN
      CALL CPATPR(SETIDTO,ASETIDTO)
      END IF
      IF (NSETTO.NE.' ') THEN
      CALL CPATPR(NSETTO,ANSETTO)
      END IF
      END IF
      RETURN
      END
C=====================================================================
      SUBROUTINE CPATPR(WD,ARRAY)
C
C routine copies array into specified atom object
C
C all atom objects are supported except the scatter_fp
C and scatter_fdp arrays
C
C Author: Axel T. Brunger
C
      IMPLICIT NONE
C I/O
      INCLUDE 'cns.inc'
      INCLUDE 'coord.inc'
      INCLUDE 'coordc.inc'
      INCLUDE 'cnst.inc'
      INCLUDE 'mtf.inc'
      INCLUDE 'vector.inc'
      INCLUDE 'deriv.inc'
      INCLUDE 'heap.inc'
      INCLUDE 'consta.inc'
      INCLUDE 'funct.inc'
      CHARACTER*(*) WD
      DOUBLE PRECISION ARRAY(*)
C local
      INTEGER I, II
C parameter
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
C begin
      IF (WD(1:4).EQ.'X   ') THEN
      CALL COPYR8(ARRAY,X,NATOM)
      ELSE IF (WD(1:4).EQ.'Y   ') THEN
      CALL COPYR8(ARRAY,Y,NATOM)
      ELSE IF (WD(1:4).EQ.'Z   ') THEN
      CALL COPYR8(ARRAY,Z,NATOM)
      ELSE IF (WD(1:4).EQ.'B   ') THEN
      CALL COPYR8(ARRAY,WMAIN,NATOM)
      ELSE IF (WD(1:4).EQ.'Q   ') THEN
      CALL COPYR8(ARRAY,QMAIN,NATOM)
      ELSE IF (WD(1:4).EQ.'XCOM') THEN
      CALL COPYR8(ARRAY,XCOMP,NATOM)
      ELSE IF (WD(1:4).EQ.'YCOM') THEN
      CALL COPYR8(ARRAY,YCOMP,NATOM)
      ELSE IF (WD(1:4).EQ.'ZCOM') THEN
      CALL COPYR8(ARRAY,ZCOMP,NATOM)
      ELSE IF (WD(1:4).EQ.'BCOM') THEN
      CALL COPYR8(ARRAY,WCOMP,NATOM)
      ELSE IF (WD(1:4).EQ.'QCOM') THEN
      CALL COPYR8(ARRAY,QCOMP,NATOM)
      ELSE IF (WD(1:4).EQ.'REFX') THEN
      CALL COPYR8(ARRAY,REFX,NATOM)
      ELSE IF (WD(1:4).EQ.'REFY') THEN
      CALL COPYR8(ARRAY,REFY,NATOM)
      ELSE IF (WD(1:4).EQ.'REFZ') THEN
      CALL COPYR8(ARRAY,REFZ,NATOM)
      ELSE IF (WD(1:4).EQ.'RMSD') THEN
      CALL COPYR8(ARRAY,RMSD,NATOM)
      ELSE IF (WD(1:4).EQ.'HARM') THEN
      CALL COPYR8(ARRAY,KCNSTR,NATOM)
      ELSE IF (WD(1:4).EQ.'ZHAR') THEN
      CALL COPYR8(ARRAY,KZCNSTR,NATOM)
      ELSE IF (WD(1:4).EQ.'MASS') THEN
      CALL COPYR8(ARRAY,AMASS,NATOM)
      ELSE IF (WD(1:4).EQ.'CHAR') THEN
      CALL COPYR8(ARRAY,CG,NATOM)
      ELSE IF (WD(1:4).EQ.'DX  ') THEN
      CALL COPYR8(ARRAY,DX,NATOM)
      ELSE IF (WD(1:4).EQ.'DY  ') THEN
      CALL COPYR8(ARRAY,DY,NATOM)
      ELSE IF (WD(1:4).EQ.'DZ  ') THEN
      CALL COPYR8(ARRAY,DZ,NATOM)
C
      ELSE IF (WD(1:4).EQ.'VX  ') THEN
      DO I=1,NATOM
      XV(I)=XV(I)/TIMFAC
      END DO
      CALL COPYR8(ARRAY,XV,NATOM)
      DO I=1,NATOM
      XV(I)=XV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'VY  ') THEN
      DO I=1,NATOM
      YV(I)=YV(I)/TIMFAC
      END DO
      CALL COPYR8(ARRAY,YV,NATOM)
      DO I=1,NATOM
      YV(I)=YV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'VZ  ') THEN
      DO I=1,NATOM
      ZV(I)=ZV(I)/TIMFAC
      END DO
      CALL COPYR8(ARRAY,ZV,NATOM)
      DO I=1,NATOM
      ZV(I)=ZV(I)*TIMFAC
      END DO
      ELSE IF (WD(1:4).EQ.'FBET') THEN
      CALL COPYR8(ARRAY,FBETA,NATOM)
C
      ELSE IF (WD(1:5).EQ.'STORE') THEN
      IF (WD(6:6).EQ.'1') THEN
      II=1
      ELSEIF (WD(6:6).EQ.'2') THEN
      II=2
      ELSEIF (WD(6:6).EQ.'3') THEN
      II=3
      ELSEIF (WD(6:6).EQ.'4') THEN
      II=4
      ELSEIF (WD(6:6).EQ.'5') THEN
      II=5
      ELSEIF (WD(6:6).EQ.'6') THEN
      II=6
      ELSEIF (WD(6:6).EQ.'7') THEN
      II=7
      ELSEIF (WD(6:6).EQ.'8') THEN
      II=8
      ELSEIF (WD(6:6).EQ.'9') THEN
      II=9
      ELSE
      CALL DSPERR('CPATPR',' invalid atom object for this command')
      END IF
C
      IF ( PTRSTO(II).EQ.0) THEN
      PTRSTO(II) = ALLHP(IREAL8(NATOM))
      LENSTO(II) = NATOM
      CALL FILLR8(HEAP(PTRSTO(II)),NATOM,ZERO)
      ENDIF
      CALL COPYR8(ARRAY,HEAP(PTRSTO(II)),NATOM)
C
      ELSE
      CALL DSPERR('CPATPR',' invalid atom object for this command')
      END IF
      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE EXANGLES (EANGLES, WHICH)
C     ------------------------------------------------------------------
C     Calls EXANGLES2, which does the actual energy calculation
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "heap.inc"
      INCLUDE  "xangle.inc"

      DOUBLE PRECISION EANGLES
      CHARACTER*7 WHICH

      CALL EXANGLES2(EANGLES,HEAP(XANGLESJPTR),HEAP(XANGLESKPTR),
     &                       HEAP(XANGLESJLST),HEAP(XANGLESKLST),
     &                       HEAP(XANGLESOBS1PTR),HEAP(XANGLESOBS2PTR),
     &                       HEAP(XANGLESERRPTR),
     &                       HEAP(CALCXANGLESPTR),WHICH)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE EXANGLES2 (EANGLES,ATOMJPTR,ATOMKPTR,ATOMJLST,ATOMKLST,
     &                      XANGLESOBS1,XANGLESOBS2,XANGLESERR,
     &                      XANGLESCALC,WHICH)
C     ------------------------------------------------------------------
C     Calculates RDC-ANGLES energies
C
C     Energies are of the form:
C        E = K1*(SIN(ANG)**2)
C     where:
C        K1 = Force constant, 
C        ANG = The angle between the target vector and the actual vector
C
C     Note that: 
C        Atom J = Detected nucleus (e.g. H)
C        Atom K = Coupled nucleus (e.g. N)
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE


      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xangle.inc"
      INCLUDE  "consta.inc"

      INTEGER ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMJLST(*),ATOMKLST(*)
      DOUBLE PRECISION XANGLESOBS1(*),XANGLESOBS2(*),XANGLESERR(*)
      DOUBLE PRECISION XANGLESCALC(*),EANGLES
      CHARACTER*7 WHICH
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER COUNT,CLASS,MM,NN,II,I,J,K,L,NA,M,N
      PARAMETER (NA=20)
      INTEGER DMM,DNN,OUTFLAG(NA),MCOUNT,NCOUNT,PCOUNT
      DOUBLE PRECISION XJ,XK,YJ,YK,ZJ,ZK,CALCXANGLES,E,
     &                 DFXJ(NA),DFYJ(NA),DFZJ(NA),
     &                 DFXK(NA),DFYK(NA),DFZK(NA),DF1,
     &                 O1,O2,O3,O4,O5,O6,O7,O8,O9,O10,O11,O12,
     &                 PS,DJK,DJK2,DJK3
      DOUBLE PRECISION OBSXANGLES1,OBSXANGLES2,ERRXANGLES,K1,
     &                 A,B,
     &                 DT,DP,DELTA,DELTAXANGLES,
     &                 DD
C     ------------------------------------------------------------------
C     Zero out partial energy
C     ------------------------------------------------------------------
      EANGLES = ZERO

      CLASS = 1
      K1=XANGLESFORCES(1)

      COUNT=0

      DO WHILE(COUNT.LT.ANGLESNUM)
         COUNT = COUNT+1
C     ------------------------------------------------------------------
C     Reset individual E to zero
C     ------------------------------------------------------------------
         E=0

         DO WHILE ((XANGLESASSNDX(CLASS).LT.COUNT).OR.
     &             (XANGLESASSNDX(CLASS).EQ.0))
                    CLASS=CLASS+1
         END DO

         IF (XANGLESASSNDX(CLASS).EQ.XANGLESASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         K1=XANGLESFORCES(CLASS)
C     ------------------------------------------------------------------
C     Note there should only be one atom for J and K
C     ------------------------------------------------------------------
         J=ATOMJPTR(COUNT)+1
         K=ATOMKPTR(COUNT)+1

         XJ=X(ATOMJLST(J))
         XK=X(ATOMKLST(K))
         YJ=Y(ATOMJLST(J))
         YK=Y(ATOMKLST(K))
         ZJ=Z(ATOMJLST(J))
         ZK=Z(ATOMKLST(K))

         OBSXANGLES1=XANGLESOBS1(COUNT)
         OBSXANGLES2=XANGLESOBS2(COUNT)
         ERRXANGLES=XANGLESERR(COUNT)
C     ------------------------------------------------------------------
C     Initialize calculated RDC-angles and counter
C     ------------------------------------------------------------------
         CALCXANGLES=0
         II=0
         MCOUNT=0
         NCOUNT=0
C     ------------------------------------------------------------------
C     Check for correct permutations of paired atoms to get the nucleus-
C     nucleus vector. This depends solely on the order of the assigned
C     atoms. OUTFLAG=1 indicates that the permutation is not allowed.
C     ------------------------------------------------------------------
         DMM=ATOMJPTR(COUNT+1)-ATOMJPTR(COUNT)
         DNN=ATOMKPTR(COUNT+1)-ATOMKPTR(COUNT)
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            MCOUNT=MCOUNT+1
            NCOUNT=0
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               NCOUNT=NCOUNT+1
               II=II+1
               IF ((DMM.GT.1).AND.(DNN.GT.1)) THEN
                    IF (MCOUNT.EQ.NCOUNT) THEN
                        OUTFLAG(II)=0
                    ELSE
                        OUTFLAG(II)=1
                    ENDIF
               ELSE
                    OUTFLAG(II)=0
               END IF
            END DO
         END DO

         II=0
         PCOUNT=0
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
C     ------------------------------------------------------------------
C     Calculate the function and its derivatives
C     ------------------------------------------------------------------
                   OBSXANGLES1=OBSXANGLES1*PI/180.
                   IF (OBSXANGLES1.LT.0.) OBSXANGLES1=OBSXANGLES1+2.*PI
                   OBSXANGLES2=OBSXANGLES2*PI/180.
                   IF (OBSXANGLES2.LT.0.) OBSXANGLES2=OBSXANGLES2+2.*PI

                   O1=SIN(OBSXANGLES1)*COS(OBSXANGLES2)
                   O2=SIN(OBSXANGLES1)*SIN(OBSXANGLES2)
                   O3=COS(OBSXANGLES1)
                   O4=XJ-XK
                   O5=YJ-YK
                   O6=ZJ-ZK
                   O7=O4**2
                   O8=O5**2
                   O9=O6**2
                   DJK2=O7+O8+O9
                   DJK=SQRT(DJK2)
                   DJK3=DJK**3
                   PS=O1*O4+O2*O5+O3*O6
                   O10=O1*DJK-PS*O4/DJK
                   O11=O2*DJK-PS*O5/DJK
                   O12=O3*DJK-PS*O6/DJK

                   DFXJ(II)=-2.*PS*O10/DJK3
                   DFYJ(II)=-2.*PS*O11/DJK3
                   DFZJ(II)=-2.*PS*O12/DJK3
                   DFXK(II)=-DFXJ(II)
                   DFYK(II)=-DFYJ(II)
                   DFZK(II)=-DFZJ(II)
C     ------------------------------------------------------------------
C     Calculate the cosine square of the angle
C     ------------------------------------------------------------------
                   CALCXANGLES=(PS/DJK)**2
               END IF
            END DO
         END DO

         IF (WHICH.EQ.'ANALYZE') THEN
             XANGLESCALC(COUNT)=CALCXANGLES
         END IF
C     ------------------------------------------------------------------
C     The deviation is the sine square of the angle
C     ------------------------------------------------------------------
         DELTA=(1.-CALCXANGLES)
C     ------------------------------------------------------------------
C     Adjust the deviation based on the error range (expressed as the
C     accepted deviation of the cosine square from 1)
C     ------------------------------------------------------------------
         IF ((DELTA.GT.0.000).AND.(DELTA.GT.ERRXANGLES)) THEN
              DELTAXANGLES=DELTA-ERRXANGLES
         ELSE
              DELTAXANGLES=0.0
         END IF

         DD=DELTAXANGLES

         II=0
         PCOUNT=0
         DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
            DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
               II=II+1
               IF (OUTFLAG(II).NE.1) THEN
                   PCOUNT=PCOUNT+1
                   IF (DD.EQ.0.0) THEN
                       E=E+0.0
                       DF1=0.0
                   ELSE
                       E=E+K1*DELTAXANGLES
                       DF1=K1
                   END IF
               END IF
            END DO
         END DO
C     ------------------------------------------------------------------
C     Accumulate energy
C     ------------------------------------------------------------------
         EANGLES=EANGLES+E
C     ------------------------------------------------------------------
C     Now update forces if in energy/force mode
C     ------------------------------------------------------------------
         IF (WHICH.NE.'ANALYZE') THEN
             II=0
             DO MM=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
                DO NN=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
                   II=II+1
                   IF (OUTFLAG(II).NE.1) THEN
                       DX(ATOMJLST(J))=DX(ATOMJLST(J))+DF1*DFXJ(II)
                       DY(ATOMJLST(J))=DY(ATOMJLST(J))+DF1*DFYJ(II)
                       DZ(ATOMJLST(J))=DZ(ATOMJLST(J))+DF1*DFZJ(II)
                       DX(ATOMKLST(K))=DX(ATOMKLST(K))+DF1*DFXK(II)
                       DY(ATOMKLST(K))=DY(ATOMKLST(K))+DF1*DFYK(II)
                       DZ(ATOMKLST(K))=DZ(ATOMKLST(K))+DF1*DFZK(II)
                   END IF
                END DO
             END DO
         END IF
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXANGLES
C     ------------------------------------------------------------------
C     Reads in RDC-ANGLES information
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "xangle.inc"
      INCLUDE  "funct.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "heap.inc"
      INCLUDE  "numbers.inc"

      INTEGER COUNT,SPTR,OLDCLASS,OLDMAXXANGLES
      DOUBLE PRECISION K1,CUTOFF
      CHARACTER*4 THENAME

      SPTR=ALLHP(INTEG4(NATOM))
      CALL PUSEND('XANGLE>')
862   CONTINUE
      CALL NEXTWD('XANGLE>')
      CALL MISCOM('XANGLE>',USED)
      IF (.NOT.USED) THEN
C     ------------------------------------------------------------------
C     Documentation
C     ------------------------------------------------------------------
          IF (WD(1:4).EQ.'HELP') THEN
              WRITE(DUNIT,'(10X,A)')
     &              ' XANGLE {<ANGLE-STATEMENT>} END ',
     &              ' <ANGLE-STATEMENT>:== ',
     &              ' ASSIGN <SEL> <SEL> <REAL> <REAL> <REAL>',
     &              ' * Restraint: Detected_nucleus Coupled_nucleus',
     &              ' Theta Phi Err *',
     &              ' CLASsification <NAME>',
     &              ' * Starts a new class *',
     &              ' FORCeconstant <REAL>',
     &              ' * Force constant for the current class *',
     &              ' NREStraints <INTEGER>',
     &              ' * Number of slots for restraints to allocate *',
     &              ' PRINt THREshold <REAL>',
     &              ' * Prints violations larger than the THREshold *',
     &              ' RESEt',
     &              ' * Erases the restraint table, but keeps NRES *'
C     ------------------------------------------------------------------
C     Get class name. Determine if it's an already-defined class.
C     Insert a new class if it's not.
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'CLAS') THEN
              OLDCLASS=CURCLASS
              CALL NEXTA4('Class name =',THENAME)
              MODE=NEW
              DO COUNT=1,NCLASSES
                 IF (XANGLESCLASSNAMES(COUNT).EQ.THENAME) THEN
                     MODE=UPDATE
                     CURCLASS=COUNT
                  END IF
              END DO
              IF (MODE.EQ.NEW) THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more than the maximum number of classes
C     ------------------------------------------------------------------
                  IF (OLDCLASS.EQ.MAXXANGLESCLASSES) THEN
                      CALL DSPERR('XANGLE','Too many classes.')
                      CALL DSPERR('XANGLE',
     &                     'Increase MAXXANGLESCLASSES and recompile.')
                      CALL WRNDIE(-5, 'READXANGLES',
     &                     'Too many RDC-angles classes.')
                   END IF
                   NCLASSES=NCLASSES+1
                   CURCLASS=NCLASSES
                   XANGLESCLASSNAMES(CURCLASS)=THENAME
C     ------------------------------------------------------------------
C     If this isn't the first class, close off the old class
C     ------------------------------------------------------------------
                   IF (NCLASSES.GT.1) THEN
                       XANGLESASSNDX(OLDCLASS)=ANGLESNUM
                   END IF
              END IF
C     ------------------------------------------------------------------
C     Set force constant for current class
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'FORC') THEN
C     ------------------------------------------------------------------
C     Start a default class if there isn't one defined
C     ------------------------------------------------------------------
              IF (CURCLASS.EQ.0) THEN
                  NCLASSES = 1
                  CURCLASS = 1
              END IF
              CALL NEXTF('Force constant =',K1)
              WRITE(DUNIT,'(A,A,A,F8.3)') 
     &              'Setting force constant for class ', 
     &              XANGLESCLASSNAMES(CURCLASS),' to ',K1
                    XANGLESFORCES(CURCLASS)=K1
C     ------------------------------------------------------------------
C     Reset RDC-angles database
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'RESE') THEN
               CALL XANGLESDEFAULTS
               CALL ALLOCXANGLES(0,MAXXANGLES)
C     ------------------------------------------------------------------
C     Change number of assignment slots
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'NRES') THEN
               OLDMAXXANGLES=MAXXANGLES
               CALL NEXTI('Number of slots =',MAXXANGLES)
               CALL ALLOCXANGLES(OLDMAXXANGLES,MAXXANGLES)
               WRITE(DUNIT,'(A,I8,A)')
     &            'XANGLE: Allocating space for',MAXXANGLES,
     &            'number of restraints.'
C     ------------------------------------------------------------------
C     Read in an assignment
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'ASSI') THEN
C     ------------------------------------------------------------------
C     Make sure you can't add more assignments than you have slots for
C     ------------------------------------------------------------------
               IF (XANGLESMX.EQ.MAXXANGLES) THEN
                   CALL DSPERR('XANGLE','Too many assignments.')
                   CALL DSPERR('XANGLE',
     &                         'Increasing NREStraints by 100.')
                   OLDMAXXANGLES=MAXXANGLES
                   MAXXANGLES=MAXXANGLES+100
                   CALL ALLOCXANGLES(OLDMAXXANGLES,MAXXANGLES)
               END IF
C     ------------------------------------------------------------------
C     If there isn't a class specified, start a default class
C     ------------------------------------------------------------------
               IF (CURCLASS.EQ.0) THEN
                   NCLASSES=1
                   CURCLASS=1
               END IF
               CALL READXANGLES2(HEAP(XANGLESJPTR),HEAP(XANGLESKPTR),
     &                           HEAP(XANGLESJLST),HEAP(XANGLESKLST),
     &                           HEAP(XANGLESOBS1PTR),
     &                           HEAP(XANGLESOBS2PTR),
     &                           HEAP(XANGLESERRPTR),HEAP(SPTR))
C     ------------------------------------------------------------------
C     Print violations
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'PRIN') THEN
               CALL NEXTWD('PRINT>')
               IF (WD(1:4).NE.'THRE') THEN
                   CALL DSPERR('XANGLE',
     &                  'PRINt expects THREshold parameter.')
               ELSE
                   CALL NEXTF('THREshold =',CUTOFF)
                   IF (CUTOFF.LT.ZERO) THEN
                       CALL DSPERR('XANGLE',
     &                             'Cutoff must be positive.')
                       CUTOFF = ABS(CUTOFF)
                   END IF
                   CALL NEXTA4('ALL OR CLASs>',THENAME)
                   IF (THENAME(1:3).EQ.'ALL') THEN
                       DO COUNT=1,NCLASSES
                          PRINTCLASS(COUNT)=.TRUE.
                       END DO
                   ELSE IF (THENAME(1:4).EQ.'CLAS') THEN
                       CALL NEXTA4('CLASS NAME =',THENAME)
                       DO COUNT=1,NCLASSES
                          IF (XANGLESCLASSNAMES(COUNT).EQ.THENAME) THEN
                              PRINTCLASS(COUNT)=.TRUE.
                          ELSE
                              PRINTCLASS(COUNT)=.FALSE.
                          END IF
                       END DO
                    ELSE
                       DO COUNT=1,NCLASSES
                          PRINTCLASS(COUNT)=.TRUE.
                       END DO
                    END IF
                    CALL PRINTXANGLES(CUTOFF,HEAP(CALCXANGLESPTR),
     &                                HEAP(XANGLESOBS1PTR),
     &                                HEAP(XANGLESOBS2PTR),
     &                                HEAP(XANGLESERRPTR),
     &                                HEAP(XANGLESJPTR),
     &                                HEAP(XANGLESKPTR),
     &                                HEAP(XANGLESJLST),
     &                                HEAP(XANGLESKLST))
               END IF
C     ------------------------------------------------------------------
C     Check for END statement
C     ------------------------------------------------------------------
          ELSE
              CALL CHKEND('XANGLE>', DONE)
          END IF
      END IF
      IF (.NOT.(DONE)) GOTO 862
      DONE=.FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE ALLOCXANGLES (OLDSIZE, NEWSIZE)
C     ------------------------------------------------------------------
C     Resets RDC-angles arrays to hold size entries
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "funct.inc"
      INCLUDE  "xangle.inc"

      INTEGER OLDSIZE,NEWSIZE

      IF (OLDSIZE.NE.0) THEN
           CALL FREHP(XANGLESJPTR,INTEG4(OLDSIZE))
           CALL FREHP(XANGLESKPTR,INTEG4(OLDSIZE))

           CALL FREHP(XANGLESJLST,INTEG4(OLDSIZE))
           CALL FREHP(XANGLESKLST,INTEG4(OLDSIZE))

           CALL FREHP(XANGLESOBS1PTR,IREAL8(OLDSIZE))
           CALL FREHP(XANGLESOBS2PTR,IREAL8(OLDSIZE))
           CALL FREHP(XANGLESERRPTR,IREAL8(OLDSIZE))
           CALL FREHP(CALCXANGLESPTR,IREAL8(OLDSIZE))
      END IF

      XANGLESJPTR=ALLHP(INTEG4(NEWSIZE))
      XANGLESKPTR=ALLHP(INTEG4(NEWSIZE))

      XANGLESJLST=ALLHP(INTEG4(NEWSIZE))
      XANGLESKLST=ALLHP(INTEG4(NEWSIZE))

      XANGLESOBS1PTR=ALLHP(IREAL8(NEWSIZE))
      XANGLESOBS2PTR=ALLHP(IREAL8(NEWSIZE))
      XANGLESERRPTR=ALLHP(IREAL8(NEWSIZE))
      CALCXANGLESPTR=ALLHP(IREAL8(NEWSIZE))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XANGLESDEFAULTS
C     ------------------------------------------------------------------
C     Sets up defaults
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xangle.inc"

      INTEGER COUNT

      MODE=NEW
      MAXXANGLES=200
      XANGLESMX=200
      ANGLESNUM=0
      NCLASSES=0
      CURCLASS=0
      DO COUNT=1,MAXXANGLESCLASSES
           XANGLESCLASSNAMES(COUNT)='DEFAULT'
           XANGLESASSNDX(COUNT)=0
           XANGLESFORCES(COUNT)=5.0
      END DO

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE READXANGLES2(ATOMJPTR,ATOMKPTR,ATOMJLST,ATOMKLST,
     &                        XANGLESOBS1,XANGLESOBS2,XANGLESERR,SEL)
C     ------------------------------------------------------------------
C     Reads actual RDC-angles assignments into arrays
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "xangle.inc"

      INTEGER ATOMJPTR(*),ATOMKPTR(*),ATOMJLST(*),ATOMKLST(*),SEL(*)
      INTEGER JTMP,KTMP,LTMP,II
      DOUBLE PRECISION XANGLESOBS1(*),XANGLESOBS2(*),XANGLESERR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      INTEGER NSEL,INSERTPOS,COUNT,CURSTOP,OTHERSTOP,NFLAG
      INTEGER I
      DOUBLE PRECISION XANGLESO1,XANGLESO2,XANGLESE
C     ------------------------------------------------------------------
C     If we're in UPDATE mode, make a space for the new line
C     ------------------------------------------------------------------
      NFLAG = 0
      IF (MODE.EQ.UPDATE) THEN
          DO COUNT=ANGLESNUM+1,XANGLESASSNDX(CURCLASS)+1,-1
             ATOMJPTR(COUNT)=ATOMJPTR(COUNT-1)
             ATOMKPTR(COUNT)=ATOMKPTR(COUNT-1)
             XANGLESOBS1(COUNT)=XANGLESOBS1(COUNT-1)
             XANGLESOBS2(COUNT)=XANGLESOBS2(COUNT-1)
             XANGLESERR(COUNT)=XANGLESERR(COUNT-1)
           END DO
           CURSTOP=XANGLESASSNDX(CURCLASS)
           DO COUNT=1,NCLASSES
                OTHERSTOP=XANGLESASSNDX(COUNT)
                IF (OTHERSTOP.GT.CURSTOP) THEN
                     XANGLESASSNDX(COUNT)=OTHERSTOP+1
                END IF
           END DO
           XANGLESASSNDX(CURCLASS)=CURSTOP+1
           INSERTPOS=CURSTOP
           ANGLESNUM=ANGLESNUM + 1
      ELSE
           ANGLESNUM=ANGLESNUM + 1
           INSERTPOS=ANGLESNUM
           XANGLESASSNDX(CURCLASS)=INSERTPOS
      END IF
C     ------------------------------------------------------------------
C     Reading in the atom selection in the constraint table
C     ------------------------------------------------------------------
      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN 
          CALL DSPERR('XANGLE',
     &                'More than 1 atom in SEL for atom J. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XANGLE','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL, NATOM, NSEL) 
      IF (INSERTPOS.EQ.1) ATOMJPTR(INSERTPOS)=0
      II=ATOMJPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XANGLESMX) XANGLESMX=II
      ATOMJLST(II)=SEL(1)
      ATOMJPTR(INSERTPOS+1)=II

      CALL SELCTA(SEL,NSEL,X,Y,Z,.TRUE.)
      IF (NSEL.GT.1) THEN 
          CALL DSPERR('XANGLE',
     &                'More than 1 atom in SEL for atom K. Using first')
      END IF
      IF (NSEL.EQ.0) THEN
          CALL DSPERR('XANGLE','Error with atom selection')
          NFLAG=1
      END IF
      CALL MAKIND(SEL,NATOM,NSEL) 
      IF (INSERTPOS.EQ.1) ATOMKPTR(INSERTPOS)=0
      II=ATOMKPTR(INSERTPOS)
      II=II+1
      IF (II.GT.XANGLESMX) XANGLESMX=II
      ATOMKLST(II)=SEL(1)
      ATOMKPTR(INSERTPOS+1)=II
C     ------------------------------------------------------------------
C     Reading in the observed Theta and Phi
C     ------------------------------------------------------------------
      CALL NEXTF('Observed THETA =',XANGLESO1)
      CALL NEXTF('Observed PHI =',XANGLESO2)
      CALL NEXTF('Error on sine square =',XANGLESE)

      XANGLESOBS1(INSERTPOS)=XANGLESO1
      XANGLESOBS2(INSERTPOS)=XANGLESO2
      XANGLESERR(INSERTPOS)=XANGLESE
C     ------------------------------------------------------------------
C     Check for error in atom selection. If there is one then reset the
C     counter for restraint
C     ------------------------------------------------------------------
      IF (NFLAG.EQ.1) THEN
          ANGLESNUM=ANGLESNUM-1
      END IF

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE XANGLESINIT
C     ------------------------------------------------------------------
C     Initializes RDC-angles stuff
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "xangle.inc"

      CALL XANGLESDEFAULTS
      CALL ALLOCXANGLES(0,MAXXANGLES)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE PRINTXANGLES (CUTOFF,XANGLESCALC,XANGLESOBS1,
     &                         XANGLESOBS2,XANGLESERR,
     &                         ATOMJPTR,ATOMKPTR,ATOMJLST,ATOMKLST)
C     ------------------------------------------------------------------
C     Prints RDC-angles with deviation of cosine square from 1 larger
C     than cutoff, calculates RMSD and puts it into $RESULT
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "xangle.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "numbers.inc"

      DOUBLE PRECISION CUTOFF,XANGLESCALC(*),XANGLESOBS1(*),
     &                        XANGLESOBS2(*),XANGLESERR(*)
      INTEGER ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMJPTR(*),ATOMKPTR(*)
C     ------------------------------------------------------------------
C     Local variables
C     ------------------------------------------------------------------
      DOUBLE PRECISION CALCXANGLES,OBSXANGLES1,OBSXANGLES2,
     &                 DELTAXANGLES,DELTA,DP
      INTEGER COUNT,CLASS,J,K,NUM,II
      DOUBLE PRECISION RMS,VIOLS,ERRXANGLES,XANGLESENERGY
      DOUBLE COMPLEX DUMMY2
      LOGICAL PRINTTHISCLASS

      RMS=ZERO
      VIOLS=ZERO
      NUM=0
C     ------------------------------------------------------------------
C     Make sure that the array of calculated RDC-angles is up to date
C     ------------------------------------------------------------------
      CALL EXANGLES(XANGLESENERGY,'ANALYZE')
      WRITE (PUNIT,'(A)') 'The following RDC-angles have'
      WRITE (PUNIT,'(A)') 'deviation of cosine square from 1'
      WRITE (PUNIT,'(A)') 'larger than or equal to the cutoff:'
C     ------------------------------------------------------------------
C     Write out first class heading
C     ------------------------------------------------------------------
      CLASS=1
      PRINTTHISCLASS=PRINTCLASS(CLASS)
      IF (PRINTTHISCLASS) THEN
           WRITE (PUNIT,'(A,A)') 'Class ',XANGLESCLASSNAMES(1)
      END IF
C     ------------------------------------------------------------------
C     For every RDC-angles entry...
C     ------------------------------------------------------------------
      COUNT=0
      DO WHILE(COUNT.LT.ANGLESNUM)
          COUNT=COUNT+1
C     ------------------------------------------------------------------
C     Is this the start of a new class?
C     ------------------------------------------------------------------
          IF (XANGLESASSNDX(CLASS).LT.COUNT) THEN
              CLASS=CLASS+1
              PRINTTHISCLASS=PRINTCLASS(CLASS)
              IF (XANGLESASSNDX(CLASS).EQ.XANGLESASSNDX(CLASS-1)) THEN
                  COUNT=COUNT-1
              END IF
              IF (PRINTTHISCLASS) THEN
                  WRITE(PUNIT,'(A,A)') 'Class ',XANGLESCLASSNAMES(CLASS)
              END IF
          END IF
C     ------------------------------------------------------------------
C     If this assignment is in a class to be printed
C     and make sure there is an entry for that class
C     ------------------------------------------------------------------
          IF((PRINTTHISCLASS).AND.
     &       (XANGLESASSNDX(CLASS).NE.XANGLESASSNDX(CLASS-1))) THEN
C     ------------------------------------------------------------------
C     Always update RMSD
C     ------------------------------------------------------------------
              CALCXANGLES=XANGLESCALC(COUNT)
              OBSXANGLES1=XANGLESOBS1(COUNT)
              OBSXANGLES2=XANGLESOBS2(COUNT)
              ERRXANGLES=XANGLESERR(COUNT)
              DP=(1.-CALCXANGLES)

              IF ((DP.GT.0.000).AND.(DP.GT.ERRXANGLES)) THEN
                   DELTAXANGLES=DP-ERRXANGLES
              ELSE
                   DELTAXANGLES=0.0
              END IF

              RMS=RMS+DELTAXANGLES**2
              NUM=NUM+1
C     ------------------------------------------------------------------
C     Print out deviations larger than cutoff
C     and update number of violations
C     ------------------------------------------------------------------
              IF (ABS(DELTAXANGLES).GE.CUTOFF) THEN
                  J=ATOMJLST(ATOMJPTR(COUNT)+1)
                  K=ATOMKLST(ATOMKPTR(COUNT)+1)
                  WRITE(PUNIT,'(A,A)') '==============================',
     &                                 '=============================='
                  WRITE(PUNIT,'(A)') ' Set-J-atoms'
                  DO II=ATOMJPTR(COUNT)+1,ATOMJPTR(COUNT+1)
                     J=ATOMJLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(J),RESID(J),
     &                                           RES(J),TYPE(J)
                  END DO
                  WRITE(PUNIT,'(A)') ' Set-K-atoms'
                  DO II=ATOMKPTR(COUNT)+1,ATOMKPTR(COUNT+1)
                     K=ATOMKLST(II)
                     WRITE(PUNIT,'(9X,4(1X,A))') SEGID(K),RESID(K),
     &                                           RES(K),TYPE(K)
                  END DO
                  WRITE(PUNIT,'(2(2X,A,1X,F8.3))')
     &                  'Calc: ',CALCXANGLES,'Obs: ',1.
                  WRITE(PUNIT,'(2X,A,1X,F8.3,2X,A,1X,F8.3)')
     &                  'Error: ',ERRXANGLES,'Delta: ',DELTAXANGLES
                  VIOLS=VIOLS+ONE
              END IF
          END IF
      END DO

      IF (NUM.GT.0) THEN
          RMS=SQRT(RMS/NUM)
      ELSE
          RMS=0.0
      ENDIF

      CALL DECLAR('RESULT','DP',' ',DUMMY2,RMS)
      CALL DECLAR('VIOLATIONS','DP',' ',DUMMY2,VIOLS)

      RETURN
      END

C     ------------------------------------------------------------------
      SUBROUTINE XT1DIST
C     ------------------------------------------------------------------
C     Reads in relaxation rate enhancement information
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "comand.inc"
      INCLUDE  "funct.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "heap.inc"
      INCLUDE  "numbers.inc"

      INTEGER SPTR
      CHARACTER KT1INPUT*132,KT1OUTPUT*132,KPDB*132
      DOUBLE PRECISION KT1

      SPTR=ALLHP(INTEG4(NATOM))
      CALL PUSEND('XT1D>')
862   CONTINUE
      CALL NEXTWD('XT1D>')
      CALL MISCOM('XT1D>',USED)
      IF (.NOT.USED) THEN
C     ------------------------------------------------------------------
C     Documentation
C     ------------------------------------------------------------------
          IF (WD(1:4).EQ.'HELP') THEN
              WRITE(DUNIT,'(10X,A)')
     &              ' XT1D {<T1-STATEMENT>} END ',
     &              ' <T1-STATEMENT>:== ',
     &              ' KINPut <NAME> <REAL> <NAME>',
     &              ' * InputFile Kvalue OutputFile *',
     &              ' STRUcture <NAME> <NAME> <NAME>',
     &              ' * PDBfile InputFile OutputFile *'
C     ------------------------------------------------------------------
C     Restraint conversion using a given value of K
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'KINP') THEN
              CALL NEXTFI('Input file for T1 =',KT1INPUT)
              PRINT*,'Using as input file for T1:',KT1INPUT
              CALL NEXTF('Value of K =',KT1)
              PRINT*,'Using as value of K:',KT1
              CALL NEXTFI('Output NOE-like file for T1 =',KT1OUTPUT)
              PRINT*,'Using as output NOE-like file for T1:',KT1OUTPUT
              CALL KT1TYPECALC(KT1INPUT,KT1,KT1OUTPUT)
C     ------------------------------------------------------------------
C     Restraint conversion using a structure
C     ------------------------------------------------------------------
          ELSE IF (WD(1:4).EQ.'STRU') THEN
              CALL NEXTFI('Input PDB file for T1 =',KPDB)
              PRINT*,'Using as input PDB file for T1:',KPDB
              CALL NEXTFI('Input file for T1 =',KT1INPUT)
              PRINT*,'Using as input file for T1:',KT1INPUT
              CALL NEXTFI('Output NOE-like file for T1 =',KT1OUTPUT)
              PRINT*,'Using as output NOE-like file for T1:',KT1OUTPUT
              CALL KT1PDB(KT1INPUT,KPDB,KT1OUTPUT)
C     ------------------------------------------------------------------
C     Check for END statement
C     ------------------------------------------------------------------
          ELSE
              CALL CHKEND('XT1D>',DONE)
          END IF
      END IF
      IF (.NOT.(DONE)) GOTO 862
      DONE=.FALSE.
      CALL FREHP(SPTR,INTEG4(NATOM))

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE KT1TYPECALC (KT1INPUT,KT1,KT1OUTPUT)
C     ------------------------------------------------------------------
C     Converts T1 data to distance restraints using a given value of K
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      CHARACTER KT1INPUT*132,KT1OUTPUT*132
      CHARACTER BEGIN*3
      DOUBLE PRECISION KT1,R,RNOE
      INTEGER N1A,N2A
      CHARACTER*4 R1A,R2A
      INTEGER NLINES

      OPEN(21,FILE=KT1INPUT,STATUS='OLD',ERR=666)
      OPEN(31,FILE=KT1OUTPUT)

      NLINES=0
      DO I=1,10000 
10    READ(21,91,END=20,ERR=21) BEGIN
      NLINES=NLINES+1
      IF (BEGIN.NE.'   ') THEN
          IF (BEGIN.EQ.'KT1') THEN
              BACKSPACE 21
              READ(21,92) BEGIN,N1A,R1A,N2A,R2A,R
              RNOE=((KT1/R)**(1/6.))+1
              WRITE(31,94) ' assign (resid ',N1A,' and name ',R1A,
     &                     ') (resid ',N2A,' and name ',R2A,') ',
     &                     RNOE,RNOE,' 0'
          END IF
      END IF
20    CONTINUE        
      END DO
21    CONTINUE
      CLOSE (21)
      CLOSE (31)
      
91    FORMAT (A3)
92    FORMAT (A3,1X,I4,1X,A4,1X,I4,1X,A4,1X,F6.2)
94    FORMAT (A15,I4,A10,A4,A9,I4,A10,A4,A2,F5.1,F5.1,A2)      

      RETURN
666   PRINT*,'The file:',KT1INPUT,'does not exist...'
      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE KT1PDB (KT1INPUT,KPDB,KT1OUTPUT)
C     ------------------------------------------------------------------
C     Converts T1 data to distance restraints using a given structure
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      CHARACTER KT1INPUT*132,KT1OUTPUT*132,KPDB*132
      CHARACTER BEGIN*4,BEGIN1*6
      DOUBLE PRECISION KT1,R(2000),RNOE,RMAX
      DOUBLE PRECISION X1,Y1,Z1,RA,X2,Y2,Z2
      INTEGER N1A(2000),N2A(2000)
      CHARACTER*4 R1A(2000),R2A(2000)
      INTEGER NLINES,NUMBERATOM,NORES,BB
      CHARACTER NAMEATOM*4

      OPEN(21,FILE=KT1INPUT,STATUS='OLD',ERR=666)

      RMAX=0
      NLINES=0
      DO I=1,10000
10    READ(21,91,END=20,ERR=21) BEGIN
      IF (BEGIN.NE.'    ') THEN
          IF (BEGIN.EQ.'KT1 ') THEN
              NLINES=NLINES+1
              BACKSPACE 21
              READ(21,92) BEGIN,N1A(NLINES),R1A(NLINES),N2A(NLINES),
     &                    R2A(NLINES),R(NLINES)
          END IF
      END IF
20    CONTINUE
      END DO
21    CONTINUE
      CLOSE(21)
    
      K=0
      DO J=1,NLINES
         OPEN(11,FILE=KPDB,STATUS='OLD',ERR=667)
         BB=0
         DO I=1,10000
            READ(11,91,END=102) BEGIN1
            IF (BEGIN1.NE.'      ') THEN
                IF (BEGIN1.EQ.'ATOM  ') THEN 
                    BACKSPACE 11  
                    READ(11,'(5X,I6,1X,A4,6X,I4,4X,3F8.3)')
     &                   NUMBERATOM,NAMEATOM,NORES,XA,YA,ZA
                    IF (NORES.EQ.N1A(J)) THEN
                        IF (NAMEATOM.EQ.R1A(J)) THEN 
                            X1=XA
                            Y1=YA
                            Z1=ZA
                            BB=BB+1
                        END IF
                    END IF
                    IF (NORES.EQ.N2A(J)) THEN
                        IF (NAMEATOM.EQ.R2A(J)) THEN
                            X2=XA
                            Y2=YA
                            Z2=ZA
                            BB=BB+1
                        END IF
                    END IF
                END IF
            END IF
         END DO
102      CONTINUE
         IF (BB.NE.2) THEN
             PRINT*,'%T1DIST-ERR: Mismatch in PDB file at line:',J
             STOP
         END IF
         RA=SQRT((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)
         K=(RA**6)*R(J)
         IF (K.GT.KMAX) THEN
             KMAX=K
         END IF
         CLOSE (11)
      END DO
      PRINT*,'Value of KMAX:',KMAX

      OPEN(31,FILE=KT1OUTPUT)
      DO J=1,NLINES
         RNOE=(KMAX/R(J))**(1/6.)
         WRITE(31,94) ' assign (resid ',N1A(J),' and name ',R1A(J),
     &                ') (resid ',N2A(J),' and name ',R2A(J),') ',
     &                RNOE,RNOE,' 0'
      END DO
      CLOSE(31)
      
91    FORMAT (A4)
92    FORMAT (A3,1X,I4,1X,A4,1X,I4,1X,A4,1X,F6.2)
94    FORMAT (A15,I4,A10,A4,A9,I4,A10,A4,A2,F8.3,F8.3,A2)

      RETURN
666   PRINT*,'The file:',KT1INPUT,' does not exist...'
      RETURN
667   PRINT*,'The file:',KPDB,' does not exist...'
      RETURN

      END

C     ------------------------------------------------------------------
      SUBROUTINE FANTADIPO(ATOMIPTR,ATOMJPTR,ATOMKPTR,ATOMLPTR,ATOMMPTR,
     &                     ATOMNPTR,ATOMILST,ATOMJLST,ATOMKLST,ATOMLLST,
     &                     ATOMMLST,ATOMNLST,XRDCOBS,XRDCERR,
     &                     NCLASS,NOMEFILE)
C     ------------------------------------------------------------------
C     Fits residual dipolar couplings tensor on a given structure
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE

      INCLUDE  "cns.inc"
      INCLUDE  "mtf.inc"
      INCLUDE  "coord.inc"
      INCLUDE  "numbers.inc"
      INCLUDE  "deriv.inc"
      INCLUDE  "xdipo_rdc.inc"
      INCLUDE  "consta.inc"
      INCLUDE  "fantaxplor.inc"
      INCLUDE  'heap.inc'

      CHARACTER NOMEFILE*132
      DOUBLE PRECISION APARA,APERP
      COMMON /FRUN/APERP,APARA
      INTEGER FDSWITCH,FDSAVE,FDERR
      COMMON /FDPARAM/FDSWITCH,FDSAVE,FDERR
      INTEGER FDVIOLS
      COMMON /DVIOL/FDVIOLS
      DOUBLE PRECISION FENERGTOT
      COMMON /FENERG/FENERGTOT
      DOUBLE PRECISION FDENT(20,2000),FDPER(20,2000),FDPAR(20,2000),
     &                 FDIPOE(20,2000) 
      INTEGER DCONTSAVE(20)
      COMMON /FDMEDIA/FDENT,FDPER,FDPAR,FDIPOE,DCONTSAVE
      DOUBLE PRECISION DIPOE
      COMMON /DIPOENERGY/ DIPOE
      DOUBLE COMPLEX DUMMY2
      INTEGER ATOMIPTR(*),ATOMJPTR(*),ATOMKPTR(*)
      INTEGER ATOMLPTR(*),ATOMMPTR(*),ATOMNPTR(*)
      INTEGER ATOMILST(*),ATOMJLST(*),ATOMKLST(*)
      INTEGER ATOMLLST(*),ATOMMLST(*),ATOMNLST(*)
      INTEGER COUNT,MM,NN,I,J,K,L,NA,M,N,CLASS,NORES
      INTEGER NCLASS,NNCO,NNCC
      DOUBLE PRECISION XRDCOBS(*),XRDCERR(*)
      DOUBLE PRECISION XI,XJ,XK,XL,XM,XN,YI,YJ,YK,YL,YM,YN,
     &                 ZI,ZJ,ZK,ZL,ZM,ZN
      DOUBLE PRECISION XFA(1000),YFA(1000),ZFA(1000),XMFA(1000),
     &                 YMFA(1000),ZMFA(1000),ERRFA(1000),OBSFA(1000),
     &                 WPROT(1000)
C     ------------------------------------------------------------------
C     CLASS must remain this during the cycle of variables exchange.
C     The class is defined by NCLASS.
C     ------------------------------------------------------------------
      CLASS=1
      NNCO=0
      NNCC=0
      COUNT=0

      PRINT*,'This is FANTALIN for RDC.'
      PRINT*,'RDCNUM is:',RDCNUM

      DO WHILE(COUNT.LT.RDCNUM)
         COUNT=COUNT+1
         DO WHILE ((XRDCASSNDX(CLASS).LT.COUNT).OR.
     &             (XRDCASSNDX(CLASS).EQ.0))
            CLASS=CLASS+1
         END DO
         IF (XRDCASSNDX(CLASS).EQ.XRDCASSNDX(CLASS-1)) THEN
             COUNT=COUNT-1
         ENDIF

         IF (NCLASS.EQ.CLASS) THEN 
             NNCO=NNCO+1
             I=ATOMIPTR(COUNT)+1
             J=ATOMJPTR(COUNT)+1
             K=ATOMKPTR(COUNT)+1
             L=ATOMLPTR(COUNT)+1
             XI=X(ATOMILST(I))
             XJ=X(ATOMJLST(J))
             XK=X(ATOMKLST(K))
             XL=X(ATOMLLST(L))
             YI=Y(ATOMILST(I))
             YJ=Y(ATOMJLST(J))
             YK=Y(ATOMKLST(K))
             YL=Y(ATOMLLST(L))
             ZI=Z(ATOMILST(I))
             ZJ=Z(ATOMJLST(J))
             ZK=Z(ATOMKLST(K))
             ZL=Z(ATOMLLST(L))
             OBSFA(NNCO)=XRDCOBS(COUNT)
             ERRFA(NNCO)=XRDCERR(COUNT)
         END IF

         DO MM=ATOMMPTR(COUNT)+1,ATOMMPTR(COUNT+1)
            DO NN=ATOMNPTR(COUNT)+1,ATOMNPTR(COUNT+1)
               IF (NCLASS.EQ.CLASS) THEN
                   NNCC=NNCC+1
                   XMFA(NNCC)=X(ATOMMLST(MM))
                   XFA(NNCC)=X(ATOMNLST(NN))
                   YMFA(NNCC)=Y(ATOMMLST(MM))
                   YFA(NNCC)=Y(ATOMNLST(NN))
                   ZMFA(NNCC)=Z(ATOMMLST(MM))
                   ZFA(NNCC)=Z(ATOMNLST(NN))
                   NORES=ATOMNLST(NN)
                   NRESIDFA(NNCC)=RESID(NORES)
                   NRESFA(NNCC)=RES(NORES)
                   NTYPEFA(NNCC)=TYPE(NORES)
               END IF
            END DO
         END DO
      END DO      

      IF (NNCC.EQ.NNCO) THEN
          CALL FANTALINEXE(XFA,YFA,ZFA,XMFA,YMFA,ZMFA,NNCO,OBSFA,ERRFA,
     &                     0,NOMEFILE,WPROT,0,DIPFLG)
          PRINT*,'FDERR is=',FDERR
          IF (FDERR.EQ.1) THEN
              CALL FANTAERRORE(XFA,YFA,ZFA,XMFA,YMFA,ZMFA,NNCO,OBSFA,
     &                         ERRFA,0,DIPFLG)
          END IF
      ELSE
          PRINT*,'Error in atom count...'
      END IF

      PRINT*,'FDSWITCH is:',FDSWITCH
      IF (FDSWITCH.EQ.1) THEN
          XRDCCOEF1(NCLASS)=APARA
          XRDCCOEF2(NCLASS)=APERP
          PRINT*,'For class:',NCLASS
          PRINT*,'New value for A1 =',APARA
          PRINT*,'New value for A2 =',APERP
      END IF

      IF (FDSAVE.EQ.1) THEN
          DCONTSAVE(NCLASS)=DCONTSAVE(NCLASS)+1
          FDENT(NCLASS,DCONTSAVE(NCLASS))=FENERGTOT
          FDIPOE(NCLASS,DCONTSAVE(NCLASS))=DIPOE
          FDPAR(NCLASS,DCONTSAVE(NCLASS))=APARA
          FDPER(NCLASS,DCONTSAVE(NCLASS))=APERP
          PRINT*,'XDIPO_RDC energy =',DIPOE
          PRINT*,'Total energy =',FENERGTOT
          PRINT*,'DCONTSAVE is:',DCONTSAVE(NCLASS)
      END IF

      CALL DECLAR('DCHIAX','DP',' ', DUMMY2,APARA)
      CALL DECLAR('DCHIRH','DP',' ', DUMMY2,APERP)

      RETURN
      END
C     ------------------------------------------------------------------
      SUBROUTINE FANTADIPOMEDIA (FMA,PERC)
C     ------------------------------------------------------------------
C     Averages tensor parameters on a given sub-ensemble of structures
C
C     By Gabriele Cavallaro, Andrea Giachetti and Giacomo Parigi (2003)
C     ------------------------------------------------------------------
      IMPLICIT NONE
      DOUBLE PRECISION VETE(2,2000),VETT(3,2000)
      DOUBLE PRECISION FDENT(20,2000),FDPER(20,2000),FDPAR(20,2000),
     &                 FDIPOE(20,2000)
      COMMON /FDMEDIA/ FDENT,FDPER,FDPAR,FDIPOE,DCONTSAVE
      INTEGER DCONTSAVE(20)
      INTEGER FMA,COUNT,CB,NUM,COUNT1,CONFPRE
      DOUBLE PRECISION PERC
      DOUBLE PRECISION M1PAR,M1PER,DEVPAR
      DOUBLE COMPLEX DUMMY2
C     ------------------------------------------------------------------
C     Through FMA the class on which the average must be done is passed.
C     If it is zero, all the counters are reset.
C     ------------------------------------------------------------------
      IF (FMA.EQ.0) THEN
          DO COUNT=1,19
             DCONTSAVE(COUNT)=0
          END DO
          PRINT*,'Mean vectors reset.'
      ELSE
C     ------------------------------------------------------------------
C     The best are selected
C     ------------------------------------------------------------------
          DO COUNT=1,DCONTSAVE(FMA)
             VETE(1,COUNT)=0
          END DO

          DO COUNT=1,DCONTSAVE(FMA)
            NUM=DCONTSAVE(FMA)
            DO WHILE (VETE(1,NUM).EQ.1)
               NUM=NUM-1
            END DO
            DO COUNT1=1,DCONTSAVE(FMA)-1
               IF ((FDENT(FMA,COUNT1).LE.FDENT(FMA,NUM)).AND.
     &             (VETE(1,COUNT1).EQ.0.0)) THEN
                    NUM=COUNT1
               END IF
            END DO
            PRINT*,'NUM is:',NUM
            VETE(1,NUM)=1
            VETE(2,COUNT)=FDENT(FMA,NUM)
            VETT(1,COUNT)=FDPAR(FMA,NUM)
            VETT(2,COUNT)=FDPER(FMA,NUM)
         END DO

         CONFPRE=NINT((DBLE(DCONTSAVE(FMA))*(PERC/100.)))
         IF (CONFPRE.EQ.0) THEN
             CONFPRE=1
         END IF
         PRINT*,'CONFPRE is:',CONFPRE
         PRINT*,'PERC is:',PERC
         PRINT*,'DBLE(CONTSAVE(FMA)) is:',DBLE(DCONTSAVE(FMA))

         DO COUNT=1,DCONTSAVE(FMA)
            PRINT*,'Number',COUNT,'Energy',VETE(1,COUNT),VETE(2,COUNT)
            PRINT*,'A1',VETT(1,COUNT),' A2',VETT(2,COUNT)
         END DO

         CB=0
         M1PAR=0
         M1PER=0
         DO COUNT=1,CONFPRE
            M1PAR=M1PAR+VETT(1,COUNT)
            M1PER=M1PER+VETT(2,COUNT)
            CB=CB+1
            PRINT*,'A1 =',VETT(1,COUNT),'A2 =',VETT(2,COUNT)
         END DO
         M1PAR=M1PAR/CB
         M1PER=M1PER/CB

         CB=0
         DEVPAR=0
         DO COUNT=1,CONFPRE
            DEVPAR=DEVPAR+(VETT(1,COUNT)-M1PAR)**2
         END DO
         DEVPAR=DEVPAR/CONFPRE
         PRINT*,'Averaged new A1 =',M1PAR
         PRINT*,'Averaged new A2 =',M1PER
         PRINT*,'Standard deviation for new A1 =',SQRT(DEVPAR)

         CALL DECLAR('DCHIAX','DP',' ',DUMMY2,M1PAR)
         CALL DECLAR('DCHIRH','DP',' ',DUMMY2,M1PER)

         END IF

         RETURN
         END

# Developing HADDOCK3

This file provides information on how to setup a development environment for HADDOCK3.

- [System requirements](#system-requirements)
- [Setting up the development environment](#setting-up-the-development-environment)
  - [Clone the repository](#clone-the-repository)
  - [Python environment](#python-environment)
  - [Install haddock3 in development mode](#install-haddock3-in-development-mode)
  - [Running tests](#running-tests)

## System requirements

- Python 3.9
- OpenMPI

### Installing system dependencies

Below the instructions are provided for a Ubuntu system using `apt-get`. If you are using a different system, please refer to the respective package manager - `yum`, `dnf`, `pacman`, `homebrew`, `port`, etc.

```bash
sudo apt-get update &&
    # Needed for building Python
    sudo apt-get install build-essential python-setuptools python-pip &&
    sudo apt-get install libncursesw5-dev libgdbm-dev libc6-dev &&
    sudo apt-get install zlib1g-dev libsqlite3-dev tk-dev &&
    sudo apt-get install libssl-dev openssl &&
    sudo apt-get install libffi-dev &&
    # Needed for haddock3 installation
    sudo apt-get install git gcc &&
    # Needed to run the MPI related tests
    sudo apt-get install openmpi-bin libopenmpi3 libopenmpi-dev
```

After all the system-dependencies are in place, download and compile python.

**Conda is NOT recommended for development**

```bash
wget https://www.python.org/ftp/python/3.9.6/Python-3.9.6.tgz
tar -xf Python-3.9.6.tgz
cd Python-3.9.6
./configure --enable-optimizations
sudo make altinstall -j 8
```

Then `python3.9` should be available on your system at `/usr/local/bin/python3.9`

On **OSX**, you can use a package-manager such as [brew](https://brew.sh) to install Python 3.9.

> Please keep in mind installing python with a package manager can mask system dependencies that your development might add. That's why we recommended you install it from source.

```bash
brew install python@3.9
```

## Setting up the development environment

### Clone the repository

```bash
git clone https://github.com/haddocking/haddock3.git
cd haddock3
```

### Python environment

We recommend you use Python's native virtual environment to manage the dependencies.

```bash
python3.9 -m venv .venv
source .venv/bin/activate
```

### Install haddock3 in development mode

Install both project dependencies and test dependencies using pip.

```bash
pip install -e '.[dev,docs]'
```

> If you are using a Mac, if the installation of mpi4py fails, run first `brew install mpi4py`

## Running tests

In `haddock3` we use the pytest framework, make sure you check it's [documentation](https://docs.pytest.org/en/6.2.x/contents.html) the tests are located in `tests/` (unit) and `integration_tests/` directories.

```bash
pytest tests/
```

```bash
pytest integration_tests/
```

## Installation in an HPC environment

**Please get in contact with the system administrator before doing development in a shared HPC environment.**

For installation in an HPC environment we recommend to check the installed Python versions on the system and also importantly if an `openmpi` (or other custom MPI) installation is available on the system.
Those are often offered via the `module` command.
If you only intend to develop haddock3 using the multiprocessing scheduler, the above instructions should be fine. But to harvest the MPI capabilities of an HPC system it is best to build haddock3 using the installed MPI version on the HPC system.

# Installation

Create a virtual environment with Python 3.9:

You can use Python's `venv` or `conda` depending on your choice.
Commands are provided below:

### with `venv`

```bash
python -m venv .venv
source .venv/bin/activate
```

### with `conda`

```bash
conda create -n haddock3 python=3.9
conda activate haddock3
```

```bash
git clone https://github.com/haddocking/haddock3.git
cd haddock3
pip install .
```

## (Optional) Install MPI libraries if you intend to run HADDOCK3 with MPI

To use the mpi implementation of haddock3 you must have mpi4py installed in the `(haddock3)` python environment, and OpenMPI in the host system.

```bash
$ pip install mpi4py
# or
$ conda install -c conda-forge mpi4py
```

Later, you can find [here](https://www.bonvinlab.org/haddock3/tutorials/mpi.html) instructions on how to run HADDOCK3 with MPI.

## (Optional) Install web service dependencies if you intend to run HADDOCK3 restraints web service

To run the restraints web service you must have the following dependencies installed in the `(haddock3)` python environment:

```bash
pip install uvicorn fastapi
```

Information on the restraints web service can be found [here](https://github.com/haddocking/haddock3/blob/main/src/haddock/clis/restraints/webservice.py).

## Installing third-party packages

HADDOCK3 can integrate third-party software in its workflows.
We are not responsible for the proper installation of such packages, but
we help you install them. Below, you will find a list of all third-party
packages HADDOCK3 can use and guidelines for their proper installation.

### `lightdock` (outdated)

To install [lightdock](https://github.com/lightdock/lightdock) follow
the instructions on the project's website. Remember to install it under
the same Python environment you created for HADDOCK3. If you have any
doubts, please let us know.

### `gdock` (outdated)

1. Clone the latest version:

```
cd some-folder
git clone https://github.com/rvhonorato/gdock.git
```

2. Install Python3+ dependencies

```
pip install deap scipy mgzip biopython
```

3. Set `GDOCK_PATH`

```
export GDOCK_PATH=some-folder
```

**Important**: These are not the full `gdock` installation
instructions as only the model generation is used here. Please check the
[repository page](https://github.com/rvhonorato/gdock) for more
information.

## `openmm`

1. Install the latest version of openmm and pdbfixer
```bash
# Activate the haddock3 env
conda activate haddock3
# libstdxx must be installed, maybe already present in your system
conda install -c conda-forge libstdcxx-ng
# Install OpenMM and related tools/binaries
conda install -c conda-forge openmm pdbfixer
```

Openmm should automatically detect the fastest platform among those available
on your machine.

Please refer to the [official page](http://docs.openmm.org/latest/userguide/)
of the project for a full description of the installation procedure.

# Citing

Cite HADDOCK3 with the following:

1. HADDOCK3, Bonvin's Lab, https://github.com/haddocking/haddock3, 2022.
2. Dominguez, C., Boelens, R. & Bonvin, A. M. J. J. HADDOCK: a protein-protein docking approach based on biochemical or biophysical information. J Am Chem Soc 125, 1731–1737 (2003).

Developed with financial support from the Horizon 2020 [BioExcel CoE](https://www.bioexcel.eu) project [823830](https://cordis.europa.eu/project/id/823830)

# Running HADDOCK3 with MPI

To run this example you must have `mpi4py` installed in the haddock3 python
environment, and `OpenMPI` in the host system.

```bash
$ pip install mpi4py
# or
$ conda install -c conda-forge mpi4py
```

**Do not run it as: `mpirun -np haddock3 run.cfg`**, this logic is handled
internally.

Edit the `.cfg` according to the `.job` parameters you have set

In the `.job` header:

```bash
#SBATCH --nodes=5
#SBATCH --tasks-per-node=96
```

In the `.cfg` params

```toml
ncores = 480
```

Then prepare the rest of the `.job` file according to your cluster, a SLURM
example is provided at
`haddock3/examples/docking-protein-protein/docking-protein-protein-mpi.job` and
below:

```bash
#!/bin/bash
#SBATCH --nodes=5
#SBATCH --tasks-per-node=96
#SBATCH -J haddock3mpi

# make sure anaconda is activated
source $HOME/software/miniconda3/bin/activate
conda activate haddock3

# go to the example directory
cd $HOME/repos/haddock3/examples/docking-protein-protein

# remove any old runs
rm -rf run-mpi

# execute
haddock3 docking-protein-protein-mpi-test.cfg
```

Then:

```bash
sbatch docking-protein-protein-mpi.job
```

Please report any errors as an [issue](https://github.com/haddocking/haddock3/issues/new/choose).

# Usage

Before using HADDOCK3, install HADDOCK3 following the [installation
instructions](INSTALL.md).

## Run HADDOCK3

This is a minimal description of how to run HADDOCK3. We are currently
creating detailed documentation and tutorials. The minimal HADDOCK3
execution command is:

```bash
haddock3 <CONFIG WORKFLOW>
```

Where the `<CONFIG WORKFLOW>` is a haddock3 configuration file
describing the simulation workflow.

You can inspect all `haddock3` options with:

```bash
haddock3 -h
```

Inside the HADDOCK3 main folder, there is an `examples/` folder. There
you will find several subfolder with examples for specific docking
scenarios. Please experiment running those configuration files ending in
`-test.cfg`. For example:

```bash
cd examples/docking-protein-protein
haddock3 docking-protein-protein-test.cfg
```

Feel free to open the `cfg` files with your preferred test editor, these
are plain text files.

To get the list of all possible parameters for each module:

```bash
haddock3-cfg -h
haddock3-cfg -m <MODULE NAME>
haddock3-cfg -m rigidbody
```

We are actively working towards expanding our documentation pages.
Thanks for using HADDOCK3! For any question please [open an issue
here](https://github.com/haddocking/haddock3/issues).

# Editing and extending runs

The modularity of HADDOCK3 allows restarting halted runs from a certain step,
extending previous runs with additional steps, and using successful steps as
starting points for new runs. Let's see some examples.

## Restarting a run

Use the `--restart` flag to restart a HADDOCK3 run. For example, imagine you
start a run:

```
haddock3 my-run-config.cfg
```

Unfortunately, something went wrong in step 4 (the fourth module defined in the
configuration file).  You want now to continue the run from where it stopped.
Use the `--restart` followed by `N`, where `N` is an integer corresponding to
the step you which to restart from. **Remember**, haddock steps are 0-indexed
(0, 1, 2, 3, ...); so, `--restart 3` is the fourth step.

```
haddock3 my-run-config.cfg --restart 3
```

**Important:** As soon you run the above command, The `--restart` option will
**delete** step folders from `3` onward (inclusive), that is, `3_`, `4_`,
`...`, will be deleted.

## Restarting a run with modified parameters

You can profit from the `--restart` option described above to (re)run modules
with modified parameters. For example, if you noticed a parameter was set to
`true` when you wanted it to `false`, or if you wish to increase the sampling
for a given refinement module. Simply edit the configuration file modifying the
parameters for the modules you want to (re)run, in this case, from the fourth
module onward.

```
haddock3 my-edited-config.cfg --restart 3
```

**Important:** As soon you run the above command, The `--restart` option will
**delete** step folders from `3` onward (inclusive), that is, `3_`, `4_`,
`...`, will be deleted.

## Restarting a run with additional steps

You can profit from the `--restart` option to add steps to a run. For example,
a run has **five** steps and is completed successfully. You now realize you want
to perform an additional refinement (`mdref`) followed by CAPRI evaluation
(`caprieval`) and FCC clustering (`clustfcc`). Add the parameters for those
modules to the **original** configuration file, keeping all the original
parameters unchanged, and run haddock:

```
haddock3 config-with-additional-step.cfg --restart 5
```

We use `--restart 5` because the first new step is the sixth in the new
workflow: the five initial steps and three new steps. Remember `--restart` is
0-indexed.


## Extend a run

You can extend a successful run with additional steps. For that, prepare a
configurtation file containing only the new steps you wish to execute on top of
the previously successful run. In these cases, you **don't** need to define the
`run_dir` and `molecules` parameters in this new configuration file because
they will be ignored. You **can** define the other general parameters like
`ncores`, `mode`, etc. To extend a run with additional modules:

```
haddock3 new-steps.cfg --extend-run <run_dir>
```

## Starting new runs from successful steps

You can also start an independent run from a successful step of a previous run.
Consider the following successful run:

```
run1/
|--- 0_topoaa/
|--- 1_rigidbody/
|--- 2_caprieval/
|--- 3_seletop/
|--- 4_flexref/
|--- (etc...)
|--- data/
```

Now, you want to start a new independent run from the `4_flexref` step.

First, you need to copy the step to a new run folder using our `haddock3-copy` CLI.

```
haddock3-copy -r run1 -m 0 4 -o run2
```

The above command copies steps `0_topoaa` and `4_flexref` to a new `run2`
directory. It also updates the path references in the step folders. Resulting in:

```
run2/
|--- 0_topoaa/
|--- 1_flexref/
|--- data/
     |--- 0_topoaa/
     |--- 1_flexref/
```

Do **not** use the bash `cp` command to emulate this operation because there
several internal aspects treated by `haddock3-copy` that wouldn't be treated
by `cp`.

**Note:** If the new run uses CNS-dependent modules, you **also need** to copy
the folder corresponding to the initial topology creation (the `topoaa` module).

Second, create a configuration file for the new run containing **only** the
parameters of the new modules you wish to execute after the `flexref`. You
**don't** need to define the `run_dir` and `molecules` parameters in this new
configuration file because they will be ignored. You **can** define the other
general parameters like `ncores`, `mode`, etc. For example:

```toml
ncores = 40

[emref]
tolerance = 20
ambig_fname = "path/to/air.tbl"

[caprieval]
reference_fname = "path/to/reference.pdb"
```

Following the example, to start the new run:

```
haddock3 my-new-config.cfg --extend-run run2
```

## Additional considerations

You can now combine the functionalities explained above in many different
variations.

Below is some quick Q&A regarding these options:

1. Can I copy run directories to different folders on my computer?

Yes. HADDOCK3 uses relative paths inside the run directory.

2. Can I copy run directories to different computers?

Yes, provided you have installed HADDOCK3 following the [INSTALL](INSTALL.md)
instructions in the two systems. You can copy a run directory (or some of its
steps) to a different computer/system and (re)run it using the `--restart` and
`--extend-run` options.

3. Modules are 0-indexed. Is this related to Python being 0-indexed also?

No. It is because we defined the `topoaa` module as zero.

4. Where can I find additional help?

You can find additional help by running the command: `haddock3 -h` and reading
the parameters' explanations. Otherwise, ask us in the ["issues"
forum](https://github.com/haddocking/haddock3/issues).

# Contributing to HADDOCK3

Welcome, we made many efforts to facilitate your contribution to this
fantastic project. There are several ways to contribute:

* you can improve tutorials and/or documentation
* improve the code itself (maybe you even found some bug :bug:?)
* improve error messages so they become clearer
* add a new simulation module altogether
* write more unittests (we dare you to do that :godmode:)

Before attempting any development, please install HADDOCK3 following the
instructions in the [INSTALL](docs/INSTALL.md) file. Afterwards, follow the
instructions in this file.

## 1. Contributing new code

HADDOCK3 has two main testing workflows. Here, within the repository, we
test the HADDOCK3's Python shell, code style, and package building.  Our
Continuous Integration (CI) pipeline is based on
[tox][tox] and GitHub Actions. We will
explain you how to use them.

To contribute to the HADDOCK3's Python shell, follow these steps:

1.  [Fork][fork] the HADDOCK3 repository
2.  Create a new branch in your fork (`git checkout -b <new_branch_name>`)
3.  Develop your code and tests:

    1.  HADDOCK3 source is in `src/haddock`. Always implement code in
    the lowest Python version supported (this case is 3.9).
    2.  Tests sit in the `tests/` folder. Use
    [pytest](https://docs.pytest.org/en/6.2.x/) for testing.
    3. See more details on how to contribute with code and tests in the
    subheadings below.

4.  While you are developing (or when you think you have finished), you can
    (should) use our `tox` environments to test your code. Use the
    following commands from the main repository folder:

    1.  `tox -e test` runs tests in current python version. If you tox
    to report test names and status for every single test (high verbosity) use
    `tox -e test -- -vv`.
    2.  `tox -e lint` shows you errors in the code style.
    3.  `tox -e build` simulates building the HADDOCK3 package.
    4.  Run the above altogether with the simple `tox` command
    5.  If you want to submit high-quality code, you may wish to run
    `tox -e radon` to assess your code cyclomatic complexity.

5.  You can work on these `tox` tests until they all pass green before
submitting your PR.

6. Check if your contribution fulfills the requeriments proposed in the
PR template, these are based on the experience of some developers to ensure the long-term
survival of the codebase. Suggestions are always welcomed.

7.  We also have an `examples` folder with test cases that you can run
(should) to ensure the integrity of the python shell as a whole:
    1.  Navigate to any of the examples folder and run the `-test.cfg`
    file (see [USAGE](USAGE.md)).
    2. `*-test.cfg` runs are meant for testing purposes only. The
    `examples/` folder also contain `*-full.cfg` files for production runs.
    You don't need to run these for testin.
    2.  If you have a powerful computer and want to run all tests in a
    row, navigate to the `examples` folder and run `python run_tests.py
    -b`. The `-b` flag ensures the run will stop asap an error is found.
    3. if your computer is not powerful enough, you can ask us to run
    those tests once you submitted the pull request.
    4. For example, the `docking-protein-protein-test.cfg` run in less
    than 3 minutes on a `Intel(R) Core(TM) i7-8550U CPU @ 1.80GHz` laptop
    using 7 cores. All `-test.cfg` together take about 45 minutes.

8.  Add a list of your new additions to the `CHANGELOG.md` file by
adding a new sub-header as described bellow. This is mandatory for `tox
-e build` to pass. Note this applies only after we have released the
stable `3.0.0` version.

```markdown
# Changelog

## new_version

* your change one
* your change two

(... the rest of the file ...)
```

8.  If you have difficulties with `tox`, let us know. These `tox` tests
are the same that run on the GitHub Actions once you send the PR. So,
sending the PR is another way to ensure all tests pass.

9.  Submit your PR if you haven't done so yet :wink:

    1.  GitHub allows submitting "Draft PRs". You can use this
    option to let us know you are working on some new good stuff so we
    can help you from the beginning.

### 1.1 Contributing with code (additional details)

**You should also know that...** HADDOCK3 folders, files, and code
follow a well defined structure with very specific patterns. Inside each
source folder you will (likely) find a `README` file describing the
structure of the folder and presenting guidelines on how to better
contribute to that folder and respective files. Summarizing here:

* New command-line clients go in the `clis/` folder. See how the current
  clients here created and use that as a template. Remember to update also the
  `setup.py` file.
* Add any new functions that you foresee are general and
  could serve different places in the code to the `libs/` folder. Find a
  `lib*.py` files that would serve your purpuses, otherwise create a new
  one.
* Any plug-in like functionality, for example *"check if input is
  correct"*, should go into its own python module inside the `gear/`
  folder. Any variables, functions, and classes related only to that
  implementation should go all inside the same module (Python file).
* Any general hard definitions, or physical constants, should go in the
  `core/` folder.
* If you want to implement a new HADDOCK3 module, navigate to the
  `modules/` folder and follow the instructions in the `README` file
  there. You will see that all folders and files follow a pattern.
* Talk with us before developing any CNS related part.

### 1.2 Contributing with tests (additional details)

Inside the `tests/` folder you will find several `test_*.py` files.
Normally, each file has the tests for each `*.py` file in the source. If
you create new `*.py` files you should create a new test file of the
same name, `test_new_file_name.py`. Aim at 100% test coverage for the
code you have created. Write tests according to [pytest][pytest]. You
can see examples in our `test_*.py` files. You can run the tests using
the `tox -e test` commands explained above. Or, if you want to run the
tests for a singly file use `tox -e test -- tests/test_myfile.py`.

### 1.3 Dependencies

HADDOCK3 is highly interconnected with other projects. Many of them use
HADDOCK3 core functionalities. Therefore, we aim to keep HADDOCK3 with
the lowest dependency footprint possible. Avoid adding dependencies when
developing new functionalities. How?

1. Use the Python standard library as much as possible.
1. Numpy is always allowed.
1. If you need to implement heavy calculations, it is best you use
[Numba][numba] instead of C libraries. Talk with us before.
1. You need a small function from a large library. Try to reimplement it
yourself with the Python standard library.
    1. If you can't, talk first with
us by opening an issue.
1. You need a big and complex function or maybe a whole python file from
another project. If licenses are compatible, copy their code to the
HADDOCK3 repository writing all necessary headers to grant authorship
and comply with license requirements.
    1. If licenses aren't compatible, talk is us. We may have an
    alternative.
1. Your new module largely depends on a library and reimplementing or
copying is not an option. Then, consider if we can use that dependency
as a **runtime dependency** (like `gdock` or `lightdock`) instead of an
installation dependency.
1. Nothing of the above is possible. You **really** need an *install
dependency*. Talk with us before.

### 1.4 Code style

HADDOCK3 follows nice code style rules. These are *almost* hard rules,
but there is some room for exceptions - common sense prevails. When
developing code, run `tox -e lint` to inspect if your code follows our
conventions. We use [flake8][flake] with the [following rules][fr] and
docstrings follow [numpydoc][numpydoc] style. You can hold on our code
for style. Nevertheless, here's a dummy code snippet for your reference.
Line have a soft max of 80 chars.

```python
"""Module's docstring."""
# any comments. You can add here licensing stuff
# first import standard library
import os
from path import Pathlib

# import third library
import numpy as np

# import from haddock3
from haddock import log
# multiline import
from haddock.libs.libio import (
    lib1,
    lib2,
    lib3,
    lib4,
    )


# all this are possible
GLOBAL_VARIBLE = None
_hidden_global_variable = None

avoid_lower_case_globals = None


def my_nice_func(arg1, arg2, arg3):
    """Docstring here."""
    # do stuf

# if the function has many arguments, separate them by new lines.
# mind the identations
def my_nice_func_with_big_name(
        var1,
        var2,
        var3,
        named_var1="something",
        named_var2="else",
        **kwargs,
        ):
    """Docstring here."""
    # do stuff
    return


multiline_list = [
    var1,
    var2,
    var3,
    var4,
    ]

multiline_dict = {
    "key1": 1,
    "key2": 2,
    "key3": 3,
    "key4": 4,
    "key5": 5,
    }

# separate comprehensions by sections if line don't fit 80 chars
# same for dictionaries
cool_list_comprehension = [
    dome_some_long_stuff(i)
    for i in some_iterable
    if validate(i)
    ]

double_quotes_allowed = "string"
single_quotes_allowed = 'string'
# don't try to homogenize quotes all around the code, respect the
# original input.

# define first use later
generator_with_a_large_name = zip(
    iter1,
    iter2,
    iter3,
    iter4,
    iter5,
    )

for a, b, c, d, e in generator_with_a_large_name:
    # do stuff

# use noqa: E501 for slightly long lines, in case splitting into
# multiple lines reduces readability
this_is_a_long_line = that_makes_no_much_sense(to_separate, in_multiple_lines, abcd)  # noqa: E501
```

### 1.5 Code structure

Write code in the form of small functions, because small functions are
easier to test. Combine small functions to compose larger functions. If
you need to use a global variable in a function, pass it as a default
value of a parameter. Avoid using complex classes, or avoid using
classes at all, unless you need to maintain a state or you really know
what you are doing. Flat is better than nested (though it's harder to
write, but it's easier to maintain and read). Use long variable names if
needed. Write comments that explain why you do stuff, and not how you do
stuff. Use the `TODO:` flag in your comments to note something for the
future. If needed, raise an issue.

### 1.6 Creating a new module

To develop a new HADDOCK3 module follow our guidelines and templates
under `src/haddock/modules/_template_cat/_template_mod/`.

## 2. Contributing with documentation

You may contribute to HADDOCK3 documentation by improving parts where
documentation is lacking or writing the documentation for the new code
you propose. HADDOCK3 documentation is hosted online at
https://bonvinlab.org/haddock3.

HADDOCK3 documentation is rendered with
[Sphinx](https://www.sphinx-doc.org/en/master/) combining markdown
files, restructured text files, and extracting the docstrings in the
source code.

The `docs/` folder contains all the files used by Sphinx to compile the
documentation to HTML files. To incorporate new documentation pages or
update the existing ones, navigate around the `docs/` folder to learn
how we have structured it and add/edit the files you find relevant. You
will see that the structure of folders and files follows the design of
the documentation website.

You can render the documentation locally to inspect the end result
before creating a pull request. To compile the documentation locally:
activate the `haddock3` python environment inside the haddock3 github
folder, run `tox -e docs` and then use your favourite browser to open the
`haddock3-docs/index.html` file. We invite you to read through Sphinx-doc
webpage if you want to exploit any advanced feature of Sphinx, but we
already provide examples for virtually any use you may need.

If you need to install any additional library, talk to us first. The
documentation requirements are in the `devtools` folder.

Finally, if you find the need to generate new pages during the HTML
compilation part, you may follow the `devtools/build_defaults_rst.py` as
an example. See also the `docs/conf.py` file `setup(app)` line.

**Troubleshooting:**

1. If you add any new dependency (import statement) in the code, you
  need to add that library name to the `mock` list in the `docs/conf.py`
  file.


[tox]: https://tox.wiki/en/latest/index.html "tox"
[fork]: https://docs.github.com/en/get-started/quickstart/fork-a-repo
[pytest]: https://docs.pytest.org/ "pytest"
[flake]: https://flake8.pycqa.org/en/latest/ "flake8"
[fr]: https://github.com/haddocking/haddock3/blob/b44304f0a1509d44d9689d7e2e4124f0ae3af0a1/tox.ini#L116-L130
[numpydoc]: https://numpydoc.readthedocs.io/en/latest/format.html
[numba]: https://numba.pydata.org/ "Numba"

# HADDOCK3 benchmark tutorial

Developing HADDOCK3 requires handling thousands of parameters, either at
the CNS level or the Python level. Therefore, unit-testing is sometimes
not enough. To assess the correct functioning of HADDOCK3 we have
assembled a benchmarking workflow where we dock well known and studied
complexes and ensure the outcome matches expectations.

To run HADDOCK3 as a user, you don't need to run this benchmark. But if
you are an advanced user who has configured HADDOCK3 in your systems,
you may wish to run the benchmark to make sure HADDOCK3 behaves as
expected.

HADDOCK3 has two command-line clients that set up the benchmark workflow
automatically. Let's go through them step-by-step.

## Obtaining the initial models

The Bonvin lab has manually curated a list of systems ideal for this
benchmark. The repository is available here. Clone it to your machine
with:

`git clone https://github.com/haddocking/BM5-clean`

If you inspect the new `BM5-clean` folder, you will see the
`HADDOCK-ready` folder has more than 200 sub-folders with "ready-to-use"
systems for HADDOCK.

## Setting up the runs

Having HADDOCK3 installed, you can set up the runs with the following
command:

```
# first, make a new folder where you want the runs to be stored
mkdir <folder-where-the-BM-jobs-will-be-created>
haddock3-bm BM5-clean/HADDOCK-ready <folder-where-the-BM-jobs-will-be-created> [OPTIONS]
```

`[OPTIONS]` are optional :relaxed:. Look at the `haddock3-bm -h` help
menu and select which ones better adapt to your system.

## Running with the daemon

Running more than 200 HADDOCK jobs is time-consuming. Inspecting the
queue system manually over several days is a pain. Therefore, we created
a daemon that will handle the queue and submit the jobs for you. Use the
command:

`haddock3-dmn <folder-where-the-BM-jobs-were-created> [OPTIONS]`

Use `haddock3-dmn -h` to read all possible options.

From this point on, the daemon will manage the queue for you. You can
also run the daemon as a job; please read further.

Initially, all jobs have a file named `AVAILABLE` pointing that the jobs
are ready to run. Jobs that are sent to the queue get the file flag
`RUNNING`. Completed jobs get the file flag `DONE`, and failed jobs get
the file flag `FAIL`.You can inspect which jobs are at which state with
the `find` command:

`find <folder-where-the-BM-jobs-were-created> -name DONE`

You can count the number of folders with:

`find <folder-where-the-BM-jobs-were-created> -name DONE | wc -l`

## Stopping the daemon

If you want to stop the daemon, press `Ctrl+c` in the window where you
launch it. And manually cancel the remaining jobs. You can try the
following command:

`qstat -a | awk '{print $4}' | grep BM5 | xargs scancel`

`BM5` comes because all jobs prepared for the benchmark have the `BM5`
tag in their job name (unless you defined otherwise in the `[OPTIONS]`)

## Further notes

As with any command-line tool, the haddock3-daemon will run as long as
the terminal window is open. However, we don't recommend using the `&`
terminal detacher suffix command unless you know what you do.
Alternatively, you could use [`tmux`](https://github.com/tmux/tmux) to
maintain the session running even when you disconnect from your login
node.

A better way can be to send the daemon job to some queue. You can easily
do that by using the daemon job created by the `haddock3-bm` command.

## What happens if you halt the daemon?

If you halt the daemon, you can restart the operations from where they
left. Two scenarios are possible:

1. you also canceled running jobs
2. you let the running jobs finish properly

In the first scenario, you want the previously running jobs to restart.
For that, run the command:

`haddock3-dmn <new-folder-of-my-preference> --restart [OPTIONS]`

Or you can update the `hd3-daemon.job` file with the `--restart` option.

In the second scenario, run the daemon as you would from scratch. Only
the jobs with the file flag `AVAILABLE` will be executed.

Thanks for using HADDOCK3. [Any feedback is very
welcomed](https://github.com/haddocking/haddock3/issues).

The HADDOCK team.

# HADDOCK3 DISCLAIMER

The HADDOCK3 software is provided "as is" and without warranties.
The authors of the software will not be held liable for any use of the HADDOCK3 package and derivatives/results. 

Some of HADDOCK3 modules use the CNS software (<http://cns-online.org/v1.3/>) (Crystallography and NMR System) 
as computational engine.

While CNS is free of use for non-profit users, a proper license is required for commercial applications. 
Biovia is handling those licenses (<https://www.3ds.com/how-to-buy/contact-sales>). 
While they officially do not distribute CNS (CNX) anymore, they usually allow the use of the non-profit version 
provided a proper license is purchased for some of their modelling software.

The HADDOCK3 modules using CNS are:

- topology modules:
  - topoaa
  - topocg

- sampling modules:
  - rigidbody

- refinement modules:
  - flexref
  - emref
  - mdref

- scoring modules:
  - emscoring
  - mdscoring
	
- analysis modules:
  - alascan

Commercial use of any of the above-mentioned modules in a HADDOCK3 workflow will thus require a proper CNS license.
It is your responsibility as a user to make sure you have such a license.

# Running integration tests manually

*This documentation is for developers.*

The integration tests ensure HADDOCK3 workflows work correctly by performing
short docking or analysis on testing systems. With these tests, we evaluate if
the final scoring values in the developing branch are equal to those obtained in
the `main` branch.

You can run the integration tests locally using our helper scripts and
following the guidelines here.

For a pull request to be accepted, it must pass these integration tests. So we
kindly ask you to run them before submitting a pull request. We are currently
working on incorporating these tests into our automatic CI pipelines.

Running the integration tests for a single branch takes about 1 hour using 8 CPU
cores in a AMD EPYC 7451 24-Core Processor. In case you do not have the computer
power to run these tests, ask us and we will run them for you.

**How to correctly set up and run the integration tests?**

The easiest way is to have two installations of haddock3:
one fixed at the `main` branch and another with your developments.

## 1. Install HADDOCK3 main branch separately

First, you should install HADDOCK3 main branch in a separate folder and
python environment:

```bash
git clone --recursive https://github.com/haddocking/haddock3 haddock3main
cd haddock3main
```

Rename the conda env name in requirements.yml file

```
sed -i 's/haddock3/haddock3main/g' requirements.yml
```

Proceed to install the HADDOCK3 main following the installation
instructions in the repository.

This repository and environment will be the ones you will use to run the
test examples from the `main` branch.

Once installed, you don't need to install this "main" repository again for
future occasions. You can keep using it to test all your developments.

## 3. Running the tests in the `main`

Before running the integration tests, ensure the reference repository `main`
branch is up-to-date.

```bash
cd haddock3main
git checkout main
git pull
```

Remember to activate the corresponding python environment.

```bash
conda activate haddock3main
```

Or, if you used `venv`:

```bash
source venv/bin/activate
```

Navigate to the `examples/` folder and execute the tests:

```bash
cd examples/
python run_tests.py -b
```

This script will run all the test cases in the `examples/` folder (`*-test.cfg`
files) and stop if any of the tests break. For help, see `python run_tests.py
-h`.

## 4. Running the tests on your branch

Navigate to your development repository and activate the haddock3 environment -
you are likely on a different terminal window.

Run the tests the same way as before by navigating to the `examples/` folder and
executing the tests:

```bash
cd examples/
python run_tests.py -b
```

## 5. Comparing both runs

Once tests in the `main` and your development branch complete, that is, all
`*-test.cfg` files were executed, you can compare their CAPRI scores.

Inside the `examples/` folder of your development branch, run:

```bash
python compare-runs.py -r <path-to-haddock-main-examples-folder>
```

This command will tell you if there are any differences in the CAPRI tables:
missing rows or columns and different values. Numeric scores are evaluated with
0.001 tolerance.

If there are differences, likely something went wrong unless you are developing
code that explicitly affects the CAPRI scores. If that is the case, explain it
in the pull request description.

## Additional considerations

### Tests breaking with `run_tests.py`

Tests break during the `run_test.py` step if the new code breaks the core
HADDOCK3 workflow. You should work towards correcting those errors first. Once
the workflows execute completely, you can then compare the CAPRI tables.

### Running on a cluster

Following the instructions here, the test cases will run locally on your
computer. But if you have access to a job scheduling system in a cluster, you
can prepare a `job` script and launch the job as you would to for any other
related process.

### Running individual test cases

If you want to compare a particular test case only, for example, two different
runs for the `docking-protein-protein/docking-protein-protein-test.cfg`, run:

```bash
python compare_runs.py -r1 <PATH-TO-RUN1> -r2 <PATH-TO-RUN2>
```

*Thanks, and enjoy developing and using HADDOCK3 :-)*

# A brief introduction to HADDOCK3

HADDOCK3 is the next generation integrative modelling software in the
long-lasting HADDOCK project. It represents a complete rethinking and rewriting
of the HADDOCK2.X series, implementing a new way to interact with HADDOCK and
offering new features to users who can now define custom workflows.

In the previous HADDOCK2.x versions, users had access to a highly
parameterisable yet rigid simulation pipeline composed of three steps:
`ridig-body docking (it0)`, `semi-flexible refinement (it1)`, and `final refinement (itw)`.

![HADDOCK 2.x workflow](figs/HADDOCK2-stages.png)

In HADDOCK3, users have the freedom to configure docking workflows into
functional pipelines by combining the different HADDOCK3 modules, thus
adapting the workflows to their projects. HADDOCK3 has therefore developed to
truthfully work like a puzzle of many pieces (simulation modules) that users can
combine freely. To this end, the “old” HADDOCK machinery has been modularised,
and several new modules added, including third-party software. As a
result, the modularisation achieved in HADDOCK3 allows users to duplicate steps
within one workflow (e.g., to repeat the `it1` stage of the HADDOCK2.x
rigid workflow).

Note that, for simplification purposes, at this time, not all functionalities of
HADDOCK2.x have been ported to HADDOCK3, which does not (yet) support NMR RDC,
PCS and diffusion anisotropy restraints, cryo-EM restraints and coarse-graining.
Any type of information that can be converted into ambiguous interaction
restraints can, however, be used in HADDOCK3, which also supports the
*ab initio* docking modes of HADDOCK.

![HADDOCK3 workflow](figs/HADDOCK3-workflow-scheme.png)

To keep HADDOCK3's modules organised, we catalogued them into several
categories. But, there are no constraints on piping modules of different
categories.

The main module's categories are "topology", "sampling", "refinement",
"scoring", and "analysis". There is no limit to how many modules can belong to a
category. Modules are added as developed, and new categories will be created
if/when needed. You can access the HADDOCK3 documentation page for the list of
all categories and modules. Below is a summary of the available modules:

* **Topology modules**
    * `topoaa`: *generates the all-atom topologies for the CNS engine.*
* **Sampling modules**
    * `rigidbody`: *Rigid body energy minimisation with CNS (`it0` in haddock2.x).*
    * `lightdock`: *Third-party Glow-worm Swarm Optimisation (GSO) docking software.*
    * `gdock`: *Third-party genetic algorithm-based docking software.*
* **Model refinement modules**
    * `flexref`: *Semi-flexible refinement using a simulated annealing protocol through molecular dynamics simulations in torsion angle space (`it1` in haddock2.x).*
    * `emref`: *Refinement by energy minimisation (`itw` EM only in haddock2.4).*
    * `mdref`: *Refinement by a short molecular dynamics simulation in explicit solvent (`itw` in haddock2.X).*
* **Scoring modules**
    * `emscoring`: *scoring of a complex performing a short EM (builds the topology and all missing atoms).*
    * `mdscoring`: *scoring of a complex performing a short MD in explicit solvent + EM (builds the topology and all missing atoms).*
* **Analysis modules**
    * `alascan`: *Performs alanine scanning on the models generated in the previous step.*
    * `caprieval`: *Calculates CAPRI metrics (i-RMDS, l-RMSD, Fnat, DockQ) with respect to the top scoring model or reference structure if provided.*
    * `contactmap`: *Calculates the contact maps for the models generated in the previous step.*
    * `clustfcc`: *Clusters models based on the fraction of common contacts (FCC)*
    * `clustrmsd`: *Clusters models based on pairwise RMSD matrix calculated with the `rmsdmatrix` module.*
    * `ilrmsdmatrix`: *Calculates the pairwise iLRMSD matrix between all the models generated in the previous step.*
    * `rmsdmatrix`: *Calculates the pairwise RMSD matrix between all the models generated in the previous step.*
    * `seletop`: *Selects the top N models from the previous step.*
    * `seletopclusts`: *Selects top N clusters from the previous step.*

The HADDOCK3 workflows are defined in simple configuration text files, similar to the TOML format but with extra features. Here is an example of a configuration file that would reproduce the HADDOCK2.x rigid workflow:

```toml
run_dir = "run1-protein-protein"
ncores = 40
mode = "local"

# molecules to be docked
molecules =  [
    "data/e2aP_1F3G.pdb",
    "data/hpr_ensemble.pdb"
    ]

[topoaa]

[rigidbody]
ambig_fname = "data/e2a-hpr_air.tbl"

[seletop]

[flexref]
ambig_fname = "data/e2a-hpr_air.tbl"

[emref]
ambig_fname = "data/e2a-hpr_air.tbl"

[clustfcc]

[caprieval]
```

In this example only very few parameters are defined as most correspond to the default ones defined for each module. The sampling in this case would be 1000 rigidbody models and 200 for the refinement stages. Clustering is based on the fraction of common contacts and the final clusters are analysed using the best model generated as a reference (the `caprieval` module).

Detailed explanations on how to configure a workflow through the configuration files can be found
<a href="https://github.com/haddocking/haddock3/blob/main/docs/tutorials/user_config.rst">here</a>.

Having the configuration file ready, users can run HADDOCK3 with a single command-line input:

```bash
haddock3 config-file.cfg
```

You can find examples of HADDOCK3 workflows for the different biological
systems in the `examples` [subfolder][examples] of the HADDOCK3 folder.

HADDOCK3 will start running (different execution modes are available using
either local resources (threads) or in "batch" mode using a batch queuing system) -
for details, see [here][queue]. See examples in the `examples` [subfolder][examples]
for configuration files ending in `-full.cfg`.

Finally, HADDOCK3 has several advanced features that allow users additional
flexibility in creating, restarting and extending runs, for example. Please
read about our advanced features [here][advanced].

Please continue exploring our documentation pages for more information and
explanations on HADDOCK3. If you wish to go beyond that, you might wish to see
our lectures on YouTube:

* [Introducing HADDOCK3: Enabling modular integrative modelling pipelines](https://www.youtube.com/watch?v=V7uwFbVDKFE)
* [Modular code for a modular software: developing HADDOCK3](https://www.youtube.com/watch?v=5Uk1EvzCOIg)

[queue]: https://github.com/haddocking/haddock3/blob/87e7c81ab6827d331d0c00bb9fa1b1d742344ef6/src/haddock/modules/defaults.yaml#L26-L40
[examples]: https://github.com/haddocking/haddock3/tree/main/examples
[advanced]: https://github.com/haddocking/haddock3/tree/main/docs/tutorials

# CNS Installation

The computational engine for most of HADDOCK3's modules is the [Crystallography and NMR System (CNS)](http://cns-online.org/v1.3/).
Once you have [cloned the HADDOCK3 repository](INSTALL.md), please follow these instructions to compile a CNS executable that can be used to run HADDOCK.

Before starting, make sure you download the system requirements, they are `gcc`, `gfortran` and `csh`. Luckily they are easily available from the package manager, so if you are using Ubuntu (for example):

```bash
sudo apt-get install gcc gfortran csh
```

> Make sure `gfortran` is in your `$PATH`, check it with `which gfortran`.

## 1. Downloading CNS

Downloading CNS requires a license, which academic users can [request for free](http://cns-online.org).

To Download CNS, go to their [website](http://cns-online.org) and  click on the `Download` menu and fill the form. You will be sent a password for the download via e-mail - keep in mind only education e-mails are allowed for this.

You will receive a login/password in the e-mail, once you have those go to the [download page](http://cns-online.org/download/v1.3/cns_solve_1.3_all.tar.gz) and use the provided login/password to download the CNS package - the archive you need is: `cns_solve_1.3_all.tar.gz`.

> The CNS website is not currently using SSL certificates, this mean your download might be blocked or it might give you a warning, double check in your browser.

Once the archive `cns_solve_1.3_all.tar.gz` has been downloaded, move it to a `$HOME/software` directory (or any other directory of your choice) and decompress it:

```bash
mkdir ~/software
mv ~/Downloads/cns_solve_1.3_all.tar.gz ~/software/
tar -zxvf cns_solve_1.3_all.tar.gz
```

The command above will have create a `cns_solve_1.3` directory in the `~/software` directory, containing the CNS source code.

## 2. Configuring CNS

Go to the CNS directory:

```bash
cd cns_solve_1.3
```

Inside this directory there will be a `cns_solve_env` file.

You need to edit this file to point to the current directory.

You will need to change line 18 of this file to point to the current directory.

You can do that either by opening this file in a code editor such as VScode or vim, or by running the command below:

```bash
sed -i 's@_CNSsolve_location_@'"$PWD"'@' cns_solve_env
```

> **Note:** On a Mac, the default sed version will give an error with the above command. Install instead `gnu-sed` using `brew`, and then replace `sed` by `gsed` in the above command.

Check if the substitution worked:

```bash
sed -n 18p cns_solve_env
```

The expected output will be (with the path to your CNS installation directory):

```shell
        setenv CNS_SOLVE '/Absolute/path/where/cns_solve/is/cns_solve_1.3'
```

## 3. Patch CNS with HADDOCK custom files

For HADDOCK to use CNS, some modifications were made to the CNS source code. We provide those modifications together with the haddock3 source files.

> ❗ You cannot use CNS in HADDOCK without these patched files❗

Copy the CNS files distributed with HADDOCK3 to the CNS directory:

```bash
\cp -r ~/software/haddock3/varia/cns1.3/[bis]*  ~/software/cns_solve_1.3/
```

> **Note:** Make sure to use the correct path to your haddock3 location in the above command.

## 4. Compiling CNS

Before installing CNS, you need to check wether your operating system is supported by CNS.

The list of supported architectures can be seen with the following command:

```bash
ls ~/software/cns_solve_1.3/instlib/machine/supported
arm-aarch64-linux  intel-x86_64bit-linux  linux  mac-arm-darwin  mac-intel-darwin
```

To check what is *your* architecture, type the following command:

```bash
~/software/cns_solve_1.3/bin/getarch
```

> You might get something like `unknown-...`, in that case installation is still possible, however it means the compiler options might not be properly defined - check the Troubleshooting section

Several `Makefile` headers are already provided - here we will use on the one that uses `gfortran` as the compiler.

Now it is time to compile CNS, you can do that with the following command:

```bash
make install compiler=gfortran
```

You should see the progress of the compilation, followed by a confirmation that an executable has been created.

The executable will be located in a new architecture-specific directory.

For example under Linux (Intel or AMD processors) it will be under `~software/cns_solve_1.3/intel-x86_64bit-linux/source/cns_solve-XXXXXXX.exe`
And on a Mac with arm processors (M1/2/3) is will be under `~software/cns_solve_1.3/mac-arm64-darwin/source/cns_solve-XXXXXXX.exe`

> The `XXXXXXX` will be a number specific to your compilation.

Check if it is working by executing it:

```bash
~/software/cns_solve_1.3/intel-x86_64bit-linux/source/cns_solve-2405221906.exe
```

If you see the CNS prompt, the compilation was successful! 🎉

```text
============================================================
|                                                          |
|            Crystallography & NMR System (CNS)            |
|                         CNSsolve                         |
|                                                          |
============================================================
 Version: 1.3 at patch level U
 Status: Special UU release with Rg, paramagnetic
         and Z-restraints (A. Bonvin, UU 2013)
============================================================
```

The command to exit CNS is `stop`!

If this does not work, check the [troubleshooting section](#troubleshooting) below.

> **Note:** If you want to use CNS as standalone application, you should first source the `cns_solve_env` file (csh) or `.cns_solve_env_sh` file (bash). CNS will then be defined in you path and can be simply started using `cns` as command. If using bash, make sure to first edit the `cns_solve_env` variable in the `.cns_solve_env_sh` file to define the installation directory as described above.

## 5. Installing the created CNS executable into haddock3

You can find the freshly compiled CNS executable a newly created directory in the CNS installation directory named after the architecture of your system. E.g. for a M1/2/3/ Mac Arm processor it will be `mac-arm64-darwin`. In the `source` directory in that directory you can find the compiled CNS executable.

```bash
ls mac-arm64-darwin/source/*exe
> mac-arm64-darwin/source/cns_solve-2405221019.exe
```

You can then copy this executable into the `haddock3/bin` directory, renaming it simply to `cns`.

## Troubleshooting

### 1. System not recognized

If the installation fails because your OS/hardware are not recognized, most likely the `bin/getarch` script needs to be updated.

From within your CNS installation directory type the following command to check if your system is recognized:

```text
./bin/getarch
```

For an unknown system you might see as output:

```text
~/software/cns_solve_1.31-UU> ./bin/getarch
unknown-...
```

If your OS/hardware is unknown, this is not per se a problem, but it means the compiler options might not be properly defined.
For example, the default CNS package will not recognize the Mac M1/2/3/ processors (but after copying the CNS files distributed with haddock3 it should!).
To solve that edit the `./bin/get_arch` script and add lines such as your system be recognized (e.g. after line 179 - this should be added after a line containing `exit 0`). Here is an example to add support for the Mac M1/2/3 processors:

```shell
    arm64:Darwin:*:*)
    echo mac-arm64-darwin
    exit 0 ;;
```

You should then create a directory under `instlib/machine/supported` with the same name as the one you defined in `getarch`. Copy then and edit if needed the files from another supported system into the directory you created.

### 2. Compiler

If no suitable compiler is found, you will get an error message:

```text
Error: no suitable compiler (ifort, pgf95, ifort_i4, ifort_mp or pgf95_mp) found
```

In this case, you will have to install a compiler. For more information, check the [CNS Installation page](http://cns-online.org/v1.3/installation/frame.html).
One Fortran compiler that is easy (and free) to install is `gfortran`. It is part of the GNU Compiler Collection (GCC), which can be installed with one command if you have homebrew:

```bash
brew install gcc
```

Alternatively, gfortran can be downloaded as a [separate binary](https://gcc.gnu.org/wiki/GFortranBinaries).

### 3. Makefile

If a suitable compiler is installed but no corresponding `Makefile.header` is found, `make install` will give an error as well. For example (with gfortran):

```text
Error: Makefile template for compiler gfortran is not available
```

Makefile headers for each supported system-compiler combination are provided in `instlib/machine/supported/` (for unsupported systems, see `instlib/machine/unsupported/`). If you already tried `make install`, the appropriate directory for your system (eg. `mac-intel-darwin`) will have been copied to the main `cns_solve_1.3` directory.
If this directory does not contain the desired file (eg. `Makefile.header.2.gfortran`), you can create one manually.

For example, for `gfortran`, create a new file named `Makefile.header.6.gfortran` inside the directory containing Makefile headers for your system. Save the following lines in this file:

```makefile
# fortran options
F77 = gfortran
F77STD = -fdefault-integer-8 -w -fallow-argument-mismatch
F77OPT = -O3 $(CNS_MALIGN_I86) -funroll-loops -ffast-math -march=native -mtune=native
F77FLAGS = $(F77STD) $(F77OPT) $(EXT_F77FLAGS) $(F77BUG)

# C options
CC = gcc
CPP = g++
CCFLAGS = -O -DINTEGER='long int' -DCNS_ARCH_TYPE_$(CNS_ARCH_TYPE) $(EXT_CCFLAGS)

# link options
LD = gfortran
LDFLAGS = -w $(EXT_LDFLAGS) -static-libgfortran
```

Note the `-fallow-argument-mismatch` flag. From gfortran version 10 onward, type mismatches by default give an error rather than a warning. This flag returns warnings instead, so that CNS compilation can successfully complete. If a `Makefile.header.x.gfortran` is provided for your system but compilation fails with (many) `Error: Type mismatch`, you may need to add this flag to the provided file.

# Workflow Examples

The HADDOCK3 `examples/` directory contains various subdirectories and config files
corresponding to different types of complexes, scenarios and data.

1. [docking-antibody-antigen](#docking-antibogy-antigen)
1. [docking-protein-DNA](#docking-protein-dna)
1. [docking-protein-glycan](#docking-protein-glycan)
1. [docking-protein-homotrimer](#docking-protein-homotrimer)
1. [docking-protein-ligand](#docking-protein-ligand)
1. [docking-protein-ligand-shape](#docking-protein-ligand-shape)
1. [docking-protein-peptide](#docking-protein-peptide)
1. [docking-protein-protein](#docking-protein-protein)
1. [refine-complex](#refine-complex)
1. [scoring](#scoring)
1. [docking-multiple-ambig](#docking-multiple-ambig)
1. [general analysis tasks](#general-analysis-tasks)

Each directory contains both:

- __test__ runs config files (to test the various workflows, make sure the installation works and any changes to the code/scripts have not broken the machinery). Those are set up to run locally.
- __full__ runs config files with recommended parameter settings. Those runs are set up to be executed in "batch" mode using slurm (the `...full.cfg`) files. Examples making use of MPI are also provided in some cases, together with an associated job file that should be submitted to the slurm batch system (`...full-mpi.cfg` and `...full-mpi.job`). Make sure to adapt the full config files to your own system.

The following examples are currently provided:


## docking-antibogy-antigen

An antibody-antigen docking example making use only of the knowledge of the hypervariables (HV) loops on the antibody to guide the docking. This is the same complex used in our [HADDOCK2.4 webserver tutorial](https://www.bonvinlab.org/education/HADDOCK24/HADDOCK24-antibody-antigen/); refer to it for more details. Three different ways of using the knowledge of the HV loop residues are illustrated:

- __CDR-accessible__: using ambiguous distance restraints (AIRs) between the HV loop residues and the solvent-accessible residues of the antigen. Those are defined in the `ambig.tbl` file provided in the `data` directory
- __ranairCDR__: using random AIRs sampled from the HV loops on the antibody and the solvent-accessible residues on the antigen. The random AIRs are used during the rigidbody docking sampling phase and replaced by contact AIRs during refinement.
- __CDR-NMR-CSP__: using ambiguous distance restraints (AIRs) between the HV loop residues and the epitope residues identified by NMR.

Since antibodies consist of two separate chains, a few additional unambiguous restraints are defined between the antibody chains to keep them together during the flexible refinement stage. Those are defined in the `unambig.tbl` file in the `data` directory.

Three different protocols/workflows are illustrated:

1) 10000 rigidbody docking models, selection of top500 and flexible refinement + EM of those ([docking-antibody-antigen-CDR-accessible-full.cfg](../examples/docking-antibody-antigen/docking-antibody-antigen-CDR-accessible-full.cfg) and [`docking-antibody-antigen-ranairCDR-full.cfg`](../examples/docking-antibody-antigen/docking-antibody-antigen-ranairCDR-full.cfg))
2) 10000 rigidbody docking models, FCC clustering and selection of max 20 models per cluster followed by flexible refinement and EM ([docking-antibody-antigen-CDR-accessible-clt-full.cfg](../examples/docking-antibody-antigen/docking-antibody-antigen-CDR-accessible-clt-full.cfg) and [docking-antibody-antigen-ranairCDR-clt-full.cfg](../examples/docking-antibody-antigen/docking-antibody-antigen-ranairCDR-clt-full.cfg)`).
3) 1000 rigidbody docking models, selection of top200 and flexible refinement + EM of those (default sampling in the case in which the epitope has been determined by NMR: [docking-antibody-antigen-CDR-NMR-CSP-full.cfg](../examples/docking-antibody-antigen/docking-antibody-antigen-CDR-NMR-CSP-full.cfg))

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.

## docking-protein-dna

A protein-DNA docking example making use of rather specific protein-DNA distance restraints defined in the `ambig.tbl` file in the `data` directory.

Three different protocols/workflows are illustrated:

1) 1000 rigidbody docking models, selection of top200 and flexible refinement + EM of those ([docking-protein-DNA-full.cfg](../examples/docking-protein-DNA/docking-protein-DNA-full.cfg))
2) 1000 rigidbody docking models, selection of top200 and flexible refinement + final refinement in explict solvent (water) of those ([docking-protein-DNA-mdref-full.cfg](../examples/docking-protein-DNA/docking-protein-DNA-mdref-full.cfg)
3) 1000 rigidbody docking models, FCC clustering and selection of max 20 models per cluster followed by flexible refinement and EM ([docking-protein-DNA-cltsel-full.cfg](../examples/examples/docking-protein-DNA/docking-protein-DNA-cltsel-full.cfg)).

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.

__Note__ the modified electrostatic treatment for DNA (`cdie` and `epsilon=78`) and the automatic definition of DNA restraints to maintain the double helix (`dnarest_on=true`).

## docking-protein-glycan

A protein-glycan docking example making use of the knowledge of the binding site on the protein to guide the docking. The conformation of the glycan has been obtained from the [GLYCAM webserver](http://glycam.org/), while the structure of the protein is taken from the PDB in its unbound form. In the proposed workflows, a clustering step is always performed after initial docking stage, so as to increase the diversity of the ensemble of models to be refined. Three different workflows are illustrated:

1) 1000 rigidbody docking models, RMSD clustering to select 50 clusters, flexible refinement of the top 5 models of each cluster, final RMSD clustering for cluster-based scoring ([docking-protein-glycan-full.cfg](../examples/docking-protein-glycan/docking-protein-glycan-full.cfg)). The RMSD clustering assumes a good knowledge of the interface, as the user has to define the residues involved in the binding site by means of the resdic_ parameter.
2) 1000 rigidbody docking models, interface-ligand-RMSD (`ilrmsd`) clustering to select 50 clusters, flexible refinement of the top 5 models of each cluster, final ilRMSD clustering for cluster-based scoring ([docking-protein-glycan-ilrmsd-full.cfg](../examples/docking-protein-glycan/docking-protein-glycan-ilrmsd-full.cfg)). The interface-ligand-RMSD clustering is a more general approach, as it does not require the user to define the residues involved in the binding site. The interface is automatically defined by the residues involved in the protein-glycan interaction in the input models.
3) 500 flexible docking runs + final RMSD clustering for cluster-based scoring [docking-flexref-protein-glycan-full.cfg](../examples/docking-protein-glycan/docking-flexref-protein-glycan-full.cfg). In this case, the rigidbody docking is skipped and the docking is performed at the flexible refinement level. In this case the flexible refinement has more steps than usual (`mdsteps_rigid = 5000`, `mdsteps_cool1 = 5000` and so on) and the glycan is defined as fully flexible (`fle_sta_1`, `fle_end_1`, `fle_seg_1`).

__Note__ the modified weight of the van der Waals energy term for the scoring of the rigidbody docking models (`w_vdw = 1.0`), as in the [protein-ligand example](#docking-protein-ligand).


## docking-protein-homotrimer

A protein homotrimer with C3 symmetry docking example making use of bioinformatics interface predictions from our [Whiscy webserver](https://wenmr.science.uu.nl/whiscy/) defined in the [1qu9_whiscy_air.tbl](../examples/docking-protein-homotrimer/data/1qu9_whiscy_air.tbl) file in the `data` directory. Note that this is a bound docking example since the protein monomers used for docking are taken from the crystal structure of the homotrimer. The workflow does however perform a flexible refinement of the models, which might lead to deviations from the bound conformation.

The [docking-protein-homotrimer-full.cfg](../examples/docking-protein-homotrimer/docking-protein-homotrimer-full.cfg) workflow consists of the generation of 2000 rigidbody docking models, selection of top200 and flexible refinement + EM of those. C3 and non-crystallographic (NCS) symmetry restraints are defined to guide the docking.

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.


## docking-protein-ligand

A protein-ligand docking example making use of the knowledge of the binding site on the protein to guide the docking.

As explained in our [protein-ligand HADDOCK2.4 tutorial](https://www.bonvinlab.org/education/HADDOCK24/HADDOCK24-binding-sites/), in the rigidbody docking phase all residues of the binding site are defined as active to draw the ligand into it (the corresponding AIRs are defined in the [ambig-active-rigidbody.tbl](../examples/docking-protein-ligand/data/ambig-active-rigidbody.tbl) file in the `data` directory). For the flexible refinement only the ligand is defined as active and the binding site as passive to allow the ligand to explore the binding site (the corresponding AIRs are defined in the [ambig-passive.tbl](../examples/docking-protein-ligand/data/ambig-passive.tbl) file in the `data` directory).

The [docking-protein-ligand-full.cfg](../examples/docking-protein-ligand/docking-protein-ligand-full.cfg) workflow consists of the generation of 1000 rigidbody docking models, selection of top200 and flexible refinement of those.

__Note__ the modified weight of the van der Waals energy term for the scoring of the rigidbody docking models (`w_vdw = 1.0`) and the skipping of the high temperature first two stages of the simulated annealing protocol during the flexible refinement (`mdsteps_rigid = 0` and `mdsteps_cool1 = 0`). Parameter and topology files must be provided for the ligand (`ligand_param_fname = "data/ligand.param"` and `ligand_top_fname = "data/ligand.top"`). Those were obtained with a local version of PRODRG ([Schüttelkopf and van Aalten Acta Crystallogr. D 60, 1355−1363 (2004)](http://scripts.iucr.org/cgi-bin/paper?S0907444904011679)).

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.

## docking-protein-ligand-shape

A protein-ligand docking example making use of the knowledge of a template ligand (a ligand similar to the ligand we want to dock and bind to the same receptor). The template ligand information is used in the form of shape consisting of dummy beads and positioned within the binding site to which distance restraints are defined. More details about the method and the performance of the protocol when benchmarked on a fully unbound dataset
can be seen in our freely available [paper on JCIM](https://pubs.acs.org/doi/full/10.1021/acs.jcim.1c00796).

As explained in our [shape small molecule HADDOCK2.4 tutorial](https://www.bonvinlab.org/education/HADDOCK24/shape-small-molecule/), during the docking and refinement the protein and the shape are kept in their original positions (see the `mol_fix_origin_X` parameters in the config file) and ambiguous distance restraints between the ligand and the shape beads are defined. (The corresponding AIRs are defined in the `shape-restraints-from-shape-1.tbl` file in the `data` directory). This is effectively a three body docking. For the ligand an ensemble of 10 different conformations is provided as starting point for the docking (`ligand-ensemble.pdb` in the `data` directory). Please refer to our [shape small molecule tutorial](https://www.bonvinlab.org/education/HADDOCK24/shape-small-molecule/) for information on how to generate such an ensemble.

The [docking-protein-ligand-shape-full.cfg](../examples/docking-protein-ligand-shape/docking-protein-ligand-shape-full.cfg) workflow consists of the generation of 1000 rigidbody docking models with the protein and shape kept in their origin position, selection of top200 and flexible refinement of those.

__Note__ the modified weight of the van der Waals energy term for the scoring of the rigidbody docking models (`w_vdw = 1.0`). To allow the ligand to penetrate better into the binding site the intermolecular energy components are scaled down during the rigidbody docking phase (`inter_rigid = 0.001`). As for the protein-ligand example, parameter and topology files must be provided for the ligand (`ligand_param_fname = "data/ligand.param"` and `ligand_top_fname = "data/ligand.top"`). Those were obtained with a local version of PRODRG ([Schüttelkopf and van Aalten Acta Crystallogr. D 60, 1355−1363 (2004)](http://scripts.iucr.org/cgi-bin/paper?S0907444904011679)).


The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.


## docking-protein-peptide

The protein-peptide docking example makes use of the knowledge of the binding site on the protein to guide the docking. The active site residues are defined as active and the peptide as passive (the corresponding AIRs are defined in the `ambig.tbl` file in the `data` directory). This example follows the protocol described in our protein-peptide docking article ([Trellet et. al. PLoS ONE 8, e58769 (2013)](https://dx.plos.org/10.1371/journal.pone.0058769)). For the peptide, an ensemble of three conformations (alpha-helix, polyproline-II and extended) is provided as starting point for the docking. Those were built using PyMol (instructions on how to do that can be found [here](https://www.bonvinlab.org/education/molmod_online/simulation/#preparing-the-system)).

Three different workflows are illustrated:

1) 3000 rigidbody docking models, selection of top400 and flexible refinement + EM of those ([docking-protein-peptide-full.cfg](../examples/docking-protein-peptide/docking-protein-peptide-full.cfg)
2) 3000 rigidbody docking models, selection of top400 and flexible refinement + final refinement in explicit solvent (water) of those ([docking-protein-peptide-mdref-full.cfg](../examples/docking-protein-peptide/docking-protein-peptide-mdref-full.cfg)
3) 3000 rigidbody docking models, FCC clustering and selection of max 20 models per cluster followed by flexible refinement and EM ([docking-protein-peptide-cltsel-full.cfg](../examples/docking-protein-peptide/docking-protein-peptide-cltsel-full.cfg)).

__Note__ how the peptide is defined as fully flexible for the refinement phase (`fle_sta_1`, `fle_end_1`, `fle_seg_1`) and dihedral angle restraints are automatically defined to maintain secondary structure elements (`ssdihed = "alphabeta"`)

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.


## docking-protein-protein

The protein-protein docking example makes use of the NMR chemical shift perturbation data providing information on the residues of binding site to guide the docking. The NMR-identified residues are defined as active with their surface neighbors as passive (the corresponding AIRs are defined in the [e2a-hpr_air.tbl](../examples/docking-protein-protein/data/e2a-hpr_air.tbl) file in the `data` directory). This system is the same as described in our [HADDOCK2.4 basic protein-protein docking tutorial](https://www.bonvinlab.org/education/HADDOCK24/HADDOCK24-protein-protein-basic/). For the second molecule (HPR), an ensemble of 10 conformations (taken from the NMR solution structure of this protein) is used as starting point for the docking. Refer to above tutorial for more details about the system and restraints.

Three different workflows are illustrated:

1) 1000 rigidbody docking models, selection of top200 and flexible refinement + EM of those ([docking-protein-protein-full.cfg](../examples/docking-protein-protein/docking-protein-protein-full.cfg))
2) 1000 rigidbody docking models, selection of top200 and flexible refinement + final refinement in explicit solvent (water) of those ([docking-protein-protein-mdref-full.cfg](../examples/docking-protein-protein/docking-protein-protein-mdref-full.cfg))
3) 1000 rigidbody docking models, FCC clustering and selection of max 20 models per cluster followed by flexible refinement and EM ([docking-protein-protein-cltsel-full.cfg](../examples/docking-protein-protein/docking-protein-protein-cltsel-full.cfg)).

In this example all parameters are left to their default settings, except for manually defining the histidines protonation states.

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.


## refine-complex

This example illustrates the refinement of a complex. In this case (workflow [refine-complex-test.cfg](../examples/refine-complex/refine-complex-test.cfg)) the molecules are kept in their original positions and the complex is subjected to a short flexible refinement in explicit solvent with the `mdref` module. The same complex as for the `docking-protein-protein` example is used. The molecules are defined separately in the config file (and could consist each of an ensemble, provided the two ensembles have exactly the same number of models).

In this example all parameters are left to their default settings, except for manually defining the histidines' protonation states and setting the `sampling_factor` to 10, which means that from each starting complex 10 models will be generated with different random seeds for initiating the molecular dynamics phase.

The `caprieval` module is called at the end to assess the quality of the models with respect to the known reference structure.


## scoring

This example illustrates the use of HADDOCK3 for scoring purposes. In contrast to HADDOCK2.4, HADDOCK3 can score a heterogenous set of complexes within one run/workflow. In this example, four different types of complexes are scored within the same workflow:

- an ensemble of 5 models taken from CAPRI Target161
- a protein-DNA complex (model taken from our protein-DNA docking example)
- two models of a protein-protein complex (taken from our protein-protein docking example)
- a homotrimer model (taken from our protein-homotrimer docking examples)

Two scoring workflows are illustrated:

1) Only a short energy minimisation is performed on each model ([emscoring-test.cfg](../examples/scoring/emscoring-test.cfg)).
2) A short molecular dynamics simulation in explicit solvent (water) is performed on each model. In that case contact AIRs (`contactairs = true`), dihedral angle restraints on secondary structure element (`ssdihed = alphabeta`) and DNA restraints (`dnarest_on = true`) are automatically defined ([mdscoring-test.cfg](../examples/scoring/mdscoring-test.cfg)).
3) An example scoring pipeline using in the CAPRI55 competition ([capri-scoring-test.cfg](../examples/scoring/capri-scoring-test.cfg)), where energy minimisation is followed by FCC clustering and selection of the top 2 models per cluster. Then a short molecular dynamics simulation in explicit solvent (water) is performed on each model and the models are clustered again.

The model listings with their associated HADDOCK scores can be found in a `.tsv` file in the stage 01 directory of the respective runs.

## docking-multiple-ambig

This example shows how to use HADDOCK3 when several restraint files are available. The example ([docking-multiple-tbls-test.cfg](../examples/docking-multiple-ambig/docking-multiple-tbls-test.cfg)) is built upon the results obtained running [arctic3d](https://github.com/haddocking/arctic3d) on two proteins forming the complex `2GAF`. The presence of multiple interfaces in both structures allows to define several `.tbl` ambiguous restraint files to be used in the calculations. At first, these files must be compressed in a `.tbl.tgz` archive. During the workflow, the HADDOCK3 machinery unzips the archive and evenly assigns each `.tbl` file to a number of models to be generated. Even if only one sixth of the restraint files contain reasonable information on the interface, HADDOCK3 is still able to retrieve good docking models in the best-scoring positions.

__Note__ how the information about restraint files is propagated during the workflow (`previous_ambig = true` for `flexref` and `emref` modules), so that each model is always refined with its corresponding `.tbl` file.

Importantly, in the [docking-multiple-tbls-clt-full.cfg](../examples/docking-multiple-ambig/docking-multiple-tbls-clt-full.cfg) example the clustering is performed right after the `rigidbody` module, so as to lump together solutions resulting from the application of different sets of restraints.

The `caprieval` module is called at various stages during the workflow to assess the quality of the models with respect to the known reference structure.

## general analysis tasks

In the `analysis` directory, a few examples of how to perform general analysis tasks are provided. These workflows aim at showing how HADDOCK3 can be used outside the scope of docking and refinement to analyse structures and models coming from different sources (e.g. Alphafold2). These example workflows include:

- [alascan-test.cfg](../examples/analysis/alascan-test.cfg): an example of how to perform alanine scanning on a protein-protein complex.
- [contmap-test.cfg](../examples/analysis/contmap-test.cfg): an example of how to generate contact maps from a set of models.
- [topoaa-caprieval-test.cfg](../examples/analysis/topoaa-caprieval-test.cfg): an example of how to run a CAPRI-like (`caprieval`) analysis on an ensemble of models.
- [topoaa-clustfcc-test.cfg](../examples/analysis/topoaa-clustfcc-test.cfg): an example of how to run a FCC clustering analysis on an ensemble of models.
- [topoaa-ilrmsdmatrix-clustrmsd-test.cfg](../examples/analysis/topoaa-ilrmsdmatrix-clustrmsd-test.cfg): an example of how to run a ilRMSD matrix clustering analysis on an ensemble of models.
